/*
 * Created on 08.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;

/**
 * @author timo
 */
public class DoubleMatrix {

    public double[][] value;
    
    public DoubleMatrix(int n, int m){value = new double[n][m];}
    // bernimmt das double-array ohne Kopie
    public DoubleMatrix(double[][] in)
    {
        value = in;
    }
    
    
    public static DoubleMatrix copyValues(double[][] in) 
    {
        double[][] val = new double[in.length][in[0].length];
        for (int i=0; i<in.length; i++) 
            for (int j=0; j<val[i].length; j++) val[i][j] = in[i][j];
        return new DoubleMatrix(val);
    }

    // Creater
    public DoubleMatrix copy() 
    {
        return copyValues(this.value);
    }
    public static DoubleMatrix unity(int n) 
    {
        double[][] val = new double[n][n];
        for (int i=0; i<n; i++) 
            for (int j=0; j<n; j++) val[i][j] = (i==j?1:0);
        return new DoubleMatrix(val);
    }
    public static DoubleMatrix zero(int n, int m) 
    {
        double[][] val = new double[n][m];
        for (int i=0; i<n; i++) 
            for (int j=0; j<m; j++) val[i][j] = 0;
        return new DoubleMatrix(val);
    }
    
    // Simple infomartions
    public int rows() {return value.length;}
    public int columns() {return value[0].length;}
    
    // Arithemtic Operations
    public void addTo(DoubleMatrix add)
    {
	    for (int i=0; i<value.length; i++) 
	        for (int j=0; j<value[i].length; j++) value[i][j] += add.value[i][j];
    }
    public void subFrom(DoubleMatrix arg)
    {
	    for (int i=0; i<value.length; i++) 
	        for (int j=0; j<value[i].length; j++) value[i][j] -= arg.value[i][j];
    }
    public void multTo(DoubleMatrix arg)
    {
        int einsZeilen = rows();
        int einsSpalten = columns();
        if (einsSpalten != arg.rows()) throw new RuntimeException("Matrix Multiplication failed due to unfitting columns to rows.");
        int zweiSpalten = arg.columns();
        for (int i=0; i<einsZeilen; i++)
	    {
	        double[] neuZeile = new double[zweiSpalten]; 
	        for (int j=0; j<zweiSpalten; j++) 
	        {
	            neuZeile[j] = 0;
	            for (int k=0; k<einsSpalten; k++) neuZeile[j] += value[i][k] * arg.value[k][j];
	        }
	    }
    }
    public DoubleMatrix mult(DoubleMatrix arg)
    {
        int einsZeilen = rows();
        int einsSpalten = columns();
        if (einsSpalten != arg.rows()) throw new RuntimeException("Matrix Multiplication failed due to unfitting columns to rows.");
        int zweiSpalten = arg.columns();
        DoubleMatrix erg = new DoubleMatrix(einsZeilen,zweiSpalten);
        for (int i=0; i<einsZeilen; i++)
	    {
	        for (int j=0; j<zweiSpalten; j++) 
	        {
	            erg.value[i][j] = 0;
	            for (int k=0; k<einsSpalten; k++) erg.value[i][j] += value[i][k] * arg.value[k][j];
	        }
	    }
        return erg;
    }
    public void negate()
    {
	    for (int i=0; i<value.length; i++) 
	        for (int j=0; j<value[i].length; j++) value[i][j] = -value[i][j];
    }
    public void invert() 
    {
    	int n = value.length;

    	double[][] erg = new double[n][n];
    	for (int i=0; i<n; i++)
    		for (int j=0; j<n; j++) erg[i][j] = (i==j?1:0);

    	for (int spalte=0; spalte<n; spalte++)
    	{
    		int pivot = spalte;
    		double maxBetrag = 0.0;
    		for (int j=spalte; j<n; j++) 
    			if (Math.abs(value[j][spalte]) > maxBetrag) {pivot = j; maxBetrag = Math.abs(value[j][spalte]);}
    		if (maxBetrag == 0.0) 
    		{
    			throw new RuntimeException ("Matrix has no inverse");
    		}
    		double piv = value[pivot][spalte];
    		for (int j=0; j<n; j++)
    		{
    			double t = value[pivot][j];
    			value[pivot][j] = value[spalte][j];
    			value[spalte][j] = t / piv;
    			t = erg[pivot][j];
    			erg[pivot][j] = erg[spalte][j];
    			erg[spalte][j] = t / piv;
    		}
    		for (int zeile = spalte+1; zeile < n; zeile++)
    		{
    			piv = value[zeile][spalte];
    			for (int j=0; j<n; j++)
    			{
    			    value[zeile][j] -= value[spalte][j]*piv;
    				erg[zeile][j] -= erg[spalte][j]*piv;
    			}
    		}
    	}
    	for (int spalte = n-1; spalte >= 0; spalte--)
    	{
    		for (int zeile = 0; zeile < spalte; zeile++)
    		{
    			double piv = value[zeile][spalte];
    			for (int j=0; j<n; j++)
    			{
//    				value[zeile][j] -= value[spalte][j]*piv;
    				value[zeile][j] = erg[zeile][j] - erg[spalte][j]*piv;
    			}
    		}
    	}
    }
    
    public DoubleMatrix transpose()
    {
        DoubleMatrix erg = new DoubleMatrix(columns(),rows());
        for (int i=0; i<value.length; i++)
            for (int j=0; j<value[i].length; j++)
                erg.value[j][i] = value[i][j];
        return erg;
    }

    // Determinanten und Eigenschaften
    /**
     * Prft auf positive definite und liefert die Determinante zurck, oder -1, falls die Matrix nicht positive definit ist.
     * @param matrix
     * @return
     */
    public double determinantOfPositiveDefiniteMatrix() 
    {
    	int n = value.length;

    	double[][] mat = new double[n][n];
    	double erg = 1.0;
    	
    	for (int i=0; i<n; i++)
    		for (int j=0; j<n; j++)
    			mat[i][j] = value[i][j];

    	for (int spalte=0; spalte<n; spalte++)
    	{
    		double piv = mat[spalte][spalte];
    		if (piv <= 0.0) return -1.0;
    		erg *= piv;
    		for (int zeile = spalte+1; zeile < n; zeile++)
    		{
    			double piv2 = mat[zeile][spalte];
    			for (int j=0; j<n; j++)
    				mat[zeile][j] -= mat[spalte][j]*piv2/piv;
    		}
    	}

    	return erg;
    }
    public boolean isPositiveDefinite(){return determinantOfPositiveDefiniteMatrix()!=-1;}
    
    // Decompostions
    /**
     * performs Cholesky-Decomposition in situ
     * @return 0 if all ok, -1 if the matrix was not positive definite.
     */
    public int choleskyDecomposeInSitu()
    {
        int zeilen = value.length, spalten = value[0].length; 
    	for (int i=0; i<zeilen; i++)
    	{
    		for (int j=0; j<=i; j++)
    		{
    			double v = value[i][j];
    			for (int k=0; k<j; k++)
    				v -= value[j][k]*value[i][k];

    			if (j==i) 						// Varianz?
    			{
    				if (v<0) return -1; 
    				v = Math.sqrt(v);
    			} else 
    			{
    				if ((value[j][j]==0.0) && (v != 0.0)) return -1;
    				v = v / value[j][j];
    			}
    			value[i][j] = v;
    		}
    		for (int j=i+1; j<spalten; j++) value[i][j] = 0;
    	}
    	return 0;
    }
    public DoubleMatrix choleskyDecompose()
    {
        DoubleMatrix copy = copy();
        if (copy.choleskyDecomposeInSitu()==-1) throw new RuntimeException("Cholesky Decomposition failed: Matrix not positive definite.");
        return copy;
    }
    
    // Statistic Matrices
    public static DoubleMatrix covarianceMatrix(double[][] data)
    {
        int anzPer = data.length;
        int anzVar = data[0].length;
        double[] mu = new double[anzVar];
        for (int i=0; i<anzVar; i++) mu[i] = 0;
        for (int i=0; i<anzPer; i++)
            for (int j=0; j<anzVar; j++) mu[j] += data[i][j];
        for (int i=0; i<anzVar; i++) mu[i] /= anzPer;
        
        double[][] erg = new double[anzVar][anzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
            {
                erg[i][j] = 0;
                for (int k=0; k<anzPer; k++) erg[i][j] += (data[k][i]-mu[i])*(data[k][j] - mu[j]);
                erg[i][j] /= anzPer;
            }
        
        return new DoubleMatrix(erg);
    }
    
    public String toString()
    {
        String erg = "";
        for (int i=0; i<value.length; i++)
        {
            for (int j=0; j<value[0].length; j++)
                erg += StatikOld.doubleNStellen(value[i][j],3)+"\t";
            erg += "\r\n";
        }
        return erg;
    }
}
