/*
 * Created on 26.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;
import java.util.Arrays;
import java.util.Random;

import silvers.Statik;


/**
 * @author timo
 */
public class FactorModel 
{
    static int NOPARAMETER = -1;
    static final double LNTWOPI = Math.log(2*Math.PI);
    static Random rand = new Random();
    
    public static enum parameterType {loading, facCov, err};

  int anzFac;
  int anzPar;
  int anzVar;
  
  double[][] loadingsVal;
  int[][] loadingsPar;
  double[][] facCovVal;
  int[][] facCovPar;
  double errVal;
  int errPar;
  
  int anzPer;
  double[][] data;
  double[] dataMean;
  double[] xsum;
  double[][] dataCov;
  double[][] xBiSum;
  
  double[][] sigma;
  
  double ll;
  double[] llD;
  double[][] llDD;
  
  // parameter types
  parameterType[] parType;
  
  // factor reordering
  int[] facNr, itemNr;
  
  // derivatives
  double[][][] sigmaDev;
  double[][][][] sigmaDevDev;
  
  // Some working variables
  double[][] facCovWork, sigmaWork, sigmaWork2, sigmaWork3, sigmaWork4, structureWork, structureTransWork;
  double[] muWork;
  int[] sDevRow, sDevCol, cDevRow, cDevCol, mDev;
  
  double[][] sigInv;
//  double[][][] sigInvD;
  
  public double[][] fisherInformationMatrix;

      public FactorModel(int[][] loadingsPar, double[][] loadingsVal, 
              int[][] facCovPar, double[][] facCovVal, int errPar, double errVal)
      {
          this.loadingsPar = loadingsPar; this.loadingsVal = loadingsVal; 
          this.facCovVal = facCovVal; this.facCovPar = facCovPar;  
          this.errVal = errVal; this.errPar = errPar;
          
          anzFac = loadingsPar.length;
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++) anzVar++;
          facNr = new int[anzVar]; itemNr = new int[anzVar];
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
              {
                  facNr[anzVar]=i; itemNr[anzVar]=j;
                  anzVar++;
              }
          anzPar = getActiveParameters().length;
          collectParameterTypes();
          
          anzPer = 0; data = new double[0][];
          
          fisherInformationMatrix = new double[anzPar][anzPar];
          
      }

      public FactorModel(FactorModel toCopy)
      {
          anzFac = toCopy.anzFac;
          anzVar = toCopy.anzVar;
          anzPar = toCopy.anzPar;
          anzPer = toCopy.anzPer;
    
          loadingsPar = new int[toCopy.loadingsPar.length][toCopy.loadingsPar[0].length];
          for (int i=0; i<loadingsPar.length; i++) for (int j=0; j<loadingsPar[i].length; j++) 
              loadingsPar[i][j] = toCopy.loadingsPar[i][j];
          loadingsVal = Statik.copy(toCopy.loadingsVal);
          facCovPar = new int[toCopy.anzFac][toCopy.anzFac];
          for (int i=0; i<anzFac; i++) for (int j=0; j<anzFac; j++) facCovPar[i][j] = toCopy.facCovPar[i][j]; 
          facCovVal = Statik.copy(toCopy.facCovVal);
          errVal = toCopy.errVal; errPar = toCopy.errPar;
          collectParameterTypes();
          
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++) anzVar++;
          facNr = new int[anzVar]; itemNr = new int[anzVar];
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
              {
                  facNr[anzVar]=i; itemNr[anzVar]=j;
                  anzVar++;
              }

          data = Statik.copy(toCopy.data);
          computeMoments();
          fisherInformationMatrix = new double[anzPar][anzPar];
      }
      
      public void collectParameterTypes()
      {
          int maxPar = maxParNumber();
          parType = new parameterType[maxPar+1];
          
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++) 
                  if (loadingsPar[i][j]!=NOPARAMETER) parType[loadingsPar[i][j]] = parameterType.loading;
          for (int i=0; i<anzFac; i++) for (int j=0; j<anzFac; j++) 
              if (facCovPar[i][j]!=NOPARAMETER) parType[facCovPar[i][j]] = parameterType.facCov;
          if (errPar != NOPARAMETER) parType[errPar] = parameterType.err;
      }
      
      public int maxParNumber()
      {
          int erg = NOPARAMETER;
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++) erg = Math.max(loadingsPar[i][j], erg);
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<anzFac; j++) erg = Math.max(facCovPar[i][j], erg);
          erg = Math.max(errPar, erg);
          return erg;
      }
      
      public int[] getActiveParameters()
      {
          int toPar = maxParNumber()+1;
          int[] ergO = new int[toPar];
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
                  if (loadingsPar[i][j] != NOPARAMETER) ergO[loadingsPar[i][j]]=1;
          for (int i=0; i<anzFac; i++)
              for (int j=i; j<anzFac; j++)
                  if (facCovPar[i][j] != NOPARAMETER) ergO[facCovPar[i][j]]=1;
          if (errPar != NOPARAMETER) ergO[errPar]=1;
          int anz = 0; for (int i=0; i<toPar; i++) if (ergO[i]!=0) anz++;
          int[] erg = new int[anz]; int j=0; 
          for (int i=0; i<toPar; i++) if (ergO[i]!=0) erg[j++] = i;
          Arrays.sort(erg);
          return erg;
      }
      
      public void renumberParameter(int oldNumber, int newNumber)
      {
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
                  if (loadingsPar[i][j] == oldNumber) loadingsPar[i][j] = newNumber;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<anzFac; j++)
                  if (facCovPar[i][j] == oldNumber) facCovPar[i][j] = newNumber;
          if (errPar == oldNumber) errPar = newNumber;
          collectParameterTypes();
      }
    
    public int getAnzFac() {
        return anzFac;
    }
    public int getAnzPar() {
        return anzPar;
    }
    public int getAnzVar() {
        return anzVar;
    }

    public void applyParameterValues(double[] vals)
    {
        for (int i=0; i<loadingsVal.length; i++)
            for (int j=0; j<loadingsVal[i].length; j++)
                loadingsVal[i][j] = (loadingsPar[i][j]==-1?loadingsVal[i][j]:vals[loadingsPar[i][j]]);
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                facCovVal[i][j] = (facCovPar[i][j]==NOPARAMETER?facCovVal[i][j]:vals[facCovPar[i][j]]);
        errVal = (errPar==NOPARAMETER?errVal:vals[errPar]);
    }
    
    private int parameterPos(int par)
    {
        boolean done = false; int k=-1;
        for (int f=0; (!done) && (f<loadingsPar.length); f++)
            for (int i=0; (!done) && (i<loadingsPar[f].length); i++)
            {
                k++;
                done = (loadingsPar[f][i]==par);
            }
        if (!done) {System.out.println("Warning: Parameter "+par+" not found in loading parameters."); return -1;}
        return k;
    }
    
    public void computeSigmaInvDev(int par, double[][] erg)
    {
        if (parType[par]==parameterType.loading)
        {
            int k = parameterPos(par);
            for (int i=0; i<anzVar; i++)
                for (int j=0; j<anzVar; j++)
                {
                    if (j==k)
                    {
                        erg[i][j] = 0;
                        for (int l=0; l<anzVar; l++)
                            erg[i][j] += sigInv[i][l]*facCovVal[facNr[k]][facNr[l]]*loadingsVal[facNr[l]][itemNr[l]]*(l==k?2:1);
                    } else {
                        erg[i][j] = sigInv[i][k]*facCovVal[facNr[k]][facNr[j]]*loadingsVal[facNr[j]][itemNr[j]];
                    }
                }
        }
        if (parType[par]==parameterType.facCov)
        {
            int fnr1 = -1, fnr2 = -1;
            for (int i=0; (i<anzFac) && (fnr1==-1); i++)
                for (int j=i; (j<anzFac) && (fnr1==-1); j++) if (facCovPar[i][j]==par) {fnr1 = i; fnr2 = j;}
            if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
            for (int i=0; i<anzVar; i++) for (int j=i; j<anzVar; j++) 
            {
                if ((facNr[i]==fnr1) && (facNr[j]==fnr2)) sigmaWork4[i][j] = sigmaWork4[j][i] = loadingsVal[fnr1][itemNr[i]] * loadingsVal[fnr2][itemNr[j]];
                else sigmaWork4[i][j] = sigmaWork4[j][i] = 0;
            }
            Statik.multiply(sigInv, sigmaWork4, erg);            
        }
        if (parType[par]==parameterType.err)
        {
            for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = sigInv[i][j];
        }
    }
    
    public void computeSigmaInvDevDev(int par1, int par2, double[][] erg)
    {
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++) erg[i][j] = 0;
        if ((parType[par1] == parameterType.loading) && (parType[par2] == parameterType.loading))
        {
            int k1 = parameterPos(par1), k2 = parameterPos(par2);
            for (int i=0; i<anzVar; i++)
            {
                erg[i][k1] += facCovVal[facNr[k1]][facNr[k2]]*sigInv[i][k2]; 
                erg[i][k2] += facCovVal[facNr[k1]][facNr[k2]]*sigInv[i][k1]; 
            }
        }
        if (((parType[par1]==parameterType.loading) && (parType[par2]==parameterType.facCov)) ||
            ((parType[par2]==parameterType.loading) && (parType[par1]==parameterType.facCov))) 
        {
            if (parType[par1]==parameterType.loading) {int t=par1; par1 = par2; par2 = t;}
            int k = parameterPos(par2);
            int fnr1 = -1, fnr2 = -1;
            for (int i=0; (i<anzFac) && (fnr1==-1); i++)
                for (int j=i; (j<anzFac) && (fnr1==-1); j++) if (facCovPar[i][j]==par1) {fnr1 = i; fnr2 = j;}
            if (facNr[k]!=fnr1) {int t = fnr1; fnr1 = fnr2; fnr2 = t;}
            if (facNr[k] == fnr1)
            {
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++)
                    {
                        if (j==k) 
                        {
                            int start = 0; for (int l=0; l<fnr2; l++) start += loadingsVal[l].length;
                            for (int l=0; l<loadingsVal[fnr2].length; l++) 
                                erg[i][j] += sigInv[i][start+l]*loadingsVal[fnr2][l] * (start+l == k?2:1);
                        } else if (facNr[j]==fnr2) erg[i][j] = sigInv[i][k] * loadingsVal[fnr2][itemNr[j]];                            
                    }
            }
            
        }
        
    }

    public void setData(double[][] data)
    {
        this.data = data;
        this.anzPer = data.length;
        computeMoments();
    }
    
    public void computeMoments()
    {
        if (data==null) return;
        xsum = new double[anzVar];
        dataMean = new double[anzVar];
		for (int i=0; i<anzVar; i++) xsum[i] = 0.0;
		for (int i=0; i<anzPer; i++)
			for (int j=0; j<anzVar; j++) xsum[j] += data[i][j];
		for (int i=0; i<anzVar; i++) dataMean[i] = xsum[i] / (double)anzPer;
			
		xBiSum = new double[anzVar][anzVar];
		dataCov = new double[anzVar][anzVar];
		for (int i=0; i<anzVar; i++)
			for (int j=0; j<=i; j++)
			{
				xBiSum[i][j] = 0.0;
				for (int k=0; k<anzPer; k++) xBiSum[i][j] += data[k][i] * data[k][j];
				for (int k=0; k<anzPer; k++) dataCov[i][j] += (data[k][i]-dataMean[i]) * (data[k][j]-dataMean[j]);
				xBiSum[j][i] = xBiSum[i][j];
				dataCov[i][j] /= (double)anzPer;
				dataCov[j][i] = dataCov[i][j];
			}
    }

    public void setParameter(double[] values) {for (int i=0; i<values.length; i++) setParameter(i,values[i]);}
    public void setParameter(int nr, double value)
    {
        if (parType[nr]==parameterType.loading)
            for (int i=0; i<anzFac; i++)
                for (int j=0; j<loadingsPar[i].length; j++)
                    if (loadingsPar[i][j]==nr) loadingsVal[i][j] = value; 
        if (parType[nr]==parameterType.facCov)
            for (int i=0; i<anzFac; i++)
                for (int j=0; j<anzFac; j++)
                    if (facCovPar[i][j]==nr) facCovVal[i][j] = value;
        if (parType[nr]==parameterType.err) errVal = value;
    }
    
    
    public static FactorModel fixParameter(FactorModel in, int nr, double value) {FactorModel erg = new FactorModel(in); erg.fixParameter(nr,value); return erg;}
    public void fixParameter(int nr, double value)
    {
        anzPar--;
        if (parType[nr]==parameterType.loading)
            for (int i=0; i<anzFac; i++)
                for (int j=0; j<loadingsPar[i].length; j++)
                {
                    if (loadingsPar[i][j]==nr) { loadingsVal[i][j] = value; loadingsPar[i][j] = -1;}
                    if (loadingsPar[i][j] >nr)  loadingsPar[i][j]--;
                }
        if (parType[nr]==parameterType.facCov)
            for (int i=0; i<anzFac; i++)
                for (int j=0; j<anzFac; j++)
                {
                    if (facCovPar[i][j]==nr) { facCovVal[i][j] = value; facCovPar[i][j] = -1;}
                    if (facCovPar[i][j] >nr)  facCovPar[i][j]--;
                }
        if (parType[nr]==parameterType.err) {errPar = -1; errVal = value;}
        collectParameterTypes();
    }

    
    public double[][] createData (int anzPersons) {return createData(anzPersons, facCovVal, loadingsVal, errVal);}
    public double[][] createData (int anzPersons, double[] values) {applyParameterValues(values); return createData(anzPersons, facCovVal, loadingsVal, errVal);}
    public double[][] createData (int anzPersons, double[][] covMatrix, double[][] loadingsVal, double error)
    {
        this.anzPer = anzPersons;
        double[][] cholesky = Statik.choleskyDecompose(covMatrix);

        data = new double[anzPersons][anzVar];

        double[] m = new double[anzFac], m2 = new double[anzFac];
        for (int i=0; i<anzPersons; i++)
        {
            for (int j=0; j<anzFac; j++) m[j] = rand.nextGaussian();
            Statik.multiply(cholesky,m,m2);
            for (int j=0; j<anzVar; j++) data[i][j] = loadingsVal[facNr[j]][itemNr[j]]*m2[facNr[j]] + rand.nextGaussian()*Math.sqrt(error);
        }
        computeMoments();
        return data;
    }
    
    public void evaluateSigma() {evaluateSigma(null);}
    public void evaluateSigma(double[] values)
    {
        if ((sigma==null) || (sigma.length!=anzVar) || (sigma[0].length!=anzVar)) sigma = new double[anzVar][anzVar];
        if (values!=null) applyParameterValues(values);

        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
                sigma[i][j] = loadingsVal[facNr[i]][itemNr[i]]*loadingsVal[facNr[j]][itemNr[j]]*facCovVal[facNr[i]][facNr[j]];
        
        for (int i=0; i<anzVar; i++) 
            sigma[i][i] += errVal;
    }
    
    public boolean factorPositiveDefinite(double[] values)
    {
        applyParameterValues(values);
        return (Statik.determinantOfPositiveDefiniteMatrix(facCovVal) != -1); 
    }
    
    public double euclididanDistance(double[] values)
    {
        evaluateSigma(values);
        double erg = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) erg += (sigma[i][j] - dataCov[i][j])*(sigma[i][j] - dataCov[i][j]);
        return erg;
    }
        
    public double getMinusTwoLogLikelihood(double[] value) {return getMinusTwoLogLikelihood(value, true);}
    public double getMinusTwoLogLikelihood(double[] value, boolean recomputeSigma) 
    {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];

        if (value != null) applyParameterValues(value);
        if (recomputeSigma) evaluateSigma(value);
        
        double det = Statik.invert(sigma,sigInv, sigmaWork);
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(det);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += xBiSum[i][j]*sigInv[i][j];
        
        return ll;
    }


    /**
     * Computes the minus two log likelihood and for each parameter its derivative and second derivative. Parameters are expected to be numbered
     * from 0 to anzPar-1. If values is not zero, these parameter values are applied; otherwise, the method assumes all values are correct.
     */
    public void computeLogLikelihoodDerivatives(double[] value) {computeLogLikelihoodDerivatives(value,true);}
    public void computeLogLikelihoodDerivatives(double[] value, boolean recomputeSigma)
    {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((sigmaWork2==null) || (sigmaWork2.length!=anzVar) || (sigmaWork2[0].length!=anzVar)) sigmaWork2 = new double[anzVar][anzVar];
        if ((sigmaWork3==null) || (sigmaWork3.length!=anzVar) || (sigmaWork3[0].length!=anzVar)) sigmaWork3 = new double[anzVar][anzVar];
        if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];
        if ((llD==null) || (llD.length!=anzPar)) llD = new double[anzPar];
        if ((llDD==null) || (llDD.length!=anzVar) || (llDD[0].length!=anzVar)) llDD = new double[anzPar][anzPar];
        
        if (value != null) applyParameterValues(value);
        if (recomputeSigma) evaluateSigma(value);
        
        double det = Statik.invert(sigma,sigInv, sigmaWork);
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(det);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += xBiSum[i][j]*sigInv[i][j];
        
        for (int p=0; p<anzPar; p++)
        {
            computeSigmaInvDev(p, sigmaWork);
            llD[p] = 0.0;
            for (int i=0; i<anzVar; i++) llD[p] += sigmaWork[i][i];
            llD[p] *= anzPer;
            Statik.multiply(sigmaWork, sigInv, sigmaWork2);
            for (int i=0; i<anzVar; i++) 
                for (int j=0; j<anzVar; j++) llD[p] -= xBiSum[i][j]*sigmaWork2[i][j];
        }
        
        for (int p1=0; p1<anzPar; p1++)
            for (int p2=0; p2<anzPar; p2++)
            {
                computeSigmaInvDev(p1, sigmaWork);
                computeSigmaInvDev(p2, sigmaWork2);
                computeSigmaInvDevDev(p1, p2, sigmaWork3);
                Statik.multiply(sigmaWork, sigmaWork2, sigmaWork4);
                llDD[p1][p2] = 0.0;
                for (int i=0; i<anzVar; i++) llDD[p1][p2] += sigmaWork3[i][i] - sigmaWork4[i][i];
                llDD[p1][p2] *= anzPer;
                Statik.multiply(sigmaWork4, sigInv, sigmaWork);
                Statik.multiply(sigmaWork3, sigInv, sigmaWork2);
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++)
                        llDD[p1][p2] += xBiSum[i][j] * (2*sigmaWork[i][j] - sigmaWork2[i][j]);
            }
    }
    
    public double[] estimateML(double[] starting) {return estimateML(starting, 0.0001);}
    public double[] estimateML(double[] starting, double EPS)
    {
        final int MAXRUNS = 50; 

        double[] move = new double[anzPar];
        double[] pos = new double[anzPar];
        double[][] work1 = new double[anzPar][anzPar], work2 = new double[anzPar][anzPar];
        
        for (int i=0; i<anzPar; i++) pos[i] = starting[i];
        
        int runs = 0; double steplength = Double.POSITIVE_INFINITY, gain = Double.POSITIVE_INFINITY;
        computeLogLikelihoodDerivatives(pos);
        double DEBUGstart = ll;
        while ((runs<=MAXRUNS) && (steplength > EPS) && ((gain > EPS) || (gain<0)))
        {
            double lastLL = ll;
            Statik.invert(llDD, work1, work2);
            Statik.multiply(work1, llD, move);
            
            // get damping
            double lambda = (runs<3?-0.2:(runs<6?-0.5:-1.0));
            Statik.multiply(lambda, move, move);
            Statik.add(pos, move, pos);
            computeLogLikelihoodDerivatives(pos);
            steplength = Statik.abs(move);
            gain = lastLL - ll;
            
            if (gain < 0) 
            {
                lambda *= -2;
                Statik.multiply(work1, llD, move);
                Statik.multiply(lambda, move, move);
                Statik.add(pos, move, pos);
                computeLogLikelihoodDerivatives(pos);
                steplength = Statik.abs(move);
                gain = lastLL - ll;
            } 
            if (gain < 0) 
            {
                for (int i=0; i<move.length; i++) move[i] = 5*rand.nextDouble()*EPS;
                gain = lastLL - ll;
            }
            
            runs++;
        }

        if (runs > MAXRUNS) System.out.println("Warning: More than 50 runs needed, final steplength = "+steplength);
//        System.out.println("Runs       = "+runs);
//        System.out.println("Steplength = "+steplength);
//        System.out.println("Last gain  = "+gain);
//        System.out.println("Total gain = "+(DEBUGstart - ll));
//        System.out.println("Final LL   = "+ll);
        
        return pos;
    }
    
    public void independentSigma() 
    {
        for (int i=0; i<sigma.length; i++)
            for (int j=0;j<sigma.length ;j++)
                sigma[i][j] = (i==j?this.dataCov[i][j]:0);
    }
    
    public int restrictedDF()
    {
        return anzVar*(anzVar+1)/2 - anzPar;
    }
    
    public double getSaturatedLL() 
    {
        double myll = ll;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
                sigma[i][j] = dataCov[i][j];
        
        double sat = getMinusTwoLogLikelihood(null, false);
        ll = myll;
        return sat;
    }

    public double getRMSEA()
    {
        return Math.sqrt(Math.max((ll - restrictedDF()),0) / (restrictedDF()*(anzPer-1)));
    }
    
    public double getDeltaRMSEA(MultipleGroupFactorModel restrictedModel)
    {
        return Math.sqrt(((restrictedModel.ll - ll) - (restrictedModel.anzPar - anzPar))/((restrictedModel.anzPar - anzPar)*(anzPer-1)));
    }
    
    public double getCFI()
    {
        double myll = ll;
        independentSigma(); 
        this.computeLogLikelihoodDerivatives(null,false);
        double indepLL = ll;
        ll = myll;
        int restrictedDF = restrictedDF();
        int indepRestrictedDF = anzVar*(anzVar-1)/2;
        if (myll <= restrictedDF) return 1.0;
        return 1.0-((myll-restrictedDF) / Math.max(myll-restrictedDF,indepLL - indepRestrictedDF));
    }

    public double getCFI(MultipleGroupFactorModel restrictedModel)
    {
        if (ll <= restrictedDF()) return 1.0;
        return 1.0-((ll-restrictedDF()) / Math.max(ll-restrictedDF(),restrictedModel.ll - restrictedModel.restrictedDF()));
    }
    
    public double getDeltaCFI(MultipleGroupFactorModel restrictedModel)
    {
        return this.getCFI() - restrictedModel.getCFI();
    }
    
    public double getMcDonaldsCentralityIndex()
    {
        return Math.exp(-0.5*(ll-restrictedDF())/(anzPer-1));
    }
    
    
    public static void main(String args[])
    {
        powerLdtke();
        System.exit(0);
        
        FactorModel test = new FactorModel(
                new int[][]{{0,-1,-1},{2,-1,-1}},
                new double[][]{{1,1,1},{1,1,1}},
                new int[][]{{3,4},{4,-1}},
                new double[][]{{1,0.3},{0.3,1}},
                1,0.1
                );
        double[] values = new double[]{6,0.3,3,1,0.5};
        test.applyParameterValues(values);
        test.createData(100);

        double EPS = 0.0001;
        double[] grad = new double[5];
        double[][] jac = new double[5][5];
        test.computeLogLikelihoodDerivatives(values);
        double[] symGrad = Statik.copy(test.llD);
        double symVal = test.ll;
        
        for (int i=0; i<grad.length; i++)
        {
            values[i] += EPS;
            test.computeLogLikelihoodDerivatives(values);
            grad[i] = -(symVal - test.ll) / EPS;
            values[i] -= EPS;
        }
        for (int i=0; i<grad.length; i++)
        {
            values[i] += EPS;
            test.computeLogLikelihoodDerivatives(values);
            for (int j=0; j<grad.length; j++)
                jac[i][j] = -(symGrad[j] - test.llD[j]) / EPS;
            values[i] -= EPS;
        }
        
        test.computeLogLikelihoodDerivatives(values);
        System.out.println("Value = "+test.ll);
        System.out.println("Gradient (sym) = "+Statik.matrixToString(test.llD));
        System.out.println("Gradient (num) = "+Statik.matrixToString(grad));
        System.out.println("Jacobian (sym) = \r\n"+Statik.matrixToString(test.llDD));
        System.out.println("Jacobian (num) = \r\n"+Statik.matrixToString(jac));
        
        System.out.println("Values    = "+Statik.matrixToString(values));
//        values = new double[]{7,1,3,8,0.5};
        double[] est = test.estimateML(values);
        System.out.println("Estimates = "+Statik.matrixToString(est));

        
        /*
        FactorModel test2 = new FactorModel(test);
        test2.fixParameter(4, values[4]);
        test2.fixParameter(3, values[3]);
        test.applyParameterValues(values); 
        test.createData(100);
        test.sigma = new double[6][6];
        for (int i=0; i<6; i++)
            for (int j=0; j<6; j++) test.sigma[i][j] = test.dataCov[i][j];
        test.computeLogLikelihoodDerivatives(null, false);
        System.out.println("saturated ll = "+test.ll);

        int anzbins = 100;
        int[] count1 = new int[anzbins], count2 = new int[anzbins];
        int anzReps = 1000;
        double sum1 = 0, sum2 = 0;
        for (int i=0; i<anzReps; i++)
        {
            test.applyParameterValues(values); 
            test.createData(100);
            test.estimateML(values);
//            int cat = (int)Math.round(anzbins*test.getCFI());
//            count1[cat]++;
            test2.setData(test.data);
            test2.estimateML(values2);
            double cfi = test.getCFI();
//          int cat = (int)Math.round(cfi*anzbins); count1[cat]++;
            int cat = (int)Math.round((test.ll-2400)*anzbins/200.0); count1[(cat>=0?(cat<anzbins?cat:anzbins-1):0)]++;
            sum1 += test.ll;
            double n1 = rand.nextGaussian(), n2 = rand.nextGaussian();
//            n1 = n2 = 0.0;
            test2.ll -= n1*n1+n2*n2;
            double cfi2 = test2.getCFI();
//            cat = (int)Math.round(cfi2*anzbins); count2[cat]++;
            cat = (int)Math.round((test2.ll-2400)*anzbins/200.0); count2[(cat>=0?(cat<anzbins?cat:anzbins-1):0)]++;
            sum2 += test2.ll;
        }
        System.out.println("Mean1 = "+(sum1/anzReps));
        System.out.println("Mean2 = "+(sum2/anzReps));
        int s = 0; for (int i=0; i<anzbins; i++) {s += count1[i]; System.out.print(s+"\t");} System.out.println();
            s = 0; for (int i=0; i<anzbins; i++) {s += count2[i]; System.out.print(s+"\t");} System.out.println();
            */
    }
    
    public static void powerLdtke()
    {
        double varLE = 1.0;
        double varCOM = .1136326681;
//        double varCOM = 0.09706514640;
//        double varCOM = 1;
      double varCTRL = 0.351;
//        double varCTRL = 0.8;
        int N = 10;
        
        double secloading = Math.sqrt(1/varCTRL); System.out.println("Population loading = "+secloading);
//        double secloading = 0;
        FactorModel full = new FactorModel(new int[][]{{-1,0}}, 
                new double[][]{{Math.sqrt(1/varCOM),secloading}}, 
                new int[][]{{-1}}, 
                new double[][]{{varLE}}, -1, 1);
        FactorModel res = new FactorModel(full); res.fixParameter(0, 0.0);
        
        MultipleGroupFactorModel mfull = new MultipleGroupFactorModel(new FactorModel[]{full});
        MultipleGroupFactorModel mres = new MultipleGroupFactorModel(new FactorModel[]{res});
        
        double[] population = new double[]{secloading};
        double[] resPopulation = new double[]{};
        int count = 0, anzRep = 10000;
        for (int rep = 0; rep < anzRep; rep++)
        {
            full.setParameter(population);
            full.createData(N);
            res.setData(full.data);
            double[] est = mfull.estimateML(population,0.001);
            mres.estimateML(resPopulation);
            double difference = mres.ll - mfull.ll;
//            System.out.println("Est = "+est[0]+"  \tDiff="+difference);
            if (difference > Statik.FIVEPERCENTTHRESHOLD[0]) count++;
        }
        System.out.println("Power = "+(double)count/(double)anzRep);
    }

}
