package lgmsimulation;

import java.awt.*;
import javax.swing.*;

/**
 * Insert the type's description here.
 * Creation date: (11.12.2002 10:06:42)
 * @author: 
 */
public class FormulaFrame extends javax.swing.JFrame 
{
	int anzFormula;
	JTextField[] createFormula;
	JTextField[] errorVariance;
	JTextField[] missingProbability;
	JTextField[] assumeFormula;
	Choice method;
/**
 * FormulaFrame constructor comment.
 */
public FormulaFrame() 
{
	this(2);
}
/**
 * FormulaFrame constructor comment.
 * @param title java.lang.String
 */
public FormulaFrame(int size) 
{
	super("Simson - Formulas");

	anzFormula = size;

	JPanel formulaPanel = new JPanel();
	formulaPanel.setLayout(new GridLayout(anzFormula+1,5));

	createFormula = new JTextField[anzFormula];
	errorVariance = new JTextField[anzFormula];
	missingProbability = new JTextField[anzFormula];
	assumeFormula = new JTextField[anzFormula];

	formulaPanel.add(new JLabel("\\")); 
	formulaPanel.add(new JLabel("real formula"));
	formulaPanel.add(new JLabel("error variance"));
	formulaPanel.add(new JLabel("missing probability"));
	formulaPanel.add(new JLabel("assumed formula")); 
	for (int i=0; i<anzFormula; i++)
	{
		formulaPanel.add(new JLabel("v"+(i+1)));
		createFormula[i] = new JTextField("p"+(i+1)+" + p"+(i+1+anzFormula)+"*x1");
		formulaPanel.add(createFormula[i]);
		errorVariance[i] = new JTextField("1.0");
		formulaPanel.add(errorVariance[i]);
		missingProbability[i] = new JTextField("0.0");
		formulaPanel.add(missingProbability[i]);
		assumeFormula[i] = new JTextField("p"+(i+1)+" + p"+(i+1+anzFormula)+"*x1");
		formulaPanel.add(assumeFormula[i]);
	}

	method = new Choice();
	method.add("Least Squares");
	method.add("Maximum Likelihood");

	JPanel p1 = new JPanel(new FlowLayout());
	p1.add(method);
	
	JPanel p2 = new JPanel(new GridLayout(2,1));
	p2.add(new JLabel("analysis method :"));
	p2.add(p1);
	
	JPanel p3 = new JPanel(new BorderLayout());
	p3.add(p2,BorderLayout.EAST);
	p3.add(formulaPanel,BorderLayout.CENTER);

	setContentPane(p3);
	setSize(600,anzFormula*30+80);
	show();	
}
/**
 * Insert the method's description here.
 * Creation date: (15.12.2002 10:39:51)
 * @return double
 * @param formula java.lang.String

	normaler String mit Doubles darin.
 
 */
public static double evalFormulaString(String formula) 
{
	int ix = formula.indexOf("(");
	if (ix!=-1)
	{
		int ix2 = ix+1;
		int tiefe = 1;
		while (tiefe > 0)
		{
			int cb = formula.indexOf(")",ix2);
			if (cb==-1) throw new RuntimeException("To less closing brackets in formula "+formula);
			int ob = formula.indexOf("(",ix2);
			if ((ob!=-1) && (ob<cb))
			{
				tiefe++;
				ix2 = ob+1;
			} else
			{
				tiefe--;
				ix2 = cb+1;
			}
		}
		String n = formula.substring(0,ix)+evalFormulaString(formula.substring(ix+1,ix2-1))+formula.substring(ix2);
		return evalFormulaString(n);
	}
	ix = formula.indexOf("+");
	if (ix!=-1) return evalFormulaString(formula.substring(0,ix)) + evalFormulaString(formula.substring(ix+1));
	ix = formula.indexOf("-");
	if (ix==0) return -evalFormulaString(formula.substring(1));
	while ((ix>0) && ((formula.charAt(ix-1)=='E') || (formula.charAt(ix-1)=='*') || 
				      (formula.charAt(ix-1)=='+') || (formula.charAt(ix-1)=='/'))) ix = formula.indexOf("-",ix+1);
	if (ix!=-1) return evalFormulaString(formula.substring(0,ix)) - evalFormulaString(formula.substring(ix+1));
	ix = formula.indexOf("*");
	if (ix!=-1) return evalFormulaString(formula.substring(0,ix)) * evalFormulaString(formula.substring(ix+1));
	ix = formula.indexOf("/");
	if (ix!=-1) return evalFormulaString(formula.substring(0,ix)) / evalFormulaString(formula.substring(ix+1));
	ix = formula.indexOf("^");
	if (ix!=-1) return Math.pow(evalFormulaString(formula.substring(0,ix)),evalFormulaString(formula.substring(ix+1)));

	String f = StatikOld.loescheRandWhitespaces(formula);
	if (f.length()==0) return 0.0;
	return Double.parseDouble(f);
}
/**
 * Insert the method's description here.
 * Creation date: (15.12.2002 11:22:23)
 * @return java.lang.String[]
 */
public String[] getCreationFormulas() 
{
	String[] erg = new String[createFormula.length];
	for (int i=0; i<erg.length; i++) erg[i] = createFormula[i].getText();
	return erg;
}
/**
 * Insert the method's description here.
 * Creation date: (15.12.2002 11:25:09)
 * @return java.lang.String[]
 */
public String[] getErrorVariances() 
{
	String[] erg = new String[errorVariance.length];
	for (int i=0; i<erg.length; i++) erg[i] = errorVariance[i].getText();
	return erg;
}
/**
 * Insert the method's description here.
 * Creation date: (15.12.2002 11:25:47)
 * @return java.lang.String[]
 */
public String[] getMissingProbabilities() 
{
	String[] erg = new String[missingProbability.length];
	for (int i=0; i<erg.length; i++) erg[i] = missingProbability[i].getText();
	return erg;
}
}
