/*
 * Created on 26.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;
import silvers.Statik;


/**
 * @author timo
 */
public class GeneralModel 
{
    static int NOPARAMETER = -1;
//  static Random rand = new Random();
//    public final static DoublePolynomial FIXED = new DoublePolynomial();

  int anzFac;
  int anzPar;
  int anzVar;
  
  double[][] structureVal;
  DoublePolynomial[][] structurePar;
  DoublePolynomial[][] facCovPar;
  double[][] facCovVal;
  DoublePolynomial[] facMeanPar;
  double[] facMeanVal;
  DoublePolynomial[] errPar;
  double[] errVal;
  
  int anzPer;
  double[][] data;
  double[] dataMean;
  double[] xsum;
  double[][] dataCov;
  double[][] xBiSum;
  
  // derivatives
  double[][][] facCovDev;
  double[][][][] facCovDevDev;
  double[][] meanDev;
  double[][][] meanDevDev;
  double[][][] sigmaDev;
  double[][][][] sigmaDevDev;
  double[][] muDev;
  double[][][] muDevDev;
  double[][][] structDev;
  double[][][][] structDevDev;
  
  // Some working variables
  double[][] structureWork, structureTransWork, facCovWork, sigmaWork;
  double[] muWork;
  
  public double[][] fisherInformationMatrix;

      public GeneralModel(DoublePolynomial[][] structurePar, double[][] structureVal, 
                          DoublePolynomial[][] facCovPar, double[][] facCovVal, 
                          DoublePolynomial[] facMeanPar, double[] facMeanVal, 
                          DoublePolynomial[] errPar, double[] errVal)
      {
          this.structurePar = structurePar; this.structureVal = structureVal; this.facCovPar = facCovPar; this.facCovVal = facCovVal; 
          this.facMeanPar = facMeanPar; this.facMeanVal = facMeanVal; this.errPar = errPar; this.errVal = errVal;
          
          anzFac = structureVal[0].length;
          anzVar = structureVal.length;
          
          int maxPar = maxParNumber();
          anzPar = maxPar+1;
          
          anzPer = 0; data = new double[0][];
          
          fisherInformationMatrix = new double[anzPar][anzPar];
      }

      public GeneralModel(int[][] structurePar, double[][] structureVal, 
              int[][] facCovPar, double[][] facCovVal, 
              int[] facMeanPar, double[] facMeanVal, 
              int[] errPar, double[] errVal)
        {
            this.structurePar = new DoublePolynomial[structurePar.length][structurePar[0].length];
            for (int i=0; i<structurePar.length; i++)
                for (int j=0; j<structurePar[0].length; j++)
                    this.structurePar[i][j] = new DoublePolynomial(structurePar[i][j]);
            this.structureVal = structureVal; 
            
            this.facCovPar = new DoublePolynomial[facCovPar.length][facCovPar[0].length];
            for (int i=0; i<facCovPar.length; i++)
                for (int j=0; j<facCovPar[0].length; j++)
                    this.facCovPar[i][j] = new DoublePolynomial(facCovPar[i][j]);
            this.facCovVal = facCovVal; 

            this.facMeanPar = new DoublePolynomial[facMeanPar.length];
            for (int i=0; i<facMeanPar.length; i++)
                this.facMeanPar[i] = new DoublePolynomial(facMeanPar[i]);
            this.facMeanVal = facMeanVal; 

            this.errPar = new DoublePolynomial[errPar.length];
            for (int i=0; i<errPar.length; i++)
                this.errPar[i] = new DoublePolynomial(errPar[i]);
            this.errVal = errVal; 

            anzFac = structureVal[0].length;
            anzVar = structureVal.length;
            
            int maxPar = maxParNumber();
            anzPar = maxPar+1;
            
            anzPer = 0; data = new double[0][];
            
            fisherInformationMatrix = new double[anzPar][anzPar];
        }

      public GeneralModel(GeneralModel toCopy)
      {
          anzFac = toCopy.anzFac;
          anzVar = toCopy.anzVar;
          anzPar = toCopy.anzPar;
          anzPer = toCopy.anzPer;
    
          structurePar = new DoublePolynomial[toCopy.structurePar.length][toCopy.structurePar[0].length];
          for (int i=0; i<structurePar.length; i++) for (int j=0; j<structurePar[i].length; j++) 
              structurePar[i][j] = new DoublePolynomial(toCopy.structurePar[i][j]);
          structureVal = Statik.copy(toCopy.structureVal);
          facCovVal = Statik.copy(toCopy.facCovVal);
          facCovPar = new DoublePolynomial[toCopy.facCovPar.length][toCopy.facCovPar[0].length];
          for (int i=0; i<facCovPar.length; i++) for (int j=0; j<facCovPar[i].length; j++) 
              facCovPar[i][j] = new DoublePolynomial(toCopy.facCovPar[i][j]);
          facMeanVal = Statik.copy(toCopy.facMeanVal);
          facMeanPar = new DoublePolynomial[toCopy.facMeanPar.length];
          for (int i=0; i<facMeanPar.length; i++)  
              facMeanPar[i] = new DoublePolynomial(toCopy.facMeanPar[i]);
          errVal = Statik.copy(toCopy.errVal);
          errPar = new DoublePolynomial[toCopy.errPar.length];
          for (int i=0; i<errPar.length; i++)  
              errPar[i] = new DoublePolynomial(toCopy.errPar[i]);

          data = Statik.copy(toCopy.data);
          computeMoments();
          fisherInformationMatrix = new double[anzPar][anzPar];
      }
      
      public int maxParNumber()
      {
          int erg = NOPARAMETER;
          for (int i=0; i<structurePar.length; i++)
              for (int j=0; j<structurePar[i].length; j++) erg = Math.max(structurePar[i][j].maxParNumber(), erg);
          for (int i=0; i<facCovPar.length; i++)
              for (int j=0; j<facCovPar[i].length; j++) erg = Math.max(facCovPar[i][j].maxParNumber(), erg);
          for (int i=0; i<facMeanPar.length; i++) erg = Math.max(facMeanPar[i].maxParNumber(), erg);
          for (int i=0; i<errPar.length; i++) erg = Math.max(errPar[i].maxParNumber(), erg);
          return erg;
      }
    
    public int getAnzFac() {
        return anzFac;
    }
    public int getAnzPar() {
        return anzPar;
    }
    public int getAnzVar() {
        return anzVar;
    }

    public void applyParameterValues(double[] vals)
    {
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzFac; j++)
                structureVal[i][j] = structurePar[i][j].evaluate(vals);
        for (int i=0; i<anzFac; i++) 
            facMeanVal[i] = facMeanPar[i].evaluate(vals);
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                facCovVal[i][j] = facCovPar[i][j].evaluate(vals);
        for (int i=0; i<anzVar; i++)
            errVal[i] = errPar[i].evaluate(vals);
    }
    
    public void applyToDerivatives(double[] vals)
    {
        applyParameterValues(vals);
        
        if ((facCovDev==null) || (facCovDev.length!=anzPar) || (facCovDev[0].length!=anzFac) || (facCovDev[0][0].length!=anzFac)) facCovDev = new double[anzPar][anzFac][anzFac];
        if ((facCovDevDev==null) || (facCovDevDev.length!=anzPar) || (facCovDevDev[0].length!=anzPar) || (facCovDevDev[0][0].length!=anzFac) || (facCovDevDev[0][0][0].length!=anzFac)) facCovDevDev = new double[anzPar][anzPar][anzFac][anzFac];
        if ((meanDev==null) || (meanDev.length!=anzPar) || (meanDev[0].length!=anzFac)) meanDev = new double[anzPar][anzFac];
        if ((meanDevDev==null) || (meanDevDev.length!=anzPar) ||  (meanDevDev[0].length!=anzPar) || (meanDevDev[0][0].length!=anzFac)) meanDevDev = new double[anzPar][anzPar][anzFac];
        if ((sigmaDev==null) || (sigmaDev.length!=anzPar) || (sigmaDev[0].length!=anzVar) || (sigmaDev[0][0].length!=anzVar)) sigmaDev = new double[anzPar][anzVar][anzVar];
        if ((sigmaDevDev==null) || (sigmaDevDev.length!=anzPar) || (sigmaDevDev[0].length!=anzPar) || (sigmaDevDev[0][0].length!=anzVar) || (sigmaDevDev[0][0][0].length!=anzVar)) sigmaDevDev = new double[anzPar][anzPar][anzVar][anzVar];
        if ((muDev==null) || (muDev.length!=anzPar) || (muDev[0].length!=anzVar)) muDev = new double[anzPar][anzVar];
        if ((muDevDev==null) || (muDevDev.length!=anzPar) ||  (muDevDev[0].length!=anzPar) || (muDevDev[0][0].length!=anzVar)) muDevDev = new double[anzPar][anzPar][anzVar];
        if ((structDev==null) || (structDev.length!=anzPar) || (structDev[0].length!=anzVar) || (structDev[0][0].length!=anzFac)) structDev = new double[anzPar][anzVar][anzFac];
        if ((structDevDev==null) || (structDevDev.length!=anzPar) || (structDevDev[0].length!=anzPar) || (structDevDev[0][0].length!=anzVar) || (structDevDev[0][0][0].length!=anzFac)) facCovDevDev = new double[anzPar][anzPar][anzVar][anzFac];
        if ((structureWork==null) || (structureWork.length!=anzVar) || (structureWork[0].length != anzFac)) structureWork = new double[anzVar][anzFac];
        if ((structureTransWork==null) || (structureTransWork.length!=anzFac) || (structureTransWork[0].length != anzPar)) structureTransWork = new double[anzFac][anzVar];
        if ((muWork==null) || (muWork.length!=anzVar)) muWork = new double[anzVar];

        for (int i=0; i<anzPar; i++)
        {
            for (int k=0; k<anzFac; k++) 
                for (int l=0; l<anzFac; l++) facCovDev[i][k][l] = facCovPar[k][l].evaluate(vals, i);
            for (int k=0; k<anzVar; k++)
                for (int l=0; l<anzFac; l++) structDev[i][k][l] = structurePar[k][l].evaluate(vals, i);
            for (int k=0; k<anzFac; k++)
                meanDev[i][k] = facMeanPar[k].evaluate(vals, i);
            
            Statik.multiply(structDev[i],facMeanVal, muWork);
            Statik.multiply(structureVal,meanDev[i], muDev[i]);
            Statik.add(muWork, muDev[i], muDev[i]);
            
            Statik.transpose(structureVal, structureTransWork);
            Statik.multiply(structDev[i], facCovVal, structureWork);
            Statik.multiply(structureWork, structureTransWork, sigmaWork);
            Statik.multiply(2.0, sigmaWork, sigmaWork);
            Statik.multiply(structureVal, facCovDev[i], structureWork);
            Statik.multiply(structureWork, structureTransWork, sigmaDev[i]);
            Statik.add(sigmaWork, sigmaDev[i], sigmaDev[i]);
        }
        
        for (int i=0; i<anzPar; i++)
            for (int j=0; j<anzPar; j++)
            {
                for (int k=0; k<anzFac; k++) 
                    for (int l=0; l<anzFac; l++) facCovDevDev[i][j][k][l] = facCovPar[k][l].evaluate(vals, i,j);
                for (int k=0; k<anzVar; k++)
                    for (int l=0; l<anzFac; l++) structDevDev[i][j][k][l] = structurePar[k][l].evaluate(vals, i,j);
                for (int k=0; k<anzFac; k++)
                    meanDevDev[i][j][k] = facMeanPar[i].evaluate(vals, i,j);
                
                Statik.multiply(structDevDev[i][j], facMeanVal, muDevDev[i][j]);
                Statik.multiply(structDev[i], meanDev[j], muWork); Statik.add(muDevDev[i][j], muWork, muDevDev[i][j]);
                Statik.multiply(structDev[j], meanDev[i], muWork); Statik.add(muDevDev[i][j], muWork, muDevDev[i][j]);
                Statik.multiply(structureVal, meanDevDev[i][j], muWork); Statik.add(muDevDev[i][j], muWork, muDevDev[i][j]);
                
                Statik.transpose(structureVal, structureTransWork);
                Statik.multiply(structDevDev[i][j], facCovVal, structureWork); Statik.multiply(structureWork, structureTransWork, sigmaDevDev[i][j]);
                Statik.multiply(structDev[i], facCovDev[j], structureWork); Statik.multiply(structureWork, structureTransWork, sigmaWork); Statik.add(sigmaDevDev[i][j], sigmaWork, sigmaDevDev[i][j]);
                Statik.multiply(structDev[j], facCovDev[i], structureWork); Statik.multiply(structureWork, structureTransWork, sigmaWork); Statik.add(sigmaDevDev[i][j], sigmaWork, sigmaDevDev[i][j]);
                Statik.transpose(structDev[j], structureTransWork);
                Statik.multiply(structDev[i], facCovVal, structureWork); Statik.multiply(structureWork, structureTransWork, sigmaWork); Statik.add(sigmaDevDev[i][j], sigmaWork, sigmaDevDev[i][j]);
                Statik.multiply(2.0, sigmaDevDev[i][j]);
                Statik.transpose(structureVal, structureTransWork);
                Statik.multiply(structureVal, facCovDevDev[i][j], structureWork); Statik.multiply(structureWork, structureTransWork, sigmaWork); Statik.add(sigmaDevDev[i][j], sigmaWork, sigmaDevDev[i][j]);
            }
    }

    public void setData(double[][] data)
    {
        this.data = data;
        this.anzPer = data.length;
        computeMoments();
    }
    
    public void computeMoments()
    {
        if (data==null) return;
        xsum = new double[anzVar];
        dataMean = new double[anzVar];
		for (int i=0; i<anzVar; i++) xsum[i] = 0.0;
		for (int i=0; i<anzPer; i++)
			for (int j=0; j<anzVar; j++) xsum[j] += data[i][j];
		for (int i=0; i<anzVar; i++) dataMean[i] = xsum[i] / (double)anzPer;
			
		xBiSum = new double[anzVar][anzVar];
		dataCov = new double[anzVar][anzVar];
		for (int i=0; i<anzVar; i++)
			for (int j=0; j<=i; j++)
			{
				xBiSum[i][j] = 0.0;
				for (int k=0; k<anzPer; k++) xBiSum[i][j] += data[k][i] * data[k][j];
				for (int k=0; k<anzPer; k++) dataCov[i][j] += (data[k][i]-dataMean[i]) * (data[k][j]-dataMean[j]);
				xBiSum[j][i] = xBiSum[i][j];
				dataCov[i][j] /= (double)anzPer;
				dataCov[j][i] = dataCov[i][j];
			}
    }

    public static GeneralModel fixParameter(GeneralModel in, int nr, double value) {GeneralModel erg = new GeneralModel(in); erg.fixParameter(nr,value); return erg;}
    public void fixParameter(int nr, double value)
    {
        anzPar--;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzFac; j++)
                structurePar[i][j].fixParameter(nr, value);
        for (int i=0; i<anzFac; i++) 
            facMeanPar[i].fixParameter(nr, value);
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                facCovPar[i][j].fixParameter(nr, value);
        for (int i=0; i<anzVar; i++)
            errPar[i].fixParameter(nr, value);
    }

    public static GeneralModel pickDatapoints(GeneralModel in, int[] picked) {GeneralModel erg = new GeneralModel(in); erg.pickDatapoints(picked); return erg;}
    public void pickDatapoints(int[] picked)
    {
        anzVar = picked.length;
        if (anzPer > 0) 
            for (int i=0; i<anzPer; i++) data[i] = Statik.subvector(data[i], picked);

        structureVal = Statik.submatrix(structureVal, picked);
        DoublePolynomial[][] nstruct = new DoublePolynomial[anzVar][anzFac];
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzFac; j++) nstruct[i][j] = structurePar[picked[i]][j];
        structurePar = nstruct;
        
        errVal = Statik.subvector(errVal, picked);
        DoublePolynomial[] nerr = new DoublePolynomial[anzVar];
        for (int i=0; i<anzVar; i++) 
            nerr[i] = errPar[picked[i]];
        errPar = nerr;
    }
    
    public double[][] createData (int anzPersons) {return createData(anzPersons, facCovVal, facMeanVal, structureVal, errVal);}
    public double[][] createData (int anzPersons, double[][] covMatrix, double[] muVector, double[][] structureMatrix, double[] error)
    {
        this.anzPer = anzPersons;
        int anzVar = structureMatrix.length;
        int anzFac = muVector.length;
        double[][] cholesky = Statik.choleskyDecompose(covMatrix);

        data = new double[anzPersons][anzVar];
        double[][] structureChol = Statik.multiply(structureMatrix,cholesky);
        double[] structureMu   = Statik.multiply(structureMatrix,muVector);

        double[] m = new double[anzFac];
        double[] sm = new double[anzVar];
        for (int i=0; i<anzPersons; i++)
        {
            for (int j=0; j<anzFac; j++) m[j] = SimpleLGM.rand.nextGaussian();
            Statik.multiply(structureChol,m,sm); Statik.add(sm,structureMu,sm);
            for (int j=0; j<anzVar; j++) data[i][j] = sm[j] + SimpleLGM.rand.nextGaussian()*Math.sqrt(error[j]);
        }
        computeMoments();
        return data;
    }
    
    public double[][] evaluateSigma() {return evaluateSigma(null);}
    public void evaluateSigmaErgGiven(double[][] erg) {evaluateSigma(null, erg);}
    public double[][] evaluateSigma(double[] values) {double[][] erg = new double[anzVar][anzVar]; evaluateSigma(values, erg); return erg;}
    public void evaluateSigma(double[] values, double[][] erg)
    {
        if (values != null) applyParameterValues(values);
        if ((structureWork==null) || (structureWork.length!=anzVar) || (structureWork[0].length != anzFac)) structureWork = new double[anzVar][anzFac];
        if ((structureTransWork==null) || (structureTransWork.length!=anzFac) || (structureTransWork[0].length != anzPar)) structureTransWork = new double[anzFac][anzVar];
        Statik.multiply(structureVal, facCovVal, structureWork);
        Statik.transpose(structureVal, structureTransWork);
        Statik.multiply(structureWork, structureTransWork, erg);
        
        for (int i=0; i<anzVar; i++) 
            erg[i][i] += errVal[i];
    }

    public double[] evaluateMu() {return evaluateMu(null);}
    public void evaluateMuErgGiven(double[] erg) {evaluateMu(null, erg);}
    public double[] evaluateMu(double[] values) {double[] erg = new double[anzVar]; evaluateMu(values, erg); return erg;}
    public void evaluateMu(double[] values, double[] erg)
    {
        if (values == null) applyParameterValues(values);
        for (int i=0; i<anzVar; i++)
        {
            double zwerg = 0;
            for (int j=0; j<anzFac; j++) zwerg += structureVal[i][j]*facMeanVal[i];
            erg[i] = zwerg;                
        }
    }
    
/*
    public double[][][] evaluateSigmaDev()
    {
        double[][][] erg = new double[anzPar][anzVar][anzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
                for (int k=0; k<anzFac; k++)
                    for (int l=0; l<anzFac; l++)
                        if (facCovPar[k][l]!=NOPARAMETER) erg[facCovPar[k][l]][i][j] += structure[i][k]*structure[j][l];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]!=NOPARAMETER) erg[errPar[i]][i][i] += 1;
        return erg;
    }
    
    public double[][] evaluateMuDev()
    {
        double[][] erg = new double[anzPar][anzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzFac; j++)
                if (facMeanPar[j]!=NOPARAMETER) erg[facMeanPar[j]][i] += structure[i][j];
        return erg;
    }
  */
    
    public boolean factorPositiveDefinite(double[] values)
    {
        applyParameterValues(values);
        return (Statik.determinantOfPositiveDefiniteMatrix(facCovVal) != -1); 
    }
    
    public double euclididanDistance(double[] values)
    {
        double[][] sigma = evaluateSigma(values);
        double[] mu = evaluateMu();
        double erg = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) erg += (sigma[i][j] - dataCov[i][j])*(sigma[i][j] - dataCov[i][j]);
        for (int i=0; i<anzVar; i++) erg += (mu[i] - dataMean[i])*(mu[i] - dataMean[i]);
        return erg;
    }
    
    /*
    public double[] leastSquareAproximation() 
    {
        return null;
    }
    */
    
    /*
    public double sigmaSquaredError(double[] values)
    {
        double[][] sigma = evaluateSigma(values);
        double error = 0;
        for (int i=0; i<dataCov.length; i++)
            for (int j=0; j<dataCov[i].length; j++) error += (sigma[i][j]-dataCov[i][j])*(sigma[i][j]-dataCov[i][j]);
        return error;
    }
    */
    
    /*
                   FISHER INFORMATION / WALD TEST 
      
    public boolean significantlyDifferent(int parameter, double value, double compare)
    {
        double[][] fisherInv = Statik.invert(fisherInformationMatrix);
        double v = Math.abs(value-compare) / Math.sqrt(fisherInv[parameter][parameter]);
        return (v > 1.645);
    }
    
    public void computeFisher(){computeFisher(getParameters());}
    public void computeFisher(double[] xd)
    {
		double[][][] sigmaDev = evaluateSigmaDev();
		double[][] muDev = evaluateMuDev();
		double[][] sigD = evaluateSigma(xd);
		double[][] sigMInvD = new double[anzVar][anzVar];
		double[][] mat1 = new double[anzVar][anzVar];	// Arbeitsplatz fr Matrixinvertierung
		double[][][] sigMInvSigDevD = new double[anzPar-anzMeanPar][anzVar][anzVar];
		double[][][] sigMInvSigDevDSigMInv = new double[anzPar-anzMeanPar][anzVar][anzVar];

		Statik.invert(sigD, sigMInvD, mat1);
		for (int i=anzMeanPar; i<anzPar; i++)
		{
			Statik.multiply(sigMInvD, sigmaDev[i], sigMInvSigDevD[i-anzMeanPar]);
			Statik.multiply(sigMInvSigDevD[i-anzMeanPar], sigMInvD, sigMInvSigDevDSigMInv[i-anzMeanPar]);
		}
		// Aufbau der Jacobi-Matrix, zunchst Mittelwert - Mittelwert
		for (int i=0; i<anzMeanPar; i++)
			for (int j=i; j<anzMeanPar; j++)
			{
				double sum = 0.0;
				for (int k=0; k<anzVar; k++)
					for (int l=0; l<anzVar; l++)
						sum += sigMInvD[k][l] * muDev[i][k] * muDev[j][l];
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = 2*anzPer*sum; 
			}
		// jetzt Mittelwert - Varianz
		for (int i=0; i<anzMeanPar; i++)
			for (int j=anzMeanPar; j<anzPar; j++)
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = 0.0; 
		// und jetzt Varianz - Varianz
		for (int i=anzMeanPar; i<anzPar; i++)
			for (int j=i; j<anzPar; j++)
			{
				Statik.multiply(sigMInvSigDevD[i-anzMeanPar],sigMInvSigDevD[j-anzMeanPar], mat1);

				double spur = 0.0;
				for (int k=0; k<anzVar; k++) spur += mat1[k][k];
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = (double)anzPer * spur / 2.0; 
			}
    }
    */
    
    public static void main(String args[])
    {
    }
    
}
