/*
 * Created on 26.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;
import java.util.Comparator;
import java.util.TreeSet;
import java.util.Vector;

import silvers.Statik;


/**
 * @author timo
 * 
 * TODO LinearModel is not yet derived from Model
 */
public class LinearModel
{
    static int NOPARAMETER = -1;
//    static Random rand = new Random();
    
    int anzFac;
    int anzPar;
    int anzMeanPar;
    int anzErrPar;
    int anzVarPar;
    int anzVar;
    
    double[][] structure;
    int[][] facCovPar;
    double[][] facCovVal, facCovValWork;
    int[] facMeanPar;
    double[] facMeanVal;
    int[] errPar;
    double[] errVal;
    
    int anzPer;
    double[][] data;
    double[] dataMean;
    double[] xsum;
    double[][] dataCov;
    double[][] xBiSum;
    
    public double[][] fisherInformationMatrix;
    
    public double lastMinusTwoLL;

    public LinearModel(double[][] structure, int[][] facCovPar, double[][] facCovVal, int[] facMeanPar,
            double[] facMeanVal, int[] errPar, double[] errVal)
    {
        this.structure = structure; this.facCovPar = facCovPar; this.facCovVal = facCovVal; 
        this.facMeanPar = facMeanPar; this.facMeanVal = facMeanVal; this.errPar = errPar; this.errVal = errVal;
        
        anzFac = structure[0].length;
		anzVar = structure.length;
		this.facCovValWork = new double[anzFac][anzFac];
		
		int maxPar = NOPARAMETER;
		for (int i=0; i<anzFac; i++) maxPar = Math.max(maxPar, facMeanPar[i]);
		anzMeanPar = maxPar+1;
		for (int i=0; i<anzFac; i++)
		    for (int j=0; j<anzFac; j++) maxPar = Math.max(maxPar, facCovPar[i][j]);
		anzVarPar = (maxPar - anzMeanPar)+1;
		for (int i=0; i<anzVar; i++) maxPar = Math.max(maxPar, errPar[i]);
		anzErrPar = (maxPar - anzVarPar - anzMeanPar)+1;
		anzPar = maxPar+1;
		
		anzPer = 0; data = new double[0][];
		
		fisherInformationMatrix = new double[anzPar][anzPar];
    }
    public LinearModel(double[][] structure)
    {
        this.structure = structure;
        anzFac = structure[0].length;
        anzVar = structure.length;
        
        anzPar = 0;
        facMeanVal = new double[anzFac]; facMeanPar = new int[anzFac]; for (int i=0; i<anzFac; i++) facMeanPar[i] = anzPar++;
        anzMeanPar = anzPar;
        facCovVal = new double[anzFac][anzFac]; this.facCovValWork = new double[anzFac][anzFac]; facCovPar = new int[anzFac][anzFac];
        for (int i=0; i<anzFac; i++) facCovPar[i][i] = anzPar++;
        for (int i=0; i<anzFac; i++) for (int j=0; j<i; j++) facCovPar[i][j] = facCovPar[j][i] = anzPar++;
        errVal = new double[anzVar]; errPar = new int[anzVar];
        anzVarPar = anzPar - anzMeanPar;
        for (int i=0; i<anzVar; i++) errPar[i] = anzPar;
        anzPar++; anzErrPar = 1;
		anzPer = 0; data = new double[0][];
		fisherInformationMatrix = new double[anzPar][anzPar];
    }
    public LinearModel(double[][] structure, double[][] facCovVal, double[] facMeanVal, double[] errVal)
    {
        this(structure);
        this.facCovVal = facCovVal; this.facMeanVal = facMeanVal; this.errVal = errVal;
    }
    public LinearModel(LinearModel toCopy)
    {
        anzFac = toCopy.anzFac;
        anzVar = toCopy.anzVar;
        anzPar = toCopy.anzPar;
        anzMeanPar = toCopy.anzMeanPar;
        anzVarPar = toCopy.anzVarPar;
        anzErrPar = toCopy.anzErrPar;
        anzPer = toCopy.anzPer;

        structure = Statik.copy(toCopy.structure);
        facMeanVal = Statik.copy(toCopy.facMeanVal);
        facMeanPar = Statik.copy(toCopy.facMeanPar);
        facCovVal = Statik.copy(toCopy.facCovVal);
        facCovValWork = Statik.copy(toCopy.facCovValWork);
        facCovPar = Statik.copy(toCopy.facCovPar);
        errVal = Statik.copy(toCopy.errVal);
        errPar = Statik.copy(toCopy.errPar);
		data = (toCopy.data==null?null:Statik.copy(toCopy.data));
		computeMoments();
		fisherInformationMatrix = new double[anzPar][anzPar];
    }
    
    /**
     * Computes the power for a simple two-latent-two-indicator model with middle edge weight x and errors err1 and err2.
     * 
     * @param var1		Real Variance of first latent
     * @param covar		Real Covariance of first to second latent
     * @param var2		Real Variance of second latent
     * @param var1Alt	Alternative Variance of first latent
     * @param covarAlt	Alternative Covariance of first to second latent
     * @param var2Alt	Alternative Variance of second latent
     * @param ADedge	Edge from first latent to second indicator
     * @param err1		Error Variance of first indicator
     * @param err2		Error Variance of second indicator
     * @param threshold	Threshold of significance
     */
    
    public static double powerOfTwoLatentTwoIndicator(double var1, double covar, double var2, double var1Alt, double covarAlt, double var2Alt, double ADedge, double err1, double err2, int N, double threshold, int additionalDF)
    {
        double s11 = var1+err1, s11Alt = var1Alt + err1;
        double s12 = ADedge*var1 + covar, s12Alt = ADedge*var1Alt+covarAlt;
        double s22 = ADedge*s12 + ADedge*covar + var2 + err2, s22Alt = ADedge*s12Alt + ADedge*covarAlt + var2Alt + err2;
        double det = s11*s22-s12*s12, detAlt = s11Alt*s22Alt - s12Alt*s12Alt;
        double c11 = Math.sqrt(s11), c11Alt = Math.sqrt(s11Alt);
        double c12 = s12 / c11, c12Alt = s12Alt / c11Alt;
        double c22 = Math.sqrt(det)/c11, c22Alt = Math.sqrt(detAlt)/c11Alt;
        
        double a = (-c11*c11*s22Alt+2*c12*c11*s12Alt-c12*c12*s11Alt)/detAlt+(c11*c11*s22-2*c11*c12*s12+c12*c12*s11)/det;
        double b = 2*c22*((c11*s12Alt - c12*s11Alt)/detAlt + (c12*s11 - c11*s12)/det );
        double c = c22*c22*(s11/det-s11Alt/detAlt);
        double d = Math.log(det/detAlt);
        
        System.out.println("a = "+a+", b = "+b+", c = "+c+", d = "+d);
        System.out.println("theoretical mean="+(-a-c-d)*N);
        
        double erg = 1.0-Statik.generalMultiDegreeTwoNormalDensity(-a,-b,-c,-d,N,threshold,0.01,additionalDF);
//        double erg = Statik.generalMultiDegreeTwoNormalDensityNumerical(-a,-b,-c,-d,N,10000,threshold);
        return erg;
    }
    
    /**
     * Converts a two-latent-many-indicator model to a two-latent-two-indicator model. Ignores all entries of eta, nu and errCovMat after andInd.
     * Destroys this arguments in the process. 
     * 
     * @param anzInd	Number of Indicators (all entries after this one ignored)
     * @param eta		Weights from first latent to indicators
     * @param nu		Weights from second latent to indicators
     * @param chol		Error Cholesky Matrix 
     * @return			three doubles as array: first error, second error, weight from first latent to second indicator. 
     */
    private static double[] convertTwoLatentToTwoLatentTwoIndicator(int anzInd, double[] eta, double[] nu, double[][] chol)
    {
        double t;
        int nuZero = -1;
        for (int i=0; i<anzInd; i++) if (nu[i]==0.0) nuZero = i;
        if (nuZero!=-1) 
        {
            t = nu[nuZero]; nu[nuZero] = nu[0]; nu[0] = t; 
            t = eta[nuZero]; eta[nuZero] = eta[0]; eta[0] = t;
            for (int i=0; i<anzInd; i++) {t = chol[nuZero][i]; chol[nuZero][i] = chol[0][i]; chol[0][i] = t;}
            for (int i=0; i<anzInd; i++) {t = chol[i][nuZero]; chol[i][nuZero] = chol[i][0]; chol[i][0] = t;}
        } else {
            eta[0] = eta[0] - eta[1] * nu[0]/nu[1];
            for (int i=0; i<anzInd; i++) chol[0][i] = chol[0][i] - chol[1][i] * nu[0]/nu[1];            
            nu[0] = 0; 
        }
        Statik.choleskyDecompose(Statik.multiply(chol,Statik.transpose(chol)),chol);
        chol[0][0] = chol[0][0] / eta[0];
        eta[0] = 1;
        // If all right, we should power equivalently have transformed the model such that nu[0] is zero and eta[0] = 1.
        
        if (chol[0][0]!=0.0)
        {
            for (int i=1; i<anzInd; i++)
            {
                double fak = chol[i][0] / chol[0][0];
                nu[i] = nu[i] - fak * nu[0];
                eta[i] = eta[i] - fak * eta[0];
                for (int j=0; j<anzInd; j++) chol[i][j] = chol[i][j] - fak * chol[0][j];
            }
        }
        // Now, all edges from the first error node to all inidicators but the first should be eliminated.
        if (anzInd == 2)
        {
            double e1 = chol[0][0]*chol[0][0];
            double e2 = chol[1][1]*chol[1][1]/(nu[1]*nu[1]);
            double x  = eta[1]/nu[1];
            return new double[]{e1,e2,x};
        } else {
            Statik.choleskyDecompose(Statik.multiply(chol,Statik.transpose(chol)),chol);
            double[] etadot = new double[anzInd-1]; for (int i=0; i<anzInd-1; i++) etadot[i] = eta[i+1];
            double[] nudot = new double[anzInd-1]; for (int i=0; i<anzInd-1; i++) nudot[i] = nu[i+1];
            double[][] choldot = new double[anzInd-1][anzInd-1];
            for (int i=0; i<anzInd-1; i++)
                for (int j=0; j<anzInd-1; j++) choldot[i][j] = chol[i+1][j+1];
            double[] zwerg = convertTwoLatentToTwoLatentTwoIndicator(anzInd-1,etadot,nudot,choldot);
            zwerg[0] = chol[0][0]*chol[0][0]*zwerg[0]/(chol[0][0]*chol[0][0]+zwerg[0]);
            return zwerg;
        }        
    }
    // Assumes a simple one-variable LGCM
    private LinearModel convertTwoLatentToTwoLatentTwoIndicator()
    {
        double[] eta = new double[anzVar], nu = new double[anzVar]; double[][] chol = new double[anzVar][anzVar];  
        for (int i=0; i<anzVar; i++) {eta[i] = structure[i][0]; nu[i] = structure[i][1]; chol[i][i] = Math.sqrt(errVal[i]);}
        double[] zwerg = convertTwoLatentToTwoLatentTwoIndicator(anzVar, eta, nu, chol);
        LinearModel erg = new LinearModel(new double[][]{{1,0},{zwerg[2],1}}, Statik.copy(facCovPar), Statik.copy(facCovVal), Statik.copy(facMeanPar),
        Statik.copy(facMeanVal), new int[]{-1,-1}, new double[]{zwerg[0],zwerg[1]});
        return erg;
    }
    
    /**
     * Computes the power for a simple two-latent-many-indicator model with edge weights lambda from first latent to indicators,
     * nu from second latent to indicator, errCovMat as covariance matrix of the errors and indCovMat and indCovMatAlt as 
     * the covariance matrices of the indicators and alternative, respectively.
     * 
     * @param anzInd	Number of indicators
     * @param eta		Weights from first latent to indicators
     * @param nu		Weiths from second latent ot indicators
     * @param errCovMat Error Covariance Matrix
     * @param indCovMat Indicator Covariance Matrix (true Model)
     * @param indCovMatAlt	Indicator Covariance Matrix (alternative Model)
     * @param threshold	significance threshold
     * @return			the probability to hit a -2ll difference higher than threshold with data from the true model.
     */
    public static double powerOfTwoLatent(int anzInd, double[] eta, double[] nu, double[][] errCovMat, double[][] indCovMat, double[][] indCovMatAlt, int N, double threshold, int df)
    {
        double[] zwerg = convertTwoLatentToTwoLatentTwoIndicator(anzInd, eta, nu, Statik.choleskyDecompose(errCovMat));
        return powerOfTwoLatentTwoIndicator(indCovMat[0][0],indCovMat[0][1],indCovMat[1][1],indCovMatAlt[0][0],indCovMatAlt[0][1],indCovMatAlt[1][1],zwerg[2],zwerg[0],zwerg[1],N,threshold,df);
    }
    
    /**
     * ASSUMES identical error in all observations.
     * 
     * Computes a matrix erg such that erg &* struct is upper right and the error structure is an identy matrix times sigma_err again.
     * 
     * @return
     */
    public double[][] computePowerEquivalenceTransformationMatrix()
    {
       double[][] erg = Statik.identityMatrix(anzVar);
       double[][] work = Statik.copy(structure);
       double[][] work2 = new double[anzVar][anzVar], work3 = new double[anzVar][anzVar];
       for (int i=0; i<anzFac; i++)
       {
           double piv = work[i][i];
           for (int j=0; j<anzFac; j++) {work[i][j] /= piv; erg[i][j] /= piv;}
           for (int j=i+1; j<anzVar; j++)
           {
               double lead = work[j][i];
               for (int k=0; k<anzFac; k++) {work[j][k] -= lead*work[i][k]; erg[j][k] -= lead*erg[i][k];} 
           }
       }
       for (int i=anzFac-1; i>=0; i--)
       {
           for (int j=i-1; j>=0; j--)
           {
               double lead = work[j][i];
               for (int k=0; k<anzFac; k++) {work[j][k] -= lead*work[i][k]; erg[j][k] -= lead*erg[i][k];}
           }
       }
       Statik.transpose(erg, work3);
       Statik.multiply(erg, work3, work2);
       Statik.transposeContradiagonal(work2,work2);
       Statik.transpose(work2,work2);       
       Statik.choleskyDecompose(work2, work3);
       Statik.transposeContradiagonal(work3,work3);
       Statik.transpose(work3, work3);
       
       for (int i=anzVar-1; i>=0; i--)
       {
           double piv = work3[i][i];
           for (int j=0; j<anzVar; j++) {work3[i][j] /= piv; erg[i][j] /= piv;}
           for (int j=i-1; j>=0; j--)
           {
               double lead = work3[j][i];
               for (int k=0; k<anzVar; k++) {work3[j][k] -= lead*work3[i][k]; erg[j][k] -= lead*erg[i][k];}
           }
       }
       
       return erg;
    }

    /**
     * ASSUMES same error parameter in all observations, and all covariance matrix parameters to be estimated.
     * 
     * Transforms the model into a minimal model and remaining error indicator. Then, the error and the covariance matrix are fit symbolically.
     * 
     * TODO: Call of estimate is still over SimpleLGM (to be changed, becomes deprecated)
     * TODO: Means are ignored.
     * 
     * @param initial
     * @return
     */
    public double[] estimateMLFullCovarianceSupportedByPowerEquivalence()
    {
        double[][] trans = computePowerEquivalenceTransformationMatrix();
        double[][] prod = Statik.multiply(trans,structure);
        double[][] interStruct = new double[anzFac][]; for (int i=0; i<anzFac; i++) interStruct[i] = prod[i];
        double[][] prod2ul = Statik.invert(interStruct);
        double[][] prod2 = Statik.identityMatrix(anzVar);
        for (int i=0; i<anzFac; i++) for (int j=0; j<anzFac; j++) prod2[i][j] = prod2ul[i][j];
        double[][] transnew = Statik.multiply(prod2, trans);
        double[][] transData = new double[anzPer][anzVar];
        
        double sqrsum = 0;
        for (int i=0; i<anzPer; i++) {
             transData[i] = Statik.multiply(transnew, data[i]);
             for (int j=anzFac; j<anzVar; j++) sqrsum += transData[i][j]*transData[i][j];
        }
        double errvar = sqrsum / (anzPer*(anzVar-anzFac));
        
        double[] mean = new double[anzFac];
        double[][] covD = new double[anzFac][anzFac];
        
        for (int i=0; i<anzPer; i++) 
            for (int j=0; j<anzFac; j++) mean[j] += transData[i][j];
        for (int i=0; i<anzFac; i++) mean[i] /= anzPer;
        for (int i=0; i<anzFac; i++) if (facMeanPar[i]==-1) mean[i] = facMeanVal[i];
        
        for (int i=0; i<anzPer; i++)
            for (int j=0; j<anzFac; j++)
                for (int k=0; k<anzFac; k++) covD[j][k] += (transData[i][j]-mean[j])*(transData[i][k]-mean[k]);
        
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) covD[i][j] /= (anzPer);
        
        double[][] work = Statik.transpose(prod2ul);
        for (int i=0; i<anzFac; i++) 
            for (int j=0; j<anzFac; j++) work[i][j] *= errvar;
        
        double[][] subtractMatrix = Statik.multiply(prod2ul, work);
        
        double[] erg = new double[anzPar];
        erg[errPar[0]] = errvar;
        for (int i=0; i<anzFac; i++) if (facMeanPar[i]!=-1) erg[facMeanPar[i]] = mean[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<=i; j++) if (facCovPar[i][j]!=-1) erg[facCovPar[i][j]] = covD[i][j] - subtractMatrix[i][j];
        
        lastMinusTwoLL = (new SimpleLGM()).twollEvaluate(this, erg);
        return erg;    
    }
    
    
    /**
     * ASSUMES same error parameter in all observations.
     * 
     * Transformts the model into a minimal model and remaining error indicator. Then, the error is fit and fixed in the remainder.
     * 
     * TODO: Call of estimate is still over SimpleLGM (to be changed, becomes deprecated)
     * TODO: Means are ignored.
     * 
     * @param initial
     * @return
     */
    public double[] estimateMLSupportedByPowerEquivalence(double[] initial)
    {
        double[][] trans = computePowerEquivalenceTransformationMatrix();
        double[][] prod = Statik.multiply(trans,structure);
        double[][] newStruct = new double[anzFac][]; for (int i=0; i<anzFac; i++) newStruct[i] = prod[i];
        LinearModel work = new LinearModel(this);
        work.anzVar = anzFac; work.structure = newStruct;
        double[] vec = new double[anzVar];
        double sqrsum = 0;
        for (int i=0; i<work.data.length; i++) {
            vec = Statik.multiply(trans, work.data[i]);
            for (int j=anzFac; j<anzVar; j++) sqrsum += vec[j]*vec[j];
            work.data[i] = new double[anzFac];
            for (int j=0; j<anzFac; j++) work.data[i][j] = vec[j];            
        }
        work.computeMoments();
        double errvar = sqrsum / (anzPer*(anzVar-anzFac)-1);
        work.fixParameter(errPar[0],errvar);
        
        SimpleLGM workhorse = new SimpleLGM();
        double[] init = new double[initial.length-1];
        int j=0;
        for (int i=0; i<init.length; i++) if (j!=errPar[0]) init[i] = initial[j++];
        double[] zwerg = workhorse.twollAproxLinearModel(work, init);
        double[] erg = new double[zwerg.length+1];
        j=0; 
        for (int i=0; i<erg.length; i++) if (i==errPar[0]) erg[i]=errvar; else erg[i] = zwerg[j++];
        lastMinusTwoLL = workhorse.twollEvaluate(this, erg);
        

        return erg;
    }
    
    private double[][] testBootstrapMLSupportedByPowerEquivalence(double[] initial)
    {
        double[][] trans = computePowerEquivalenceTransformationMatrix();
        double[][] prod = Statik.multiply(trans,structure);
        double[][] newStruct = new double[anzFac][]; for (int i=0; i<anzFac; i++) newStruct[i] = prod[i];
        LinearModel work = new LinearModel(this);
        work.anzVar = anzFac; work.structure = newStruct;
        double[][] fullDataTrans = new double[anzPer][anzVar];
        for (int i=0; i<work.data.length; i++) {
            fullDataTrans[i] = Statik.multiply(trans, work.data[i]);
            work.data[i] = new double[anzFac];
            for (int j=0; j<anzFac; j++) work.data[i][j] = fullDataTrans[i][j];            
        }
        work.computeMoments();
        work.fixParameter(errPar[0],0);
        SimpleLGM workhorse = new SimpleLGM();
        double[] init = new double[initial.length-1];
        int j=0;
        for (int i=0; i<init.length; i++) if (j!=errPar[0]) init[i] = initial[j++];
        
        int subN = 75;
        int N = anzPer;
        int trials = 100000;
        int[] nr = new int[N];
        
        long time0 = 0, time1 = 1;
        double[][] erg = new double[2][anzPar];
        double[][] mean = new double[2][anzPar];
        double[][] fullDataOrg = Statik.copy(data); data = new double[subN][]; anzPer = subN;
        double[][] fullDataTransCut = Statik.copy(work.data); work.data = new double[subN][]; work.anzPer = subN;
        java.util.Random rand = new java.util.Random();
        long time = System.currentTimeMillis();
        for (int rep=0; rep<trials; rep++)
        {
            for (int i=0; i<N; i++) nr[i] = i;
            Statik.shuffle(nr,rand);
            for (int i=0; i<subN; i++) {data[i] = fullDataOrg[nr[i]]; work.data[i] = fullDataTransCut[nr[i]];}
            computeMoments(); work.computeMoments();
            double sqrsum = 0;
            for (int i=0; i<work.data.length; i++)
                for (j=anzFac; j<anzVar; j++) sqrsum += fullDataTrans[nr[i]][j]*fullDataTrans[nr[i]][j];
            double errvar = sqrsum / (anzPer*(anzVar-anzFac)-1);
            for (int i=0; i<anzFac; i++) work.errVal[i] = errvar;

            double[] zwerg = workhorse.twollAproxLinearModel(work, init);
            j=0; 
            for (int i=0; i<anzPar; i++) {
                if (i==errPar[0]) {erg[0][i]+=errvar*errvar; mean[0][i] += errvar;} 
                else {erg[0][i] += zwerg[j]*zwerg[j]; mean[0][i] += zwerg[j];  j++;}
            }
            
//            time = System.currentTimeMillis();
//            zwerg = workhorse.twollAproxLinearModel(this, initial);
//            for (int i=0; i<anzPar; i++) {erg[1][i] += zwerg[i]*zwerg[i]; mean[1][i] += zwerg[i];}
//            time1 += (System.currentTimeMillis() - time);
        }
        time0 += (System.currentTimeMillis() - time);
        for (int i=0; i<anzPar; i++) for (int k=0; k<2; k++)
        {
            mean[k][i] /= (double)trials; erg[k][i] = Math.sqrt(erg[k][i]/(double)trials - mean[k][i]*mean[k][i]); 
        }
     
        System.out.println("Time Preprocessing(per trial) = "+(time0/(double)(1000*trials)));
        System.out.println("Time Preprocessing(total)     = "+(time0));
        System.out.println("Time Direct        = "+(time1/(double)(1000*trials)));
        return erg;
    }

    
    public int getAnzMeanPar() {return anzMeanPar;}
    public int getAnzErrPar() {
        return anzErrPar;
    }
    public int getAnzFac() {
        return anzFac;
    }
    public int getAnzPar() {
        return anzPar;
    }
    public int getAnzVar() {
        return anzVar;
    }
    public int getAnzVarPar() {
        return anzVarPar;
    }
    public void setParameterValue(int nr, double value)
    {
        for (int i=0; i<anzFac; i++) 
            if (facMeanPar[i]==nr) facMeanVal[i]=value;
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (facCovPar[i][j]==nr) facCovVal[i][j]=value;
        for (int i=0; i<anzVar; i++)
            if (errPar[i]==nr) errVal[i]=value;
    }
    public void setParameterValue(double[] vals)
    {
        for (int i=0; i<vals.length; i++) setParameterValue(i, vals[i]);
    }
    public void setParameterValueAccordingToOtherModel(LinearModel reference, int nr, double value)
    {
        for (int i=0; i<anzFac; i++) 
            if (reference.facMeanPar[i]==nr) facMeanVal[i]=value;
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (reference.facCovPar[i][j]==nr) facCovVal[i][j]=value;
        for (int i=0; i<anzVar; i++)
            if (reference.errPar[i]==nr) errVal[i]=value;
    }
    public void setParameterValueAccordingToOtherModel(LinearModel reference, int nr)
    {
        for (int i=0; i<anzFac; i++) 
            if (reference.facMeanPar[i]==nr) facMeanVal[i]=reference.facMeanVal[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (reference.facCovPar[i][j]==nr) facCovVal[i][j]=reference.facCovVal[i][j];
        for (int i=0; i<anzVar; i++)
            if (reference.errPar[i]==nr) errVal[i]=reference.errVal[i];
    }
    public void setData(double[][] data)
    {
        this.data = data;
        this.anzPer = data.length;
        computeMoments();
    }
    
    public double getParameterValue(int nr)
    {
        for (int i=0; i<anzFac; i++) 
            if (facMeanPar[i]==nr) return facMeanVal[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (facCovPar[i][j]==nr) return facCovVal[i][j];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]==nr) return errVal[i];
        throw new RuntimeException("Parameter "+nr+" existiert nicht.");
    }
    
    public double[] getParameters()
    {
        double[] erg = new double[anzPar];
        for (int i=0; i<anzFac; i++) 
            if (facMeanPar[i]!=NOPARAMETER) erg[facMeanPar[i]] = facMeanVal[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (facCovPar[i][j]!=NOPARAMETER) erg[facCovPar[i][j]] = facCovVal[i][j];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]!=NOPARAMETER) erg[errPar[i]] = errVal[i];
        return erg;
    }
    
    public double[] getNoMeanParameters()    
    {
        double[] erg = new double[anzVarPar+anzErrPar];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (facCovPar[i][j]!=NOPARAMETER) erg[facCovPar[i][j]-anzMeanPar] = facCovVal[i][j];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]!=NOPARAMETER) erg[errPar[i]-anzMeanPar] = errVal[i];
        return erg;
    }
    
    public void computeMoments()
    {
        if (data==null) return;
        xsum = new double[anzVar];
        dataMean = new double[anzVar];
		for (int i=0; i<anzVar; i++) xsum[i] = 0.0;
		for (int i=0; i<anzPer; i++)
			for (int j=0; j<anzVar; j++) xsum[j] += data[i][j];
		for (int i=0; i<anzVar; i++) dataMean[i] = xsum[i] / (double)anzPer;
			
		xBiSum = new double[anzVar][anzVar];
		dataCov = new double[anzVar][anzVar];
		for (int i=0; i<anzVar; i++)
			for (int j=0; j<=i; j++)
			{
				xBiSum[i][j] = 0.0;
				for (int k=0; k<anzPer; k++) xBiSum[i][j] += data[k][i] * data[k][j];
				for (int k=0; k<anzPer; k++) dataCov[i][j] += (data[k][i]-dataMean[i]) * (data[k][j]-dataMean[j]);
				xBiSum[j][i] = xBiSum[i][j];
				dataCov[i][j] /= (double)anzPer;
				dataCov[j][i] = dataCov[i][j];
			}
    }

    public static LinearModel fixParameter(LinearModel in, int nr) {LinearModel erg = new LinearModel(in); erg.fixParameter(nr); return erg;}
    public static LinearModel fixParameter(LinearModel in, int nr, double value) {LinearModel erg = new LinearModel(in); erg.fixParameter(nr,value); return erg;}
    public void fixParameter(int nr, double value) {setParameterValue(nr, value); fixParameter(nr);}
    public void fixParameter(int nr)
    {
        if (nr < anzMeanPar) anzMeanPar--;
        else if ((nr >= anzMeanPar ) && (nr < anzVarPar+anzMeanPar)) anzVarPar--;
        else if (nr >= anzVarPar+anzMeanPar) anzErrPar--;
        anzPar--;
        for (int i=0; i<anzFac; i++)
        {
            if (facMeanPar[i]>nr) facMeanPar[i]--;
            else if (facMeanPar[i]==nr) facMeanPar[i]=NOPARAMETER;
        }
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
            {
                if (facCovPar[i][j]>nr) facCovPar[i][j]--;
                else if (facCovPar[i][j]==nr) facCovPar[i][j] = NOPARAMETER;
            }
        for (int i=0; i<anzVar; i++)
        {
            if (errPar[i]>nr) errPar[i]--;
            else if (errPar[i]==nr) errPar[i] = NOPARAMETER;
        }
    }
    public static LinearModel picDatapoints(LinearModel in, int[] piced) {LinearModel erg = new LinearModel(in); erg.picDatapoints(piced); return erg;}
    public void picDatapoints(int[] piced)
    {
        anzVar = piced.length;
        if (anzPer > 0) 
            for (int i=0; i<anzPer; i++) data[i] = Statik.subvector(data[i], piced);

        structure = Statik.submatrix(structure, piced);
        errVal = Statik.subvector(errVal, piced);
        errPar = Statik.subvector(errPar, piced);
    }
    
    public static LinearModel createMulitpleIndicators(LinearModel in, int ind, double[] indVar, double[] indLambda) {LinearModel erg = new LinearModel(in); erg.createMulitpleIndicators(ind, indVar, indLambda); return erg;}
    public void createMulitpleIndicators(int ind, double[] indVar, double[] indLambda)
    {
        int nanzFac = anzFac + anzVar;
        int nanzPar = anzPar + 1;
        int nanzVarPar = anzVarPar +1;
        int nanzVar = anzVar * ind;
        int newPar = anzMeanPar + anzVarPar;
        
        double[][] nstructure = new double[nanzVar][nanzFac];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<ind; j++)
            {
                for (int k=0; k<anzFac; k++) nstructure[i*ind + j][k] = structure[i][k];
                for (int k=anzFac; k<nanzFac; k++) nstructure[i*ind + j][k] = 0;
                nstructure[i*ind + j][anzFac + i] = indLambda[j];
            }
        int[][] nfacCovPar = new int[nanzFac][nanzFac];
        double[][] nfacCovVal = new double[nanzFac][nanzFac];
        for (int i=0; i<anzFac; i++) 
        {
            for (int j=0; j<anzFac; j++) {nfacCovPar[i][j] = facCovPar[i][j]; nfacCovVal[i][j] = facCovVal[i][j];}
            for (int j=anzFac; j<nanzFac; j++) {nfacCovPar[i][j] = -1; nfacCovVal[i][j] = 0;} 
        }
        for (int i=anzFac; i<nanzFac; i++)
            for (int j=0; j<nanzFac; j++) {nfacCovPar[i][j] = (i==j?newPar:-1); nfacCovVal[i][j] = (i==j?indVar[(j-anzFac)%ind]:0);}
        
        int[] nfacMeanPar = new int[nanzFac]; double[] nfacMeanVal = new double[nanzFac];
        for (int i=0; i<nanzFac; i++)
        {
            nfacMeanPar[i] = (i<anzFac?facMeanPar[i]:-1);
            nfacMeanVal[i] = (i<anzFac?facMeanVal[i]:0);
        }
        
        int[] nerrPar = new int[nanzVar]; double[] nerrVal = new double[nanzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<ind; j++)
            {
                nerrPar[i*ind + j] = (errPar[i]==-1?-1:errPar[i]+1);
                nerrVal[i*ind + j] = errVal[i];
            }
        
        structure = nstructure;
        facCovPar = nfacCovPar;
        facCovVal = nfacCovVal;
        facMeanPar = nfacMeanPar;
        facMeanVal = nfacMeanVal;
        errPar = nerrPar;
        errVal = nerrVal;

        anzFac = nanzFac; anzPar = nanzPar; anzVarPar = nanzVarPar; anzVar = nanzVar;
		fisherInformationMatrix = new double[anzPar][anzPar];
    }
    
    
    public double[][] createData (int anzPersons) {return createData(anzPersons, facCovVal, facMeanVal, structure, errVal);}
    public double[][] createData (int anzPersons, double[][] covMatrix, double[] muVector, double[][] structureMatrix, double[] error)
    {
        this.anzPer = anzPersons;
        int anzVar = structureMatrix.length;
        int anzFac = muVector.length;
        double[][] cholesky = Statik.choleskyDecompose(covMatrix);
        data = new double[anzPersons][anzVar];
        double[][] structureChol = Statik.multiply(structureMatrix,cholesky);
        double[] structureMu   = Statik.multiply(structureMatrix,muVector);

        double[] m = new double[anzFac];
        double[] sm = new double[anzVar];
        for (int i=0; i<anzPersons; i++)
        {
            for (int j=0; j<anzFac; j++) m[j] = SimpleLGM.rand.nextGaussian();
            Statik.multiply(structureChol,m,sm); Statik.add(sm,structureMu,sm);
            for (int j=0; j<anzVar; j++) data[i][j] = sm[j] + SimpleLGM.rand.nextGaussian()*Math.sqrt(error[j]);
        }
        computeMoments();
        return data;
    }
    
    public double[][] evaluateSigma() {return evaluateSigma(getParameters());}
    public double[][] evaluateSigma(double[] position) {return evaluateSigma(position, false);}
    public double[][] evaluateSigma(double[] position, boolean noMeansGiven) {double[][] erg = new double[anzVar][anzVar]; evaluateSigma(position, erg, noMeansGiven); return erg;}
    public double[][] evaluateSigma(double[] position, double[][] erg) {evaluateSigma(position, erg, false); return erg;}
    public void evaluateSigma(double[] position, double[][] erg, boolean noMeansGiven)
    {
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
            {
                double zwerg = 0;
                for (int k=0; k<anzFac; k++)
                    for (int l=0; l<anzFac; l++) 
                        zwerg += structure[i][k]*structure[j][l]*(facCovPar[k][l]==NOPARAMETER?facCovVal[k][l]:position[facCovPar[k][l]-(noMeansGiven?anzMeanPar:0)]);
                erg[i][j] = zwerg;                
            }
        for (int i=0; i<anzVar; i++) 
            erg[i][i] += (errPar[i]==NOPARAMETER?errVal[i]:position[errPar[i]-(noMeansGiven?anzMeanPar:0)]);
    }

    public double[] evaluateMu(double[] position) {double[] erg = new double[anzVar]; evaluateMu(position, erg); return erg;}
    public void evaluateMu(double[] position, double[] erg)
    {
        for (int i=0; i<anzVar; i++)
        {
            double zwerg = 0;
            for (int j=0; j<anzFac; j++) zwerg += structure[i][j]*(facMeanPar[j]==NOPARAMETER?facMeanVal[j]:position[facMeanPar[j]]);
            erg[i] = zwerg;                
        }
    }
    
    public double[][] evaluateFactorMatrix(double[] position) {double[][] erg = new double[anzFac][anzFac]; evaluateFactorMatrix(position, erg); return erg;}
    public void evaluateFactorMatrix(double[] position, double[][] erg)
    {
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                erg[i][j] = (facCovPar[i][j]==NOPARAMETER?facCovVal[i][j]:position[facCovPar[i][j]]);
    }
    
    public double[][][] evaluateSigmaDev()
    {
        double[][][] erg = new double[anzPar][anzVar][anzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
                for (int k=0; k<anzFac; k++)
                    for (int l=0; l<anzFac; l++)
                        if (facCovPar[k][l]!=NOPARAMETER) erg[facCovPar[k][l]][i][j] += structure[i][k]*structure[j][l];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]!=NOPARAMETER) erg[errPar[i]][i][i] += 1;
        return erg;
    }
    
    public double[][] evaluateMuDev()
    {
        double[][] erg = new double[anzPar][anzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzFac; j++)
                if (facMeanPar[j]!=NOPARAMETER) erg[facMeanPar[j]][i] += structure[i][j];
        return erg;
    }
    
    public boolean  factorPositiveDefinite(double[] position) {return factorPositiveDefinite(position, false);}
    public boolean factorPositiveDefinite(double[] position, boolean noMeansGiven)
    {
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                facCovValWork[i][j] = (facCovPar[i][j]==NOPARAMETER?facCovVal[i][j]:position[facCovPar[i][j]-(noMeansGiven?anzMeanPar:0)]);
        return (Statik.determinantOfPositiveDefiniteMatrix(facCovValWork) != -1); 
    }
    
    public void raiseVarianceParameters(double[] position)
    {
        for (int i=0; i<anzFac; i++)
        	if (facCovPar[i][i]!=NOPARAMETER) position[facCovPar[i][i]] = Math.abs(position[facCovPar[i][i]]) + 10;
                
        for (int i=0; i<anzErrPar; i++)
            if (errPar[i] != NOPARAMETER) position[errPar[i]] = Math.abs(position[errPar[i]]) + 10;
    }
    
    public double evaluateLeastSquareIndex(double[][] observedCovariances, double[] observedMeans, double[] position)
    {
        double[][] sigma = evaluateSigma(position);
        double[] mu = evaluateMu(position);
        double erg = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) erg += (sigma[i][j] - observedCovariances[i][j])*(sigma[i][j] - observedCovariances[i][j]);
        for (int i=0; i<anzVar; i++) erg += (mu[i] - observedMeans[i])*(mu[i] - observedMeans[i]);
        return erg;
    }
    
    public double[] leastSquareAproxLinearModel() 
    {
        if (anzPar == 0) return new double[0];
        // initial vector set to (0,...,0) for easier computation

    	double[] fitDev1 = new double[anzMeanPar];
    	for (int i=0; i<anzMeanPar; i++) fitDev1[i] = 0.0;
    	double[][] fitJac1 = new double[anzMeanPar][anzMeanPar];
    	for (int i=0; i<anzMeanPar; i++)
    		for (int j=0; j<anzMeanPar; j++) fitJac1[i][j] = 0.0;

    	double[] fitDev2 = new double[anzVarPar + anzErrPar];
    	for (int i=0; i<anzVarPar + anzErrPar; i++) fitDev2[i] = 0.0;
    	double[][] fitJac2 = new double[anzVarPar + anzErrPar][anzVarPar + anzErrPar];
    	for (int i=0; i<anzVarPar + anzErrPar; i++)
    		for (int j=0; j<anzVarPar + anzErrPar; j++) fitJac2[i][j] = 0.0;

    	for (int i=0; i<anzVar; i++)
    	{
    	    double v = 0.0;
    	    for (int j=0; j<anzFac; j++) if (facMeanPar[j]==NOPARAMETER) v += structure[i][j] * facMeanVal[j]; 
    	    v -= dataMean[i]; v *= 2.0; 
    		for (int j=0; j<anzFac; j++)
    			if (facMeanPar[j]!=NOPARAMETER) fitDev1[facMeanPar[j]] += structure[i][j]*v;	// Ableitungen

    		for (int k=0; k<anzFac; k++)
    			for (int l=0; l<anzFac; l++)
    				if ((facMeanPar[k]!=NOPARAMETER) && (facMeanPar[l]!=NOPARAMETER)) 
    					fitJac1[facMeanPar[k]][facMeanPar[l]] += 2.0*structure[i][k]*structure[i][l];
    	}

    	for (int i=0; i<anzVar; i++)
    	{
    		for (int j=0; j<anzVar; j++)
    		{
    		    double v = 0.0; 
        	    for (int k=0; k<anzFac; k++) 
        	        for (int l=0; l<anzFac; l++)
        	            if (facCovPar[k][l]==NOPARAMETER) v += structure[i][k] * structure[j][l] * facCovVal[k][l];
        	    if ((i==j) && (errPar[i]==NOPARAMETER)) v += errVal[i];
    		    v -= dataCov[i][j]; v *= 2.0;
    		    
    			for (int k=0; k<anzFac; k++)
    			    for (int l=0; l<anzFac; l++)
    			        if (facCovPar[k][l]!=NOPARAMETER)
    			            fitDev2[facCovPar[k][l]-anzMeanPar] += structure[i][k] * structure[j][l] * v;	// Ableitungen
    			if ((i==j) && (errPar[i]!=NOPARAMETER)) fitDev2[errPar[i]-anzMeanPar] += v;
    			
    			for (int k=0; k<anzFac; k++)
    				for (int l=0; l<anzFac; l++)
    				    if (facCovPar[k][l]!=NOPARAMETER)
    		    			for (int k2=0; k2<anzFac; k2++)
    		    				for (int l2=0; l2<anzFac; l2++)
    		    				    if (facCovPar[k2][l2]!=NOPARAMETER) 
    		    				        fitJac2[facCovPar[k][l]-anzMeanPar][facCovPar[k2][l2]-anzMeanPar] += 2*structure[i][k]*structure[j][l]*structure[i][k2]*structure[j][l2];
    			if ((i==j) && (errPar[i]!=NOPARAMETER)) 
    			{
    			    for (int k=0; k<anzFac; k++)
    			        for (int l=0; l<anzFac; l++)
    			            if (facCovPar[k][l]!=NOPARAMETER) 
    			            {
    			                v = 2*structure[i][k]*structure[j][l];
    			                fitJac2[facCovPar[k][l]-anzMeanPar][errPar[i]-anzMeanPar] += v; fitJac2[errPar[i]-anzMeanPar][facCovPar[k][l]-anzMeanPar] += v;
    			            }
    			    fitJac2[errPar[i]-anzMeanPar][errPar[i]-anzMeanPar] += 2.0;
    			}
    		}
    	}
/*
    	final LinearModel fthis = this;
		DoubleFunction foo = new DoubleFunction(){
		    public double foo(double[] arg) {
				// Evaluation of Sigma
		        return fthis.sigmaSquaredError(arg);
		    }
		};
		double[] zero = new double[anzPar];
		double[][] numJacobian = Statik.numericalHessian(foo, zero, 0.001);
		System.out.println("Numerical Jacobian = \r\n"+Statik.matrixToString(numJacobian));
		double[] numGradient = Statik.numericalGradient(foo, zero, 0.001);
		System.out.println("Numerical Gradient = "+Statik.matrixToString(numGradient));
		
		System.out.println("Jacobian       = \r\n"+Statik.matrixToString(fitJac2));
		System.out.println("Gradient       = \r\n"+Statik.matrixToString(fitDev2));
 */   	
    	double[][] jinv1 = Statik.invert(fitJac1);
    	double[][] jinv2 = Statik.invert(fitJac2);

    	double[] erg = new double[anzPar];
    	for (int i=0; i<anzMeanPar; i++)
    		for (int j=0; j<anzMeanPar; j++) erg[i] -= jinv1[i][j]*fitDev1[j];
    		
    	for (int i=0; i<anzVarPar + anzErrPar; i++)
    		for (int j=0; j<anzVarPar + anzErrPar; j++) erg[i+anzMeanPar] -= jinv2[i][j]*fitDev2[j];

/*
    	double[][] theoSigma = null;
    	if (anzPar==6) theoSigma = evaluateSigma(new double[]{100,-20,100,50,0,1});
    	if (anzPar==5) theoSigma = evaluateSigma(new double[]{100,-20,100,50,1});
    	if (anzPar==3) theoSigma = evaluateSigma(new double[]{100,-20,1});
    	System.out.println(Statik.matrixToString(theoSigma));
    	System.out.println(Statik.matrixToString(observedCovariances));
    	System.out.println(Statik.matrixToString(erg));
*/    	
    	return erg;
    }
    
    public double sigmaSquaredError(double[] position)
    {
        double[][] sigma = evaluateSigma(position);
        double error = 0;
        for (int i=0; i<dataCov.length; i++)
            for (int j=0; j<dataCov[i].length; j++) error += (sigma[i][j]-dataCov[i][j])*(sigma[i][j]-dataCov[i][j]);
        return error;
    }
    
    public boolean significantlyDifferent(int parameter, double value, double compare)
    {
        double[][] fisherInv = Statik.invert(fisherInformationMatrix);
        double v = Math.abs(value-compare) / Math.sqrt(fisherInv[parameter][parameter]);
        return (v > 1.645);
    }
    
    public void computeFisher(){computeFisher(getParameters());}
    public void computeFisher(double[] xd)
    {
		double[][][] sigmaDev = evaluateSigmaDev();
		double[][] muDev = evaluateMuDev();
		double[][] sigD = evaluateSigma(xd);
		double[][] sigMInvD = new double[anzVar][anzVar];
		double[][] mat1 = new double[anzVar][anzVar];	// Arbeitsplatz fr Matrixinvertierung
		double[][][] sigMInvSigDevD = new double[anzPar-anzMeanPar][anzVar][anzVar];
		double[][][] sigMInvSigDevDSigMInv = new double[anzPar-anzMeanPar][anzVar][anzVar];

		Statik.invert(sigD, sigMInvD, mat1);
		for (int i=anzMeanPar; i<anzPar; i++)
		{
			Statik.multiply(sigMInvD, sigmaDev[i], sigMInvSigDevD[i-anzMeanPar]);
			Statik.multiply(sigMInvSigDevD[i-anzMeanPar], sigMInvD, sigMInvSigDevDSigMInv[i-anzMeanPar]);
		}
		// Aufbau der Jacobi-Matrix, zunchst Mittelwert - Mittelwert
		for (int i=0; i<anzMeanPar; i++)
			for (int j=i; j<anzMeanPar; j++)
			{
				double sum = 0.0;
				for (int k=0; k<anzVar; k++)
					for (int l=0; l<anzVar; l++)
						sum += sigMInvD[k][l] * muDev[i][k] * muDev[j][l];
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = 2*anzPer*sum; 
			}
		// jetzt Mittelwert - Varianz
		for (int i=0; i<anzMeanPar; i++)
			for (int j=anzMeanPar; j<anzPar; j++)
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = 0.0; 
		// und jetzt Varianz - Varianz
		for (int i=anzMeanPar; i<anzPar; i++)
			for (int j=i; j<anzPar; j++)
			{
				Statik.multiply(sigMInvSigDevD[i-anzMeanPar],sigMInvSigDevD[j-anzMeanPar], mat1);

				double spur = 0.0;
				for (int k=0; k<anzVar; k++) spur += mat1[k][k];
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = (double)anzPer * spur / 2.0; 
			}
    }
    
    public static void steveSimulation()
    {
        double errvar = 0.1, errstdv = Math.sqrt(errvar);
        LinearModel model = new LinearModel(
                new double[][]{{1,-5,25},{1,-4,16},{1,-3,9},{1,-2,4},{1,-1,1},{1,0,0},{1,1,1},{1,2,4},{1,3,9},{1,4,16},{1,5,25}},
                new int[][]{{0,3,4},{3,1,5},{4,5,2}},
                new double[][]{{1,0,0},{0,1,0},{0,0,1}},
                new int[]{-1,-1,-1},
                new double[]{0,0,0},
                new int[]{6,6,6,6,6,6,6,6,6,6,6},
                new double[]{.1,.1,.1,.1,.1,.1,.1,.1,.1,.1,.1}
                );
        
//        double[] initial = new double[]{1,1,1,0,0,0,errvar};
        model.fixParameter(4, 0);
        double[] initial = new double[]{1,1,0,0,0,errvar};
        int N = 100;
        int dataLength = 100;
        double probPhaseJump = 0.05;
        double[][] fullData = new double[N][dataLength];
        
        java.util.Random rand = new java.util.Random();
        double f = 0.05;
        double phase = 0;
        f = 0.06; for (int n=0; n<N/3; n++)
            for (int i=0; i<dataLength; i++) 
            {if (rand.nextDouble()<probPhaseJump) phase = rand.nextDouble()*2*Math.PI; fullData[n][i] = Math.sin(2*Math.PI*i*f+phase) + rand.nextGaussian()*errstdv;};
        f = 0.08; for (int n=N/3; n<2*N/3; n++)
            for (int i=0; i<dataLength; i++) 
            {if (rand.nextDouble()<probPhaseJump) phase = rand.nextDouble()*2*Math.PI; fullData[n][i] = Math.sin(2*Math.PI*i*f+phase) + rand.nextGaussian()*errstdv;};
        f = 0.1; for (int n=2*N/3; n<N; n++)
            for (int i=0; i<dataLength; i++) 
            {if (rand.nextDouble()<probPhaseJump) phase = rand.nextDouble()*2*Math.PI; fullData[n][i] = Math.sin(2*Math.PI*i*f+phase) + rand.nextGaussian()*errstdv;};

        for (int i=30; i<70; i++) System.out.println(fullData[5][i]+"\t"+fullData[50][i]+"\t"+fullData[85][i]);
            
        // contains double[], first number of members in cluster, second -2ll value, sequential cluster members
        double[][] cluster = new double[2*N][];
        double[][][] data = new double[2*N][][];
        boolean[] isActive = new boolean[2*N]; 
        for (int i=0; i<2*N; i++) isActive[i] = false; for (int i=0; i<N; i++) isActive[i] = true;
        for (int i=0; i<N; i++)
            cluster[i] = new double[]{1,-1,i};
        SimpleLGM workhorse = new SimpleLGM();
        
        long time = System.currentTimeMillis();
        
        for (int i=0; i<N; i++)
        {
            data[i] = new double[dataLength-11+1][11];
            for (int j=0; j<dataLength-11+1; j++)
                for (int k=0; k<11; k++) data[i][j][k] = fullData[i][j+k];
            model.data = data[i]; model.anzPer = model.data.length;
            model.computeMoments();
            double[] est1 = model.estimateMLSupportedByPowerEquivalence(initial); double ll1 = model.lastMinusTwoLL; ll1 = model.lastMinusTwoLL;
            double[] est2 = workhorse.twollAproxLinearModel(model, initial); model.lastMinusTwoLL = workhorse.twollValue; double ll2 = model.lastMinusTwoLL;
            double[] est3 = model.estimateMLFullCovarianceSupportedByPowerEquivalence(); double ll3 = model.lastMinusTwoLL;
            System.out.println(Statik.matrixToString(est1)+"\t\t"+ll1+"\r\n"+Statik.matrixToString(est2)+"\t\t"+ll2+
                    "\r\n"+Statik.matrixToString(est3)+"\t\t"+ll3+"\r\n");
            cluster[i][1] = model.lastMinusTwoLL;
        }

        // cluster1, cluster2, loss
        TreeSet<double[]> pairs = new TreeSet<double[]>(new Comparator<double[]>(){
            public int compare(double[] a, double[] b) {return (a[2]>b[2]?1:(a[2]<b[2]?-1:0));}
        });        

        for (int i=0; i<N; i++)
            for (int j=i+1; j<N; j++)
            {
                double[][] combinedData = new double[data[i].length+data[j].length][];
                for (int k=0; k<data[i].length; k++) combinedData[k] = data[i][k];
                for (int k=0; k<data[j].length; k++) combinedData[k+data[i].length] = data[j][k];
                model.data = combinedData; model.anzPer = model.data.length;
                model.computeMoments();
                model.estimateMLFullCovarianceSupportedByPowerEquivalence();
//              model.estimateMLSupportedByPowerEquivalence(initial);
//                workhorse.twollAproxLinearModel(model, initial); model.lastMinusTwoLL = workhorse.twollValue;
                double loss = model.lastMinusTwoLL - cluster[i][1] - cluster[j][1];
                pairs.add(new double[]{i,j,loss});
            }

        int ergcounter = 2*N-2;
        int[] ergnr = new int[2*N-1];
        double[][] memory = new double[2*N][];
        double[] t; double[][] t2;
        int anzCluster = N;
        // Start of clustering
        while (!pairs.isEmpty())
        {
            double[] winner = pairs.first();
            int wi = (int)winner[0], wj = (int)winner[1]; 
            double[][] winningData = new double[data[wi].length+data[wj].length][];
            for (int k=0; k<data[wi].length; k++) winningData[k] = data[wi][k];
            for (int k=0; k<data[wj].length; k++) winningData[k+data[wi].length] = data[wj][k];
            cluster[anzCluster] = cluster[wi]; data[anzCluster] = data[wi]; 
            cluster[wi] = new double[2+(int)Math.round(cluster[anzCluster][0]) + (int)Math.round(cluster[wj][0])];
            cluster[wi][0] = cluster[anzCluster][0] + cluster[wj][0]; cluster[wi][1] = winner[2] + cluster[anzCluster][1] + cluster[wj][1]; 
            for (int i=0; i<cluster[anzCluster][0]; i++) cluster[wi][i+2] = cluster[anzCluster][i+2];
            for (int i=0; i<cluster[wj][0]; i++) cluster[wi][i+(int)cluster[anzCluster][0]+2] = cluster[wj][i+2];
            data[wi] = winningData;
            isActive[wj] = false;
            anzCluster++;
            
            int count = 0;
            for (double[] w:pairs) 
                if (((int)w[0]==wi) || ((int)w[0]==wj) || ((int)w[1]==wi) || ((int)w[1]==wj)) memory[count++] = w;
            for (int i=0; i<count; i++) pairs.remove(memory[i]);
            ergnr[ergcounter--] = anzCluster-1; ergnr[ergcounter--] = wj;
            
            for (int i=0; i<cluster.length; i++) if ((i!=wi) && (isActive[i]))
            {
                double[][] combinedData = new double[data[i].length+data[wi].length][];
                for (int k=0; k<data[i].length; k++) combinedData[k] = data[i][k];
                for (int k=0; k<data[wi].length; k++) combinedData[k+data[i].length] = data[wi][k];
                model.data = combinedData; model.anzPer = model.data.length;
                model.computeMoments();
                model.estimateMLFullCovarianceSupportedByPowerEquivalence();
//                model.estimateMLSupportedByPowerEquivalence(initial);
//                workhorse.twollAproxLinearModel(model, initial); model.lastMinusTwoLL = workhorse.twollValue;
                double loss = model.lastMinusTwoLL - cluster[i][1] - cluster[wi][1];
                pairs.add(new double[]{i,wi,loss});
            }
            if (pairs.isEmpty()) ergnr[ergcounter--] = wi;
        }
        
        for (int i=0; i<10; i++) System.out.println(Statik.matrixToString(cluster[ergnr[i]])); 
            
        System.out.println("Total time = "+(System.currentTimeMillis() - time));
    }
    
    public static void ldeFitDrumming()
    {
        int tau = 10;
        double[][] rawData = Statik.loadMatrix("continuous\\SE342__3_2_2_6.raw", '\t');
        int embed = 25; 
        double deltaT = 0.001;
        double[][] data = new double[rawData.length-embed*tau+1][2*embed];
        for (int i=0; i<data.length; i++)
        {
            for (int j=0; j<embed; j++) data[i][j] = rawData[i+j*tau][1];
            for (int j=0; j<embed; j++) data[i][embed+j] = rawData[i+j*tau][2];
        }
        
        int half = embed / 2;
        double[][] struct = new double[2*embed][6];
        for (int i=0; i<2*embed; i++) 
        {
            if (i<embed) struct[i] = new double[]{1,(i-half)*deltaT*tau,(i-half)*deltaT*tau*(i-half)*deltaT*tau,0,0,0};
            else         struct[i] = new double[]{0,0,0,1,(i-half)*deltaT*tau,(i-half)*deltaT*tau*(i-half)*deltaT*tau};
        }
        int[][] cov = new int[][]{
                {0,1,2,-1,-1,3},
                {1,4,5,-1,-1,-1},
                {2,5,6,7,-1,-1},
                {-1,-1,7,8,9,10},
                {-1,-1,-1,9,11,12},
                {3,-1,-1,10,12,13}};
        int[] errPar = new int[2*embed];
        for (int i=0; i<embed; i++) errPar[i] = 14;
        for (int i=embed; i<2*embed; i++) errPar[i] = 15;
        double[] errVal = new double[2*embed]; for (int i=0; i<2*embed; i++) errVal[i] = 1;
        
        LinearModel model = new LinearModel(
                struct,
                cov,
                Statik.identityMatrix(6),
                new int[]{-1,-1,-1,-1,-1,-1},
                new double[]{0,0,0,0,0,0},
                errPar,
                errVal
                );
        model.setData(data);
        model.computeMoments();
        for (int i=0; i<data.length; i++)
            for (int j=0; j<2*embed; j++) 
                model.data[i][j] -= model.dataMean[j];
        model.computeMoments();
        
        double[] initial = new double[16];
        for (int i=0; i<16; i++) initial[i] = model.getParameterValue(i);
        
        double[][] substruct = new double[embed][3];
        for (int i=0; i<embed; i++) 
            substruct[i] = new double[]{1,(i-half)*deltaT*tau,(i-half)*deltaT*tau*(i-half)*deltaT*tau};
        LinearModel submodel = new LinearModel(substruct);
        double[][] subTransform = submodel.computePowerEquivalenceTransformationMatrix();
        double[][] totalTransform = new double[2*embed][2*embed];
        for (int i=0; i<embed; i++) for (int j=0; j<embed; j++) 
            totalTransform[i][j] = totalTransform[i+embed][j+embed] = subTransform[i][j];
        double[][] prodstruct = Statik.multiply(totalTransform,model.structure);
        double[][] proddata = new double[model.anzPer][6];
        for (int i=0; i<model.anzPer; i++)
            proddata[i] = Statik.multiply(totalTransform, model.data[i]);
        double[][] newstruct = new double[6][6];
        for (int i=0; i<3; i++) for (int j=0; j<3; j++) 
            newstruct[i][j] = newstruct[i+3][j+3] = prodstruct[i][j];
        double[][] newdata = new double[model.anzPer][6];
        for (int i=0; i<model.anzPer; i++) for (int j=0; j<3; j++) { 
            newdata[i][j] = proddata[i][j];
            newdata[i][j+3] = proddata[i][embed+j];
        }
        double sqrsum1 = 0, sqrsum2 = 0;
        for (int i=0; i<newdata.length-3; i++) {
            for (int j=3; j<embed; j++) sqrsum1 += proddata[i][j]*proddata[i][j];
            for (int j=3; j<embed; j++) sqrsum2 += proddata[i][j+embed]*proddata[i][j+embed];
        }
        double errvar1 = sqrsum1 / (model.anzPer*(embed-3));
        double errvar2 = sqrsum2 / (model.anzPer*(embed-3));
//        model.fixParameter(errPar[0],   errvar1);
//        model.fixParameter(errPar[embed],errvar2);
        double[] suberrVal = new double[]{errvar1,errvar1,errvar1,errvar2,errvar2,errvar2};
        int[] suberrPar = new int[]{14,14,14,15,15,15};
        double[][] additionalErrorInformation = new double[][]{{14,model.anzPer*(embed-3),sqrsum1},{15,model.anzPer*(embed-3),sqrsum2}};
        
        LinearModel redModel = new LinearModel(newstruct, model.facCovPar, model.facCovVal, model.facMeanPar,
                model.facMeanVal,suberrPar,suberrVal);
        double[] redInitial = new double[initial.length-2];
        for (int i=0; i<redInitial.length; i++) redInitial[i] = initial[i];
        redModel.setData(newdata);

        // computing full covariance matrix symbolically
        double[][] redStructInv = Statik.invert(newstruct);
        double[][] redDataTrans = new double[model.anzPer][];
        for (int i=0; i<model.anzPer; i++) redDataTrans[i] = Statik.multiply(redStructInv, newdata[i]);
        double[][] errCov = Statik.multiply(redStructInv,Statik.transpose(redStructInv));
        for (int i=0; i<3; i++) for (int j=0; j<3; j++) { errCov[i][j] *= errvar1; errCov[i+3][j+3] *= errvar2;}
        double[][] symbCovariance = Statik.covarianceMatrix(redDataTrans);
        Statik.subtract(symbCovariance, errCov, symbCovariance);
        double[] symbEstimate = new double[model.anzVarPar];
        for (int i=0; i<6; i++) for (int j=0; j<6; j++) if (model.facCovPar[i][j] != -1) symbEstimate[model.facCovPar[i][j]] = symbCovariance[i][j];
        
        for (int i=0; i<symbEstimate.length; i++) redModel.setParameter(i, symbEstimate[i]); redModel.setParameter(14, errvar1); redModel.setParameter(15, errvar2);
        SimpleLGM workhorse = new SimpleLGM();
        double[] subEstimates = workhorse.twollAproxLinearModel(redModel, redModel.getParameters(), additionalErrorInformation);

        redModel.fixParameter(15,errvar1); redModel.fixParameter(14,errvar1);
        double[] subEstimatesErrFixed = workhorse.twollAproxLinearModel(redModel, redModel.getParameters());
        
        for (int i=0; i<subEstimates.length; i++) initial[i] = subEstimates[i];
        initial[model.errPar[0]] = errvar1;
        initial[model.errPar[embed]] = errvar2;
        double[] estimates = workhorse.twollAproxLinearModel(model, initial);

        for (int i=0; i<symbEstimate.length; i++) initial[i] = symbEstimate[i];
        initial[model.errPar[0]] = errvar1;
        initial[model.errPar[1]] = errvar2;
        double[] estimates2 = workhorse.twollAproxLinearModel(model, initial);

        double[] est1 = new double[16]; for (int i=0; i<14; i++) est1[i] = symbEstimate[i]; est1[14] = errvar1; est1[15] = errvar2; 
        double[] est3 = new double[16]; for (int i=0; i<14; i++) est3[i] = subEstimatesErrFixed[i]; est3[14] = errvar1; est3[15] = errvar2; 
        System.out.println("Symbolic Results from whole covariance matrix  = "+(est1==null?"not converged":Statik.matrixToString(est1)+"\t\t"+workhorse.twollEvaluate(model, est1)));
        System.out.println("Estimates from reduced model with error info   = "+(subEstimates==null?"not converged":Statik.matrixToString(subEstimates)+"\t\t"+workhorse.twollEvaluate(model, subEstimates)));
        System.out.println("Estimates from reduced model                   = "+(est3==null?"not converged":Statik.matrixToString(est3)+"\t\t"+workhorse.twollEvaluate(model, est3)));
        System.out.println("Estimate (using errvar approx as starting)     = "+(estimates==null?"not converged":Statik.matrixToString(estimates)+"\t\t"+workhorse.twollEvaluate(model, estimates)));
        System.out.println("Estimate (using full covariance as starting)   = "+(estimates2==null?"not converged":Statik.matrixToString(estimates2)+"\t\t"+workhorse.twollEvaluate(model, estimates2)));
        
        double[][] interCor = new double[3][3];
        for (int i=0; i<3; i++) for (int j=0; j<3; j++) interCor[i][j] = symbCovariance[3+i][j]/Math.sqrt(symbCovariance[3+i][3+i]*symbCovariance[j][j]);
        
        System.out.println("Inter covariance matrix = \r\n"+Statik.matrixToString(interCor));
    }
    
    public static void main3()
    {
        for (int anzInd = 2; anzInd<20; anzInd++)
        {
            double err = 1;
            double[] eta = new double[anzInd]; for (int i=0; i<anzInd; i++) eta[i] = 1;
            double[] nu = new double[anzInd]; for (int i=0; i<anzInd; i++) nu[i] = i;
            double[][] chol = new double[anzInd][anzInd]; for (int i=0; i<anzInd; i++) chol[i][i] = err;
            double[] erg = convertTwoLatentToTwoLatentTwoIndicator(anzInd, eta, nu, chol);
            System.out.println(anzInd+": "+erg[0]+", "+erg[1]+", "+erg[2]);
        }
    }

    
    public static void main2()
    {
        double svar = 50;
        LinearModel fullModelOld = new LinearModel(
                new double[][]{{1,0.0},{1,0.1},{1,0.2},{1,0.3},{1,0.4},{1,0.5},{1,0.6},{1,0.7},{1,0.8},{1,0.9}},
                new int[][]{{0,2},{2,1}},
                new double[][]{{100,0.25 * Math.sqrt(100*svar)},{0.25 * Math.sqrt(100*svar),svar}},
                new int[]{-1,-1},
                new double[]{0,0},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{1,1,1,1,1,1,1,1,1,1}
                );
        LinearModel covFixedModelOld = LinearModel.fixParameter(fullModelOld, 2, 0.0);
        LinearModel varFixedModelOld = LinearModel.fixParameter(covFixedModelOld, 1, 0.0);
        
        LinearModel fullModelNew = fullModelOld.convertTwoLatentToTwoLatentTwoIndicator();
        LinearModel covFixedModelNew = LinearModel.fixParameter(fullModelNew, 2, 0.0);
        LinearModel varFixedModelNew = LinearModel.fixParameter(covFixedModelNew, 1, 0.0);
        
        double sumVarOld = 0, sumCovOld = 0, sumVarNew = 0, sumCovNew = 0;
        int trials = 50000;
        int N = 100;
        int countVarOld = 0, countCovOld = 0;
        int countVarNew = 0, countCovNew = 0;
        SimpleLGM slgm = new SimpleLGM();
        
        for (int i=0; i<trials; i++)
        {
	        fullModelOld.createData(N);
	        covFixedModelOld.setData(fullModelOld.data);
	        varFixedModelOld.setData(fullModelOld.data);
	        slgm.twollAproxLinearModel(fullModelOld, new double[]{100,0.25*Math.sqrt(100*svar),svar});
	        double base = slgm.twollValue;
	        slgm.twollAproxLinearModel(covFixedModelOld, new double[]{100,svar});
	        sumCovOld += slgm.twollValue-base; if (slgm.twollValue-base > Statik.FIVEPERCENTTHRESHOLD[0]) countCovOld++;
	        slgm.twollAproxLinearModel(varFixedModelOld, new double[]{100});
	        sumVarOld += slgm.twollValue-base; if (slgm.twollValue-base > Statik.FIVEPERCENTTHRESHOLD[1]) countVarOld++;
	        
	        fullModelNew.createData(N);
	        covFixedModelNew.setData(fullModelNew.data);
	        varFixedModelNew.setData(fullModelNew.data);
	        slgm.twollAproxLinearModel(fullModelNew, new double[]{100,0.25*Math.sqrt(100*svar),svar});
	        base = slgm.twollValue;
	        slgm.twollAproxLinearModel(covFixedModelNew, new double[]{100,svar});
	        sumCovNew += slgm.twollValue-base; if (slgm.twollValue-base > Statik.FIVEPERCENTTHRESHOLD[0]) countCovNew++;
	        slgm.twollAproxLinearModel(varFixedModelNew, new double[]{100});
	        sumVarNew += slgm.twollValue-base; if (slgm.twollValue-base > Statik.FIVEPERCENTTHRESHOLD[1]) countVarNew++;
        }
        System.out.println("Mean Deviation Cov Old = "+sumCovOld/(double)trials);
        System.out.println("Mean Deviation Var Old = "+sumVarOld/(double)trials);
        System.out.println("Power Cov Old 		   = "+(double)countCovOld/(double)trials);
        System.out.println("Power Var Old 		   = "+(double)countVarOld/(double)trials);
        System.out.println();
        System.out.println("Mean Deviation Cov New = "+sumCovNew/(double)trials);
        System.out.println("Mean Deviation Var New = "+sumVarNew/(double)trials);
        System.out.println("Power Cov New 		   = "+(double)countCovNew/(double)trials);
        System.out.println("Power Var New 		   = "+(double)countVarNew/(double)trials);
        
        System.exit(0);
    }
    
    public static void main(String args[])
    {
        // LDE auf Trommeldaten (skript)
        ldeFitDrumming();
        
        // Steves LDE simulation
//        steveSimulation();
        
        System.exit(0);
        // Bootstrapping to test speed of acceleration
        LinearModel model = SimpleLGM.createExponentialFloModel(40, 40);
        model.fixParameter(0,0);
        model.fixParameter(0,0);
        model.fixParameter(0,0);
       
        // fit test
//        model = new LinearModel(new double[][]{{1,0},{1,1},{1,2},{1,3},{1,4}}, new int[][]{{0,1},{1,2}},new double[][]{{10,0},{0,10}},new int[]{-1,-1},new double[]{0,0},new int[]{3,3,3,3,3},new double[]{1,1,1,1,1});
//        double[] vals = new double[]{10,0,10,1};
//        double[] initial = new double[]{10,0,10,212};
        double[] vals = new double[]{10,0,0,10,0,10,1};
        double[] initial = new double[]{10,0,0,10,0,10,212};
        model.setParameterValue(vals);
        model.createData(100);

        double[][] erg = model.testBootstrapMLSupportedByPowerEquivalence(initial);
        System.out.println(Statik.matrixToString(erg[0],5));
        System.out.println(Statik.matrixToString(erg[1],5));
        
        System.exit(0);
        
        double[] ergPE=new double[model.anzPar], ergDi=new double[model.anzPar], ergPEloc = null, ergDiloc = null;
        int trials = 10;
        long time = System.currentTimeMillis();
        for (int i=0; i<trials; i++)
        {
            ergPEloc = model.estimateMLSupportedByPowerEquivalence(initial);
            for (int j=0; j<model.anzPar; j++) ergPE[j] += (ergPEloc[j] - vals[j])*(ergPEloc[j] - vals[j]);
        }
        double peTime = (System.currentTimeMillis() - time)/(double)(1000*trials); 
        time = System.currentTimeMillis();
        for (int i=0; i<trials; i++)
        {
            ergDiloc = (new SimpleLGM()).twollAproxLinearModel(model, initial);
            for (int j=0; j<model.anzPar; j++)
                ergDi[j] += (ergDiloc[j] - vals[j])*(ergDiloc[j] - vals[j]);
        }
        for (int j=0; j<model.anzPar; j++) ergPE[j] = Math.sqrt((ergPE[j]/trials));
        for (int j=0; j<model.anzPar; j++) ergDi[j] = Math.sqrt((ergDi[j]/trials));
            
        double diTime = (System.currentTimeMillis() - time)/(double)(1000*trials); 
        
        System.out.println(Statik.matrixToString(ergPE)+", "+peTime+" s.");
        System.out.println(Statik.matrixToString(ergDi)+", "+diTime+" s.");
        
        
        System.exit(0);
       /*
        
        
        
        double svar = 70;
        LinearModel test = new LinearModel(
                new double[][]{{1,0},{1,0.1},{1,0.2}},
                new int[][]{{0,1},{1,2}},
                new double[][]{{100,0.25*Math.sqrt(100*svar)},{0.25*Math.sqrt(100*svar),svar}},
                new int[]{-1,-1},
                new double[]{0,0},
                new int[]{-1,-1,-1},
                new double[]{20,20,20}
                );
        LinearModel test2 = LinearModel.fixParameter(test,2,0);
        test2.fixParameter(1,0);
//        double threshold = 3.8415;
        double threshold = 5.99146455;
        
        double[][] sigD = test.evaluateSigma(), sigDAlt = test2.evaluateSigma();
        double[] muD = new double[]{0,0,0};
        SimpleLGM slgm = new SimpleLGM();
	    double[] parAlt = slgm.twollAproxLinearModelTwoMatrixCompare(test2, sigD, new double[]{100});
	    System.out.println("Parameters alternative: "+parAlt[0]);
	    sigDAlt = test2.evaluateSigma(parAlt);
	    test2.setParameterValue(0, parAlt[0]);

        double sumReal = 0, sumAssum = 0;
        int trials = 1000;
        int N = 1000;
        int countReal = 0;
        int countAssum = 0;
        
        for (int i=0; i<trials; i++)
        {
	        test.createData(N);
	        test.computeMoments();
	        test2.setData(test.data);

	        double[] zwerg = slgm.twollAproxLinearModel(test, new double[]{100,0.25*Math.sqrt(100*svar),svar});
	        double t1 = slgm.twollValue;
//	        sigD = test.evaluateSigma(zwerg);
	        zwerg = slgm.twollAproxLinearModel(test2, new double[]{100});
//	        sigDAlt = test2.evaluateSigma(zwerg);
	        double t2 = slgm.twollValue;
		    double diffReal = t2-t1;
		    if (diffReal>threshold) countReal++;

	        double t1deb = slgm.twollEvaluate(N, test.xsum, test.xBiSum, sigD, muD, false);
		    double t2deb = slgm.twollEvaluate(N, test.xsum, test.xBiSum, sigDAlt, muD, false);
		    double diff = t2deb - t1deb;
		    if (diff>threshold) countAssum++;

		    sumAssum += diff;
		    sumReal  += diffReal;
        }
        System.out.println("Practical(Real)  = "+(countReal/(double)trials));
        System.out.println("Practical(Assum) = "+(countAssum/(double)trials));
        
        double[][] errMat = new double[3][3]; for (int i=0; i<3; i++) errMat[i][i] = test.errVal[i];
        double[] firstLat = new double[3]; for (int i=0; i<3; i++) firstLat[i] = test.structure[i][0];
        double[] secondLat = new double[3]; for (int i=0; i<3; i++) secondLat[i] = test.structure[i][1];
        double v1 = test.facCovVal[0][0], v12 = test.facCovVal[0][1], v2 = test.facCovVal[1][1];
        double v1Alt = test2.facCovVal[0][0], v12Alt = test2.facCovVal[0][1], v2Alt = test2.facCovVal[1][1];
        double theory = LinearModel.powerOfTwoLatent(3, firstLat, secondLat, errMat, test.facCovVal, test2.facCovVal,N,threshold,2);
        System.out.println("practical mean (Real)= "+sumReal / trials);
        System.out.println("practical mean (Assum)= "+sumAssum / trials);
        System.out.println("Theoretical = "+theory);
        */
    }
    public void computeLeastSquaresDerivatives(double[] value,
            boolean recomputeMuAndSigma) {
        // TODO Auto-generated method stub
        
    }
    public void computeLogLikelihoodDerivatives(double[] value,
            boolean recomputeMuAndSigma) {
        // TODO Auto-generated method stub
        
    }
    protected void computeMatrixTimesMuDev(int par, double[][] matrix,
            double[] erg) {
        // TODO Auto-generated method stub
        
    }
    protected void computeMatrixTimesSigmaDev(int par, double[][] matrix,
            double[][] erg) {
        // TODO Auto-generated method stub
        
    }
    protected void computeMatrixTimesSigmaDevDev(int par1, int par2,
            double[][] matrix, double[][] erg) {
        // TODO Auto-generated method stub
        
    }
    public Model copy() {
//        return new LinearModel(this);
        return null;
    }
    public void evaluateMuAndSigma(double[] values) {
        evaluateSigma(values);
        evaluateMu(values);
    }
    public double getParameter(int nr) {
        return getParameterValue(nr);
    }
    public boolean isErrorParameter(int nr) {
        boolean erg = false;
        for (int i=0; i<errPar.length; i++) if (errPar[i] == nr) erg = true;
        return erg;
    }
    
    public void setParameter(int nr, double value) {
        setParameterValue(nr,value);
    }
    
    
}
