/*
 * Created on 26.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;
import java.util.Arrays;
import java.util.Comparator;
import java.util.TreeSet;
import java.util.Vector;

import lgmsimulation.SingletonModel.parameterType;

import silvers.Statik;


/**
 * @author timo
 * 
 * TODO LinearModel is not yet derived from Model
 */
public class LinearModelNew extends Model
{
    public static enum parameterType {mean, facCov, err};
//    static Random rand = new Random();
    
    int anzFac;
    
    double[][] structure;
    int[][] covPar;
    double[][] covVal;
    int[] meanPar;
    double[] meanVal;
    int[] errPar;
    double[] errVal;
    
    // if not null, addErrorInfo is gives an additional additive term to the likelihood based on the value of the error parameters.
    // addErrorInfo contains triplets, first parameter number, second number of additional information units, and third summed squared of these units.
    double[][] addErrorInfo;
    
    // gives the position of the parameter (row, column); second is unused for mean and error, 1st <= 2nd for facCov
    int[][] parPos;
    
    // parameter types
    parameterType[] parType;
    
    public double[][] fisherInformationMatrix;

    // Some working variables
    double[][] facCovWork, sigmaWork, sigmaWork2, sigmaWork3, sigmaWork4, structureWork, structureTransWork;
    double[] muWork, posWork, p1w, p2w, cew, a1w, a2w;
    int[] sDevRow, sDevCol, cDevRow, cDevCol, mDev;
    
    public LinearModelNew(double[][] structure, int[][] covPar, double[][] covVal, int[] meanPar,
            double[] meanVal, int[] errPar, double[] errVal)
    {
        this.structure = structure; this.covPar = covPar; this.covVal = covVal; 
        this.meanPar = meanPar; this.meanVal = meanVal; this.errPar = errPar; this.errVal = errVal;
        
        anzFac = structure[0].length;
		anzVar = structure.length;

		collectParameterTypesAndPos();
		anzPer = 0; data = new double[0][];
		
		fisherInformationMatrix = new double[anzPar][anzPar];
    }
    public LinearModelNew(double[][] structure)
    {
        this.structure = structure;
        anzFac = structure[0].length;
        anzVar = structure.length;
        
        anzPar = 0;
        meanVal = new double[anzFac]; meanPar = new int[anzFac]; for (int i=0; i<anzFac; i++) meanPar[i] = anzPar++;
        covVal = new double[anzFac][anzFac]; covPar = new int[anzFac][anzFac];
        for (int i=0; i<anzFac; i++) covPar[i][i] = anzPar++;
        for (int i=0; i<anzFac; i++) for (int j=0; j<i; j++) covPar[i][j] = covPar[j][i] = anzPar++;
        errVal = new double[anzVar]; errPar = new int[anzVar];
        for (int i=0; i<anzVar; i++) errPar[i] = anzPar;
        anzPar++; 
		anzPer = 0; data = new double[0][];
		collectParameterTypesAndPos();
		fisherInformationMatrix = new double[anzPar][anzPar];
    }
    public LinearModelNew(double[][] structure, double[][] covVal, double[] meanVal, double[] errVal)
    {
        this(structure);
        this.covVal = covVal; this.meanVal = meanVal; this.errVal = errVal;
    }
    public LinearModelNew(LinearModelNew toCopy)
    {
        anzFac = toCopy.anzFac;
        anzVar = toCopy.anzVar;
        anzPar = toCopy.anzPar;
        anzPer = toCopy.anzPer;

        structure = Statik.copy(toCopy.structure);
        meanVal = Statik.copy(toCopy.meanVal);
        meanPar = Statik.copy(toCopy.meanPar);
        covVal = Statik.copy(toCopy.covVal);
        covPar = Statik.copy(toCopy.covPar);
        errVal = Statik.copy(toCopy.errVal);
        errPar = Statik.copy(toCopy.errPar);
		data = (toCopy.data==null?null:Statik.copy(toCopy.data));
		computeMoments();
		fisherInformationMatrix = new double[anzPar][anzPar];
		collectParameterTypesAndPos();
    }
    
    public LinearModelNew(LinearModel toCopy) {
        anzFac = toCopy.anzFac;
        anzVar = toCopy.anzVar;
        anzPar = toCopy.anzPar;
        anzPer = toCopy.anzPer;

        structure = Statik.copy(toCopy.structure);
        meanVal = Statik.copy(toCopy.facMeanVal);
        meanPar = Statik.copy(toCopy.facMeanPar);
        covVal = Statik.copy(toCopy.facCovVal);
        covPar = Statik.copy(toCopy.facCovPar);
        errVal = Statik.copy(toCopy.errVal);
        errPar = Statik.copy(toCopy.errPar);
        data = (toCopy.data==null?null:Statik.copy(toCopy.data));
        computeMoments();
        fisherInformationMatrix = new double[anzPar][anzPar];
        collectParameterTypesAndPos();
    }
    
    public void collectParameterTypesAndPos()
    {
        int maxPar = maxParNumber();
        parType = new parameterType[maxPar+1];
        parPos = new int[maxPar+1][];
    
        for (int i=0; i<meanPar.length; i++) if (meanPar[i]!=NOPARAMETER) {parType[meanPar[i]] = parameterType.mean; parPos[meanPar[i]] = new int[]{i,0};}
        for (int i=0; i<anzFac; i++) for (int j=i; j<anzFac; j++) 
            if (covPar[i][j]!=NOPARAMETER) {parType[covPar[i][j]] = parameterType.facCov; parPos[covPar[i][j]] = new int[]{i,j};}
        for (int i=0; i<errPar.length; i++) if (errPar[i] != NOPARAMETER) {parType[errPar[i]] = parameterType.err; parPos[errPar[i]] = new int[]{i,0};}
        anzPar = maxPar +1;
    }
    
    public int maxParNumber()
    {
        int erg = NOPARAMETER;
        for (int i=0; i<meanPar.length; i++) erg = Math.max(meanPar[i], erg);
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) erg = Math.max(covPar[i][j], erg);
        for (int i=0; i<errPar.length; i++) erg = Math.max(errPar[i], erg);
        return erg;
    }
    
    public int[] getActiveParameters()
    {
        int toPar = maxParNumber()+1;
        int[] ergO = new int[toPar];
        for (int i=0; i<meanPar.length; i++)
            if (meanPar[i] != NOPARAMETER) ergO[meanPar[i]]=1;
        for (int i=0; i<anzFac; i++)
            for (int j=i; j<anzFac; j++)
                if (covPar[i][j] != NOPARAMETER) ergO[covPar[i][j]]=1;
        for (int i=0; i<errPar.length;i++) 
            if (errPar[i] != NOPARAMETER) ergO[errPar[i]]=1;
        int anz = 0; for (int i=0; i<toPar; i++) if (ergO[i]!=0) anz++;
        int[] erg = new int[anz]; int j=0; 
        for (int i=0; i<toPar; i++) if (ergO[i]!=0) erg[j++] = i;
        Arrays.sort(erg);
        return erg;
    }
    
    public void renumberParameter(int oldNumber, int newNumber)
    {
        for (int i=0; i<meanPar.length; i++)
            if (meanPar[i] == oldNumber) meanPar[i] = newNumber;
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                if (covPar[i][j] == oldNumber) covPar[i][j] = newNumber;
        for (int i=0; i<errPar.length; i++)
            if (errPar[i] == oldNumber) errPar[i] = newNumber;
        collectParameterTypesAndPos();
    }
    
    
    
    /**
     * Computes the power for a simple two-latent-two-indicator model with middle edge weight x and errors err1 and err2.
     * 
     * @param var1		Real Variance of first latent
     * @param covar		Real Covariance of first to second latent
     * @param var2		Real Variance of second latent
     * @param var1Alt	Alternative Variance of first latent
     * @param covarAlt	Alternative Covariance of first to second latent
     * @param var2Alt	Alternative Variance of second latent
     * @param ADedge	Edge from first latent to second indicator
     * @param err1		Error Variance of first indicator
     * @param err2		Error Variance of second indicator
     * @param threshold	Threshold of significance
     */
    public static double powerOfTwoLatentTwoIndicator(double var1, double covar, double var2, double var1Alt, double covarAlt, double var2Alt, double ADedge, double err1, double err2, int N, double threshold, int additionalDF)
    {
        double s11 = var1+err1, s11Alt = var1Alt + err1;
        double s12 = ADedge*var1 + covar, s12Alt = ADedge*var1Alt+covarAlt;
        double s22 = ADedge*s12 + ADedge*covar + var2 + err2, s22Alt = ADedge*s12Alt + ADedge*covarAlt + var2Alt + err2;
        double det = s11*s22-s12*s12, detAlt = s11Alt*s22Alt - s12Alt*s12Alt;
        double c11 = Math.sqrt(s11), c11Alt = Math.sqrt(s11Alt);
        double c12 = s12 / c11, c12Alt = s12Alt / c11Alt;
        double c22 = Math.sqrt(det)/c11, c22Alt = Math.sqrt(detAlt)/c11Alt;
        
        double a = (-c11*c11*s22Alt+2*c12*c11*s12Alt-c12*c12*s11Alt)/detAlt+(c11*c11*s22-2*c11*c12*s12+c12*c12*s11)/det;
        double b = 2*c22*((c11*s12Alt - c12*s11Alt)/detAlt + (c12*s11 - c11*s12)/det );
        double c = c22*c22*(s11/det-s11Alt/detAlt);
        double d = Math.log(det/detAlt);
        
        System.out.println("a = "+a+", b = "+b+", c = "+c+", d = "+d);
        System.out.println("theoretical mean="+(-a-c-d)*N);
        
        double erg = 1.0-Statik.generalMultiDegreeTwoNormalDensity(-a,-b,-c,-d,N,threshold,0.01,additionalDF);
//        double erg = Statik.generalMultiDegreeTwoNormalDensityNumerical(-a,-b,-c,-d,N,10000,threshold);
        return erg;
    }
    
    /**
     * Converts a two-latent-many-indicator model to a two-latent-two-indicator model. Ignores all entries of eta, nu and errCovMat after andInd.
     * Destroys this arguments in the process. 
     * 
     * @param anzInd	Number of Indicators (all entries after this one ignored)
     * @param eta		Weights from first latent to indicators
     * @param nu		Weights from second latent to indicators
     * @param chol		Error Cholesky Matrix 
     * @return			three doubles as array: first error, second error, weight from first latent to second indicator. 
     */
    private static double[] convertTwoLatentToTwoLatentTwoIndicator(int anzInd, double[] eta, double[] nu, double[][] chol)
    {
        double t;
        int nuZero = -1;
        for (int i=0; i<anzInd; i++) if (nu[i]==0.0) nuZero = i;
        if (nuZero!=-1) 
        {
            t = nu[nuZero]; nu[nuZero] = nu[0]; nu[0] = t; 
            t = eta[nuZero]; eta[nuZero] = eta[0]; eta[0] = t;
            for (int i=0; i<anzInd; i++) {t = chol[nuZero][i]; chol[nuZero][i] = chol[0][i]; chol[0][i] = t;}
            for (int i=0; i<anzInd; i++) {t = chol[i][nuZero]; chol[i][nuZero] = chol[i][0]; chol[i][0] = t;}
        } else {
            eta[0] = eta[0] - eta[1] * nu[0]/nu[1];
            for (int i=0; i<anzInd; i++) chol[0][i] = chol[0][i] - chol[1][i] * nu[0]/nu[1];            
            nu[0] = 0; 
        }
        Statik.choleskyDecompose(Statik.multiply(chol,Statik.transpose(chol)),chol);
        chol[0][0] = chol[0][0] / eta[0];
        eta[0] = 1;
        // If all right, we should power equivalently have transformed the model such that nu[0] is zero and eta[0] = 1.
        
        if (chol[0][0]!=0.0)
        {
            for (int i=1; i<anzInd; i++)
            {
                double fak = chol[i][0] / chol[0][0];
                nu[i] = nu[i] - fak * nu[0];
                eta[i] = eta[i] - fak * eta[0];
                for (int j=0; j<anzInd; j++) chol[i][j] = chol[i][j] - fak * chol[0][j];
            }
        }
        // Now, all edges from the first error node to all inidicators but the first should be eliminated.
        if (anzInd == 2)
        {
            double e1 = chol[0][0]*chol[0][0];
            double e2 = chol[1][1]*chol[1][1]/(nu[1]*nu[1]);
            double x  = eta[1]/nu[1];
            return new double[]{e1,e2,x};
        } else {
            Statik.choleskyDecompose(Statik.multiply(chol,Statik.transpose(chol)),chol);
            double[] etadot = new double[anzInd-1]; for (int i=0; i<anzInd-1; i++) etadot[i] = eta[i+1];
            double[] nudot = new double[anzInd-1]; for (int i=0; i<anzInd-1; i++) nudot[i] = nu[i+1];
            double[][] choldot = new double[anzInd-1][anzInd-1];
            for (int i=0; i<anzInd-1; i++)
                for (int j=0; j<anzInd-1; j++) choldot[i][j] = chol[i+1][j+1];
            double[] zwerg = convertTwoLatentToTwoLatentTwoIndicator(anzInd-1,etadot,nudot,choldot);
            zwerg[0] = chol[0][0]*chol[0][0]*zwerg[0]/(chol[0][0]*chol[0][0]+zwerg[0]);
            return zwerg;
        }        
    }
    // Assumes a simple one-variable LGCM
    private LinearModelNew convertTwoLatentToTwoLatentTwoIndicator()
    {
        double[] eta = new double[anzVar], nu = new double[anzVar]; double[][] chol = new double[anzVar][anzVar];  
        for (int i=0; i<anzVar; i++) {eta[i] = structure[i][0]; nu[i] = structure[i][1]; chol[i][i] = Math.sqrt(errVal[i]);}
        double[] zwerg = convertTwoLatentToTwoLatentTwoIndicator(anzVar, eta, nu, chol);
        LinearModelNew erg = new LinearModelNew(new double[][]{{1,0},{zwerg[2],1}}, Statik.copy(covPar), Statik.copy(covVal), Statik.copy(meanPar),
        Statik.copy(meanVal), new int[]{-1,-1}, new double[]{zwerg[0],zwerg[1]});
        return erg;
    }
    
    /**
     * Computes the power for a simple two-latent-many-indicator model with edge weights lambda from first latent to indicators,
     * nu from second latent to indicator, errCovMat as covariance matrix of the errors and indCovMat and indCovMatAlt as 
     * the covariance matrices of the indicators and alternative, respectively.
     * 
     * @param anzInd	Number of indicators
     * @param eta		Weights from first latent to indicators
     * @param nu		Weiths from second latent ot indicators
     * @param errCovMat Error Covariance Matrix
     * @param indCovMat Indicator Covariance Matrix (true Model)
     * @param indCovMatAlt	Indicator Covariance Matrix (alternative Model)
     * @param threshold	significance threshold
     * @return			the probability to hit a -2ll difference higher than threshold with data from the true model.
     */
    public static double powerOfTwoLatent(int anzInd, double[] eta, double[] nu, double[][] errCovMat, double[][] indCovMat, double[][] indCovMatAlt, int N, double threshold, int df)
    {
        double[] zwerg = convertTwoLatentToTwoLatentTwoIndicator(anzInd, eta, nu, Statik.choleskyDecompose(errCovMat));
        return powerOfTwoLatentTwoIndicator(indCovMat[0][0],indCovMat[0][1],indCovMat[1][1],indCovMatAlt[0][0],indCovMatAlt[0][1],indCovMatAlt[1][1],zwerg[2],zwerg[0],zwerg[1],N,threshold,df);
    }
    
    /**
     * ASSUMES identical error in all observations.
     * 
     * Computes a matrix erg such that erg &* struct is upper right and the error structure is an identity matrix times sigma_err again.
     * 
     * @return
     */
    public LinearModelNew transformWithPowerEquivalence() {
        double[][] trans = computePowerEquivalenceTransformationMatrix();
        double[][] prod = Statik.multiply(trans,structure);
        double[][] newStruct = new double[anzFac][]; for (int i=0; i<anzFac; i++) newStruct[i] = prod[i];
        LinearModelNew erg = new LinearModelNew(this);
        erg.anzVar = anzFac; erg.structure = newStruct;
        double[] vec = new double[anzVar];
        double sqrsum = 0;
        for (int i=0; i<erg.data.length; i++) {
            vec = Statik.multiply(trans, erg.data[i]);
            for (int j=anzFac; j<anzVar; j++) sqrsum += vec[j]*vec[j];
            erg.data[i] = new double[anzFac];
            for (int j=0; j<anzFac; j++) erg.data[i][j] = vec[j];            
        }
        erg.computeMoments();
        double errvar = sqrsum / (anzPer*(anzVar-anzFac));
        erg.addErrorInfo = new double[][]{{errPar[0],anzPer*(anzVar-anzFac),sqrsum}};
        int[] newErrPar = new int[anzFac];
        double[] newErrVal = new double[anzFac];
        for (int i=0; i<anzFac; i++) {newErrPar[i] = errPar[0]; newErrVal[i] = errVal[i];}
        erg.errPar = newErrPar;
        erg.errVal = newErrVal;
        
        return erg;
    }

    
    /**
     * ASSUMES identical error in all observations.
     * 
     * Computes a matrix erg such that erg &* struct is upper right and the error structure is an identy matrix times sigma_err again.
     * 
     * @return
     */
    public double[][] computePowerEquivalenceTransformationMatrix()
    {
       double[][] erg = Statik.identityMatrix(anzVar);
       double[][] work = Statik.copy(structure);
       double[][] work2 = new double[anzVar][anzVar], work3 = new double[anzVar][anzVar];
       for (int i=0; i<anzFac; i++)
       {
           double piv = work[i][i];
           for (int j=0; j<anzFac; j++) {work[i][j] /= piv; erg[i][j] /= piv;}
           for (int j=i+1; j<anzVar; j++)
           {
               double lead = work[j][i];
               for (int k=0; k<anzFac; k++) {work[j][k] -= lead*work[i][k]; erg[j][k] -= lead*erg[i][k];} 
           }
       }
       for (int i=anzFac-1; i>=0; i--)
       {
           for (int j=i-1; j>=0; j--)
           {
               double lead = work[j][i];
               for (int k=0; k<anzFac; k++) {work[j][k] -= lead*work[i][k]; erg[j][k] -= lead*erg[i][k];}
           }
       }
       Statik.transpose(erg, work3);
       Statik.multiply(erg, work3, work2);
       Statik.transposeContradiagonal(work2,work2);
       Statik.transpose(work2,work2);       
       Statik.choleskyDecompose(work2, work3);
       Statik.transposeContradiagonal(work3,work3);
       Statik.transpose(work3, work3);
       
       for (int i=anzVar-1; i>=0; i--)
       {
           double piv = work3[i][i];
           for (int j=0; j<anzVar; j++) {work3[i][j] /= piv; erg[i][j] /= piv;}
           for (int j=i-1; j>=0; j--)
           {
               double lead = work3[j][i];
               for (int k=0; k<anzVar; k++) {work3[j][k] -= lead*work3[i][k]; erg[j][k] -= lead*erg[i][k];}
           }
       }
       
       return erg;
    }

    /**
     * ASSUMES same error parameter in all observations, and all covariance matrix parameters to be estimated.
     * 
     * Transforms the model into a minimal model and remaining error indicator. Then, the error and the covariance matrix are fit symbolically.
     * 
     * TODO: Call of estimate is still over SimpleLGM (to be changed, becomes deprecated)
     * TODO: Means are ignored.
     * 
     * @param initial
     * @return
     */
    public double[] estimateMLFullCovarianceSupportedByPowerEquivalence()
    {
        double[][] trans = computePowerEquivalenceTransformationMatrix();
        double[][] prod = Statik.multiply(trans,structure);
        double[][] interStruct = new double[anzFac][]; for (int i=0; i<anzFac; i++) interStruct[i] = prod[i];
        double[][] prod2ul = Statik.invert(interStruct);
        double[][] prod2 = Statik.identityMatrix(anzVar);
        for (int i=0; i<anzFac; i++) for (int j=0; j<anzFac; j++) prod2[i][j] = prod2ul[i][j];
        double[][] transnew = Statik.multiply(prod2, trans);
        double[][] transData = new double[anzPer][anzVar];
        
        double sqrsum = 0;
        for (int i=0; i<anzPer; i++) {
             transData[i] = Statik.multiply(transnew, data[i]);
             for (int j=anzFac; j<anzVar; j++) sqrsum += transData[i][j]*transData[i][j];
        }
        double errvar = sqrsum / (anzPer*(anzVar-anzFac));
        
        double[] mean = new double[anzFac];
        double[][] covD = new double[anzFac][anzFac];
        
        for (int i=0; i<anzPer; i++) 
            for (int j=0; j<anzFac; j++) mean[j] += transData[i][j];
        for (int i=0; i<anzFac; i++) mean[i] /= anzPer;
        for (int i=0; i<anzFac; i++) if (meanPar[i]==-1) mean[i] = meanVal[i];
        
        for (int i=0; i<anzPer; i++)
            for (int j=0; j<anzFac; j++)
                for (int k=0; k<anzFac; k++) covD[j][k] += (transData[i][j]-mean[j])*(transData[i][k]-mean[k]);
        
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) covD[i][j] /= (anzPer);
        
        double[][] work = Statik.transpose(prod2ul);
        for (int i=0; i<anzFac; i++) 
            for (int j=0; j<anzFac; j++) work[i][j] *= errvar;
        
        double[][] subtractMatrix = Statik.multiply(prod2ul, work);
        
        double[] erg = new double[anzPar];
        erg[errPar[0]] = errvar;
        for (int i=0; i<anzFac; i++) if (meanPar[i]!=-1) erg[meanPar[i]] = mean[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<=i; j++) if (covPar[i][j]!=-1) erg[covPar[i][j]] = covD[i][j] - subtractMatrix[i][j];
        
        return erg;    
    }
    
    
    /**
     * ASSUMES same error parameter in all observations.
     * 
     * Transforms the model into a minimal model and remaining error indicator. Then, the error is fit and fixed in the remainder.
     * 
     * TODO: Call of estimate is still over SimpleLGM (to be changed, becomes deprecated)
     * TODO: Means are ignored.
     * 
     * @param initial
     * @return
     */
    public double[] estimateMLSupportedByPowerEquivalence(double[] initial)
    {
        double[][] trans = computePowerEquivalenceTransformationMatrix();
        double[][] prod = Statik.multiply(trans,structure);
        double[][] newStruct = new double[anzFac][]; for (int i=0; i<anzFac; i++) newStruct[i] = prod[i];
        LinearModelNew work = new LinearModelNew(this);
        work.anzVar = anzFac; work.structure = newStruct;
        double[] vec = new double[anzVar];
        double sqrsum = 0;
        for (int i=0; i<work.data.length; i++) {
            vec = Statik.multiply(trans, work.data[i]);
            for (int j=anzFac; j<anzVar; j++) sqrsum += vec[j]*vec[j];
            work.data[i] = new double[anzFac];
            for (int j=0; j<anzFac; j++) work.data[i][j] = vec[j];            
        }
        work.computeMoments();
        double errvar = sqrsum / (anzPer*(anzVar-anzFac)-1);
        work.fixParameter(errPar[0],errvar);
        
        double[] init = new double[initial.length-1];
        int j=0;
        for (int i=0; i<init.length; i++) if (j!=errPar[0]) init[i] = initial[j++];
        double[] zwerg = work.estimateML(init);
        double[] erg = new double[zwerg.length+1];
        j=0; 
        for (int i=0; i<erg.length; i++) if (i==errPar[0]) erg[i]=errvar; else erg[i] = zwerg[j++];
        

        return erg;
    }
    
    private double[][] testBootstrapMLSupportedByPowerEquivalence(double[] initial)
    {
        double[][] trans = computePowerEquivalenceTransformationMatrix();
        double[][] prod = Statik.multiply(trans,structure);
        double[][] newStruct = new double[anzFac][]; for (int i=0; i<anzFac; i++) newStruct[i] = prod[i];
        LinearModelNew work = new LinearModelNew(this);
        work.anzVar = anzFac; work.structure = newStruct;
        double[][] fullDataTrans = new double[anzPer][anzVar];
        for (int i=0; i<work.data.length; i++) {
            fullDataTrans[i] = Statik.multiply(trans, work.data[i]);
            work.data[i] = new double[anzFac];
            for (int j=0; j<anzFac; j++) work.data[i][j] = fullDataTrans[i][j];            
        }
        work.computeMoments();
        work.fixParameter(errPar[0],0);
        SimpleLGM workhorse = new SimpleLGM();
        double[] init = new double[initial.length-1];
        int j=0;
        for (int i=0; i<init.length; i++) if (j!=errPar[0]) init[i] = initial[j++];
        
        int subN = 75;
        int N = anzPer;
        int trials = 100000;
        int[] nr = new int[N];
        
        long time0 = 0, time1 = 1;
        double[][] erg = new double[2][anzPar];
        double[][] mean = new double[2][anzPar];
        double[][] fullDataOrg = Statik.copy(data); data = new double[subN][]; anzPer = subN;
        double[][] fullDataTransCut = Statik.copy(work.data); work.data = new double[subN][]; work.anzPer = subN;
        java.util.Random rand = new java.util.Random();
        long time = System.currentTimeMillis();
        for (int rep=0; rep<trials; rep++)
        {
            for (int i=0; i<N; i++) nr[i] = i;
            Statik.shuffle(nr,rand);
            for (int i=0; i<subN; i++) {data[i] = fullDataOrg[nr[i]]; work.data[i] = fullDataTransCut[nr[i]];}
            computeMoments(); work.computeMoments();
            double sqrsum = 0;
            for (int i=0; i<work.data.length; i++)
                for (j=anzFac; j<anzVar; j++) sqrsum += fullDataTrans[nr[i]][j]*fullDataTrans[nr[i]][j];
            double errvar = sqrsum / (anzPer*(anzVar-anzFac)-1);
            for (int i=0; i<anzFac; i++) work.errVal[i] = errvar;

            double[] zwerg = work.estimateML(init);
            j=0; 
            for (int i=0; i<anzPar; i++) {
                if (i==errPar[0]) {erg[0][i]+=errvar*errvar; mean[0][i] += errvar;} 
                else {erg[0][i] += zwerg[j]*zwerg[j]; mean[0][i] += zwerg[j];  j++;}
            }
            
//            time = System.currentTimeMillis();
//            zwerg = workhorse.twollAproxLinearModel(this, initial);
//            for (int i=0; i<anzPar; i++) {erg[1][i] += zwerg[i]*zwerg[i]; mean[1][i] += zwerg[i];}
//            time1 += (System.currentTimeMillis() - time);
        }
        time0 += (System.currentTimeMillis() - time);
        for (int i=0; i<anzPar; i++) for (int k=0; k<2; k++)
        {
            mean[k][i] /= (double)trials; erg[k][i] = Math.sqrt(erg[k][i]/(double)trials - mean[k][i]*mean[k][i]); 
        }
     
        System.out.println("Time Preprocessing(per trial) = "+(time0/(double)(1000*trials)));
        System.out.println("Time Preprocessing(total)     = "+(time0));
        System.out.println("Time Direct        = "+(time1/(double)(1000*trials)));
        return erg;
    }

    
    public int getAnzFac() {
        return anzFac;
    }
    public int getAnzPar() {
        return anzPar;
    }
    public int getAnzVar() {
        return anzVar;
    }
    public void setParameterValue(int nr, double value)
    {
        for (int i=0; i<anzFac; i++) 
            if (meanPar[i]==nr) meanVal[i]=value;
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (covPar[i][j]==nr) covVal[i][j]=value;
        for (int i=0; i<anzVar; i++)
            if (errPar[i]==nr) errVal[i]=value;
    }
    public void setParameterValue(double[] vals)
    {
        for (int i=0; i<vals.length; i++) setParameterValue(i, vals[i]);
    }
    public void setParameterValueAccordingToOtherModel(LinearModelNew reference, int nr, double value)
    {
        for (int i=0; i<anzFac; i++) 
            if (reference.meanPar[i]==nr) meanVal[i]=value;
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (reference.covPar[i][j]==nr) covVal[i][j]=value;
        for (int i=0; i<anzVar; i++)
            if (reference.errPar[i]==nr) errVal[i]=value;
    }
    public void setParameterValueAccordingToOtherModel(LinearModelNew reference, int nr)
    {
        for (int i=0; i<anzFac; i++) 
            if (reference.meanPar[i]==nr) meanVal[i]=reference.meanVal[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (reference.covPar[i][j]==nr) covVal[i][j]=reference.covVal[i][j];
        for (int i=0; i<anzVar; i++)
            if (reference.errPar[i]==nr) errVal[i]=reference.errVal[i];
    }
    public void setData(double[][] data)
    {
        this.data = data;
        this.anzPer = data.length;
        computeMoments();
    }
    
    public double getParameterValue(int nr)
    {
        for (int i=0; i<anzFac; i++) 
            if (meanPar[i]==nr) return meanVal[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (covPar[i][j]==nr) return covVal[i][j];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]==nr) return errVal[i];
        throw new RuntimeException("Parameter "+nr+" existiert nicht.");
    }
    
    public double[] getParameters()
    {
        double[] erg = new double[anzPar];
        for (int i=0; i<anzFac; i++) 
            if (meanPar[i]!=NOPARAMETER) erg[meanPar[i]] = meanVal[i];
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++) 
                if (covPar[i][j]!=NOPARAMETER) erg[covPar[i][j]] = covVal[i][j];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]!=NOPARAMETER) erg[errPar[i]] = errVal[i];
        return erg;
    }
        
    public void computeMoments()
    {
        if (data==null) return;
        xsum = new double[anzVar];
        dataMean = new double[anzVar];
		for (int i=0; i<anzVar; i++) xsum[i] = 0.0;
		for (int i=0; i<anzPer; i++)
			for (int j=0; j<anzVar; j++) xsum[j] += data[i][j];
		for (int i=0; i<anzVar; i++) dataMean[i] = xsum[i] / (double)anzPer;
			
		xBiSum = new double[anzVar][anzVar];
		dataCov = new double[anzVar][anzVar];
		for (int i=0; i<anzVar; i++)
			for (int j=0; j<=i; j++)
			{
				xBiSum[i][j] = 0.0;
				for (int k=0; k<anzPer; k++) xBiSum[i][j] += data[k][i] * data[k][j];
				for (int k=0; k<anzPer; k++) dataCov[i][j] += (data[k][i]-dataMean[i]) * (data[k][j]-dataMean[j]);
				xBiSum[j][i] = xBiSum[i][j];
				dataCov[i][j] /= (double)anzPer;
				dataCov[j][i] = dataCov[i][j];
			}
    }

    public static LinearModelNew fixParameter(LinearModelNew in, int nr) {LinearModelNew erg = new LinearModelNew(in); erg.fixParameter(nr); return erg;}
    public static LinearModelNew fixParameter(LinearModelNew in, int nr, double value) {LinearModelNew erg = new LinearModelNew(in); erg.fixParameter(nr,value); return erg;}
    public void fixParameter(int nr) {fixParameter(nr, getParameter(nr));}
    public void fixParameter(int nr, double value)
    {
        anzPar--;
        for (int i=0; i<anzFac; i++)
        {
            if (meanPar[i]==nr) { meanVal[i] = value; meanPar[i] = NOPARAMETER;}
            if (meanPar[i] >nr)  meanPar[i]--;
        }
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
            {
                if (covPar[i][j]==nr) { covVal[i][j] = value; covPar[i][j] = -1;}
                if (covPar[i][j] >nr)  covPar[i][j]--;
            }
        for (int i=0; i<anzFac; i++)
        {
            if (errPar[i]==nr) { errVal[i] = value; errPar[i] = NOPARAMETER;}
            if (errPar[i] >nr)  errPar[i]--;
        }
        collectParameterTypesAndPos();
    }
    public static LinearModelNew picDatapoints(LinearModelNew in, int[] piced) {LinearModelNew erg = new LinearModelNew(in); erg.picDatapoints(piced); return erg;}
    public void picDatapoints(int[] piced)
    {
        anzVar = piced.length;
        if (anzPer > 0) 
            for (int i=0; i<anzPer; i++) data[i] = Statik.subvector(data[i], piced);

        structure = Statik.submatrix(structure, piced);
        errVal = Statik.subvector(errVal, piced);
        errPar = Statik.subvector(errPar, piced);
    }
    
    /*
    public static LinearModelNew createMulitpleIndicators(LinearModelNew in, int ind, double[] indVar, double[] indLambda) {LinearModelNew erg = new LinearModelNew(in); erg.createMulitpleIndicators(ind, indVar, indLambda); return erg;}
    public void createMulitpleIndicators(int ind, double[] indVar, double[] indLambda)
    {
        int nanzFac = anzFac + anzVar;
        int nanzPar = anzPar + 1;
        int nanzVar = anzVar * ind;
        
        double[][] nstructure = new double[nanzVar][nanzFac];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<ind; j++)
            {
                for (int k=0; k<anzFac; k++) nstructure[i*ind + j][k] = structure[i][k];
                for (int k=anzFac; k<nanzFac; k++) nstructure[i*ind + j][k] = 0;
                nstructure[i*ind + j][anzFac + i] = indLambda[j];
            }
        int[][] ncovPar = new int[nanzFac][nanzFac];
        double[][] ncovVal = new double[nanzFac][nanzFac];
        for (int i=0; i<anzFac; i++) 
        {
            for (int j=0; j<anzFac; j++) {ncovPar[i][j] = covPar[i][j]; ncovVal[i][j] = covVal[i][j];}
            for (int j=anzFac; j<nanzFac; j++) {ncovPar[i][j] = -1; ncovVal[i][j] = 0;} 
        }
        for (int i=anzFac; i<nanzFac; i++)
            for (int j=0; j<nanzFac; j++) {ncovPar[i][j] = (i==j?newPar:-1); ncovVal[i][j] = (i==j?indVar[(j-anzFac)%ind]:0);}
        
        int[] nmeanPar = new int[nanzFac]; double[] nmeanVal = new double[nanzFac];
        for (int i=0; i<nanzFac; i++)
        {
            nmeanPar[i] = (i<anzFac?meanPar[i]:-1);
            nmeanVal[i] = (i<anzFac?meanVal[i]:0);
        }
        
        int[] nerrPar = new int[nanzVar]; double[] nerrVal = new double[nanzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<ind; j++)
            {
                nerrPar[i*ind + j] = (errPar[i]==-1?-1:errPar[i]+1);
                nerrVal[i*ind + j] = errVal[i];
            }
        
        structure = nstructure;
        covPar = ncovPar;
        covVal = ncovVal;
        meanPar = nmeanPar;
        meanVal = nmeanVal;
        errPar = nerrPar;
        errVal = nerrVal;

        anzFac = nanzFac; anzPar = nanzPar; anzVarPar = nanzVarPar; anzVar = nanzVar;
		fisherInformationMatrix = new double[anzPar][anzPar];
    }
    */
    
    public double[][] createData (int anzPersons) {return createData(anzPersons, covVal, meanVal, structure, errVal);}
    public double[][] createData (int anzPersons, double[][] covMatrix, double[] muVector, double[][] structureMatrix, double[] error)
    {
        this.anzPer = anzPersons;
        int anzVar = structureMatrix.length;
        int anzFac = muVector.length;
        double[][] cholesky = Statik.choleskyDecompose(covMatrix);
        data = new double[anzPersons][anzVar];
        double[][] structureChol = Statik.multiply(structureMatrix,cholesky);
        double[] structureMu   = Statik.multiply(structureMatrix,muVector);

        double[] m = new double[anzFac];
        double[] sm = new double[anzVar];
        for (int i=0; i<anzPersons; i++)
        {
            for (int j=0; j<anzFac; j++) m[j] = SimpleLGM.rand.nextGaussian();
            Statik.multiply(structureChol,m,sm); Statik.add(sm,structureMu,sm);
            for (int j=0; j<anzVar; j++) data[i][j] = sm[j] + SimpleLGM.rand.nextGaussian()*Math.sqrt(error[j]);
        }
        computeMoments();
        return data;
    }
    
    public double[][] evaluateSigma() {return evaluateSigma(null);}
    public double[][] evaluateSigma(double[] position) {
        if ((sigma==null) || (sigma.length!=anzVar) || (sigma[0].length!=anzVar)) sigma = new double[anzVar][anzVar]; 
        evaluateSigma(position, sigma);
        return sigma;
    }
    public void evaluateSigma(double[] position, double[][] erg)
    {
        if (position!=null) setParameter(position);
        if (position==null) position= getParameter();

        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
            {
                double zwerg = 0;
                for (int k=0; k<anzFac; k++)
                    for (int l=0; l<anzFac; l++) 
                        zwerg += structure[i][k]*structure[j][l]*(covPar[k][l]==NOPARAMETER?covVal[k][l]:position[covPar[k][l]]);
                erg[i][j] = zwerg;                
            }
        for (int i=0; i<anzVar; i++) 
            erg[i][i] += (errPar[i]==NOPARAMETER?errVal[i]:position[errPar[i]]);
    }

    public double[] evaluateMu(double[] position) {if ((mu==null) || (mu.length!=anzVar)) mu = new double[anzVar]; evaluateMu(position, mu); return mu;}
    public void evaluateMu(double[] position, double[] erg)
    {
        for (int i=0; i<anzVar; i++)
        {
            double zwerg = 0;
            for (int j=0; j<anzFac; j++) zwerg += structure[i][j]*(meanPar[j]==NOPARAMETER?meanVal[j]:position[meanPar[j]]);
            erg[i] = zwerg;                
        }
    }
    
    public double[][] evaluateFactorMatrix(double[] position) {double[][] erg = new double[anzFac][anzFac]; evaluateFactorMatrix(position, erg); return erg;}
    public void evaluateFactorMatrix(double[] position, double[][] erg)
    {
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                erg[i][j] = (covPar[i][j]==NOPARAMETER?covVal[i][j]:position[covPar[i][j]]);
    }
    
    public double[][][] evaluateSigmaDev()
    {
        double[][][] erg = new double[anzPar][anzVar][anzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
                for (int k=0; k<anzFac; k++)
                    for (int l=0; l<anzFac; l++)
                        if (covPar[k][l]!=NOPARAMETER) erg[covPar[k][l]][i][j] += structure[i][k]*structure[j][l];
        for (int i=0; i<anzVar; i++)
            if (errPar[i]!=NOPARAMETER) erg[errPar[i]][i][i] += 1;
        return erg;
    }
    
    public double[][] evaluateMuDev()
    {
        double[][] erg = new double[anzPar][anzVar];
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzFac; j++)
                if (meanPar[j]!=NOPARAMETER) erg[meanPar[j]][i] += structure[i][j];
        return erg;
    }
    
    public boolean factorPositiveDefinite(double[] position)
    {
        if ((facCovWork==null) || (facCovWork.length!=anzVar) || (facCovWork[0].length!=anzVar)) facCovWork = new double[anzVar][anzVar]; 
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                facCovWork[i][j] = (covPar[i][j]==NOPARAMETER?covVal[i][j]:position[covPar[i][j]]);
        return (Statik.determinantOfPositiveDefiniteMatrix(facCovWork) != -1); 
    }
    
    public void raiseVarianceParameters(double[] position)
    {
        for (int i=0; i<anzFac; i++)
        	if (covPar[i][i]!=NOPARAMETER) position[covPar[i][i]] = Math.abs(position[covPar[i][i]]) + 10;
                
        for (int i=0; i<errPar.length; i++)
            if (errPar[i] != NOPARAMETER) position[errPar[i]] = Math.abs(position[errPar[i]]) + 10;
    }
    
    public double evaluateLeastSquareIndex(double[][] observedCovariances, double[] observedMeans, double[] position)
    {
        double[][] sigma = evaluateSigma(position);
        double[] mu = evaluateMu(position);
        double erg = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) erg += (sigma[i][j] - observedCovariances[i][j])*(sigma[i][j] - observedCovariances[i][j]);
        for (int i=0; i<anzVar; i++) erg += (mu[i] - observedMeans[i])*(mu[i] - observedMeans[i]);
        return erg;
    }

    public void computeLeastSquaresDerivatives(double[] value, boolean recomputeMuAndSigma) {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((muWork==null) || (muWork.length!=anzVar)) muWork = new double[anzVar];
        if ((lsD==null) || (lsD.length!=anzPar)) lsD = new double[anzPar];
        if ((lsDD==null) || (lsDD.length!=anzVar) || (lsDD[0].length!=anzVar)) lsDD = new double[anzPar][anzPar];
        
        if (value != null) setParameter(value);
        if (recomputeMuAndSigma) evaluateMuAndSigma(value);
        
        ls = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) {sigmaWork[i][j] = sigma[i][j] - dataCov[i][j]; ls += 0.5*sigmaWork[i][j]*sigmaWork[i][j];}
        for (int i=0; i<anzVar; i++) {muWork[i] = mu[i] - dataMean[i]; ls += 0.5*muWork[i]*muWork[i];}
        
        for (int p=0; p<anzPar; p++)
        {
            lsD[p] = 0;
            if (parType[p] == parameterType.mean)
                for (int i=0; i<anzVar; i++) lsD[p] += structure[i][parPos[p][0]]*muWork[i];
            if (parType[p] == parameterType.facCov)
            {
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++) 
                        lsD[p] += (parPos[p][0]==parPos[p][1]?1:2)*(structure[i][parPos[p][0]]*structure[j][parPos[p][1]])*sigmaWork[i][j];
            }
            if (parType[p] == parameterType.err)
                for (int i=0; i<anzVar; i++) lsD[p] += sigmaWork[i][i];
            for (int p2l=p; p2l<anzPar; p2l++)
            {
                int p1 = p, p2 = p2l;
                    p1 = p2l; p2 = p;
                
                lsDD[p1][p2] = 0;
                if ((parType[p1] == parameterType.facCov) && (parType[p2] == parameterType.facCov))
                {
                    for (int i=0; i<anzVar; i++)
                        for (int j=0; j<anzVar; j++) 
                        {
                            double f1 = structure[i][parPos[p1][0]]*structure[j][parPos[p1][1]]+
                                        structure[j][parPos[p1][0]]*structure[i][parPos[p1][1]]; if (parPos[p1][0]==parPos[p1][1]) f1 /= 2;
                            double f2 = structure[i][parPos[p2][0]]*structure[j][parPos[p2][1]]+
                                        structure[j][parPos[p2][0]]*structure[i][parPos[p2][1]]; if (parPos[p2][0]==parPos[p2][1]) f2 /= 2;
                            lsDD[p1][p2] += f1*f2;
                        }
                }
                if ((parType[p1] == parameterType.facCov) && (parType[p2] == parameterType.err))
                    for (int i=0; i<anzVar; i++)
                        if (errPar[i]==p2) lsDD[p1][p2] += (parPos[p][0]==parPos[p][1]?1:2)*(structure[i][parPos[p1][0]]*structure[i][parPos[p1][1]]);
                if ((parType[p1] == parameterType.err) && (parType[p2] == parameterType.err))
                    for (int i=0; i<anzVar; i++) if (errPar[i]==p2) lsDD[p1][p2]++;
                if ((parType[p1] == parameterType.mean) && (parType[p2] == parameterType.mean))
                    for (int i=0; i<anzVar; i++)
                        lsDD[p1][p2] += structure[i][parPos[p1][0]]*structure[i][parPos[p2][0]];

                lsDD[p2][p1] = lsDD[p1][p2];
            }
        }
    }
    
    public double computeLogLikelihood(double[] value)
    {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];

        evaluateMuAndSigma(value);
        sigmaDet = Statik.invert(sigma,sigInv, sigmaWork);
        if ((Statik.determinantOfPositiveDefiniteMatrix(sigma)==-1) && (sigmaDet > 0))
            sigmaDet = Double.NaN;
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(sigmaDet);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += sigInv[i][j]*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
        
        return ll;
    }
    
    public void computeLogLikelihoodDerivatives(double[] value, boolean recomputeMuAndSigma) {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((sigmaWork2==null) || (sigmaWork2.length!=anzVar) || (sigmaWork2[0].length!=anzVar)) sigmaWork2 = new double[anzVar][anzVar];
        if ((sigmaWork3==null) || (sigmaWork3.length!=anzVar) || (sigmaWork3[0].length!=anzVar)) sigmaWork3 = new double[anzVar][anzVar];
        if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];
        if ((llD==null) || (llD.length!=anzPar)) llD = new double[anzPar];
        if ((llDD==null) || (llDD.length!=anzVar) || (llDD[0].length!=anzVar)) llDD = new double[anzPar][anzPar];
        
        if (value != null) setParameter(value);
        if (recomputeMuAndSigma) evaluateMuAndSigma(value);
        
        sigmaDet = Statik.invert(sigma,sigInv, sigmaWork);
        if ((Statik.determinantOfPositiveDefiniteMatrix(sigma)==-1) && (sigmaDet > 0))
            sigmaDet = Double.NaN;
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(sigmaDet);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += sigInv[i][j]*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);

        if (addErrorInfo != null)
        {
            for (int i=0; i<addErrorInfo.length; i++) {
                int ix = (int)addErrorInfo[i][0];
                ll += addErrorInfo[i][1]*Math.log(value[ix]) + addErrorInfo[i][2]/value[ix];
            }
        }
        
        for (int p=0; p<anzPar; p++)
        {
            llD[p] = 0.0;
            if (parType[p] == parameterType.mean)
            {
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++) llD[p] -= 2*structure[i][parPos[p][0]]*sigInv[i][j]*anzPer*(dataMean[j] - mu[j]);
            } 
            if (parType[p] != parameterType.mean)
            {
                computeSigmaInvDev(p, sigmaWork);
                double trace = 0;
                for (int i=0; i<anzVar; i++) trace += sigmaWork[i][i];
                llD[p] += trace*anzPer;
                Statik.multiply(sigmaWork, sigInv, sigmaWork2);
                for (int i=0; i<anzVar; i++) 
                    for (int j=0; j<anzVar; j++) llD[p] -= sigmaWork2[i][j]*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
            }
            if (addErrorInfo != null)
            {
                for (int i=0; i<addErrorInfo.length; i++) {
                    int ix = (int)addErrorInfo[i][0];
                    llD[ix] += (addErrorInfo[i][1]*value[ix] - addErrorInfo[i][2])/(value[ix]*value[ix]);
                }
            }
        }
        
        for (int p1=0; p1<anzPar; p1++)
            for (int p2=0; p2<anzPar; p2++)
                llDD[p1][p2] = 0;
        for (int p1=0; p1<anzPar; p1++)
            for (int p2=0; p2<anzPar; p2++)
            {
                // Term 4 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]==parameterType.mean) && (parType[p2]==parameterType.mean))
                {
                    for (int i=0; i<anzVar; i++)
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += 2*anzPer*structure[i][parPos[p1][0]]*structure[j][parPos[p2][0]]*sigInv[i][j];
                }
                // Term 3 and 5 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if (((parType[p1]!=parameterType.facCov) && (parType[p1]!=parameterType.err) && (parType[p2]!=parameterType.mean))
                ||  ((parType[p1]!=parameterType.mean) && (parType[p2]!=parameterType.facCov) && (parType[p2]!=parameterType.err)))
                {
                    boolean exchange = (parType[p1]==parameterType.facCov) || (parType[p1]==parameterType.err)
                                        || (parType[p2]==parameterType.mean);
                    int q1 = (exchange?p2:p1), q2 = (exchange?p1:p2); 
                    computeSigmaInvDev(q2, sigmaWork2);
                    Statik.multiply(sigmaWork2, sigInv, sigmaWork);
                    if (parType[q1]==parameterType.mean)
                    {
                        for (int i=0; i<anzVar; i++)
                            for (int j=0; j<anzVar; j++)
                                llDD[p1][p2] += 2*structure[i][parPos[q1][0]]*sigmaWork[i][j]*anzPer*(dataMean[j]-mu[j]);
                    } else {
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += 2*meanVal[parPos[q1][1]]*sigmaWork[parPos[q1][0]][j]*anzPer*(dataMean[j]-mu[j]);
                    }
                }
                
                // Term 1,6,7 and 8 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]!=parameterType.mean) && (parType[p2]!=parameterType.mean))
                {
                    computeSigmaInvDev(p1, sigmaWork);
                    computeSigmaInvDev(p2, sigmaWork2);
                    computeSigmaInvDevDev(p1, p2, sigmaWork3);
                    Statik.multiply(sigmaWork, sigmaWork2, sigmaWork4);
                    double trace = 0;
                    for (int i=0; i<anzVar; i++) trace += sigmaWork3[i][i] - sigmaWork4[i][i];
                    llDD[p1][p2] += trace*anzPer;
                    Statik.multiply(sigmaWork4, sigInv, sigmaWork);
                    Statik.multiply(sigmaWork3, sigInv, sigmaWork2);
                    for (int i=0; i<anzVar; i++)
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += (2*sigmaWork[i][j] - sigmaWork2[i][j])*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
                }
                
                // Additional Error Information
                if (addErrorInfo != null)
                {
                    for (int i=0; i<addErrorInfo.length; i++) {
                        int ix = (int)addErrorInfo[i][0];
                        llDD[ix][ix] += (2*addErrorInfo[i][2] - addErrorInfo[i][2]*value[ix])/(value[ix]*value[ix]*value[ix]);
                    }
                }
            }
    }

    protected void computeMatrixTimesMuDev(int par, double[][] matrix, double[] erg) {
        for (int i=0; i<anzVar; i++) erg[i] = 0;
        if (parType[par]==parameterType.mean) {
            for (int i=0; i<anzVar; i++)
            {
                erg[i] = 0;
                if (matrix==null) erg[i] = structure[i][parPos[par][0]];
                else for (int j=0; j<anzVar; j++) erg[i] += matrix[i][j] * structure[j][parPos[par][0]];
            }
        }
    }
    protected void computeMatrixTimesSigmaDev(int par, double[][] matrix, double[][] erg) {
        if (parType[par]==parameterType.mean) 
            for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = 0;
        if (parType[par]==parameterType.facCov)
        {
            if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
            for (int i=0; i<anzVar; i++) for (int j=i; j<anzVar; j++) 
            {
                sigmaWork4[i][j] = sigmaWork4[j][i] = structure[i][parPos[par][0]] * structure[j][parPos[par][1]] + 
                      (parPos[par][0]!=parPos[par][1]?structure[j][parPos[par][0]] * structure[i][parPos[par][1]]:0);
            }
            if (matrix==null) Statik.copy(sigmaWork4,erg); else Statik.multiply(matrix, sigmaWork4, erg);            
        }
        if (parType[par]==parameterType.err)
        {
            for (int i=0; i<anzVar;  i++) 
                for (int j=0; j<anzVar; j++) 
                    erg[i][j] = (errPar[j]!=par?0:(matrix==null?(i==j?1:0):matrix[i][j]));
        }
    }
    protected void computeMatrixTimesSigmaDevDev(int par1, int par2, double[][] matrix, double[][] erg) {
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++) erg[i][j] = 0;
    }
    public Model copy() {
        return new LinearModelNew(this);
    }
    public void evaluateMuAndSigma(double[] values) {
        evaluateSigma(values);
        evaluateMu(values);
    }
    public double getParameter(int nr) {
        return getParameterValue(nr);
    }
    public boolean isErrorParameter(int nr) {
        boolean erg = false;
        for (int i=0; i<errPar.length; i++) if (errPar[i] == nr) erg = true;
        return erg;
    }
    
    public void setParameter(int nr, double value) {
        setParameterValue(nr,value);
    }
    
    /*
    public double[] leastSquareAproxLinearModel() 
    {
        if (anzPar == 0) return new double[0];
        // initial vector set to (0,...,0) for easier computation

    	double[] fitDev1 = new double[anzMeanPar];
    	for (int i=0; i<anzMeanPar; i++) fitDev1[i] = 0.0;
    	double[][] fitJac1 = new double[anzMeanPar][anzMeanPar];
    	for (int i=0; i<anzMeanPar; i++)
    		for (int j=0; j<anzMeanPar; j++) fitJac1[i][j] = 0.0;

    	double[] fitDev2 = new double[anzVarPar + anzErrPar];
    	for (int i=0; i<anzVarPar + anzErrPar; i++) fitDev2[i] = 0.0;
    	double[][] fitJac2 = new double[anzVarPar + anzErrPar][anzVarPar + anzErrPar];
    	for (int i=0; i<anzVarPar + anzErrPar; i++)
    		for (int j=0; j<anzVarPar + anzErrPar; j++) fitJac2[i][j] = 0.0;

    	for (int i=0; i<anzVar; i++)
    	{
    	    double v = 0.0;
    	    for (int j=0; j<anzFac; j++) if (meanPar[j]==NOPARAMETER) v += structure[i][j] * meanVal[j]; 
    	    v -= dataMean[i]; v *= 2.0; 
    		for (int j=0; j<anzFac; j++)
    			if (meanPar[j]!=NOPARAMETER) fitDev1[meanPar[j]] += structure[i][j]*v;	// Ableitungen

    		for (int k=0; k<anzFac; k++)
    			for (int l=0; l<anzFac; l++)
    				if ((meanPar[k]!=NOPARAMETER) && (meanPar[l]!=NOPARAMETER)) 
    					fitJac1[meanPar[k]][meanPar[l]] += 2.0*structure[i][k]*structure[i][l];
    	}

    	for (int i=0; i<anzVar; i++)
    	{
    		for (int j=0; j<anzVar; j++)
    		{
    		    double v = 0.0; 
        	    for (int k=0; k<anzFac; k++) 
        	        for (int l=0; l<anzFac; l++)
        	            if (covPar[k][l]==NOPARAMETER) v += structure[i][k] * structure[j][l] * covVal[k][l];
        	    if ((i==j) && (errPar[i]==NOPARAMETER)) v += errVal[i];
    		    v -= dataCov[i][j]; v *= 2.0;
    		    
    			for (int k=0; k<anzFac; k++)
    			    for (int l=0; l<anzFac; l++)
    			        if (covPar[k][l]!=NOPARAMETER)
    			            fitDev2[covPar[k][l]-anzMeanPar] += structure[i][k] * structure[j][l] * v;	// Ableitungen
    			if ((i==j) && (errPar[i]!=NOPARAMETER)) fitDev2[errPar[i]-anzMeanPar] += v;
    			
    			for (int k=0; k<anzFac; k++)
    				for (int l=0; l<anzFac; l++)
    				    if (covPar[k][l]!=NOPARAMETER)
    		    			for (int k2=0; k2<anzFac; k2++)
    		    				for (int l2=0; l2<anzFac; l2++)
    		    				    if (covPar[k2][l2]!=NOPARAMETER) 
    		    				        fitJac2[covPar[k][l]-anzMeanPar][covPar[k2][l2]-anzMeanPar] += 2*structure[i][k]*structure[j][l]*structure[i][k2]*structure[j][l2];
    			if ((i==j) && (errPar[i]!=NOPARAMETER)) 
    			{
    			    for (int k=0; k<anzFac; k++)
    			        for (int l=0; l<anzFac; l++)
    			            if (covPar[k][l]!=NOPARAMETER) 
    			            {
    			                v = 2*structure[i][k]*structure[j][l];
    			                fitJac2[covPar[k][l]-anzMeanPar][errPar[i]-anzMeanPar] += v; fitJac2[errPar[i]-anzMeanPar][covPar[k][l]-anzMeanPar] += v;
    			            }
    			    fitJac2[errPar[i]-anzMeanPar][errPar[i]-anzMeanPar] += 2.0;
    			}
    		}
    	}
/*
    	final LinearModel fthis = this;
		DoubleFunction foo = new DoubleFunction(){
		    public double foo(double[] arg) {
				// Evaluation of Sigma
		        return fthis.sigmaSquaredError(arg);
		    }
		};
		double[] zero = new double[anzPar];
		double[][] numJacobian = Statik.numericalHessian(foo, zero, 0.001);
		System.out.println("Numerical Jacobian = \r\n"+Statik.matrixToString(numJacobian));
		double[] numGradient = Statik.numericalGradient(foo, zero, 0.001);
		System.out.println("Numerical Gradient = "+Statik.matrixToString(numGradient));
		
		System.out.println("Jacobian       = \r\n"+Statik.matrixToString(fitJac2));
		System.out.println("Gradient       = \r\n"+Statik.matrixToString(fitDev2));
    	
    	double[][] jinv1 = Statik.invert(fitJac1);
    	double[][] jinv2 = Statik.invert(fitJac2);

    	double[] erg = new double[anzPar];
    	for (int i=0; i<anzMeanPar; i++)
    		for (int j=0; j<anzMeanPar; j++) erg[i] -= jinv1[i][j]*fitDev1[j];
    		
    	for (int i=0; i<anzVarPar + anzErrPar; i++)
    		for (int j=0; j<anzVarPar + anzErrPar; j++) erg[i+anzMeanPar] -= jinv2[i][j]*fitDev2[j];

/*
    	double[][] theoSigma = null;
    	if (anzPar==6) theoSigma = evaluateSigma(new double[]{100,-20,100,50,0,1});
    	if (anzPar==5) theoSigma = evaluateSigma(new double[]{100,-20,100,50,1});
    	if (anzPar==3) theoSigma = evaluateSigma(new double[]{100,-20,1});
    	System.out.println(Statik.matrixToString(theoSigma));
    	System.out.println(Statik.matrixToString(observedCovariances));
    	System.out.println(Statik.matrixToString(erg));
    	
    	return erg;
    }
    */
    
    public double sigmaSquaredError(double[] position)
    {
        double[][] sigma = evaluateSigma(position);
        double error = 0;
        for (int i=0; i<dataCov.length; i++)
            for (int j=0; j<dataCov[i].length; j++) error += (sigma[i][j]-dataCov[i][j])*(sigma[i][j]-dataCov[i][j]);
        return error;
    }
    
    public boolean significantlyDifferent(int parameter, double value, double compare)
    {
        double[][] fisherInv = Statik.invert(fisherInformationMatrix);
        double v = Math.abs(value-compare) / Math.sqrt(fisherInv[parameter][parameter]);
        return (v > 1.645);
    }

    /*
    public void computeFisher(){computeFisher(getParameters());}
    public void computeFisher(double[] xd)
    {
		double[][][] sigmaDev = evaluateSigmaDev();
		double[][] muDev = evaluateMuDev();
		double[][] sigD = evaluateSigma(xd);
		double[][] sigMInvD = new double[anzVar][anzVar];
		double[][] mat1 = new double[anzVar][anzVar];	// Arbeitsplatz fr Matrixinvertierung
		double[][][] sigMInvSigDevD = new double[anzPar][anzVar][anzVar];
		double[][][] sigMInvSigDevDSigMInv = new double[anzPar][anzVar][anzVar];

		Statik.invert(sigD, sigMInvD, mat1);
		for (int i=0; i<anzPar; i++)
		{
			Statik.multiply(sigMInvD, sigmaDev[i], sigMInvSigDevD[i]);
			Statik.multiply(sigMInvSigDevD[i], sigMInvD, sigMInvSigDevDSigMInv[i]);
		}
		// Aufbau der Jacobi-Matrix, zunchst Mittelwert - Mittelwert
		for (int i=0; i<anzMeanPar; i++)
			for (int j=i; j<anzMeanPar; j++)
			{
				double sum = 0.0;
				for (int k=0; k<anzVar; k++)
					for (int l=0; l<anzVar; l++)
						sum += sigMInvD[k][l] * muDev[i][k] * muDev[j][l];
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = 2*anzPer*sum; 
			}
		// jetzt Mittelwert - Varianz
		for (int i=0; i<anzMeanPar; i++)
			for (int j=anzMeanPar; j<anzPar; j++)
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = 0.0; 
		// und jetzt Varianz - Varianz
		for (int i=anzMeanPar; i<anzPar; i++)
			for (int j=i; j<anzPar; j++)
			{
				Statik.multiply(sigMInvSigDevD[i-anzMeanPar],sigMInvSigDevD[j-anzMeanPar], mat1);

				double spur = 0.0;
				for (int k=0; k<anzVar; k++) spur += mat1[k][k];
				fisherInformationMatrix[i][j] = fisherInformationMatrix[j][i] = (double)anzPer * spur / 2.0; 
			}
    }
    */
    
    public static void steveSimulation()
    {
        double errvar = 0.1, errstdv = Math.sqrt(errvar);
        LinearModelNew model = new LinearModelNew(
                new double[][]{{1,-5,25},{1,-4,16},{1,-3,9},{1,-2,4},{1,-1,1},{1,0,0},{1,1,1},{1,2,4},{1,3,9},{1,4,16},{1,5,25}},
                new int[][]{{0,3,4},{3,1,5},{4,5,2}},
                new double[][]{{1,0,0},{0,1,0},{0,0,1}},
                new int[]{-1,-1,-1},
                new double[]{0,0,0},
                new int[]{6,6,6,6,6,6,6,6,6,6,6},
                new double[]{.1,.1,.1,.1,.1,.1,.1,.1,.1,.1,.1}
                );
        
//        double[] initial = new double[]{1,1,1,0,0,0,errvar};
        model.fixParameter(4, 0);
        double[] initial = new double[]{1,1,0,0,0,errvar};
        int N = 100;
        int dataLength = 100;
        double probPhaseJump = 0.05;
        double[][] fullData = new double[N][dataLength];
        
        java.util.Random rand = new java.util.Random();
        double f = 0.05;
        double phase = 0;
        f = 0.06; for (int n=0; n<N/3; n++)
            for (int i=0; i<dataLength; i++) 
            {if (rand.nextDouble()<probPhaseJump) phase = rand.nextDouble()*2*Math.PI; fullData[n][i] = Math.sin(2*Math.PI*i*f+phase) + rand.nextGaussian()*errstdv;};
        f = 0.08; for (int n=N/3; n<2*N/3; n++)
            for (int i=0; i<dataLength; i++) 
            {if (rand.nextDouble()<probPhaseJump) phase = rand.nextDouble()*2*Math.PI; fullData[n][i] = Math.sin(2*Math.PI*i*f+phase) + rand.nextGaussian()*errstdv;};
        f = 0.1; for (int n=2*N/3; n<N; n++)
            for (int i=0; i<dataLength; i++) 
            {if (rand.nextDouble()<probPhaseJump) phase = rand.nextDouble()*2*Math.PI; fullData[n][i] = Math.sin(2*Math.PI*i*f+phase) + rand.nextGaussian()*errstdv;};

        for (int i=30; i<70; i++) System.out.println(fullData[5][i]+"\t"+fullData[50][i]+"\t"+fullData[85][i]);
            
        // contains double[], first number of members in cluster, second -2ll value, sequential cluster members
        double[][] cluster = new double[2*N][];
        double[][][] data = new double[2*N][][];
        boolean[] isActive = new boolean[2*N]; 
        for (int i=0; i<2*N; i++) isActive[i] = false; for (int i=0; i<N; i++) isActive[i] = true;
        for (int i=0; i<N; i++)
            cluster[i] = new double[]{1,-1,i};
        
        long time = System.currentTimeMillis();
        
        for (int i=0; i<N; i++)
        {
            data[i] = new double[dataLength-11+1][11];
            for (int j=0; j<dataLength-11+1; j++)
                for (int k=0; k<11; k++) data[i][j][k] = fullData[i][j+k];
            model.data = data[i]; model.anzPer = model.data.length;
            model.computeMoments();
            double[] est1 = model.estimateMLSupportedByPowerEquivalence(initial); double ll1 = model.ll; ll1 = model.ll;
            double[] est2 = model.estimateML(initial); double ll2 = model.ll;
            double[] est3 = model.estimateMLFullCovarianceSupportedByPowerEquivalence(); double ll3 = model.ll;
            System.out.println(Statik.matrixToString(est1)+"\t\t"+ll1+"\r\n"+Statik.matrixToString(est2)+"\t\t"+ll2+
                    "\r\n"+Statik.matrixToString(est3)+"\t\t"+ll3+"\r\n");
            cluster[i][1] = model.ll;
        }

        // cluster1, cluster2, loss
        TreeSet<double[]> pairs = new TreeSet<double[]>(new Comparator<double[]>(){
            public int compare(double[] a, double[] b) {return (a[2]>b[2]?1:(a[2]<b[2]?-1:0));}
        });        

        for (int i=0; i<N; i++)
            for (int j=i+1; j<N; j++)
            {
                double[][] combinedData = new double[data[i].length+data[j].length][];
                for (int k=0; k<data[i].length; k++) combinedData[k] = data[i][k];
                for (int k=0; k<data[j].length; k++) combinedData[k+data[i].length] = data[j][k];
                model.data = combinedData; model.anzPer = model.data.length;
                model.computeMoments();
                model.estimateMLFullCovarianceSupportedByPowerEquivalence();
//              model.estimateMLSupportedByPowerEquivalence(initial);
//                workhorse.twollAproxLinearModel(model, initial); model.lastMinusTwoLL = workhorse.twollValue;
                double loss = model.ll - cluster[i][1] - cluster[j][1];
                pairs.add(new double[]{i,j,loss});
            }

        int ergcounter = 2*N-2;
        int[] ergnr = new int[2*N-1];
        double[][] memory = new double[2*N][];
        double[] t; double[][] t2;
        int anzCluster = N;
        // Start of clustering
        while (!pairs.isEmpty())
        {
            double[] winner = pairs.first();
            int wi = (int)winner[0], wj = (int)winner[1]; 
            double[][] winningData = new double[data[wi].length+data[wj].length][];
            for (int k=0; k<data[wi].length; k++) winningData[k] = data[wi][k];
            for (int k=0; k<data[wj].length; k++) winningData[k+data[wi].length] = data[wj][k];
            cluster[anzCluster] = cluster[wi]; data[anzCluster] = data[wi]; 
            cluster[wi] = new double[2+(int)Math.round(cluster[anzCluster][0]) + (int)Math.round(cluster[wj][0])];
            cluster[wi][0] = cluster[anzCluster][0] + cluster[wj][0]; cluster[wi][1] = winner[2] + cluster[anzCluster][1] + cluster[wj][1]; 
            for (int i=0; i<cluster[anzCluster][0]; i++) cluster[wi][i+2] = cluster[anzCluster][i+2];
            for (int i=0; i<cluster[wj][0]; i++) cluster[wi][i+(int)cluster[anzCluster][0]+2] = cluster[wj][i+2];
            data[wi] = winningData;
            isActive[wj] = false;
            anzCluster++;
            
            int count = 0;
            for (double[] w:pairs) 
                if (((int)w[0]==wi) || ((int)w[0]==wj) || ((int)w[1]==wi) || ((int)w[1]==wj)) memory[count++] = w;
            for (int i=0; i<count; i++) pairs.remove(memory[i]);
            ergnr[ergcounter--] = anzCluster-1; ergnr[ergcounter--] = wj;
            
            for (int i=0; i<cluster.length; i++) if ((i!=wi) && (isActive[i]))
            {
                double[][] combinedData = new double[data[i].length+data[wi].length][];
                for (int k=0; k<data[i].length; k++) combinedData[k] = data[i][k];
                for (int k=0; k<data[wi].length; k++) combinedData[k+data[i].length] = data[wi][k];
                model.data = combinedData; model.anzPer = model.data.length;
                model.computeMoments();
                model.estimateMLFullCovarianceSupportedByPowerEquivalence();
//                model.estimateMLSupportedByPowerEquivalence(initial);
//                workhorse.twollAproxLinearModel(model, initial); model.lastMinusTwoLL = workhorse.twollValue;
                double loss = model.ll - cluster[i][1] - cluster[wi][1];
                pairs.add(new double[]{i,wi,loss});
            }
            if (pairs.isEmpty()) ergnr[ergcounter--] = wi;
        }
        
        for (int i=0; i<10; i++) System.out.println(Statik.matrixToString(cluster[ergnr[i]])); 
            
        System.out.println("Total time = "+(System.currentTimeMillis() - time));
    }
    
    public static void ldeFitDrumming()
    {
        int tau = 10;
        double[][] rawData = Statik.loadMatrix("continuous\\SE342__3_2_2_6.raw", '\t');
        int embed = 25; 
        double deltaT = 0.001;
        double[][] data = new double[rawData.length-embed*tau+1][2*embed];
        for (int i=0; i<data.length; i++)
        {
            for (int j=0; j<embed; j++) data[i][j] = rawData[i+j*tau][1];
            for (int j=0; j<embed; j++) data[i][embed+j] = rawData[i+j*tau][2];
        }
        
        int half = embed / 2;
        double[][] struct = new double[2*embed][6];
        for (int i=0; i<2*embed; i++) 
        {
            if (i<embed) struct[i] = new double[]{1,(i-half)*deltaT*tau,(i-half)*deltaT*tau*(i-half)*deltaT*tau,0,0,0};
            else         struct[i] = new double[]{0,0,0,1,(i-half)*deltaT*tau,(i-half)*deltaT*tau*(i-half)*deltaT*tau};
        }
        int[][] cov = new int[][]{
                {0,1,2,-1,-1,3},
                {1,4,5,-1,-1,-1},
                {2,5,6,7,-1,-1},
                {-1,-1,7,8,9,10},
                {-1,-1,-1,9,11,12},
                {3,-1,-1,10,12,13}};
        int[] errPar = new int[2*embed];
        for (int i=0; i<embed; i++) errPar[i] = 14;
        for (int i=embed; i<2*embed; i++) errPar[i] = 15;
        double[] errVal = new double[2*embed]; for (int i=0; i<2*embed; i++) errVal[i] = 1;
        
        LinearModelNew model = new LinearModelNew(
                struct,
                cov,
                Statik.identityMatrix(6),
                new int[]{-1,-1,-1,-1,-1,-1},
                new double[]{0,0,0,0,0,0},
                errPar,
                errVal
                );
        model.setData(data);
        model.computeMoments();
        for (int i=0; i<data.length; i++)
            for (int j=0; j<2*embed; j++) 
                model.data[i][j] -= model.dataMean[j];
        model.computeMoments();
        
        double[] initial = new double[16];
        for (int i=0; i<16; i++) initial[i] = model.getParameterValue(i);
        
        double[][] substruct = new double[embed][3];
        for (int i=0; i<embed; i++) 
            substruct[i] = new double[]{1,(i-half)*deltaT*tau,(i-half)*deltaT*tau*(i-half)*deltaT*tau};
        LinearModelNew submodel = new LinearModelNew(substruct);
        double[][] subTransform = submodel.computePowerEquivalenceTransformationMatrix();
        double[][] totalTransform = new double[2*embed][2*embed];
        for (int i=0; i<embed; i++) for (int j=0; j<embed; j++) 
            totalTransform[i][j] = totalTransform[i+embed][j+embed] = subTransform[i][j];
        double[][] prodstruct = Statik.multiply(totalTransform,model.structure);
        double[][] proddata = new double[model.anzPer][6];
        for (int i=0; i<model.anzPer; i++)
            proddata[i] = Statik.multiply(totalTransform, model.data[i]);
        double[][] newstruct = new double[6][6];
        for (int i=0; i<3; i++) for (int j=0; j<3; j++) 
            newstruct[i][j] = newstruct[i+3][j+3] = prodstruct[i][j];
        double[][] newdata = new double[model.anzPer][6];
        for (int i=0; i<model.anzPer; i++) for (int j=0; j<3; j++) { 
            newdata[i][j] = proddata[i][j];
            newdata[i][j+3] = proddata[i][embed+j];
        }
        double sqrsum1 = 0, sqrsum2 = 0;
        for (int i=0; i<newdata.length-3; i++) {
            for (int j=3; j<embed; j++) sqrsum1 += proddata[i][j]*proddata[i][j];
            for (int j=3; j<embed; j++) sqrsum2 += proddata[i][j+embed]*proddata[i][j+embed];
        }
        double errvar1 = sqrsum1 / (model.anzPer*(embed-3));
        double errvar2 = sqrsum2 / (model.anzPer*(embed-3));
//        model.fixParameter(errPar[0],   errvar1);
//        model.fixParameter(errPar[embed],errvar2);
        double[] suberrVal = new double[]{errvar1,errvar1,errvar1,errvar2,errvar2,errvar2};
        int[] suberrPar = new int[]{14,14,14,15,15,15};
        double[][] additionalErrorInformation = new double[][]{{14,model.anzPer*(embed-3),sqrsum1},{15,model.anzPer*(embed-3),sqrsum2}};
        
        LinearModelNew redModel = new LinearModelNew(newstruct, model.covPar, model.covVal, model.meanPar,
                model.meanVal,suberrPar,suberrVal);
        double[] redInitial = new double[initial.length-2];
        for (int i=0; i<redInitial.length; i++) redInitial[i] = initial[i];
        redModel.setData(newdata);

        // computing full covariance matrix symbolically
        double[][] redStructInv = Statik.invert(newstruct);
        double[][] redDataTrans = new double[model.anzPer][];
        for (int i=0; i<model.anzPer; i++) redDataTrans[i] = Statik.multiply(redStructInv, newdata[i]);
        double[][] errCov = Statik.multiply(redStructInv,Statik.transpose(redStructInv));
        for (int i=0; i<3; i++) for (int j=0; j<3; j++) { errCov[i][j] *= errvar1; errCov[i+3][j+3] *= errvar2;}
        double[][] symbCovariance = Statik.covarianceMatrix(redDataTrans);
        Statik.subtract(symbCovariance, errCov, symbCovariance);
        double[] symbEstimate = new double[model.anzPar];
        for (int i=0; i<6; i++) for (int j=0; j<6; j++) if (model.covPar[i][j] != -1) symbEstimate[model.covPar[i][j]] = symbCovariance[i][j];
        symbEstimate[14] = errvar1; symbEstimate[15] = errvar2;
        double[] initialFromSymb = Statik.copy(symbEstimate);
        double symbLL = model.computeLogLikelihood(initialFromSymb);
        while (Double.isNaN(symbLL)) {
            initialFromSymb[14] *= 2; initialFromSymb[15] *= 2;
            symbLL = model.computeLogLikelihood(initialFromSymb);
        }
        symbLL = model.computeLogLikelihood(symbEstimate);
        
//        double[] subEstimates = redModel.estimateML(additionalErrorInformation);
        redModel.addErrorInfo = additionalErrorInformation;
        double[] subEstimates = redModel.estimateML(initialFromSymb);      
        double subLL = model.computeLogLikelihood(subEstimates);

        redModel.addErrorInfo = null;
        redModel.fixParameter(15, errvar2); redModel.fixParameter(14, errvar1);
        double[] subEstimatesErrFixed = redModel.estimateML(initialFromSymb);
        double subFixdLL = model.computeLogLikelihood(subEstimatesErrFixed);
        
        for (int i=0; i<subEstimates.length; i++) initial[i] = subEstimates[i];
        initial[model.errPar[0]] = errvar1;
        initial[model.errPar[embed]] = errvar2;
        double ll1 = model.computeLogLikelihood(initial);
        while (Double.isNaN(ll1)) {
            initial[14] *= 2; initial[15] *= 2;
            ll1 = model.computeLogLikelihood(initial);
        }
        double[] estimates = model.estimateML(initial); ll1 = model.ll;
        double[] estimates2 = model.estimateML(initialFromSymb); double ll2 = model.ll;

        double[] est3 = new double[16]; for (int i=0; i<14; i++) est3[i] = subEstimatesErrFixed[i]; est3[14] = errvar1; est3[15] = errvar2; 
        System.out.println("Symbolic Results from whole covariance matrix  = "+(symbEstimate==null?"not converged":Statik.matrixToString(symbEstimate)+"\t\t"+symbLL));
        System.out.println("Estimates from reduced model with error info   = "+(subEstimates==null?"not converged":Statik.matrixToString(subEstimates)+"\t\t"+subLL));
        System.out.println("Estimates from reduced model                   = "+(est3==null?"not converged":Statik.matrixToString(est3)+"\t\t"+subFixdLL));
        System.out.println("Estimate (using errvar approx as starting)     = "+(estimates==null?"not converged":Statik.matrixToString(estimates)+"\t\t"+ll1));
        System.out.println("Estimate (using full covariance as starting)   = "+(estimates2==null?"not converged":Statik.matrixToString(estimates2)+"\t\t"+ll2));
        
        double[][] interCor = new double[3][3];
        for (int i=0; i<3; i++) for (int j=0; j<3; j++) interCor[i][j] = symbCovariance[3+i][j]/Math.sqrt(symbCovariance[3+i][3+i]*symbCovariance[j][j]);
        
        System.out.println("Inter covariance matrix = \r\n"+Statik.matrixToString(interCor));
    }
    
    public static void main(String args[])
    {
        // LDE auf Trommeldaten (skript)
//        ldeFitDrumming();

        LinearModelNew model = new LinearModelNew(
                new double[][]{{1,-5,25},{1,-4,16},{1,-3,9},{1,-2,4},{1,-1,1},{1,0,0},{1,1,1},{1,2,4},{1,3,9},{1,4,16},{1,5,25}},
                new int[][]{{0,3,4},{3,1,5},{4,5,2}},
                new double[][]{{1,0,0},{0,1,0},{0,0,1}},
                new int[]{-1,-1,-1},
                new double[]{0,0,0},
                new int[]{6,6,6,6,6,6,6,6,6,6,6},
                new double[]{.1,.1,.1,.1,.1,.1,.1,.1,.1,.1,.1}
                );
        model.createData(200);
        double[] init = model.getParameter();
        double[] estDirect = model.estimateML(init);
        LinearModelNew transform = model.transformWithPowerEquivalence();
        double[] estTrans = transform.estimateML(init);
        
        System.out.println("Direkt = "+Statik.matrixToString(estDirect));
        System.out.println("Trans  = "+Statik.matrixToString(estTrans));
    }
    
}
