/*
 * Created on 26.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;
import java.util.Arrays;
import java.util.Random;

import silvers.Statik;


/**
 * @author timo
 */
public class MeanFactorModel 
{
    static int NOPARAMETER = -1;
    static final double LNTWOPI = Math.log(2*Math.PI);
    static Random rand = new Random();
    
    public static enum parameterType {mean, loading, facCov, err};

  int anzFac;
  int anzPar;
  int anzVar;
  
  double[] meanVal;
  int[] meanPar;
  double[][] loadingsVal;
  int[][] loadingsPar;
  double[][] facCovVal;
  int[][] facCovPar;
  double errVal;
  int errPar;
  
  int anzPer;
  double[][] data;
  double[] dataMean;
  double[] xsum;
  double[][] dataCov;
  double[][] xBiSum;
  
  double[][] sigma;
  double[] mu;
  
  double ll;
  double[] llD;
  double[][] llDD;
  
  // parameter types
  parameterType[] parType;
  
  // factor reordering
  int[] facNr, itemNr;
  
  // Some working variables
  double[][] facCovWork, sigmaWork, sigmaWork2, sigmaWork3, sigmaWork4, structureWork, structureTransWork;
  double[] muWork;
  int[] sDevRow, sDevCol, cDevRow, cDevCol, mDev;
  
  double[][] sigInv;
  
  public double[][] fisherInformationMatrix;

      public MeanFactorModel(int[] meanPar, double[] meanVal, int[][] loadingsPar, double[][] loadingsVal, 
              int[][] facCovPar, double[][] facCovVal, int errPar, double errVal)
      {
          this.meanPar = meanPar; this.meanVal = meanVal;
          this.loadingsPar = loadingsPar; this.loadingsVal = loadingsVal; 
          this.facCovVal = facCovVal; this.facCovPar = facCovPar;  
          this.errVal = errVal; this.errPar = errPar;
          
          anzFac = loadingsPar.length;
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++) anzVar++;
          facNr = new int[anzVar]; itemNr = new int[anzVar];
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
              {
                  facNr[anzVar]=i; itemNr[anzVar]=j;
                  anzVar++;
              }
          anzPar = getActiveParameters().length;
          collectParameterTypes();
          
          anzPer = 0; data = new double[0][];
          
          fisherInformationMatrix = new double[anzPar][anzPar];
          
      }

      public MeanFactorModel(MeanFactorModel toCopy)
      {
          anzFac = toCopy.anzFac;
          anzVar = toCopy.anzVar;
          anzPar = toCopy.anzPar;
          anzPer = toCopy.anzPer;
    
          meanPar = new int[toCopy.meanPar.length];
          for (int i=0; i<meanPar.length; i++) meanPar[i] = toCopy.meanPar[i];
          meanVal = Statik.copy(toCopy.meanVal);
          loadingsPar = new int[toCopy.loadingsPar.length][toCopy.loadingsPar[0].length];
          for (int i=0; i<loadingsPar.length; i++) 
          {
              loadingsPar[i] = new int[toCopy.loadingsPar[i].length];
              loadingsVal[i] = new double[toCopy.loadingsPar[i].length];
              for (int j=0; j<loadingsPar[i].length; j++)
              {
                  loadingsPar[i][j] = toCopy.loadingsPar[i][j];              
                  loadingsVal[i][j] = toCopy.loadingsVal[i][j];
              }
          }
          facCovPar = new int[toCopy.anzFac][toCopy.anzFac];
          for (int i=0; i<anzFac; i++) for (int j=0; j<anzFac; j++) facCovPar[i][j] = toCopy.facCovPar[i][j]; 
          facCovVal = Statik.copy(toCopy.facCovVal);
          errVal = toCopy.errVal; errPar = toCopy.errPar;
          collectParameterTypes();
          
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++) anzVar++;
          facNr = new int[anzVar]; itemNr = new int[anzVar];
          anzVar = 0;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
              {
                  facNr[anzVar]=i; itemNr[anzVar]=j;
                  anzVar++;
              }

          data = Statik.copy(toCopy.data);
          computeMoments();
          fisherInformationMatrix = new double[anzPar][anzPar];
      }
      
      public void collectParameterTypes()
      {
          int maxPar = maxParNumber();
          parType = new parameterType[maxPar+1];
      
          for (int i=0; i<meanPar.length; i++) if (meanPar[i]!=NOPARAMETER) parType[meanPar[i]] = parameterType.mean;
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++) 
                  if (loadingsPar[i][j]!=NOPARAMETER) parType[loadingsPar[i][j]] = parameterType.loading;
          for (int i=0; i<anzFac; i++) for (int j=0; j<anzFac; j++) 
              if (facCovPar[i][j]!=NOPARAMETER) parType[facCovPar[i][j]] = parameterType.facCov;
          if (errPar != NOPARAMETER) parType[errPar] = parameterType.err;
      }
      
      public int maxParNumber()
      {
          int erg = NOPARAMETER;
          for (int i=0; i<meanPar.length; i++) erg = Math.max(meanPar[i], erg);
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++) erg = Math.max(loadingsPar[i][j], erg);
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<anzFac; j++) erg = Math.max(facCovPar[i][j], erg);
          erg = Math.max(errPar, erg);
          return erg;
      }
      
      public int[] getActiveParameters()
      {
          int toPar = maxParNumber()+1;
          int[] ergO = new int[toPar];
          for (int i=0; i<meanPar.length; i++)
              if (meanPar[i] != NOPARAMETER) ergO[meanPar[i]]=1;
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
                  if (loadingsPar[i][j] != NOPARAMETER) ergO[loadingsPar[i][j]]=1;
          for (int i=0; i<anzFac; i++)
              for (int j=i; j<anzFac; j++)
                  if (facCovPar[i][j] != NOPARAMETER) ergO[facCovPar[i][j]]=1;
          if (errPar != NOPARAMETER) ergO[errPar]=1;
          int anz = 0; for (int i=0; i<toPar; i++) if (ergO[i]!=0) anz++;
          int[] erg = new int[anz]; int j=0; 
          for (int i=0; i<toPar; i++) if (ergO[i]!=0) erg[j++] = i;
          Arrays.sort(erg);
          return erg;
      }
      
      public void renumberParameter(int oldNumber, int newNumber)
      {
          for (int i=0; i<meanPar.length; i++)
              if (meanPar[i] == oldNumber) meanPar[i] = newNumber;
          for (int i=0; i<loadingsPar.length; i++)
              for (int j=0; j<loadingsPar[i].length; j++)
                  if (loadingsPar[i][j] == oldNumber) loadingsPar[i][j] = newNumber;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<anzFac; j++)
                  if (facCovPar[i][j] == oldNumber) facCovPar[i][j] = newNumber;
          if (errPar == oldNumber) errPar = newNumber;
          collectParameterTypes();
      }
    
    public int getAnzFac() {
        return anzFac;
    }
    public int getAnzPar() {
        return anzPar;
    }
    public int getAnzVar() {
        return anzVar;
    }

    public void applyParameterValues(double[] vals)
    {
        for (int i=0; i<meanVal.length; i++)
            meanVal[i] = (meanPar[i]==-1?meanVal[i]:vals[meanPar[i]]);
        for (int i=0; i<loadingsVal.length; i++)
            for (int j=0; j<loadingsVal[i].length; j++)
                loadingsVal[i][j] = (loadingsPar[i][j]==-1?loadingsVal[i][j]:vals[loadingsPar[i][j]]);
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                facCovVal[i][j] = (facCovPar[i][j]==NOPARAMETER?facCovVal[i][j]:vals[facCovPar[i][j]]);
        errVal = (errPar==NOPARAMETER?errVal:vals[errPar]);
    }
    
    private int parameterPos(int par)
    {
        boolean done = false; int k=-1;
        for (int f=0; (!done) && (f<loadingsPar.length); f++)
            for (int i=0; (!done) && (i<loadingsPar[f].length); i++)
            {
                k++;
                done = (loadingsPar[f][i]==par);
            }
        if (!done) {System.out.println("Warning: Parameter "+par+" not found in loading parameters."); return -1;}
        return k;
    }
    
    private int meanFac(int par)
    {
        for (int i=0; i<anzFac; i++) if (meanPar[i]==par) return i;
        System.out.println("Warning: Parameter "+par+" not found in mean parameters."); 
        return -1;
    }
    
    public void computeSigmaInvDev(int par, double[][] erg)
    {
        if (parType[par]==parameterType.mean) 
            for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = 0;
        if (parType[par]==parameterType.loading)
        {
            int k = parameterPos(par);
            for (int i=0; i<anzVar; i++)
                for (int j=0; j<anzVar; j++)
                {
                    if (j==k)
                    {
                        erg[i][j] = 0;
                        for (int l=0; l<anzVar; l++)
                            erg[i][j] += sigInv[i][l]*facCovVal[facNr[k]][facNr[l]]*loadingsVal[facNr[l]][itemNr[l]]*(l==k?2:1);
                    } else {
                        erg[i][j] = sigInv[i][k]*facCovVal[facNr[k]][facNr[j]]*loadingsVal[facNr[j]][itemNr[j]];
                    }
                }
        }
        if (parType[par]==parameterType.facCov)
        {
            int fnr1 = -1, fnr2 = -1;
            for (int i=0; (i<anzFac) && (fnr1==-1); i++)
                for (int j=i; (j<anzFac) && (fnr1==-1); j++) if (facCovPar[i][j]==par) {fnr1 = i; fnr2 = j;}
            if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
            for (int i=0; i<anzVar; i++) for (int j=i; j<anzVar; j++) 
            {
                if ((facNr[i]==fnr1) && (facNr[j]==fnr2)) sigmaWork4[i][j] = sigmaWork4[j][i] = loadingsVal[fnr1][itemNr[i]] * loadingsVal[fnr2][itemNr[j]];
                else sigmaWork4[i][j] = sigmaWork4[j][i] = 0;
            }
            Statik.multiply(sigInv, sigmaWork4, erg);            
        }
        if (parType[par]==parameterType.err)
        {
            for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = sigInv[i][j];
        }
    }
    
    public void computeSigmaInvDevDev(int par1, int par2, double[][] erg)
    {
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++) erg[i][j] = 0;
        if ((parType[par1] == parameterType.loading) && (parType[par2] == parameterType.loading))
        {
            int k1 = parameterPos(par1), k2 = parameterPos(par2);
            for (int i=0; i<anzVar; i++)
            {
                erg[i][k1] += facCovVal[facNr[k1]][facNr[k2]]*sigInv[i][k2]; 
                erg[i][k2] += facCovVal[facNr[k1]][facNr[k2]]*sigInv[i][k1]; 
            }
        }
        if (((parType[par1]==parameterType.loading) && (parType[par2]==parameterType.facCov)) ||
            ((parType[par2]==parameterType.loading) && (parType[par1]==parameterType.facCov))) 
        {
            if (parType[par1]==parameterType.loading) {int t=par1; par1 = par2; par2 = t;}
            int k = parameterPos(par2);
            int fnr1 = -1, fnr2 = -1;
            for (int i=0; (i<anzFac) && (fnr1==-1); i++)
                for (int j=i; (j<anzFac) && (fnr1==-1); j++) if (facCovPar[i][j]==par1) {fnr1 = i; fnr2 = j;}
            if (facNr[k]!=fnr1) {int t = fnr1; fnr1 = fnr2; fnr2 = t;}
            if (facNr[k] == fnr1)
            {
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++)
                    {
                        if (j==k) 
                        {
                            int start = 0; for (int l=0; l<fnr2; l++) start += loadingsVal[l].length;
                            for (int l=0; l<loadingsVal[fnr2].length; l++) 
                                erg[i][j] += sigInv[i][start+l]*loadingsVal[fnr2][l] * (start+l == k?2:1);
                        } else if (facNr[j]==fnr2) erg[i][j] = sigInv[i][k] * loadingsVal[fnr2][itemNr[j]];                            
                    }
            }
            
        }
        
    }

    public void setData(double[][] data)
    {
        this.data = data;
        this.anzPer = data.length;
        computeMoments();
    }
    
    public void computeMoments()
    {
        if (data==null) return;
        xsum = new double[anzVar];
        dataMean = new double[anzVar];
		for (int i=0; i<anzVar; i++) xsum[i] = 0.0;
		for (int i=0; i<anzPer; i++)
			for (int j=0; j<anzVar; j++) xsum[j] += data[i][j];
		for (int i=0; i<anzVar; i++) dataMean[i] = xsum[i] / (double)anzPer;
			
		xBiSum = new double[anzVar][anzVar];
		dataCov = new double[anzVar][anzVar];
		for (int i=0; i<anzVar; i++)
			for (int j=0; j<=i; j++)
			{
				xBiSum[i][j] = 0.0;
				for (int k=0; k<anzPer; k++) xBiSum[i][j] += data[k][i] * data[k][j];
				for (int k=0; k<anzPer; k++) dataCov[i][j] += (data[k][i]-dataMean[i]) * (data[k][j]-dataMean[j]);
				xBiSum[j][i] = xBiSum[i][j];
				dataCov[i][j] /= (double)anzPer;
				dataCov[j][i] = dataCov[i][j];
			}
    }

    public void setParameter(double[] values) {for (int i=0; i<values.length; i++) setParameter(i,values[i]);}
    public void setParameter(int nr, double value)
    {
        if (parType[nr]==parameterType.mean)
            for (int i=0; i<anzFac; i++)
                if (meanPar[i]==nr) meanVal[i] = value; 
        if (parType[nr]==parameterType.loading)
            for (int i=0; i<anzFac; i++)
                for (int j=0; j<loadingsPar[i].length; j++)
                    if (loadingsPar[i][j]==nr) loadingsVal[i][j] = value; 
        if (parType[nr]==parameterType.facCov)
            for (int i=0; i<anzFac; i++)
                for (int j=0; j<anzFac; j++)
                    if (facCovPar[i][j]==nr) facCovVal[i][j] = value;
        if (parType[nr]==parameterType.err) errVal = value;
    }
    
    
    public static MeanFactorModel fixParameter(MeanFactorModel in, int nr, double value) {MeanFactorModel erg = new MeanFactorModel(in); erg.fixParameter(nr,value); return erg;}
    public void fixParameter(int nr, double value)
    {
        anzPar--;
        for (int i=0; i<anzFac; i++)
        {
            if (meanPar[i]==nr) { meanVal[i] = value; meanPar[i] = NOPARAMETER;}
            if (meanPar[i] >nr)  meanPar[i]--;
        }
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<loadingsPar[i].length; j++)
            {
                if (loadingsPar[i][j]==nr) { loadingsVal[i][j] = value; loadingsPar[i][j] = -1;}
                if (loadingsPar[i][j] >nr)  loadingsPar[i][j]--;
            }
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
            {
                if (facCovPar[i][j]==nr) { facCovVal[i][j] = value; facCovPar[i][j] = -1;}
                if (facCovPar[i][j] >nr)  facCovPar[i][j]--;
            }
        if (errPar==nr) { errVal = value; errPar = -1;}
        if (errPar >nr)  errPar--;
        collectParameterTypes();
    }

    
    public double[][] createData (int anzPersons) {return createData(anzPersons, facCovVal, loadingsVal, errVal);}
    public double[][] createData (int anzPersons, double[] values) {applyParameterValues(values); return createData(anzPersons, facCovVal, loadingsVal, errVal);}
    public double[][] createData (int anzPersons, double[][] covMatrix, double[][] loadingsVal, double error)
    {
        this.anzPer = anzPersons;
        double[][] cholesky = Statik.choleskyDecompose(covMatrix);

        data = new double[anzPersons][anzVar];

        double[] m = new double[anzFac], m2 = new double[anzFac];
        for (int i=0; i<anzPersons; i++)
        {
            for (int j=0; j<anzFac; j++) m[j] = rand.nextGaussian() + meanVal[j];
            Statik.multiply(cholesky,m,m2);
            for (int j=0; j<anzVar; j++) data[i][j] = loadingsVal[facNr[j]][itemNr[j]]*m2[facNr[j]] + rand.nextGaussian()*Math.sqrt(error);
        }
        computeMoments();
        return data;
    }
    
    public void evaluateMuAndSigma() {evaluateMuAndSigma(null);}
    public void evaluateMuAndSigma(double[] values)
    {
        if ((sigma==null) || (sigma.length!=anzVar) || (sigma[0].length!=anzVar)) sigma = new double[anzVar][anzVar];
        if ((mu==null) || (mu.length!=anzVar)) mu = new double[anzVar];
        if (values!=null) applyParameterValues(values);

        for (int i=0; i<anzVar; i++)
        {
            for (int j=0; j<anzVar; j++)
                sigma[i][j] = loadingsVal[facNr[i]][itemNr[i]]*loadingsVal[facNr[j]][itemNr[j]]*facCovVal[facNr[i]][facNr[j]];
        }
        
        for (int i=0; i<anzVar; i++)
            mu[i] = loadingsVal[facNr[i]][itemNr[i]]*meanVal[facNr[i]];
        
        for (int i=0; i<anzVar; i++) 
            sigma[i][i] += errVal;
    }
    
    public boolean factorPositiveDefinite(double[] values)
    {
        applyParameterValues(values);
        return (Statik.determinantOfPositiveDefiniteMatrix(facCovVal) != -1); 
    }
    
    public double euclididanDistance(double[] values)
    {
        evaluateMuAndSigma(values);
        double erg = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) erg += (sigma[i][j] - dataCov[i][j])*(sigma[i][j] - dataCov[i][j]);
        for (int i=0; i<anzVar; i++) erg += (mu[i] - dataMean[i])*(mu[i] - dataMean[i]);
        return erg;
    }
        
    public double getMinusTwoLogLikelihood(double[] value) {return getMinusTwoLogLikelihood(value, true);}
    public double getMinusTwoLogLikelihood(double[] value, boolean recomputeSigma) 
    {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];

        if (value != null) applyParameterValues(value);
        if (recomputeSigma) evaluateMuAndSigma(value);
        
        double det = Statik.invert(sigma,sigInv, sigmaWork);
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(det);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += (mu[i]-dataMean[i])*(mu[j]-dataMean[j])*sigInv[i][j];
        
        return ll;
    }


    /**
     * Computes the minus two log likelihood and for each parameter its derivative and second derivative. Parameters are expected to be numbered
     * from 0 to anzPar-1. If values is not zero, these parameter values are applied; otherwise, the method assumes all values are correct.
     */
    public void computeLogLikelihoodDerivatives(double[] value) {computeLogLikelihoodDerivatives(value,true);}
    public void computeLogLikelihoodDerivatives(double[] value, boolean recomputeMuAndSigma)
    {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((sigmaWork2==null) || (sigmaWork2.length!=anzVar) || (sigmaWork2[0].length!=anzVar)) sigmaWork2 = new double[anzVar][anzVar];
        if ((sigmaWork3==null) || (sigmaWork3.length!=anzVar) || (sigmaWork3[0].length!=anzVar)) sigmaWork3 = new double[anzVar][anzVar];
        if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];
        if ((llD==null) || (llD.length!=anzPar)) llD = new double[anzPar];
        if ((llDD==null) || (llDD.length!=anzVar) || (llDD[0].length!=anzVar)) llDD = new double[anzPar][anzPar];
        
        if (value != null) applyParameterValues(value);
        if (recomputeMuAndSigma) evaluateMuAndSigma(value);
        
        double det = Statik.invert(sigma,sigInv, sigmaWork);
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(det);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += sigInv[i][j]*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
        
        for (int p=0; p<anzPar; p++)
        {
            llD[p] = 0.0;
            if (parType[p] == parameterType.mean)
            {
                int fac = meanFac(p); int pos = 0; for (int i=0; i<fac; i++) pos += loadingsPar[i].length;
                for (int i=0; i<loadingsPar[fac].length; i++)
                    for (int j=0; j<anzVar; j++) llD[p] -= 2*loadingsVal[fac][i]*sigInv[i+pos][j]*anzPer*(dataMean[j] - mu[j]);
            } 
            if (parType[p] == parameterType.loading)
            {
                int pos = parameterPos(p);
                for (int j=0; j<anzVar; j++) llD[p] -= 2*meanVal[facNr[pos]]*sigInv[pos][j]*anzPer*(dataMean[j] - mu[j]);
            }
            if (parType[p] != parameterType.mean)
            {
                computeSigmaInvDev(p, sigmaWork);
                double trace = 0;
                for (int i=0; i<anzVar; i++) trace += sigmaWork[i][i];
                llD[p] += trace*anzPer;
                Statik.multiply(sigmaWork, sigInv, sigmaWork2);
                for (int i=0; i<anzVar; i++) 
                    for (int j=0; j<anzVar; j++) llD[p] -= sigmaWork2[i][j]*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
            }
        }
        
        for (int p1=0; p1<anzPar; p1++)
            for (int p2=0; p2<anzPar; p2++)
                llDD[p1][p2] = 0;
        for (int p1=0; p1<anzPar; p1++)
            for (int p2=0; p2<anzPar; p2++)
            {
                // Term 4 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]==parameterType.mean) && (parType[p2]==parameterType.mean))
                {
                    int fac1 = meanFac(p1); int pos1 = 0; for (int i=0; i<fac1; i++) pos1 += loadingsPar[i].length;
                    int fac2 = meanFac(p2); int pos2 = 0; for (int i=0; i<fac2; i++) pos2 += loadingsPar[i].length;
                    for (int i=0; i<loadingsPar[fac1].length; i++)
                        for (int j=0; j<loadingsPar[fac2].length; j++)
                            llDD[p1][p2] += 2*anzPer*loadingsVal[fac1][i]*loadingsVal[fac2][j]*sigInv[pos1+i][pos2+j];
                }
                if (((parType[p1]==parameterType.mean) && (parType[p2]==parameterType.loading))
                ||  ((parType[p1]==parameterType.loading) && (parType[p2]==parameterType.mean)))
                {
                    int q1 = (parType[p1]==parameterType.mean?p1:p2), q2 = (parType[p1]==parameterType.mean?p2:p1); 
                    int fac1 = meanFac(q1); int pos1 = 0; for (int i=0; i<fac1; i++) pos1 += loadingsPar[i].length;
                    int pos2 = parameterPos(q2);
                    for (int i=0; i<loadingsPar[fac1].length; i++)
                        llDD[p1][p2] += 2*anzPer*loadingsVal[fac1][i]*meanVal[facNr[pos2]]*sigInv[pos1+i][pos2];
                }
                if ((parType[p1]==parameterType.loading) && (parType[p2]==parameterType.loading))
                {
                    int pos1 = parameterPos(p1);
                    int pos2 = parameterPos(p2);
                    llDD[p1][p2] += 2*anzPer*meanVal[facNr[pos1]]*meanVal[facNr[pos2]]*sigInv[pos1][pos2];
                }
                // Term 2 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if (((parType[p1]==parameterType.mean) && (parType[p2]==parameterType.loading))
                ||  ((parType[p1]==parameterType.loading) && (parType[p2]==parameterType.mean)))
                {
                    int q1 = (parType[p1]==parameterType.mean?p1:p2), q2 = (parType[p1]==parameterType.mean?p2:p1); 
                    int fac1 = meanFac(q1); int pos1 = 0; for (int i=0; i<fac1; i++) pos1 += loadingsPar[i].length;
                    int pos2 = parameterPos(q2);
                    if (fac1==facNr[pos2])
                        for (int i=0; i<anzVar; i++)
                            llDD[p1][p2] -= 2*anzPer*(dataMean[i]-mu[i])*sigInv[pos2][i];
                }
                // Term 3 and 5 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]==parameterType.loading) && (parType[p2]==parameterType.loading))
                {
                    computeSigmaInvDev(p1, sigmaWork);
                    Statik.multiply(sigmaWork, sigInv, sigmaWork2);
                    computeSigmaInvDev(p2, sigmaWork);
                    Statik.multiply(sigmaWork, sigInv, sigmaWork3);
                    int pos1 = parameterPos(p1), pos2 = parameterPos(p2);
                    for (int j=0; j<anzVar; j++)
                    {
                        llDD[p1][p2] += 2*meanVal[facNr[pos1]]*sigmaWork3[pos1][j]*anzPer*(dataMean[j]-mu[j]);
                        llDD[p1][p2] += 2*meanVal[facNr[pos2]]*sigmaWork2[pos2][j]*anzPer*(dataMean[j]-mu[j]);
                    }
                } 
                else if (((parType[p1]!=parameterType.facCov) && (parType[p1]!=parameterType.err) && (parType[p2]!=parameterType.mean))
                ||  ((parType[p1]!=parameterType.mean) && (parType[p2]!=parameterType.facCov) && (parType[p2]!=parameterType.err)))
                {
                    boolean exchange = (parType[p1]==parameterType.facCov) || (parType[p1]==parameterType.err)
                                        || (parType[p2]==parameterType.mean);
                    int q1 = (exchange?p2:p1), q2 = (exchange?p1:p2); 
                    computeSigmaInvDev(q2, sigmaWork2);
                    Statik.multiply(sigmaWork2, sigInv, sigmaWork);
                    if (parType[q1]==parameterType.mean)
                    {
                        int fac1 = meanFac(q1); int pos1 = 0; for (int i=0; i<fac1; i++) pos1 += loadingsPar[i].length;
                        for (int i=0; i<loadingsPar[fac1].length; i++)
                            for (int j=0; j<anzVar; j++)
                                llDD[p1][p2] += 2*loadingsVal[fac1][i]*sigmaWork[pos1+i][j]*anzPer*(dataMean[j]-mu[j]);
                    } else {
                        int pos1 = parameterPos(q1);
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += 2*meanVal[facNr[pos1]]*sigmaWork[pos1][j]*anzPer*(dataMean[j]-mu[j]);
                    }
                }
                
                // Term 1,6,7 and 8 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]!=parameterType.mean) && (parType[p2]!=parameterType.mean))
                {
                    computeSigmaInvDev(p1, sigmaWork);
                    computeSigmaInvDev(p2, sigmaWork2);
                    computeSigmaInvDevDev(p1, p2, sigmaWork3);
                    Statik.multiply(sigmaWork, sigmaWork2, sigmaWork4);
                    double trace = 0;
                    for (int i=0; i<anzVar; i++) trace += sigmaWork3[i][i] - sigmaWork4[i][i];
                    llDD[p1][p2] += trace*anzPer;
                    Statik.multiply(sigmaWork4, sigInv, sigmaWork);
                    Statik.multiply(sigmaWork3, sigInv, sigmaWork2);
                    for (int i=0; i<anzVar; i++)
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += (2*sigmaWork[i][j] - sigmaWork2[i][j])*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
                }
            }
    }
    
    public double[] estimateML(double[] starting) {return estimateML(starting, 0.0001);}
    public double[] estimateML(double[] starting, double EPS)
    {
        final int MAXRUNS = 50; 

        double[] move = new double[anzPar];
        double[] pos = new double[anzPar];
        double[][] work1 = new double[anzPar][anzPar], work2 = new double[anzPar][anzPar];
        
        for (int i=0; i<anzPar; i++) pos[i] = starting[i];
        
        int runs = 0; double steplength = Double.POSITIVE_INFINITY, gain = Double.POSITIVE_INFINITY;
        computeLogLikelihoodDerivatives(pos);
        double DEBUGstart = ll;
        while ((runs<=MAXRUNS) && (steplength > EPS) && ((gain > EPS) || (gain<0)))
        {
            double lastLL = ll;
            Statik.invert(llDD, work1, work2);
            Statik.multiply(work1, llD, move);
            
            // get damping
            double lambda = (runs<3?-0.2:(runs<6?-0.5:-1.0));
            Statik.multiply(lambda, move, move);
            Statik.add(pos, move, pos);
            computeLogLikelihoodDerivatives(pos);
            steplength = Statik.abs(move);
            gain = lastLL - ll;
            
            if (gain < 0) 
            {
                lambda *= -2;
                Statik.multiply(work1, llD, move);
                Statik.multiply(lambda, move, move);
                Statik.add(pos, move, pos);
                computeLogLikelihoodDerivatives(pos);
                steplength = Statik.abs(move);
                gain = lastLL - ll;
            } 
            if (gain < 0) 
            {
                for (int i=0; i<move.length; i++) move[i] = 5*rand.nextDouble()*EPS;
                gain = lastLL - ll;
            }
            
            runs++;
        }

        if (runs > MAXRUNS) System.out.println("Warning: More than 50 runs needed, final steplength = "+steplength);
//        System.out.println("Runs       = "+runs);
//        System.out.println("Steplength = "+steplength);
//        System.out.println("Last gain  = "+gain);
//        System.out.println("Total gain = "+(DEBUGstart - ll));
//        System.out.println("Final LL   = "+ll);
        
        return pos;
    }
    
    public void independentSigma() 
    {
        for (int i=0; i<sigma.length; i++)
            for (int j=0;j<sigma.length ;j++)
                sigma[i][j] = (i==j?this.dataCov[i][j]:0);
    }
    
    public int restrictedDF()
    {
        return anzVar*(anzVar+1)/2 - anzPar;
    }
    
    public double getSaturatedLL() 
    {
        double myll = ll;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
                sigma[i][j] = dataCov[i][j];
        
        double sat = getMinusTwoLogLikelihood(null, false);
        ll = myll;
        return sat;
    }

    public double getRMSEA()
    {
        return Math.sqrt(Math.max((ll - restrictedDF()),0) / (restrictedDF()*(anzPer-1)));
    }
    
    public double getDeltaRMSEA(MultipleGroupFactorModel restrictedModel)
    {
        return Math.sqrt(((restrictedModel.ll - ll) - (restrictedModel.anzPar - anzPar))/((restrictedModel.anzPar - anzPar)*(anzPer-1)));
    }
    
    public double getCFI()
    {
        double myll = ll;
        independentSigma(); 
        this.computeLogLikelihoodDerivatives(null,false);
        double indepLL = ll;
        ll = myll;
        int restrictedDF = restrictedDF();
        int indepRestrictedDF = anzVar*(anzVar-1)/2;
        if (myll <= restrictedDF) return 1.0;
        return 1.0-((myll-restrictedDF) / Math.max(myll-restrictedDF,indepLL - indepRestrictedDF));
    }

    public double getCFI(MultipleGroupFactorModel restrictedModel)
    {
        if (ll <= restrictedDF()) return 1.0;
        return 1.0-((ll-restrictedDF()) / Math.max(ll-restrictedDF(),restrictedModel.ll - restrictedModel.restrictedDF()));
    }
    
    public double getDeltaCFI(MultipleGroupFactorModel restrictedModel)
    {
        return this.getCFI() - restrictedModel.getCFI();
    }
    
    public double getMcDonaldsCentralityIndex()
    {
        return Math.exp(-0.5*(ll-restrictedDF())/(anzPer-1));
    }
    
    
    public static void main(String args[])
    {
        MeanFactorModel model = new MeanFactorModel(new int[]{0,1,2}, new double[]{0,0,0}, 
                new int[][]{{3,4},{5,6},{7,8}}, new double[][]{{1,1},{1,1},{1,1}}, 
                new int[][]{{9,10,11},{10,12,13},{11,13,14}}, new double[][]{{1,0,0},{0,1,0},{0,0,1}}, 
                15, 0.5);
//        model.fixParameter(0, 1);
//        
//        double[] pop = new double[]{0.8,0.8,0.8,1.0,0.0,1.0,0.5};
        double[] pop = new double[]{0.5,1.0,2.0,0.6,0.7,0.8,0.9,0.65,0.5,1.0,0.1,0.2,1.0,0.3,1.0,0.5};
        model.applyParameterValues(pop);
        model.createData(100);
        
        model.computeLogLikelihoodDerivatives(pop, true);
        double ll = model.ll;
        double[] derOrg = Statik.copy(model.llD);
        double[] der = new double[pop.length];
        double[][] d2 = new double[pop.length][pop.length];
        double eps = 0.00001;
        for (int i=0; i<pop.length; i++)
        {
            pop[i] += eps;
            model.computeLogLikelihoodDerivatives(pop);
            der[i] = (model.ll - ll)/eps;
            pop[i] -= eps;
        }
        for (int i=0; i<pop.length; i++)
        {
            pop[i] += eps;
            model.computeLogLikelihoodDerivatives(pop);
            for (int j=0; j<pop.length; j++)
                d2[i][j] = (model.llD[j] - derOrg[j])/eps;
            pop[i] -= eps;
        }
        model.computeLogLikelihoodDerivatives(pop, true);
        System.out.println("Numerical Values = ");
        System.out.println(Statik.matrixToString(der));
        System.out.println(Statik.matrixToString(d2));
        System.out.println("Symbolic  Values = ");
        System.out.println("True LL = "+model.ll);
        System.out.println(Statik.matrixToString(model.llD));
        System.out.println(Statik.matrixToString(model.llDD));
        
        for (int i=0; i<pop.length; i++) der[i] -= model.llD[i];
        for (int i=0; i<pop.length; i++) for (int j=0; j<pop.length; j++) d2[i][j] -= model.llDD[i][j];
        System.out.println("\r\nDifference = ");
        System.out.println(Statik.matrixToString(der));
        System.out.println(Statik.matrixToString(d2));
    }
    
}
