/*
 * Created on 26.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;
import java.util.Arrays;
import java.util.Random;

import lgmsimulation.CholeskyModel.parameterType;

import silvers.Statik;


/**
 * @author timo
 */
public class SingletonModel extends Model 
{
    public static enum parameterType {mean, structure, facCov, err};
    
  int anzFac;
  
  double[] meanVal;
  int[] meanPar;
  double[][] structureVal;
  int[][] structurePar;
  double[][] facCovVal;
  int[][] facCovPar;
  double errVal;
  int errPar;
  
  // gives the position of the parameter (row, column); second is unused for mean, both unused for error, 1st <= 2nd for facCov
  int[][] parPos;
  
  // parameter types
  parameterType[] parType;
  
  // Some working variables
  double[][] facCovWork, sigmaWork, sigmaWork2, sigmaWork3, sigmaWork4, structureWork, structureTransWork;
  double[] muWork, posWork, p1w, p2w, cew, a1w, a2w;
  int[] sDevRow, sDevCol, cDevRow, cDevCol, mDev;
  
      public SingletonModel(int[] meanPar, double[] meanVal, int[][] structurePar, double[][] structureVal, 
              int[][] facCovPar, double[][] facCovVal, int errPar, double errVal)
      {
          this.meanPar = meanPar; this.meanVal = meanVal;
          this.structurePar = structurePar; this.structureVal = structureVal; 
          this.facCovVal = facCovVal; this.facCovPar = facCovPar;  
          this.errVal = errVal; this.errPar = errPar;
          
          anzFac = meanPar.length;
          anzVar = structurePar.length;
          anzPar = getActiveParameters().length;
          collectParameterTypesAndPos();
          
          anzPer = 0; data = new double[0][];
          
          fisherInformationMatrix = new double[anzPar][anzPar];
          
      }

      public SingletonModel(SingletonModel toCopy)
      {
          anzFac = toCopy.anzFac;
          anzVar = toCopy.anzVar;
          anzPar = toCopy.anzPar;
          anzPer = toCopy.anzPer;
    
          meanPar = new int[toCopy.meanPar.length];
          for (int i=0; i<meanPar.length; i++) meanPar[i] = toCopy.meanPar[i];
          meanVal = Statik.copy(toCopy.meanVal);
          structurePar = new int[toCopy.structurePar.length][toCopy.structurePar[0].length];
          for (int i=0; i<structurePar.length; i++) for (int j=0; j<structurePar[i].length; j++) 
              structurePar[i][j] = toCopy.structurePar[i][j];
          structureVal = Statik.copy(toCopy.structureVal);
          facCovPar = new int[toCopy.anzFac][toCopy.anzFac];
          for (int i=0; i<anzFac; i++) for (int j=0; j<anzFac; j++) facCovPar[i][j] = toCopy.facCovPar[i][j]; 
          facCovVal = Statik.copy(toCopy.facCovVal);
          errVal = toCopy.errVal; errPar = toCopy.errPar;
          collectParameterTypesAndPos();
          
          data = Statik.copy(toCopy.data);
          computeMoments();
          fisherInformationMatrix = new double[anzPar][anzPar];
      }
      
      public SingletonModel copy(){return new SingletonModel(this);}
      
      public void collectParameterTypesAndPos()
      {
          int maxPar = maxParNumber();
          parType = new parameterType[maxPar+1];
          parPos = new int[maxPar+1][];
      
          for (int i=0; i<meanPar.length; i++) if (meanPar[i]!=NOPARAMETER) {parType[meanPar[i]] = parameterType.mean; parPos[meanPar[i]] = new int[]{i,0};}
          for (int i=0; i<structurePar.length; i++) for (int j=0; j<structurePar[i].length; j++) 
              if (structurePar[i][j]!=NOPARAMETER) {parType[structurePar[i][j]] = parameterType.structure; parPos[structurePar[i][j]] = new int[]{i,j};}
          for (int i=0; i<anzFac; i++) for (int j=i; j<anzFac; j++) 
              if (facCovPar[i][j]!=NOPARAMETER) {parType[facCovPar[i][j]] = parameterType.facCov; parPos[facCovPar[i][j]] = new int[]{i,j};}
          if (errPar != NOPARAMETER) {parType[errPar] = parameterType.err; parPos[errPar] = new int[]{0,0};}
      }
      
      public int maxParNumber()
      {
          int erg = NOPARAMETER;
          for (int i=0; i<meanPar.length; i++) erg = Math.max(meanPar[i], erg);
          for (int i=0; i<structurePar.length; i++)
              for (int j=0; j<structurePar[i].length; j++) erg = Math.max(structurePar[i][j], erg);
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<anzFac; j++) erg = Math.max(facCovPar[i][j], erg);
          erg = Math.max(errPar, erg);
          return erg;
      }
      
      public int[] getActiveParameters()
      {
          int toPar = maxParNumber()+1;
          int[] ergO = new int[toPar];
          for (int i=0; i<meanPar.length; i++)
              if (meanPar[i] != NOPARAMETER) ergO[meanPar[i]]=1;
          for (int i=0; i<structurePar.length; i++)
              for (int j=0; j<structurePar[i].length; j++)
                  if (structurePar[i][j] != NOPARAMETER) ergO[structurePar[i][j]]=1;
          for (int i=0; i<anzFac; i++)
              for (int j=i; j<anzFac; j++)
                  if (facCovPar[i][j] != NOPARAMETER) ergO[facCovPar[i][j]]=1;
          if (errPar != NOPARAMETER) ergO[errPar]=1;
          int anz = 0; for (int i=0; i<toPar; i++) if (ergO[i]!=0) anz++;
          int[] erg = new int[anz]; int j=0; 
          for (int i=0; i<toPar; i++) if (ergO[i]!=0) erg[j++] = i;
          Arrays.sort(erg);
          return erg;
      }
      
      public void renumberParameter(int oldNumber, int newNumber)
      {
          for (int i=0; i<meanPar.length; i++)
              if (meanPar[i] == oldNumber) meanPar[i] = newNumber;
          for (int i=0; i<structurePar.length; i++)
              for (int j=0; j<structurePar[i].length; j++)
                  if (structurePar[i][j] == oldNumber) structurePar[i][j] = newNumber;
          for (int i=0; i<anzFac; i++)
              for (int j=0; j<anzFac; j++)
                  if (facCovPar[i][j] == oldNumber) facCovPar[i][j] = newNumber;
          if (errPar == oldNumber) errPar = newNumber;
          collectParameterTypesAndPos();
      }
    
    public int getAnzFac() {
        return anzFac;
    }

    public void setParameter(double[] vals)
    {
        for (int i=0; i<meanVal.length; i++)
            meanVal[i] = (meanPar[i]==-1?meanVal[i]:vals[meanPar[i]]);
        for (int i=0; i<structureVal.length; i++)
            for (int j=0; j<structureVal[i].length; j++)
                structureVal[i][j] = (structurePar[i][j]==-1?structureVal[i][j]:vals[structurePar[i][j]]);
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
                facCovVal[i][j] = (facCovPar[i][j]==NOPARAMETER?facCovVal[i][j]:vals[facCovPar[i][j]]);
        errVal = (errPar==NOPARAMETER?errVal:vals[errPar]);
    }
    
    protected void computeMatrixTimesSigmaDev(int par, double[][] matrix, double[][] erg)
    {
        if (parType[par]==parameterType.mean) 
            for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = 0;
        if (parType[par]==parameterType.structure)
        {
            for (int i=0; i<anzVar; i++)
                for (int j=0; j<anzVar; j++)
                {
                    erg[i][j] = 0;
                    if (j==parPos[par][0])
                    {
                        for (int l=0; l<anzVar; l++)
                        {
                            double s = 0;
                            for (int m=0; m<anzFac; m++) s += facCovVal[m][parPos[par][1]] * structureVal[l][m];
                            erg[i][j] += (matrix==null?(i==l?1:0):matrix[i][l])*s;
                        }
                    } 
                    double s = 0;
                    for (int m=0; m<anzFac; m++) s += facCovVal[parPos[par][1]][m] * structureVal[j][m];
                    erg[i][j] += (matrix==null?(i==parPos[par][0]?1:0):matrix[i][parPos[par][0]])*s;
                }
        }
        if (parType[par]==parameterType.facCov)
        {
            if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
            for (int i=0; i<anzVar; i++) for (int j=i; j<anzVar; j++) 
            {
                sigmaWork4[i][j] = sigmaWork4[j][i] = structureVal[i][parPos[par][0]] * structureVal[j][parPos[par][1]] + 
                      (parPos[par][0]!=parPos[par][1]?structureVal[j][parPos[par][0]] * structureVal[i][parPos[par][1]]:0);
            }
            if (matrix==null) Statik.copy(sigmaWork4,erg); else Statik.multiply(matrix, sigmaWork4, erg);            
        }
        if (parType[par]==parameterType.err)
        {
            for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) 
                erg[i][j]  = (matrix==null?(i==j?1:0):matrix[i][j]);
        }
    }
    
    public double[] getFreeBasisStartingValues()
    {
        SingletonModel copy = copy();
        copy.meanVal[0] = copy.dataMean[0];
        if (copy.meanPar[1]!=NOPARAMETER) copy.meanVal[1] = copy.dataMean[1] - copy.meanVal[0];
        for (int i=0; i<structureVal.length; i++) 
            if (copy.structurePar[i][1] != NOPARAMETER) {
                copy.structureVal[i][1] = (copy.dataMean[i]-copy.dataMean[0])/copy.meanVal[1]; copy.fixParameter(copy.structurePar[i][1]);}
        
        copy().estimateML(0.01);
        double[] erg = new double[anzPar];
        int j=0; 
        for (int i=0; i<anzPar; i++) erg[i] = (parType[i] == parameterType.structure?copy.structureVal[1][parPos[i][1]]:copy.getParameter(j++));
        
        return erg;
    }
    
    public double[] getArbitraryStartingValues()
    {
        double[] erg = new double[anzPar];
        
        for (int i=0; i<anzPar; i++)
        {
            if (parType[i] == parameterType.mean) erg[i] = 0;
            if (parType[i] == parameterType.facCov) 
                if (parPos[i][0] == parPos[i][1]) erg[i] = 1; else erg[i] = 0;
            if (parType[i] == parameterType.err) erg[i] = 3.0;
            if (parType[i] == parameterType.structure) 
                if (parPos[i][0] < parPos[i][1]) erg[i] = 0.0; else erg[i] = 1.0;
        }
        
        return erg;
    }
    
    protected void computeMatrixTimesSigmaDevDev(int par1, int par2, double[][] matrix, double[][] erg)
    {
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++) erg[i][j] = 0;
        if ((parType[par1] == parameterType.structure) && (parType[par2] == parameterType.structure))
        {
            for (int i=0; i<anzVar; i++)
            {
                erg[i][parPos[par2][0]] += facCovVal[parPos[par1][1]][parPos[par2][1]]*
                                    (matrix==null?(i==parPos[par1][0]?1:0):matrix[i][parPos[par1][0]]); 
                erg[i][parPos[par1][0]] += facCovVal[parPos[par1][1]][parPos[par2][1]]*
                                    (matrix==null?(i==parPos[par2][0]?1:0):matrix[i][parPos[par2][0]]); 
            }
        }
        if (((parType[par1]==parameterType.structure) && (parType[par2]==parameterType.facCov)) ||
            ((parType[par2]==parameterType.structure) && (parType[par1]==parameterType.facCov))) 
        {
            if (parType[par1]==parameterType.structure) {int t=par1; par1 = par2; par2 = t;}
//            int k = parPos(par2);
//            int fnr1 = -1, fnr2 = -1;
//            for (int i=0; (i<anzFac) && (fnr1==-1); i++)
//                for (int j=i; (j<anzFac) && (fnr1==-1); j++) if (facCovPar[i][j]==par1) {fnr1 = i; fnr2 = j;}
            int targetColumn = -1; 
            if (parPos[par1][0]==parPos[par2][1]) targetColumn = parPos[par1][1];
            if (parPos[par1][1]==parPos[par2][1]) targetColumn = parPos[par1][0];
            if (targetColumn != -1)
            {
                int k = parPos[par2][0]; 
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++)
                    {
                        erg[i][j] = 0;
                        if (j==k) 
                        {
                            for (int l=0; l<anzVar; l++) 
                                erg[i][j] += (matrix==null?(i==l?1:0):matrix[i][l])*structureVal[l][targetColumn];
                        } 
                        erg[i][j] += (matrix==null?(i==k?1:0):matrix[i][k]) * structureVal[j][targetColumn];                            
                    }
            }
            
        }
    }
    
    protected void computeMatrixTimesMuDev(int par, double[][] matrix, double[] erg)
    {
        for (int i=0; i<anzVar; i++) erg[i] = 0;
        if (parType[par]==parameterType.structure)
        {
            double v = meanVal[parPos[par][1]];
            if (matrix==null) erg[parPos[par][0]] = v;
            else for (int i=0; i<anzVar; i++) erg[i] = matrix[i][parPos[par][0]]*v;
        } else if (parType[par]==parameterType.mean) {
            for (int i=0; i<anzVar; i++)
            {
                erg[i] = 0;
                if (matrix==null) erg[i] = structureVal[i][parPos[par][0]];
                else for (int j=0; j<anzVar; j++) erg[i] += matrix[i][j] * structureVal[j][parPos[par][0]];
            }
        }
    }
    
    public boolean isErrorParameter(int nr) {return parType[nr] == parameterType.err;}

    public void setParameter(int nr, double value)
    {
        if (parType[nr]==parameterType.mean)
            for (int i=0; i<anzFac; i++)
                if (meanPar[i]==nr) meanVal[i] = value; 
        if (parType[nr]==parameterType.structure)
            for (int i=0; i<anzVar; i++)
                for (int j=0; j<anzFac; j++)
                    if (structurePar[i][j]==nr) structureVal[i][j] = value; 
        if (parType[nr]==parameterType.facCov)
            for (int i=0; i<anzFac; i++)
                for (int j=0; j<anzFac; j++)
                    if (facCovPar[i][j]==nr) facCovVal[i][j] = value;
        if (parType[nr]==parameterType.err) errVal = value;
    }
    
    public double getParameter(int nr)
    {
        if (parType[nr]==parameterType.mean) return meanVal[parPos[nr][0]];
        if (parType[nr]==parameterType.err) return errVal;
        if (parType[nr]==parameterType.structure) return structureVal[parPos[nr][0]][parPos[nr][1]];
        if (parType[nr]==parameterType.facCov) return facCovVal[parPos[nr][0]][parPos[nr][1]];
        return -999;
    }
    
    
    public static SingletonModel fixParameter(SingletonModel in, int nr, double value) {SingletonModel erg = new SingletonModel(in); erg.fixParameter(nr,value); return erg;}
    public void fixParameter(int[] nrs) {Arrays.sort(nrs); for (int i=nrs.length-1; i>=0; i--) fixParameter(nrs[i]);}
    public void fixParameter(int nr) {fixParameter(nr, getParameter(nr));}
    public void fixParameter(int nr, double value)
    {
        anzPar--;
        for (int i=0; i<anzFac; i++)
        {
            if (meanPar[i]==nr) { meanVal[i] = value; meanPar[i] = NOPARAMETER;}
            if (meanPar[i] >nr)  meanPar[i]--;
        }
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzFac; j++)
            {
                if (structurePar[i][j]==nr) { structureVal[i][j] = value; structurePar[i][j] = -1;}
                if (structurePar[i][j] >nr)  structurePar[i][j]--;
            }
        for (int i=0; i<anzFac; i++)
            for (int j=0; j<anzFac; j++)
            {
                if (facCovPar[i][j]==nr) { facCovVal[i][j] = value; facCovPar[i][j] = -1;}
                if (facCovPar[i][j] >nr)  facCovPar[i][j]--;
            }
        if (errPar==nr) { errVal = value; errPar = -1;}
        if (errPar >nr)  errPar--;
        collectParameterTypesAndPos();
    }
    
    public void evaluateMuAndSigma(double[] values)
    {
        if ((sigma==null) || (sigma.length!=anzVar) || (sigma[0].length!=anzVar)) sigma = new double[anzVar][anzVar];
        if ((structureWork==null) || (structureWork.length!=anzVar) || (structureWork[0].length!=anzFac)) structureWork = new double[anzVar][anzFac];
        if ((structureTransWork==null) || (structureTransWork.length!=anzFac) || (structureTransWork[0].length!=anzVar)) structureTransWork = new double[anzFac][anzVar];
        if ((mu==null) || (mu.length!=anzVar)) mu = new double[anzVar];
        if (values!=null) setParameter(values);

        Statik.transpose(structureVal, structureTransWork);
        Statik.multiply(structureVal, facCovVal, structureWork);
        Statik.multiply(structureWork, structureTransWork, sigma);
        
        Statik.multiply(structureVal, meanVal, mu);

        for (int i=0; i<anzVar; i++) 
            sigma[i][i] += errVal;
    }
    
    public boolean factorPositiveDefinite(double[] values)
    {
        setParameter(values);
        return (Statik.determinantOfPositiveDefiniteMatrix(facCovVal) != -1); 
    }
    
    /**
     * Computes the least square index and for each parameter its derivative and second derivative. Parameters are expected to be numbered
     * from 0 to anzPar-1. If values is not null, these parameter values are applied; otherwise, the method assumes all values are correct.
     */
    public void computeLeastSquaresDerivatives(double[] value, boolean recomputeMuAndSigma)
    {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((muWork==null) || (muWork.length!=anzVar)) muWork = new double[anzVar];
        if ((lsD==null) || (lsD.length!=anzPar)) lsD = new double[anzPar];
        if ((lsDD==null) || (lsDD.length!=anzVar) || (lsDD[0].length!=anzVar)) lsDD = new double[anzPar][anzPar];
        
        if (value != null) setParameter(value);
        if (recomputeMuAndSigma) evaluateMuAndSigma(value);
        
        ls = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) {sigmaWork[i][j] = sigma[i][j] - dataCov[i][j]; ls += 0.5*sigmaWork[i][j]*sigmaWork[i][j];}
        for (int i=0; i<anzVar; i++) {muWork[i] = mu[i] - dataMean[i]; ls += 0.5*muWork[i]*muWork[i];}
        
        for (int p=0; p<anzPar; p++)
        {
            lsD[p] = 0;
            if (parType[p] == parameterType.mean)
                for (int i=0; i<anzVar; i++) lsD[p] += structureVal[i][parPos[p][0]]*muWork[i];
            if (parType[p] == parameterType.structure)
            {
                for (int j=0; j<anzVar; j++) 
                    for (int l=0; l<anzFac; l++) 
                        lsD[p] += 2*(structureVal[j][l]*facCovVal[parPos[p][1]][l])*sigmaWork[parPos[p][0]][j];
                lsD[p] += meanVal[parPos[p][1]]*muWork[parPos[p][0]];
            }
            if (parType[p] == parameterType.facCov)
            {
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++) 
                        lsD[p] += (parPos[p][0]==parPos[p][1]?1:2)*(structureVal[i][parPos[p][0]]*structureVal[j][parPos[p][1]])*sigmaWork[i][j];
//                if (parPos[p][0]==parPos[p][1])
//                    for (int i=0; i<anzVar; i++)
//                        for (int j=0; j<anzVar; j++) 
//                            lsD[p] += (structureVal[i][parPos[p][0]]*structureVal[j][parPos[p][0]])*sigmaWork[i][j];
//                else
//                    for (int i=0; i<anzVar; i++)
//                        for (int j=0; j<anzVar; j++) 
//                            lsD[p] += 2*(structureVal[i][parPos[p][0]]*structureVal[j][parPos[p][1]])*sigmaWork[i][j];
            }
            if (parType[p] == parameterType.err)
                for (int i=0; i<anzVar; i++) lsD[p] += sigmaWork[i][i];
            for (int p2l=p; p2l<anzPar; p2l++)
            {
                int p1 = p, p2 = p2l;
                if (((parType[p1]!=parameterType.structure) && (parType[p2]==parameterType.structure)) ||
                    ((parType[p1]!=parameterType.structure) && (parType[p1]!=parameterType.facCov) && (parType[p2]==parameterType.facCov)) ||
                    ((parType[p1]==parameterType.mean) &&       (parType[p2]==parameterType.err))) {p1 = p2l; p2 = p;}
                
                lsDD[p1][p2] = 0;
                if ((parType[p1] == parameterType.structure) && (parType[p2] == parameterType.structure))
                {
                    lsDD[p1][p2] += 2*facCovVal[parPos[p1][1]][parPos[p2][1]]*sigmaWork[parPos[p1][0]][parPos[p2][0]];
                    
                    if (parPos[p1][0]==parPos[p2][0])
                    {
                        for (int j=0; j<anzVar; j++) {
                            double v1 = 0;  for (int l=0; l<anzFac; l++) v1 += facCovVal[parPos[p1][1]][l]*structureVal[j][l];
                            double v2 = 0;  for (int l=0; l<anzFac; l++) v2 += facCovVal[parPos[p2][1]][l]*structureVal[j][l];
                            lsDD[p1][p2] += (j==parPos[p1][0]?4:2)*v1*v2;
                        }
                    } else {
                        double v1 = 0;  for (int l=0; l<anzFac; l++) v1 += facCovVal[parPos[p1][1]][l]*structureVal[parPos[p2][0]][l];
                        double v2 = 0;  for (int l=0; l<anzFac; l++) v2 += facCovVal[parPos[p2][1]][l]*structureVal[parPos[p1][0]][l];
                        lsDD[p1][p2] += 2*v1*v2;
                    }
                    
                    if (parPos[p1][0] == parPos[p2][0]) lsDD[p1][p2] += meanVal[parPos[p1][1]]*meanVal[parPos[p2][1]];
                    
                }
                if ((parType[p1] == parameterType.structure) && (parType[p2] == parameterType.facCov))
                {
                    double fak = (parPos[p2][0]==parPos[p2][1]?1:2);
                    if (parPos[p1][1]==parPos[p2][0]) for (int j=0; j<anzVar; j++) lsDD[p1][p2] += fak*structureVal[j][parPos[p2][1]]*sigmaWork[parPos[p1][0]][j]; 
                    if (parPos[p1][1]==parPos[p2][1]) for (int i=0; i<anzVar; i++) lsDD[p1][p2] += fak*structureVal[i][parPos[p2][0]]*sigmaWork[i][parPos[p1][0]]; 
                    
                    for (int k=0; k<anzVar; k++)
                    {
                        double v1 = 0;  for (int l=0; l<anzFac; l++) v1 += facCovVal[parPos[p1][1]][l]*structureVal[k][l];
                        lsDD[p1][p2] += fak*(structureVal[parPos[p1][0]][parPos[p2][0]]*structureVal[k][parPos[p2][1]]+
                                           structureVal[k][parPos[p2][0]]*structureVal[parPos[p1][0]][parPos[p2][1]])*v1;
                    }
                }
                if ((parType[p1] == parameterType.structure) && (parType[p2] == parameterType.err))
                    for (int l=0; l<anzFac; l++) 
                        lsDD[p1][p2] += 2*(structureVal[parPos[p1][0]][l]*facCovVal[parPos[p1][1]][l]);
                if ((parType[p1] == parameterType.structure) && (parType[p2] == parameterType.mean))
                {
//                    for (int i=0; i<anzVar; i++) lsD[p] += structureVal[i][parPos[p][0]]*muWork[i];
                    if(parPos[p2][0]==parPos[p1][1]) lsDD[p1][p2] += muWork[parPos[p1][0]];
                    lsDD[p1][p2] += structureVal[parPos[p1][0]][parPos[p2][0]]*meanVal[parPos[p1][1]];
                }
                if ((parType[p1] == parameterType.facCov) && (parType[p2] == parameterType.facCov))
                {
                    for (int i=0; i<anzVar; i++)
                        for (int j=0; j<anzVar; j++) 
                        {
                            double f1 = structureVal[i][parPos[p1][0]]*structureVal[j][parPos[p1][1]]+
                                        structureVal[j][parPos[p1][0]]*structureVal[i][parPos[p1][1]]; if (parPos[p1][0]==parPos[p1][1]) f1 /= 2;
                            double f2 = structureVal[i][parPos[p2][0]]*structureVal[j][parPos[p2][1]]+
                                        structureVal[j][parPos[p2][0]]*structureVal[i][parPos[p2][1]]; if (parPos[p2][0]==parPos[p2][1]) f2 /= 2;
                            lsDD[p1][p2] += f1*f2;
                        }
                }
                if ((parType[p1] == parameterType.facCov) && (parType[p2] == parameterType.err))
                    for (int i=0; i<anzVar; i++)
                        lsDD[p1][p2] += (parPos[p][0]==parPos[p][1]?1:2)*(structureVal[i][parPos[p1][0]]*structureVal[i][parPos[p1][1]]);
                if ((parType[p1] == parameterType.err) && (parType[p2] == parameterType.err))
                    lsDD[p1][p2] += anzVar;
                if ((parType[p1] == parameterType.mean) && (parType[p2] == parameterType.mean))
                    for (int i=0; i<anzVar; i++)
                        lsDD[p1][p2] += structureVal[i][parPos[p1][0]]*structureVal[i][parPos[p2][0]];

                lsDD[p2][p1] = lsDD[p1][p2];
            }
        }
    }
    
    /**
     * Computes the minus two log likelihood and for each parameter its derivative and second derivative. Parameters are expected to be numbered
     * from 0 to anzPar-1. If values is not zero, these parameter values are applied; otherwise, the method assumes all values are correct.
     */
    public void computeLogLikelihoodDerivatives(double[] value, boolean recomputeMuAndSigma)
    {
        if ((sigmaWork==null) || (sigmaWork.length!=anzVar) || (sigmaWork[0].length!=anzVar)) sigmaWork = new double[anzVar][anzVar];
        if ((sigmaWork2==null) || (sigmaWork2.length!=anzVar) || (sigmaWork2[0].length!=anzVar)) sigmaWork2 = new double[anzVar][anzVar];
        if ((sigmaWork3==null) || (sigmaWork3.length!=anzVar) || (sigmaWork3[0].length!=anzVar)) sigmaWork3 = new double[anzVar][anzVar];
        if ((sigmaWork4==null) || (sigmaWork4.length!=anzVar) || (sigmaWork4[0].length!=anzVar)) sigmaWork4 = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];
        if ((llD==null) || (llD.length!=anzPar)) llD = new double[anzPar];
        if ((llDD==null) || (llDD.length!=anzVar) || (llDD[0].length!=anzVar)) llDD = new double[anzPar][anzPar];
        
        if (value != null) setParameter(value);
        if (recomputeMuAndSigma) evaluateMuAndSigma(value);
        
        sigmaDet = Statik.invert(sigma,sigInv, sigmaWork);
        if ((Statik.determinantOfPositiveDefiniteMatrix(sigma)==-1) && (sigmaDet > 0))
        {
//            System.out.println("Not positive defnite Sigma!");
            sigmaDet = Double.NaN;
        }
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(sigmaDet);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += sigInv[i][j]*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
        
        for (int p=0; p<anzPar; p++)
        {
            llD[p] = 0.0;
            if (parType[p] == parameterType.mean)
            {
                for (int i=0; i<anzVar; i++)
                    for (int j=0; j<anzVar; j++) llD[p] -= 2*structureVal[i][parPos[p][0]]*sigInv[i][j]*anzPer*(dataMean[j] - mu[j]);
            } 
            if (parType[p] == parameterType.structure)
            {
                for (int j=0; j<anzVar; j++) llD[p] -= 2*meanVal[parPos[p][1]]*sigInv[parPos[p][0]][j]*anzPer*(dataMean[j] - mu[j]);
            }
            if (parType[p] != parameterType.mean)
            {
                computeSigmaInvDev(p, sigmaWork);
                double trace = 0;
                for (int i=0; i<anzVar; i++) trace += sigmaWork[i][i];
                llD[p] += trace*anzPer;
                Statik.multiply(sigmaWork, sigInv, sigmaWork2);
                for (int i=0; i<anzVar; i++) 
                    for (int j=0; j<anzVar; j++) llD[p] -= sigmaWork2[i][j]*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
            }
        }
        
        for (int p1=0; p1<anzPar; p1++)
            for (int p2=0; p2<anzPar; p2++)
                llDD[p1][p2] = 0;
        for (int p1=0; p1<anzPar; p1++)
            for (int p2=0; p2<anzPar; p2++)
            {
                // Term 4 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]==parameterType.mean) && (parType[p2]==parameterType.mean))
                {
                    for (int i=0; i<anzVar; i++)
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += 2*anzPer*structureVal[i][parPos[p1][0]]*structureVal[j][parPos[p2][0]]*sigInv[i][j];
                }
                if (((parType[p1]==parameterType.mean) && (parType[p2]==parameterType.structure))
                ||  ((parType[p1]==parameterType.structure) && (parType[p2]==parameterType.mean)))
                {
                    int q1 = (parType[p1]==parameterType.mean?p1:p2), q2 = (parType[p1]==parameterType.mean?p2:p1); 
                    for (int i=0; i<anzVar; i++)
                        llDD[p1][p2] += 2*anzPer*structureVal[i][parPos[q1][0]]*meanVal[parPos[q2][1]]*sigInv[i][parPos[q2][0]];
                }
                if ((parType[p1]==parameterType.structure) && (parType[p2]==parameterType.structure))
                {
                    llDD[p1][p2] += 2*anzPer*meanVal[parPos[p1][1]]*meanVal[parPos[p2][1]]*sigInv[parPos[p1][0]][parPos[p2][0]];
                }
                // Term 2 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if (((parType[p1]==parameterType.mean) && (parType[p2]==parameterType.structure))
                ||  ((parType[p1]==parameterType.structure) && (parType[p2]==parameterType.mean)))
                {
                    int q1 = (parType[p1]==parameterType.mean?p1:p2), q2 = (parType[p1]==parameterType.mean?p2:p1);
                    
                    if (parPos[q1][0] == parPos[q2][1]) 
                        for (int i=0; i<anzVar; i++) llDD[p1][p2] -= 2*anzPer*(dataMean[i]-mu[i])*sigInv[parPos[q2][0]][i];
                }
                // Term 3 and 5 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]==parameterType.structure) && (parType[p2]==parameterType.structure))
                {
                    computeSigmaInvDev(p1, sigmaWork);
                    Statik.multiply(sigmaWork, sigInv, sigmaWork2);
                    computeSigmaInvDev(p2, sigmaWork);
                    Statik.multiply(sigmaWork, sigInv, sigmaWork3);
                    for (int j=0; j<anzVar; j++)
                    {
                        llDD[p1][p2] += 2*meanVal[parPos[p1][1]]*sigmaWork3[parPos[p1][0]][j]*anzPer*(dataMean[j]-mu[j]);
                        llDD[p1][p2] += 2*meanVal[parPos[p2][1]]*sigmaWork2[parPos[p2][0]][j]*anzPer*(dataMean[j]-mu[j]);
                    }
                } 
                else if (((parType[p1]!=parameterType.facCov) && (parType[p1]!=parameterType.err) && (parType[p2]!=parameterType.mean))
                ||  ((parType[p1]!=parameterType.mean) && (parType[p2]!=parameterType.facCov) && (parType[p2]!=parameterType.err)))
                {
                    boolean exchange = (parType[p1]==parameterType.facCov) || (parType[p1]==parameterType.err)
                                        || (parType[p2]==parameterType.mean);
                    int q1 = (exchange?p2:p1), q2 = (exchange?p1:p2); 
                    computeSigmaInvDev(q2, sigmaWork2);
                    Statik.multiply(sigmaWork2, sigInv, sigmaWork);
                    if (parType[q1]==parameterType.mean)
                    {
                        for (int i=0; i<anzVar; i++)
                            for (int j=0; j<anzVar; j++)
                                llDD[p1][p2] += 2*structureVal[i][parPos[q1][0]]*sigmaWork[i][j]*anzPer*(dataMean[j]-mu[j]);
                    } else {
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += 2*meanVal[parPos[q1][1]]*sigmaWork[parPos[q1][0]][j]*anzPer*(dataMean[j]-mu[j]);
                    }
                }
                
                // Term 1,6,7 and 8 in Eq. (13) of von Oertzen, Ghisletta, Lindenberger (2009)
                if ((parType[p1]!=parameterType.mean) && (parType[p2]!=parameterType.mean))
                {
                    computeSigmaInvDev(p1, sigmaWork);
                    computeSigmaInvDev(p2, sigmaWork2);
                    computeSigmaInvDevDev(p1, p2, sigmaWork3);
                    Statik.multiply(sigmaWork, sigmaWork2, sigmaWork4);
                    double trace = 0;
                    for (int i=0; i<anzVar; i++) trace += sigmaWork3[i][i] - sigmaWork4[i][i];
                    llDD[p1][p2] += trace*anzPer;
                    Statik.multiply(sigmaWork4, sigInv, sigmaWork);
                    Statik.multiply(sigmaWork3, sigInv, sigmaWork2);
                    for (int i=0; i<anzVar; i++)
                        for (int j=0; j<anzVar; j++)
                            llDD[p1][p2] += (2*sigmaWork[i][j] - sigmaWork2[i][j])*(xBiSum[i][j] - anzPer*mu[i]*dataMean[j] - anzPer*mu[j]*dataMean[i] + anzPer*mu[i]*mu[j]);
                }
            }
    }
    

    public double[] estimateLSOfLinearModel()
    {
        SingletonModel copy = new SingletonModel(this);
        double basefak = copy.structureVal[1][1]-copy.structureVal[0][1];
        for (int i=2; i<copy.anzVar; i++) copy.structureVal[i][1] = copy.structureVal[0][1] + i*basefak;
        for (int i=0; i<copy.anzPar; i++) if (copy.parType[i] == parameterType.structure) {copy.fixParameter(i,copy.parPos[i][0]); i--;}
        double[] zwerg = copy.estimateLS();
        double[] erg = new double[anzPar];
        int i=0; 
        for (int j=0; j<anzPar; j++) 
            if (parType[j]!=parameterType.structure) erg[j] = zwerg[i++]; else erg[j] = parPos[j][0];
        
        return erg;
    }
    
    public double[] estimateMLOfLinearModel()
    {
        SingletonModel copy = new SingletonModel(this);
        double basefak = copy.structureVal[1][1]-copy.structureVal[0][1];
        for (int i=2; i<copy.anzVar; i++) copy.structureVal[i][1] = copy.structureVal[0][1] + i*basefak;
        for (int i=0; i<copy.anzPar; i++) if (copy.parType[i] == parameterType.structure) {copy.fixParameter(i); i--;}
        double[] zwerg = copy.estimateML(copy.estimateLS(),0.0001);
        double[] erg = new double[anzPar];
        int i=0; 
        for (int j=0; j<anzPar; j++) 
            if (parType[j]!=parameterType.structure) erg[j] = zwerg[i++]; else erg[j] = copy.structureVal[parPos[j][0]][parPos[j][1]];
        
        return erg;
    }
    
    public static void testPathtracking()
    {
        SingletonModel model = new SingletonModel(new int[]{0,1}, new double[]{2,3}, 
                new int[][]{{-1,-1},{-1,-1},{-1,6},{-1,7},{-1,8},{-1,9}}, new double[][]{{1,0},{1,1},{1,2},{1,3},{1,4},{1,5}}, 
                new int[][]{{2,4},{4,3}}, new double[][]{{2,0.2},{0.2,1.0}}, 
                5, 0.5);

//        model.fixParameter(new int[]{6,7});
        double[] pop = model.getParameter();
        model.createData(100);
        model.computeLogLikelihoodDerivatives(model.getArbitraryStartingValues(), true);
        double popLL = model.ll;
        int anzVar = model.anzVar;
        
//        model.logStream = System.out;
        double EPS = 0.001;
        int anzRep = 10, ptFailed = 0, lsFailed = 0, abFailed = 0, ptSteps = 0, lsSteps = 0, abSteps = 0, mlSteps = 0, mlFailed = 0; 
        for (int i=0; i<anzRep; i++)
        {
            double varL = 1.0;                                                      // variance level chi^2 with mean 1., shifted by 1.
            double varS = rand.nextGaussian()/2; varS *= varS; varS += 0.01;         // variance slope chi^2 with mean 1/4.
            double covLS = Math.sqrt(varL*varS)*(rand.nextDouble()-0.5);        // correlation uniform from -0.5 to 0.5
            double err = 0.1 + rand.nextDouble()*0.4;                               // error uniform from 0.1 to 0.5
//            pop[0] = rand.nextGaussian();                                           // means and path weights Gaussian with stdv 1, mean 0
//            pop[1] = rand.nextGaussian();
//            pop[2] = varL; pop[4] = covLS; pop[3] = varS;
//            pop[5] = err;
////            pop[6] = rand.nextDouble()+0.5;
////            pop[7] = rand.nextDouble()+1.0;
//            pop[6] = rand.nextGaussian()*2;
//            pop[7] = rand.nextGaussian()*2;
//            model.evaluateMuAndSigma(pop);
//            model.createData(500);
            
            double[][] data = new double[500][6];
            SimpleLGM.createExponentialData(30, 20, 0.05, 0, 20, 20, 30, 3.0, 500, 6, data);
            model.setData(data);
            
            double[] popEstimate = model.estimateML(pop, EPS); popLL = model.ll; double popLLL = model.ll; int popLSteps = model.steps;
            double[] estimate = model.estimateML(model.getArbitraryStartingValues(),EPS); double abLLL = model.ll; int abLSteps = model.steps;
            abFailed += (model.ll - popLL > 1.0?1:0); abSteps += model.steps;
            double[] mlEstimate = model.estimateML(model.estimateMLOfLinearModel(),EPS); double mlLLL = model.ll; int mlLSteps = model.steps;
            mlFailed += (model.ll - popLL > 1.0?1:0); mlSteps += model.steps;
            estimate = model.estimateML(EPS); double lsLLL = model.ll; int lsLSteps = model.steps;
            lsFailed += (model.ll - popLL > 1.0?1:0); lsSteps += model.steps;
            double[] pathEstimate = model.estimateMLByPathtracking(null, EPS); double ptLLL = model.ll; int ptLSteps = model.steps;
            ptFailed += (model.ll - popLL > 1.0?1:0); ptSteps += model.steps;
            if (model.ll - popLL > 1.0 || true)
            {
                System.out.println("Population = "+Statik.matrixToString(pop));
                System.out.println("Pop Est    = "+Statik.matrixToString(popEstimate)+"\t steps = "+popLSteps+" ll = "+popLLL);
                System.out.println("Ab Estimate= "+Statik.matrixToString(estimate)+"\t steps = "+abLSteps+" ll = "+abLLL);
                System.out.println("ML Estimate= "+Statik.matrixToString(mlEstimate)+"\t steps = "+mlLSteps+" ll = "+mlLLL);
                System.out.println("LS Estimate= "+Statik.matrixToString(estimate)+"\t steps = "+lsLSteps+" ll = "+lsLLL);
                System.out.println("Path Track = "+Statik.matrixToString(pathEstimate)+"\t steps = "+ptLSteps+" ll = "+ptLLL);
                System.out.println();
            }
        }
        System.out.println("Arbitrary Start = ("+100*(abFailed/(double)anzRep)+" %, "+abSteps/(double)anzRep+")");
        System.out.println("ML linear Start = ("+100*(mlFailed/(double)anzRep)+" %, "+mlSteps/(double)anzRep+")");
        System.out.println("LS Start        = ("+100*(lsFailed/(double)anzRep)+" %, "+lsSteps/(double)anzRep+")");
        System.out.println("Path Tracking   = ("+100*(ptFailed/(double)anzRep)+" %, "+ptSteps/(double)anzRep+")");
        
        /*
        double[][] baseCov = new double[anzVar][anzVar], diffCov =new double[anzVar][anzVar]; 
        double[] baseMu = new double[anzVar], diffMu =new double[anzVar]; 
        for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) {baseCov[i][j] = model.sigma[i][j]; diffCov[i][j] = model.dataCov[i][j] - baseCov[i][j];}
        for (int i=0; i<anzVar; i++) {baseMu[i] = model.mu[i]; diffMu[i] = model.dataMean[i] - baseMu[i];}
        
        double lambda = 0.0;
        for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) model.dataCov[i][j] = baseCov[i][j] + lambda*diffCov[i][j];
        for (int i=0; i<anzVar; i++) model.dataMean[i] = baseMu[i] + lambda*diffMu[i];
        model.computeMomentsFromDataCovarianceAndMean();
        model.computeLogLikelihoodDerivatives(model.getArbitraryStartingValues(), true);
        model.computePathDerivatives(lambda, baseCov, diffCov, baseMu, diffMu, true);
        double orgLL = model.ll;
        double[] orgLLD = Statik.copy(model.llD);
        EPS = 0.000001;
        lambda += EPS;
        for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) model.dataCov[i][j] = baseCov[i][j] + lambda*diffCov[i][j];
        for (int i=0; i<anzVar; i++) model.dataMean[i] = baseMu[i] + lambda*diffMu[i];
        model.computeMomentsFromDataCovarianceAndMean();
        model.computeLogLikelihoodDerivatives(model.getArbitraryStartingValues(), true);
        double numLLD = (model.ll - orgLL)/EPS;
        double[] numLLDD = new double[model.anzPar];
        for (int i=0; i<model.anzPar; i++) numLLDD[i] = (model.llD[i] - orgLLD[i])/EPS;
        System.out.println("Theoretical   = "+model.llPathD+", gradient = \t\t"+Statik.matrixToString(model.llPathDD));
        System.out.println("Numerical     = "+numLLD+", gradient = \t\t"+Statik.matrixToString(numLLDD));
        System.out.println("Actual llD   = "+Statik.matrixToString(model.llD));
        System.out.println("Previous llD = "+Statik.matrixToString(orgLLD));
        for (int i=0; i<model.anzPar; i++) model.setParameter(i, model.getParameter(i) + EPS*model.pathDirection[i]);
        model.computeLogLikelihoodDerivatives(null, true);
        System.out.println("Path     llD = "+Statik.matrixToString(model.llD));
        */
        
        
        System.exit(0);
    }
    
    
    public static void main(String args[])
    {
        testPathtracking();
        
        
        SingletonModel model = new SingletonModel(new int[]{0,1}, new double[]{2,3}, 
                new int[][]{{-1,-1},{-1,-1},{-1,2},{-1,3},{-1,4}}, new double[][]{{1,0},{1,1},{1,2},{1,3},{1,4}}, 
                new int[][]{{5,7},{7,6}}, new double[][]{{2,0.5},{0.5,2}}, 
                8, 0.5);
        model.fixParameter(new int[]{3});
        
        model = new SingletonModel(new int[]{0,1}, new double[]{2,3}, 
                new int[][]{{-1,-1},{-1,-1},{-1,6},{-1,7},{-1,8},{-1,9},{-1,10},{-1,11}}, new double[][]{{1,0},{1,1},{1,2},{1,3},{1,4},{1,5},{1,6},{1,7}}, 
                new int[][]{{2,4},{4,3}}, new double[][]{{2,0.5},{0.5,2}}, 
                5, 0.5);

        double[] pop = new double[model.anzPar];
        for (int i=0; i<model.anzPar; i++) pop[i] = model.getParameter(i);
        model.createData(100);

        
        model.computeLeastSquaresDerivatives(pop, true);
        double ls = model.ls;
        double[] derOrg = Statik.copy(model.lsD);
        double[] der = new double[pop.length];
        double[][] d2 = new double[pop.length][pop.length];
        double eps = 0.00001;
        for (int i=0; i<pop.length; i++)
        {
            pop[i] += eps;
            model.computeLeastSquaresDerivatives(pop);
            der[i] = (model.ls - ls)/eps;
            pop[i] -= eps;
        }
        for (int i=0; i<pop.length; i++)
        {
            pop[i] += eps;
            model.computeLeastSquaresDerivatives(pop);
            for (int j=0; j<pop.length; j++)
                d2[i][j] = (model.lsD[j] - derOrg[j])/eps;
            pop[i] -= eps;
        }
        model.computeLeastSquaresDerivatives(pop, true);
        System.out.println("Numerical Values = ");
        System.out.println(Statik.matrixToString(der));
        System.out.println(Statik.matrixToString(d2));
        System.out.println("Symbolic  Values = ");
        System.out.println("True LS = "+model.ls);
        System.out.println(Statik.matrixToString(model.lsD));
        System.out.println(Statik.matrixToString(model.lsDD));
        
        for (int i=0; i<pop.length; i++) der[i] -= model.lsD[i];
        for (int i=0; i<pop.length; i++) for (int j=0; j<pop.length; j++) d2[i][j] -= model.lsDD[i][j];
        System.out.println("\r\nDifference = ");
        System.out.println(Statik.matrixToString(der));
        System.out.println(Statik.matrixToString(d2));

        
//        model.fixParameter(0, 1);
//        
//        double[] pop = new double[]{1,1,1,2,1,1,0.5};
        model.setParameter(pop);
        int anzRep = 100; double[] estSum = new double[pop.length], estSSum = new double[pop.length], erg = null;
        for (int i=0; i<pop.length; i++) estSum[i] = estSSum[i] = 0;
        System.out.println("Population    = "+Statik.matrixToString(pop));
        int anzOK = 0;
        for (int i=0; i<anzRep; i++)
        {
            model.setParameter(pop);
            model.createData(100);
            model.evaluateMuAndSigma(pop);
            erg = model.estimateLS(0.001);
            if (model.warningFlag != warningFlagTypes.OK) System.out.println("Susp. Estimate = "+Statik.matrixToString(erg));
            if (model.warningFlag != warningFlagTypes.FAILED) {anzOK++; for (int j=0; j<erg.length; j++) {estSum[j] += erg[j]; estSSum[j] += erg[j]*erg[j];}}
        }
        for (int j=0; j<estSum.length; j++) {estSum[j] /= (double)anzOK; estSSum[j] = Math.sqrt(estSSum[j]/(double)anzOK - estSum[j]*estSum[j]);}
        System.out.println("Population         = "+Statik.matrixToString(pop));
        System.out.println("Mean Estimate (LS) = "+Statik.matrixToString(estSum));
        System.out.println("STDV Estimate (LS) = "+Statik.matrixToString(estSSum));
        System.out.println((anzRep-anzOK)+" of "+anzRep+" runs failed.");
        
        double[] starting = new double[pop.length];
        model.setParameter(pop);
        System.out.println("Population        = "+Statik.matrixToString(pop));
        for (int i=0; i<pop.length; i++) estSum[i] = estSSum[i] = 0;
        anzOK = 0; int sus = 0; double sumll = 0;
        for (int i=0; i<anzRep; i++)
        {
            model.setParameter(pop);
            model.createData(100);
            model.evaluateMuAndSigma(pop);
            model.warningFlag = warningFlagTypes.OK;

//            starting = pop;
            starting = model.getArbitraryStartingValues();
//            starting = model.estimateLS(0.001);
            
            if (model.warningFlag != warningFlagTypes.FAILED) erg = model.estimateML(starting, 0.001);
            if (model.warningFlag != warningFlagTypes.OK) System.out.println("Susp. Estimate = "+Statik.matrixToString(erg));
            if (model.errVal > 0.8) 
            {
                System.out.println("High error: "+model.errVal+", ll = "+model.ll+", Warning = "+model.warningFlag);
                if (model.warningFlag != warningFlagTypes.FAILED) erg = model.estimateML(starting, 0.001);
            }
            if (model.warningFlag != warningFlagTypes.FAILED) {anzOK++; for (int j=0; j<erg.length; j++) {estSum[j] += erg[j]; estSSum[j] += erg[j]*erg[j];} sumll+=model.ll;}
            if (model.warningFlag == warningFlagTypes.SUSPICIOUS) sus++;
        }
        for (int j=0; j<estSum.length; j++) {estSum[j] /= (double)anzOK; estSSum[j] = Math.sqrt(estSSum[j]/(double)anzOK - estSum[j]*estSum[j]);}
        System.out.println("Population        = "+Statik.matrixToString(pop));
        System.out.println("Mean Estimate (ML)= "+Statik.matrixToString(estSum));
        System.out.println("STDV Estimate (ML)= "+Statik.matrixToString(estSSum));
        System.out.println("Average LL        = "+(sumll/(double)anzOK));
        System.out.println((anzRep-anzOK)+" of "+anzRep+" runs failed, "+sus+" were suspicious.");
        
        /*
        System.out.println("Mu = "+Statik.matrixToString(model.mu));
        System.out.println("Sigma = \r\n"+Statik.matrixToString(model.sigma));
        
        double[][] work = new double[model.anzVar][model.anzVar];
        model.sigInv = new double[model.anzVar][model.anzVar];
        Statik.invert(model.sigma, model.sigInv, work);  
        double[][] res = new double[3][3];
        for (int p = 0; p<8; p++)
        {
            model.computeSigmaInvDev(p, res);
            Statik.multiply(model.sigma, res, work);
            System.out.println("SigmaDev = \r\n"+Statik.matrixToString(work));
        }
        
        model.computeLogLikelihoodDerivatives(pop, true);
        double ll = model.ll;
        double[] derOrg = Statik.copy(model.llD);
        double[] der = new double[pop.length];
        double[][] d2 = new double[pop.length][pop.length];
        double eps = 0.00001;
        for (int i=0; i<pop.length; i++)
        {
            pop[i] += eps;
            model.computeLogLikelihoodDerivatives(pop);
            der[i] = (model.ll - ll)/eps;
            pop[i] -= eps;
        }
        for (int i=0; i<pop.length; i++)
        {
            pop[i] += eps;
            model.computeLogLikelihoodDerivatives(pop);
            for (int j=0; j<pop.length; j++)
                d2[i][j] = (model.llD[j] - derOrg[j])/eps;
            pop[i] -= eps;
        }
        model.computeLogLikelihoodDerivatives(pop, true);
        System.out.println("Numerical Values = ");
        System.out.println(Statik.matrixToString(der));
        System.out.println(Statik.matrixToString(d2));
        System.out.println("Symbolic  Values = ");
        System.out.println("True LL = "+model.ll);
        System.out.println(Statik.matrixToString(model.llD));
        System.out.println(Statik.matrixToString(model.llDD));
        
        for (int i=0; i<pop.length; i++) der[i] -= model.llD[i];
        for (int i=0; i<pop.length; i++) for (int j=0; j<pop.length; j++) d2[i][j] -= model.llDD[i][j];
        System.out.println("\r\nDifference = ");
        System.out.println(Statik.matrixToString(der));
        System.out.println(Statik.matrixToString(d2));
        */
    }
    
}
