/*
 * Created on 26.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;
import java.util.Arrays;
import java.util.Random;

import silvers.Statik;


/**
 * @author timo
 */
public class WienerProcessModel 
{
    static int NOPARAMETER = -1;
    static final double LNTWOPI = Math.log(2*Math.PI);
    static Random rand = new Random(12345678);      // Manuels Daten    
//    static Random rand = new Random();
    
    public static enum parameterType {auto, meanInitTrait, covProc, covInitTrait, err};

  int anzOcc;
  int anzPar;
  int anzVar;
  double[] times;
  
  // Note that mean Trait and mean Proc are exchangeable in the exact model.
  double[] meanInitTraitVal, errVal;
  double[][] autoVal, covProcVal, covInitTraitVal;
  int[] meanInitTraitPar, errPar;
  int[][] autoPar, covProcPar, covInitTraitPar;
      
  int anzPer;
  double[][] data;
  double[] dataMean;
  double[] xsum;
  double[][] dataCov;
  double[][] xBiSum;
  
  double[][] sigmaLat, sigma;
  double[] mu;
  double[][] corrMoments;
  
  double ll;
  double[] llD;
  double[][] llDD;
  
  // The eigenvector matrix of auto and its first and second derivatives with respect to a_11, a_12, and a_22 (in this order).
  double[][] trans = new double[2][2], transInv = new double[2][2];
  double[][][] transD = new double[4][2][2];
  double[][][][] transDD = new double[4][4][2][2];
  double detTrans;
  
  // Half the Trace and the and T^2 - the determinant of auto; D is the value in the square root of the eigenvalues of trans,
  // i.e. EV = T +- sqrt(D).
  double detAuto, T, D, sqrtD;
  final double[] TD = new double[]{0.5,0,0,0.5};
  double[] DD = new double[4];
  final double[][] DDD = new double[][]{{0.5,0,0,-0.5},{0,0,1,0},{0,1,0,0},{-0.5,0,0,0.5}};
  
  double ev1, ev2;
  double[] ev1D = new double[4], ev2D = new double[4];
  double[][] evDD = new double[4][4]; // ev2DD is the negation of evDD.
  
  // Matrices in the computation and their derivatives wrt parameters of trans. The first 
  // index refers to the time point (index of the array times). 
  double[][][] P,M;
  double[][][][] PD,MD;
  double[][][][][] PDD, MDD;

  // parameter types
  parameterType[] parType;
  int[][] parPos;         // array with one entry for arrays, two for matrices.
  
  // The following are local variables, as they are dependent of t or of parameter numbers
//  double[][] sigDev;
  
  // Some working variables
  double[][] work1,work2,work3,work4,work42, work422, work44, work5, work6, work7;
  double[][] sigmaWork1, sigmaWork2, sigmaWork3, sigmaWork4, worksd1, worksd2, worksdd;
  double[] muWork, muWork2,muWork3,muWork4,muWork5,muWork6,muWork7,muWork8, posWork, p1w, p2w, cew, a1w, a2w;
  int[] sDevRow, sDevCol, cDevRow, cDevCol, mDev;
  
  double[][] sigInv;
  double[] lastEstimate;
  
  double DEBUGDOUBLE1, DEBUGDOUBLE2;
  
  public double[][] fisherInformationMatrix;

      public WienerProcessModel(int[] meanInitTraitPar, double[] meanInitTraitVal,
              int[][] autoPar, double[][] autoVal, int[][] covProcPar, double[][] covProcVal, 
              int[][] covInitTraitPar, double[][] covInitTraitVal, int[] errPar, double[] errVal,
              double[] times)
      {
          this.meanInitTraitPar = meanInitTraitPar; this.meanInitTraitVal = meanInitTraitVal;
          this.autoPar = autoPar; this.autoVal = autoVal; this.covProcPar = covProcPar; this.covProcVal = covProcVal; 
          this.covInitTraitPar = covInitTraitPar; this.covInitTraitVal = covInitTraitVal;
          this.errPar = errPar; this.errVal = errVal;
          this.times = times;
          
          anzOcc = times.length; anzVar = anzOcc*2;
          anzPar = getActiveParameters().length;
          collectParameterTypesAndPos();
          
          anzPer = 0; data = new double[0][];
          
          fisherInformationMatrix = new double[anzPar][anzPar];
      }

      public WienerProcessModel(WienerProcessModel toCopy)
      {
          this(Statik.copy(toCopy.meanInitTraitPar), Statik.copy(toCopy.meanInitTraitVal), 
                  Statik.copy(toCopy.autoPar), Statik.copy(toCopy.autoVal), Statik.copy(toCopy.covProcPar),  Statik.copy(toCopy.covProcVal),
                  Statik.copy(toCopy.covInitTraitPar), Statik.copy(toCopy.covInitTraitVal),
                  Statik.copy(toCopy.errPar), Statik.copy(toCopy.errVal),
                  Statik.copy(toCopy.times));
          
          anzPer = toCopy.anzPer;
    
          data = Statik.copy(toCopy.data);
          computeMoments();
          fisherInformationMatrix = new double[anzPar][anzPar];
      }
      
      private void computeEigenvalues()
      {
          detAuto = (autoVal[0][0]*autoVal[1][1] - autoVal[0][1]*autoVal[1][0]);
          T = (autoVal[0][0] + autoVal[1][1])/2.0;
          D = T*T - detAuto;
          if (D < 0) {System.out.println("matrix A has complex Eigenvalues, I'll return NaN."); ev1 = Double.NaN; ev2 = Double.NaN; return;}
          sqrtD = Math.sqrt(D);
          ev1 = T + sqrtD; ev2 = T - sqrtD;
          DD[0] = T - autoVal[1][1]; DD[1] = autoVal[1][0]; DD[2] = autoVal[0][1]; DD[3] = T - autoVal[0][0];
          for (int i=0; i<4; i++) ev1D[i] = TD[i] + DD[i] / (2*sqrtD);
          for (int i=0; i<4; i++) ev2D[i] = TD[i] - DD[i] / (2*sqrtD);
          for (int i=0; i<4; i++) for (int j=0; j<4; j++) evDD[i][j] = - DD[i]*DD[j] / (4*D*sqrtD);
          evDD[0][3] -= 1/(2*sqrtD); evDD[1][2] += 1/(2*sqrtD); evDD[2][1] += 1/(2*sqrtD); evDD[3][0] -= 1/(2*sqrtD);
          evDD[0][0] += 1/(4*sqrtD); evDD[3][3] += 1/(4*sqrtD); evDD[3][0] += 1/(4*sqrtD); evDD[0][3] += 1/(4*sqrtD);
      }
      
      public void computeTransformationOld()
      {
          computeEigenvalues();
          
          trans[0][0] = autoVal[0][0] - ev2; trans[0][1] = autoVal[0][1];
          trans[1][0] = ev1 - autoVal[0][0]; trans[1][1] = -autoVal[0][1];
          detTrans = trans[0][0]*trans[1][1] - trans[0][1]*trans[1][0];
          transInv[0][0] =  trans[1][1] / detTrans; transInv[0][1] = -trans[0][1]/detTrans;
          transInv[1][0] = -trans[1][0] / detTrans; transInv[1][1] = trans[0][0]/detTrans;
              
          for (int i=0; i<4; i++) {
              transD[i][0][0] = -ev2D[i]; transD[i][0][1] = 0;
              transD[i][1][0] = +ev1D[i]; transD[i][1][1] = 0;
          }
          transD[0][0][0] += 1; transD[0][1][0] -= 1;
          transD[1][0][1] += 1; transD[1][1][1] -= 1;
          for (int i=0; i<4; i++)
              for (int j=0; j<4; j++)
              {
                  transDD[i][j][0][0] = evDD[i][j]; transDD[i][j][0][1] = 0;
                  transDD[i][j][1][0] = evDD[i][j]; transDD[i][j][1][1] = 0;
              }
      }
      
      public void computeTransformation()
      {
          computeEigenvalues();
          
          double v;
          trans[0][0] = (autoVal[0][0]-ev2)/autoVal[0][1]; trans[0][1] = 1;
          trans[1][0] = (autoVal[0][0]-ev1)/(2*sqrtD); trans[1][1] = autoVal[0][1]/(2*sqrtD);
          detTrans = trans[0][0]*trans[1][1] - trans[0][1]*trans[1][0];                         // should be constant 1!
          transInv[0][0] =  trans[1][1] / detTrans; transInv[0][1] = -trans[0][1]/detTrans;
          transInv[1][0] = -trans[1][0] / detTrans; transInv[1][1] = trans[0][0]/detTrans;
          
          double[][] w1 = new double[2][2], w2 = new double[2][2];
          Statik.multiply(trans, transInv, w1);
          Statik.multiply(trans, autoVal, w1);
          Statik.multiply(w1, transInv, w2);

          for (int i=0; i<4; i++)
          {
              transD[i][0][0] = -ev2D[i]/autoVal[0][1]; transD[i][0][1] = 0;
              transD[i][1][0] = -(autoVal[0][0]-ev1)*DD[i]/(4*sqrtD*D) - ev1D[i]/(2*sqrtD);
              transD[i][1][1] = -autoVal[0][1]*DD[i]/(4*sqrtD*D);
          }
          transD[1][0][0] -= (autoVal[0][0]-ev2)/(autoVal[0][1]*autoVal[0][1]);
          transD[0][0][0] += 1/(autoVal[0][1]);
          transD[0][1][0] += 1/(2*sqrtD);
          transD[1][1][1] += 1/(2*sqrtD);
          
          for (int i=0; i<4; i++) for (int j=0; j<4; j++)
          {
              transDD[i][j][0][0] = evDD[i][j]/autoVal[0][1]; transDD[i][j][0][1] = 0;
              transDD[i][j][1][0] = (ev1D[i]*DD[j] + ev1D[j]*DD[i])/(4*D*sqrtD) - (autoVal[0][0]-ev1)*DDD[i][j]/(4*D*sqrtD) 
                                    + 3*(autoVal[0][0]-ev1)*DD[i]*DD[j]/(8*D*D*sqrtD) - evDD[i][j]/(2*sqrtD); 
              transDD[i][j][1][1] = - autoVal[0][1]*DDD[i][j]/(4*D*sqrtD) 
                                    + 3*autoVal[0][1]*DD[i]*DD[j]/(8*D*D*sqrtD); 
          }
          transDD[1][1][0][0] += 2*(autoVal[0][0]-ev2)/(autoVal[0][1]*autoVal[0][1]*autoVal[0][1]);
          for (int i=0; i<4; i++) {v = ev2D[i]/(autoVal[0][1]*autoVal[0][1]); transDD[i][1][0][0] += v; transDD[1][i][0][0] += v;}
          v = -1/(autoVal[0][1]*autoVal[0][1]); transDD[0][1][0][0] += v; transDD[1][0][0][0] += v;
          for (int i=0; i<4; i++) {v = -DD[i]/(4*D*sqrtD); transDD[0][i][1][0] += v; transDD[i][0][1][0] += v;}
          for (int i=0; i<4; i++) {v = -DD[i]/(4*D*sqrtD); transDD[1][i][1][1] += v; transDD[i][1][1][1] += v;}
      }

      private void computePM()
      {
          if (P==null) P = new double[anzOcc][2][2]; if (PD==null) PD = new double[anzOcc][4][2][2]; if (PDD==null) PDD = new double[anzOcc][4][4][2][2];
          if (M==null) M = new double[anzOcc][2][4]; if (MD==null) MD = new double[anzOcc][4][2][4]; if (MDD==null) MDD = new double[anzOcc][4][4][2][4];

          for (int ti = 0; ti<times.length; ti++)
          {
              double t = times[ti];
              double exp2ev1 = Math.exp(2*ev1*t), v2ev1 = t*exp2ev1/(2*ev1) - (exp2ev1-1)/(4*ev1*ev1);
              double exp2ev2 = Math.exp(2*ev2*t), v2ev2 = t*exp2ev2/(2*ev2) - (exp2ev2-1)/(4*ev2*ev2);
              double exp2T   = Math.exp(2*T*t),   v2T   = t*exp2T/(2*T) - (exp2T-1)/(4*T*T);
              double exp1ev1 = Math.exp(ev1*t),   v1ev1 = t*exp1ev1/ev1 - (exp1ev1-1)/(ev1*ev1);
              double exp1ev2 = Math.exp(ev2*t),   v1ev2 = t*exp1ev2/ev2 - (exp1ev2-1)/(ev2*ev2);
              
              double w1 = (exp1ev1-1)/ev1, w2 = (exp1ev2-1)/ev2; 
              P[ti][0][0] = (exp2ev1-1)/(2*ev1); P[ti][0][1] = (exp2T-1)/(2*T); P[ti][1][0] = P[ti][0][1]; P[ti][1][1] = (exp2ev2-1)/(2*ev2);
              for (int i=0; i<2; i++) {
                  M[ti][0][i] = trans[0][i]*exp1ev1; M[ti][1][i] = trans[1][i]*exp1ev2; M[ti][0][2+i] = trans[0][i]*w1; M[ti][1][2+i] = trans[1][i]*w2;
              }
              
              for (int d1=0; d1<4; d1++)
              {
                  double e21D = 2*ev1D[d1]*v2ev1, e22D = 2*ev2D[d1]*v2ev2, e2TD = 2*TD[d1]*v2T, e11D = ev1D[d1]*v1ev1, e12D= ev2D[d1]*v1ev2;
                  // e11D Ableitung von w1: checked. 
                  if ((ti==1) && (d1==0)) DEBUGDOUBLE1 = w2;
                  PD[ti][d1][0][0] = e21D; PD[ti][d1][0][1] = e2TD; PD[ti][d1][1][0] = PD[ti][d1][0][1]; PD[ti][d1][1][1] = e22D;
                  for (int i=0; i<2; i++) {
                      MD[ti][d1][0][i] = transD[d1][0][i]*exp1ev1 + trans[0][i]*t*ev1D[d1]*exp1ev1;
                      MD[ti][d1][1][i] = transD[d1][1][i]*exp1ev2 + trans[1][i]*t*ev2D[d1]*exp1ev2;
                      MD[ti][d1][0][2+i] = transD[d1][0][i]*w1 + trans[0][i]*e11D;
                      MD[ti][d1][1][2+i] = transD[d1][1][i]*w2 + trans[1][i]*e12D;
                  }
                  for (int d2=0; d2<4; d2++)
                  {
                      double e21DD = 2*evDD[d1][d2]*v2ev1 +  4*ev1D[d1]*ev1D[d2]*(-2*v2ev1 + t*t*exp2ev1)/(2*ev1),
                             e22DD = -2*evDD[d1][d2]*v2ev2 + 4*ev2D[d1]*ev2D[d2]*(-2*v2ev2 + t*t*exp2ev2)/(2*ev2),
                             e2TDD =                         4*TD[d1]*TD[d2]*(-2*v2T + t*t*exp2T)/(2*T),
                             e11DD = evDD[d1][d2]*v1ev1   +  ev1D[d1]*ev1D[d2]*(-2*v1ev1 + t*t*exp1ev1)/ev1,
                             e12DD = -evDD[d1][d2]*v1ev2  +  ev2D[d1]*ev2D[d2]*(-2*v1ev2 + t*t*exp1ev2)/ev2;
                      if ((ti==1) && (d1==0) && (d2==1)) DEBUGDOUBLE2 = ev2D[d2]*v1ev2;
                      PDD[ti][d1][d2][0][0] = e21DD; PDD[ti][d1][d2][0][1] = e2TDD; PDD[ti][d1][d2][1][0] = e2TDD; PDD[ti][d1][d2][1][1] = e22DD;
                      for (int i=0; i<2; i++) {
                          MDD[ti][d1][d2][0][i] = exp1ev1*(transDD[d1][d2][0][i] + transD[d1][0][i]*t*ev1D[d2] + 
                                  transD[d2][0][i]*t*ev1D[d1] + trans[0][i]*t*evDD[d1][d2] + trans[0][i]*t*ev1D[d1]*ev1D[d2]*t);
                          MDD[ti][d1][d2][1][i] = exp1ev2*(transDD[d1][d2][1][i] + transD[d1][1][i]*t*ev2D[d2] + 
                                  transD[d2][1][i]*t*ev2D[d1] - trans[1][i]*t*evDD[d1][d2] + trans[1][i]*t*ev2D[d1]*ev2D[d2]*t);
                          MDD[ti][d1][d2][0][2+i] = transDD[d1][d2][0][i]*w1 + transD[d1][0][i]*ev1D[d2]*v1ev1 +
                                                transD[d2][0][i]*e11D + trans[0][i]*e11DD;
                          MDD[ti][d1][d2][1][2+i] = transDD[d1][d2][1][i]*w2 + transD[d1][1][i]*ev2D[d2]*v1ev2 +
                                                transD[d2][1][i]*e12D + trans[1][i]*e12DD;
                          
//                          MDD[ti][d2][d1][0][2+i] += transD[d2][0][i]*ev1D[2]*v1ev1;
//                          MDD[ti][d2][d1][1][2+i] += transD[d2][1][i]*ev2D[2]*v1ev2;
                      }
                  }
              }
          }          
      }
      
      public void evaluateMuAndSigma() {evaluateMuAndSigma(null);}
      public void evaluateMuAndSigma(double[] values)
      {
          if ((sigma==null) || (sigma.length!=anzVar) || (sigma[0].length!=anzVar)) sigma= new double[anzVar][anzVar];
          if ((sigmaLat==null) || (sigmaLat.length!=anzVar) || (sigmaLat[0].length!=anzVar)) sigmaLat = new double[anzVar][anzVar];
          if ((work1==null) || (work1.length!=2) || (work1[0].length!=2)) work1 = new double[2][2];
          if ((work2==null) || (work2.length!=2) || (work2[0].length!=2)) work2 = new double[2][2];
          if ((work42==null) || (work42.length!=4) || (work42[0].length!=2)) work42 = new double[4][2];
          if ((work422==null) || (work422.length!=4) || (work422[0].length!=2)) work422 = new double[4][2];
          if ((mu==null) || (mu.length!=anzVar)) mu = new double[anzVar];

          if (values!=null) applyParameterValues(values);
          computeTransformation(); computePM();
          
          for (int t=0; t<times.length; t++)
          {
              double exp1 = Math.exp(times[t]*ev1), exp2 = Math.exp(times[t]*ev2); 
              Statik.transpose(trans, work1); Statik.multiply(covProcVal,work1,work2); Statik.multiply(trans, work2, work1);
              sigmaLat[2*t][2*t] = work1[0][0]*(exp1*exp1-1)/(2*ev1); sigmaLat[2*t][2*t+1] = work1[0][1]*(Math.exp(2*times[t]*T)-1)/(2*T); 
              sigmaLat[2*t+1][2*t] = sigmaLat[2*t][2*t+1]; sigmaLat[2*t+1][2*t+1] = work1[1][1]*(exp2*exp2-1)/(2*ev2); 
          
              Statik.transpose(M[t], work42); Statik.multiply(covInitTraitVal,work42,work422); Statik.multiply(M[t], work422, work1);
              for (int i=0; i<2; i++) for (int j=0; j<2; j++) sigmaLat[2*t+i][2*t+j] += work1[i][j];
              
              if (t > 0)
              {
                  double delta = times[t]-times[t-1], diffexp1 = Math.exp(delta*ev1), diffexp2 = Math.exp(delta*ev2);
                  for (int t2=0; t2<t; t2++)
                  {
                      sigmaLat[2*t2][2*t] = diffexp1*sigmaLat[2*t2][2*t-2]; sigmaLat[2*t2][2*t+1] = diffexp2*sigmaLat[2*t2][2*t-1];
                      sigmaLat[2*t2+1][2*t] = diffexp1*sigmaLat[2*t2+1][2*t-2]; sigmaLat[2*t2+1][2*t+1] = diffexp2*sigmaLat[2*t2+1][2*t-1];
                      for (int i=0; i<2; i++) for (int j=0; j<2; j++) sigmaLat[2*t+i][2*t2+j] = sigmaLat[2*t2+j][2*t+i];
                  }
              }
              
              for (int i=0; i<2; i++)
              {
                  mu[2*t+i] = 0;
                  for (int j=0; j<4; j++) mu[2*t+i] += M[t][i][j]*meanInitTraitVal[j];
              }
          }
          for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) sigma[i][j] = sigmaLat[i][j];
          Statik.transpose(trans, work1); for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] *= errVal[i]; Statik.multiply(trans, work1, work2);
          for (int t=0; t<anzOcc; t++)
          {
              for (int i=0; i<2; i++) for (int j=0; j<2; j++) sigma[2*t+i][2*t+j] = sigmaLat[2*t+i][2*t+j] + work2[i][j];
          }
      }
      
      // Computes the derivative of the latent covariance matrix. 
      private void computeSigmaDevLatent(int pnr, double[][] erg)
      {
          if ((work1==null) || (work1.length!=2) || (work1[0].length!=2)) work1 = new double[2][2];
          if ((work2==null) || (work2.length!=2) || (work2[0].length!=2)) work2 = new double[2][2];
          if ((work3==null) || (work3.length!=2) || (work3[0].length!=2)) work3 = new double[2][2];
          if ((work4==null) || (work4.length!=2) || (work4[0].length!=2)) work4 = new double[2][2];
          if ((work5==null) || (work5.length!=anzVar) || (work5[0].length!=anzVar)) work5 = new double[anzVar][anzVar];
          if ((work42==null) || (work42.length!=4) || (work42[0].length!=2)) work42 = new double[4][2];
          if ((work44==null) || (work44.length!=4) || (work44[0].length!=4)) work44 = new double[4][4];
          if ((work422==null) || (work422.length!=4) || (work422[0].length!=2)) work422 = new double[4][2];
          if ((mu==null) || (mu.length!=anzVar)) mu = new double[anzVar];

          for (int i=0; i<erg.length; i++) for (int j=0; j<erg.length; j++) erg[i][j] = 0;
          if ((parType[pnr]==parameterType.meanInitTrait) || (parType[pnr]==parameterType.err)) return;
          for (int t=0; t<times.length; t++)
          {
              if (parType[pnr]==parameterType.auto)
              {
                  int dnr = parPos[pnr][0]*2 + parPos[pnr][1];
                  Statik.transpose(trans,work1); Statik.multiply(covProcVal,work1,work3); Statik.multiply(transD[dnr],work3,work2);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] = work2[i][j] + work2[j][i];
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] *= P[t][i][j]; 
                  Statik.multiply(trans,work3,work2);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] += work2[i][j]*PD[t][dnr][i][j];
                  Statik.transpose(M[t],work42); Statik.multiply(covInitTraitVal,work42,work422); Statik.multiply(MD[t][dnr],work422,work4); 
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] += work4[i][j] + work4[j][i];
                  erg[2*t][2*t] = work1[0][0]; erg[2*t+1][2*t] = work1[1][0]; erg[2*t][2*t+1] = work1[0][1]; erg[2*t+1][2*t+1]=work1[1][1];
                  if (t > 0)
                  {
                      double delta = times[t]-times[t-1], diffexp1 = Math.exp(delta*ev1), diffexp2 = Math.exp(delta*ev2), 
                             dD1 = delta*ev1D[dnr]*diffexp1, dD2 = delta*ev2D[dnr]*diffexp2; 
                      for (int t2=0; t2<t; t2++)
                      {
                          erg[2*t2][2*t] = diffexp1*erg[2*t2][2*t-2] + dD1*sigmaLat[2*t2][2*t-2]; 
                          erg[2*t2][2*t+1] = diffexp2*erg[2*t2][2*t-1] + dD2*sigmaLat[2*t2][2*t-1];
                          erg[2*t2+1][2*t] = diffexp1*erg[2*t2+1][2*t-2] + dD1*sigmaLat[2*t2+1][2*t-2]; 
                          erg[2*t2+1][2*t+1] = diffexp2*erg[2*t2+1][2*t-1] + dD2*sigmaLat[2*t2+1][2*t-1];
                          for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t2+j] = erg[2*t2+j][2*t+i];
                      }
                  }
              } else {
                  if (parType[pnr]==parameterType.covProc) {
                      for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] = 0;
                      work1[parPos[pnr][0]][parPos[pnr][1]] = 1; work1[parPos[pnr][1]][parPos[pnr][0]] = 1;
                      Statik.transpose(trans,work2); Statik.multiply(work1,work2,work3); Statik.multiply(trans,work3,work1);
                      for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] *= P[t][i][j];
                  } else if (parType[pnr]==parameterType.covInitTrait) {
                      for (int i=0; i<4; i++) for (int j=0; j<4; j++) work44[i][j] = 0;
                      work44[parPos[pnr][0]][parPos[pnr][1]] = 1; work44[parPos[pnr][1]][parPos[pnr][0]] = 1;
                      Statik.transpose(M[t],work42); Statik.multiply(work44,work42,work422); Statik.multiply(M[t],work422,work1);
                  }
                  erg[2*t][2*t] = work1[0][0]; erg[2*t+1][2*t] = work1[1][0]; erg[2*t][2*t+1] = work1[0][1]; erg[2*t+1][2*t+1]=work1[1][1];
                  if (t > 0)
                  {
                      double delta = times[t]-times[t-1], diffexp1 = Math.exp(delta*ev1), diffexp2 = Math.exp(delta*ev2); 
                      for (int t2=0; t2<t; t2++)
                      {
                          erg[2*t2][2*t] = diffexp1*erg[2*t2][2*t-2]; 
                          erg[2*t2][2*t+1] = diffexp2*erg[2*t2][2*t-1];
                          erg[2*t2+1][2*t] = diffexp1*erg[2*t2+1][2*t-2]; 
                          erg[2*t2+1][2*t+1] = diffexp2*erg[2*t2+1][2*t-1];
                          for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t2+j] = erg[2*t2+j][2*t+i];
                      }
                  }
              }
          }
      }

      private void computeSigmaDev(int pnr, double[][] erg)
      {
          if ((work1==null) || (work1.length!=2) || (work1[0].length!=2)) work1 = new double[2][2];
          if ((work2==null) || (work2.length!=2) || (work2[0].length!=2)) work2 = new double[2][2];

          computeSigmaDevLatent(pnr, erg);
          if (parType[pnr]==parameterType.err) { 
              int k = parPos[pnr][0];
              for (int t=0; t<anzOcc; t++)
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] = trans[i][k]*trans[j][k];
          }
          if (parType[pnr]==parameterType.auto) { 
              int dnr = parPos[pnr][0]*2 + parPos[pnr][1];
              Statik.transpose(transD[dnr], work1); for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] *= errVal[i]; Statik.multiply(trans, work1, work2);
              for (int t=0; t<anzOcc; t++)
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] += work2[i][j]+work2[j][i];
          }
      }

      private void computeSigmaDevDev(int pnr1, int pnr2, double[][] erg)
      {

          if ((work1==null) || (work1.length!=2) || (work1[0].length!=2)) work1 = new double[2][2];
          if ((work2==null) || (work2.length!=2) || (work2[0].length!=2)) work2 = new double[2][2];
          if ((work3==null) || (work3.length!=2) || (work3[0].length!=2)) work3 = new double[2][2];
          if ((work4==null) || (work4.length!=2) || (work4[0].length!=2)) work4 = new double[2][2];
          // work5 is used in function calls.
          if ((work6==null) || (work6.length!=anzVar) || (work6[0].length!=anzVar)) work6 = new double[anzVar][anzVar];
          if ((work7==null) || (work7.length!=anzVar) || (work7[0].length!=anzVar)) work7 = new double[anzVar][anzVar];
          if ((work42==null) || (work42.length!=4) || (work42[0].length!=2)) work42 = new double[4][2];
          if ((work44==null) || (work44.length!=4) || (work44[0].length!=4)) work44 = new double[4][4];
          if ((work422==null) || (work422.length!=4) || (work422[0].length!=2)) work422 = new double[4][2];

          for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = 0;
          if ((parType[pnr1]!=parameterType.auto) && (parType[pnr2]==parameterType.auto)) {int t=pnr1; pnr1 = pnr2; pnr2 = t;}
          if ((parType[pnr1]!=parameterType.auto) || (parType[pnr2]==parameterType.meanInitTrait)) return;
          int dnr1 = parPos[pnr1][0]*2 + parPos[pnr1][1];
          if (parType[pnr2]==parameterType.err) 
          {
              int k = parPos[pnr2][0];
              for (int t=0; t<anzOcc; t++)
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] = transD[dnr1][i][k]*trans[j][k]+transD[dnr1][j][k]*trans[i][k];
              return;
          }
          
          computeSigmaDevLatent(pnr2, work7);
          for (int t=0; t<times.length; t++)
          {
              if (parType[pnr2]==parameterType.auto)
              {
                  int dnr2 = parPos[pnr2][0]*2 + parPos[pnr2][1]; 
                  computeSigmaDevLatent(pnr1, work6);
                  Statik.transpose(trans,work1); Statik.multiply(covProcVal,work1,work3); Statik.multiply(transDD[dnr1][dnr2],work3,work2);
                  Statik.transpose(transD[dnr2],work1); Statik.multiply(covProcVal,work1,work3); Statik.multiply(transD[dnr1], work3, work4);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] = (work2[i][j]+work2[j][i]+work4[i][j]+work4[j][i])*P[t][i][j];
                  Statik.transpose(trans,work2); Statik.multiply(covProcVal,work2,work3);
                  Statik.multiply(transD[dnr1], work3, work2);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] += (work2[i][j]+work2[j][i])*PD[t][dnr2][i][j];
                  Statik.multiply(transD[dnr2], work3, work2);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] += (work2[i][j]+work2[j][i])*PD[t][dnr1][i][j];
                  Statik.multiply(trans,work3, work2);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] += work2[i][j]*PDD[t][dnr1][dnr2][i][j];
                  Statik.transpose(M[t],work42); Statik.multiply(covInitTraitVal, work42, work422); Statik.multiply(MDD[t][dnr1][dnr2],work422,work2);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] += work2[i][j]+work2[j][i];
                  Statik.transpose(MD[t][dnr2],work42); Statik.multiply(covInitTraitVal, work42, work422); Statik.multiply(MD[t][dnr1],work422,work2);
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] += work2[i][j]+work2[j][i];
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] = work1[i][j];

                  if (t>0)
                  {
                      double delta = times[t]-times[t-1], diffexp1 = Math.exp(delta*ev1), diffexp2 = Math.exp(delta*ev2), 
                      dD11 = delta*ev1D[dnr1]*diffexp1, dD21 = delta*ev2D[dnr1]*diffexp2,
                      dD12 = delta*ev1D[dnr2]*diffexp1, dD22 = delta*ev2D[dnr2]*diffexp2,
                      dDD1 = delta*diffexp1*(evDD[dnr1][dnr2] + ev1D[dnr1]*ev1D[dnr2]*delta),
                      dDD2 = delta*diffexp2*(-evDD[dnr1][dnr2] + ev2D[dnr1]*ev2D[dnr2]*delta);
                      for (int t2=0; t2<t; t2++)
                      {
                          erg[2*t2][2*t]     = diffexp1*erg[2*t2][  2*t-2] + dD11*work7[2*t2][  2*t-2] + dD12*work6[2*t2][  2*t-2] + dDD1*sigmaLat[2*t2][  2*t-2];
                          erg[2*t2][2*t+1]   = diffexp2*erg[2*t2][  2*t-1] + dD21*work7[2*t2][  2*t-1] + dD22*work6[2*t2][  2*t-1] + dDD2*sigmaLat[2*t2][  2*t-1];
                          erg[2*t2+1][2*t]   = diffexp1*erg[2*t2+1][2*t-2] + dD11*work7[2*t2+1][2*t-2] + dD12*work6[2*t2+1][2*t-2] + dDD1*sigmaLat[2*t2+1][2*t-2];
                          erg[2*t2+1][2*t+1] = diffexp2*erg[2*t2+1][2*t-1] + dD21*work7[2*t2+1][2*t-1] + dD22*work6[2*t2+1][2*t-1] + dDD2*sigmaLat[2*t2+1][2*t-1];
                          for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t2+j] = erg[2*t2+j][2*t+i];
                      }
                  }
              } else {
                  if (parType[pnr2]==parameterType.covProc) {
                      for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] = 0;
                      work1[parPos[pnr2][0]][parPos[pnr2][1]] = 1; work1[parPos[pnr2][1]][parPos[pnr2][0]] = 1;
                      Statik.transpose(trans,work2); Statik.multiply(work1,work2,work3); Statik.multiply(transD[dnr1],work3,work1);
                      for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] = (work1[i][j]+work1[j][i])*P[t][i][j];
                      Statik.multiply(trans,work3,work1);
                      for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] += work1[i][j]*PD[t][dnr1][i][j];
                      
                  } else if (parType[pnr2]==parameterType.covInitTrait) {
                      for (int i=0; i<4; i++) for (int j=0; j<4; j++) work44[i][j] = 0;
                      work44[parPos[pnr2][0]][parPos[pnr2][1]] = 1; work44[parPos[pnr2][1]][parPos[pnr2][0]] = 1;
                      Statik.transpose(M[t],work42); Statik.multiply(work44,work42,work422); Statik.multiply(MD[t][dnr1],work422,work1);
                      for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] = (work1[i][j]+work1[j][i]);
                  }
                  if (t > 0)
                  {
                      double delta = times[t]-times[t-1], diffexp1 = Math.exp(delta*ev1), diffexp2 = Math.exp(delta*ev2), 
                      dD1 = delta*ev1D[dnr1]*diffexp1, dD2 = delta*ev2D[dnr1]*diffexp2; 
                      for (int t2=0; t2<t; t2++)
                      {
                          erg[2*t2][2*t] = diffexp1*erg[2*t2][2*t-2] + dD1*work7[2*t2][2*t-2]; 
                          erg[2*t2][2*t+1] = diffexp2*erg[2*t2][2*t-1] + dD2*work7[2*t2][2*t-1];
                          erg[2*t2+1][2*t] = diffexp1*erg[2*t2+1][2*t-2] + dD1*work7[2*t2+1][2*t-2]; 
                          erg[2*t2+1][2*t+1] = diffexp2*erg[2*t2+1][2*t-1] + dD2*work7[2*t2+1][2*t-1];
                          for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t2+j] = erg[2*t2+j][2*t+i];
                      }
                  }
              }
          }
          if (parType[pnr2]==parameterType.auto) 
          {
              int dnr2 = parPos[pnr2][0]*2 + parPos[pnr2][1]; 
              Statik.transpose(transDD[dnr1][dnr2], work1); for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] *= errVal[i]; Statik.multiply(trans, work1, work2);
              Statik.transpose(transD[dnr1], work1); for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] *= errVal[i]; Statik.multiply(transD[dnr2], work1, work3);
              for (int t=0; t<anzOcc; t++)
                  for (int i=0; i<2; i++) for (int j=0; j<2; j++) erg[2*t+i][2*t+j] += (work2[i][j]+work2[j][i])+(work3[i][j]+work3[j][i]);
          }
      }
      
      private void computeCorrectedMoments() 
      {
          if ((corrMoments==null) || (corrMoments.length!=anzVar) || (corrMoments[0].length!=anzVar)) corrMoments = new double[anzVar][anzVar];
          computeCorrectedMoments(corrMoments);
      }
      private void computeCorrectedMoments(double[][] erg)
      {
          if ((muWork==null) || (muWork.length!=2)) muWork = new double[2];
          if ((muWork2==null) || (muWork2.length!=2)) muWork2 = new double[2];
          if ((muWork3==null) || (muWork3.length!=2)) muWork3 = new double[2];
          if ((muWork5==null) || (muWork5.length!=anzVar)) muWork5 = new double[anzVar];

          for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = 0;
          for (int i=0; i<anzPer; i++)
          {
              for (int t=0; t<times.length; t++)
              {
                  muWork3[0] = data[i][2*t]; muWork3[1] = data[i][2*t+1];
                  Statik.multiply(trans, muWork3, muWork);
                  Statik.multiply(M[t], meanInitTraitVal, muWork2);
                  for (int j=0; j<2; j++) muWork5[2*t+j] = muWork[j] - muWork2[j]; 
              }
              for (int j=0; j<anzVar; j++)
                  for (int k=0; k<anzVar; k++) erg[j][k] += muWork5[j]*muWork5[k];
          }   
      }
             
      private void computeCorrectedMomentsDev(int pnr, double[][] erg)
      {
          for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = 0;
          if ((parType[pnr]!=parameterType.auto) && (parType[pnr]!=parameterType.meanInitTrait)) return;
          if ((muWork==null) || (muWork.length!=2)) muWork = new double[2];
          if ((muWork2==null) || (muWork2.length!=2)) muWork2 = new double[2];
          if ((muWork3==null) || (muWork3.length!=2)) muWork3 = new double[2];
          if ((muWork4==null) || (muWork4.length!=2)) muWork4 = new double[2];
          if ((muWork5==null) || (muWork5.length!=anzVar)) muWork5 = new double[anzVar];
          if ((muWork6==null) || (muWork6.length!=anzVar)) muWork6 = new double[anzVar];
          
          for (int i=0; i<anzPer; i++)
          {
              for (int t=0; t<anzOcc; t++)
              {
                  muWork4[0] = data[i][2*t]; muWork4[1] = data[i][2*t+1];
                  if (parType[pnr]==parameterType.auto) 
                  {
                      int dnr = parPos[pnr][0]*2 + parPos[pnr][1];
                      Statik.multiply(transD[dnr],muWork4,muWork3);
                      Statik.multiply(MD[t][dnr],meanInitTraitVal,muWork);
                      for (int j=0; j<2; j++) muWork5[2*t+j] = muWork3[j] - muWork[j];
                  } else {
                      for (int j=0; j<2; j++) muWork5[2*t+j] = -M[t][j][parPos[pnr][0]];
                  }
                  Statik.multiply(trans, muWork4, muWork);
                  Statik.multiply(M[t], meanInitTraitVal, muWork2);
                  for (int j=0; j<2; j++) muWork6[2*t+j] = muWork[j] - muWork2[j];
              }
              for (int j=0; j<anzVar; j++)
                  for (int k=0; k<anzVar; k++) erg[j][k] += muWork5[j]*muWork6[k] + muWork6[j]*muWork5[k];
          }   
      }
      
      private void computeCorrectedMomentsDevDev(int pnr1, int pnr2, double[][] erg)
      {
          for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) erg[i][j] = 0;
          if ((parType[pnr1]!=parameterType.auto) && (parType[pnr2]==parameterType.auto)) {int t = pnr1; pnr1 = pnr2; pnr2 = t;} 
          if (((parType[pnr1]!=parameterType.auto) && (parType[pnr1]!=parameterType.meanInitTrait)) || 
              ((parType[pnr2]!=parameterType.auto) && (parType[pnr2]!=parameterType.meanInitTrait))) return;
          
          if ((muWork==null) || (muWork.length!=2)) muWork = new double[2];
          if ((muWork2==null) || (muWork2.length!=2)) muWork2 = new double[2];
          if ((muWork3==null) || (muWork3.length!=2)) muWork3 = new double[2];
          if ((muWork4==null) || (muWork4.length!=2)) muWork4 = new double[2];
          if ((muWork5==null) || (muWork5.length!=anzVar)) muWork5 = new double[anzVar];
          if ((muWork6==null) || (muWork6.length!=anzVar)) muWork6 = new double[anzVar];
          if ((muWork7==null) || (muWork7.length!=anzVar)) muWork7 = new double[anzVar];
          if ((muWork8==null) || (muWork8.length!=anzVar)) muWork8 = new double[anzVar];

          int dnr1 = 0; if (parType[pnr1]==parameterType.auto) dnr1 = parPos[pnr1][0]*2 + parPos[pnr1][1];
          for (int i=0; i<anzPer; i++)
          {
              for (int t=0; t<anzOcc; t++)
              {
                  if ((parType[pnr1]==parameterType.meanInitTrait) && (parType[pnr2]==parameterType.meanInitTrait)) 
                  {
                      for (int j=0; j<2; j++) muWork5[2*t+j] = -M[t][j][parPos[pnr1][0]];
                      for (int j=0; j<2; j++) muWork6[2*t+j] = -M[t][j][parPos[pnr2][0]];
                  } else {
                      muWork4[0] = data[i][2*t]; muWork4[1] = data[i][2*t+1];
                      Statik.multiply(transD[dnr1],muWork4,muWork3);
                      Statik.multiply(MD[t][dnr1],meanInitTraitVal,muWork);
                      for (int j=0; j<2; j++) muWork5[2*t+j] = muWork3[j] - muWork[j];
                      Statik.multiply(trans,muWork4,muWork2);
                      Statik.multiply(M[t],meanInitTraitVal,muWork);
                      for (int j=0; j<2; j++) muWork7[2*t+j] = muWork2[j] - muWork[j];
                      if (parType[pnr2]==parameterType.meanInitTrait) 
                      {
                          for (int j=0; j<2; j++) muWork6[2*t+j] = -M[t][j][parPos[pnr2][0]];
                          for (int j=0; j<2; j++) muWork8[2*t+j] = -MD[t][dnr1][j][parPos[pnr2][0]];                          
                      } else {
                          int dnr2 = parPos[pnr2][0]*2 + parPos[pnr2][1];
                          Statik.multiply(transD[dnr2],muWork4,muWork2);
                          Statik.multiply(MD[t][dnr2],meanInitTraitVal,muWork);
                          for (int j=0; j<2; j++) muWork6[2*t+j] = muWork2[j] - muWork[j];
                          Statik.multiply(transDD[dnr1][dnr2],muWork4,muWork2);
                          Statik.multiply(MDD[t][dnr1][dnr2],meanInitTraitVal,muWork);
                          for (int j=0; j<2; j++) muWork8[2*t+j] = muWork2[j] - muWork[j];
                      }
                  }
              }
              for (int j=0; j<anzVar; j++) for (int k=0; k<anzVar; k++) erg[j][k] += muWork5[j]*muWork6[k] + muWork6[j]*muWork5[k];
              if (parType[pnr1]!=parameterType.meanInitTrait) 
                  for (int j=0; j<anzVar; j++) for (int k=0; k<anzVar; k++) erg[j][k] += muWork7[j]*muWork8[k] + muWork8[j]*muWork7[k];
          }   
      }      
      
      public void collectParameterTypesAndPos()
      {
          int maxPar = maxParNumber();
          parType = new parameterType[maxPar+1];
          parPos = new int[maxPar+1][];
      
          for (int i=0; i<meanInitTraitPar.length; i++) if (meanInitTraitPar[i]!=NOPARAMETER) {parType[meanInitTraitPar[i]] = parameterType.meanInitTrait; parPos[meanInitTraitPar[i]] = new int[]{i};}
          for (int i=0; i<errPar.length; i++) if (errPar[i]!=NOPARAMETER) {parType[errPar[i]] = parameterType.err; parPos[errPar[i]] = new int[]{i};}
          for (int i=0; i<autoPar.length; i++) for (int j=0; j<autoPar[i].length; j++) 
              if (autoPar[i][j]!=NOPARAMETER) {parType[autoPar[i][j]] = parameterType.auto; parPos[autoPar[i][j]] = new int[]{i,j};}
          for (int i=0; i<covProcPar.length; i++) for (int j=i; j<covProcPar[i].length; j++) 
              if (covProcPar[i][j]!=NOPARAMETER) {parType[covProcPar[i][j]] = parameterType.covProc; parPos[covProcPar[i][j]] = new int[]{i,j};}
          for (int i=0; i<covInitTraitPar.length; i++) for (int j=0; j<covInitTraitPar[i].length; j++) 
              if (covInitTraitPar[i][j]!=NOPARAMETER) {parType[covInitTraitPar[i][j]] = parameterType.covInitTrait; parPos[covInitTraitPar[i][j]] = new int[]{i,j};}
      }
      
      public int maxParNumber()
      {
          int erg = NOPARAMETER;
          for (int i=0; i<meanInitTraitPar.length; i++) erg = Math.max(meanInitTraitPar[i], erg);
          for (int i=0; i<errPar.length; i++) erg = Math.max(errPar[i], erg);
          for (int i=0; i<autoPar.length; i++) for (int j=0; j<autoPar[i].length; j++) 
              erg = Math.max(autoPar[i][j], erg);
          for (int i=0; i<covProcPar.length; i++) for (int j=0; j<covProcPar[i].length; j++) 
              erg = Math.max(covProcPar[i][j], erg);
          for (int i=0; i<covInitTraitPar.length; i++) for (int j=0; j<covInitTraitPar[i].length; j++) 
              erg = Math.max(covInitTraitPar[i][j], erg);
          return erg;
      }
      
      public int[] getActiveParameters()
      {
          int toPar = maxParNumber()+1;
          int[] ergO = new int[toPar];

          for (int i=0; i<meanInitTraitPar.length; i++) if (meanInitTraitPar[i]!=NOPARAMETER) ergO[meanInitTraitPar[i]]=1;
          for (int i=0; i<errPar.length; i++) if (errPar[i]!=NOPARAMETER) ergO[errPar[i]]=1;
          for (int i=0; i<autoPar.length; i++) for (int j=0; j<autoPar[i].length; j++) 
              if (autoPar[i][j]!=NOPARAMETER) ergO[autoPar[i][j]]=1;
          for (int i=0; i<covProcPar.length; i++) for (int j=0; j<covProcPar[i].length; j++) 
              if (covProcPar[i][j]!=NOPARAMETER) ergO[covProcPar[i][j]]=1;
          for (int i=0; i<covInitTraitPar.length; i++) for (int j=0; j<covInitTraitPar[i].length; j++) 
              if (covInitTraitPar[i][j]!=NOPARAMETER) ergO[covInitTraitPar[i][j]]=1;

          int anz = 0; for (int i=0; i<toPar; i++) if (ergO[i]!=0) anz++;
          int[] erg = new int[anz]; int j=0; 
          for (int i=0; i<toPar; i++) if (ergO[i]!=0) erg[j++] = i;
          Arrays.sort(erg);
          return erg;
      }
      
      public void renumberParameter(int oldNumber, int newNumber)
      {
          for (int i=0; i<meanInitTraitPar.length; i++) if (meanInitTraitPar[i]==oldNumber) meanInitTraitPar[i]=newNumber;
          for (int i=0; i<errPar.length; i++) if (errPar[i]==oldNumber) errPar[i]=newNumber;
          for (int i=0; i<autoPar.length; i++) for (int j=0; j<autoPar[i].length; j++) 
              if (autoPar[i][j]==oldNumber) autoPar[i][j]=newNumber;
          for (int i=0; i<covProcPar.length; i++) for (int j=0; j<covProcPar[i].length; j++) 
              if (covProcPar[i][j]==oldNumber) covProcPar[i][j]=newNumber;
          for (int i=0; i<covInitTraitPar.length; i++) for (int j=0; j<covInitTraitPar[i].length; j++) 
              if (covInitTraitPar[i][j]==oldNumber) covInitTraitPar[i][j]=newNumber;

          collectParameterTypesAndPos();
      }
    
    public int getAnzPar() {
        return anzPar;
    }
    public int getAnzVar() {
        return anzVar;
    }

    public void applyParameterValues(double[] vals)
    {
        for (int i=0; i<meanInitTraitPar.length; i++) if (meanInitTraitPar[i]!=NOPARAMETER) meanInitTraitVal[i] = vals[meanInitTraitPar[i]];
        for (int i=0; i<errPar.length; i++) if (errPar[i]!=NOPARAMETER) errVal[i] = vals[errPar[i]];
        for (int i=0; i<autoPar.length; i++) for (int j=0; j<autoPar[i].length; j++) 
            if (autoPar[i][j]!=NOPARAMETER) autoVal[i][j] = vals[autoPar[i][j]];
        for (int i=0; i<covProcPar.length; i++) for (int j=0; j<covProcPar[i].length; j++) 
            if (covProcPar[i][j]!=NOPARAMETER) covProcVal[i][j] = vals[covProcPar[i][j]];
        for (int i=0; i<covInitTraitPar.length; i++) for (int j=0; j<covInitTraitPar[i].length; j++) 
            if (covInitTraitPar[i][j]!=NOPARAMETER) covInitTraitVal[i][j] = vals[covInitTraitPar[i][j]];
    }

    public void setData(double[][] data)
    {
        this.data = data;
        this.anzPer = data.length;
        computeMoments();
    }
    
    public void computeMoments()
    {
        if (data==null) return;
        xsum = new double[anzVar];
        dataMean = new double[anzVar];
		for (int i=0; i<anzVar; i++) xsum[i] = 0.0;
		for (int i=0; i<anzPer; i++)
			for (int j=0; j<anzVar; j++) xsum[j] += data[i][j];
		for (int i=0; i<anzVar; i++) dataMean[i] = xsum[i] / (double)anzPer;
			
		xBiSum = new double[anzVar][anzVar];
		dataCov = new double[anzVar][anzVar];
		for (int i=0; i<anzVar; i++)
			for (int j=0; j<=i; j++)
			{
				xBiSum[i][j] = 0.0;
				for (int k=0; k<anzPer; k++) xBiSum[i][j] += data[k][i] * data[k][j];
				for (int k=0; k<anzPer; k++) dataCov[i][j] += (data[k][i]-dataMean[i]) * (data[k][j]-dataMean[j]);
				xBiSum[j][i] = xBiSum[i][j];
				dataCov[i][j] /= (double)anzPer;
				dataCov[j][i] = dataCov[i][j];
			}
    }

    public void setParameter(double[] values) {for (int i=0; i<values.length; i++) setParameter(i,values[i]);}
    public void setParameter(int nr, double value)
    {
        if (parType[nr]==parameterType.meanInitTrait) meanInitTraitVal[parPos[nr][0]] = value;
        if (parType[nr]==parameterType.err) errVal[parPos[nr][0]] = value;
        if (parType[nr]==parameterType.auto) autoVal[parPos[nr][0]][parPos[nr][1]] = value;
        if (parType[nr]==parameterType.covProc) covProcVal[parPos[nr][0]][parPos[nr][1]] = covProcVal[parPos[nr][1]][parPos[nr][0]] = value;
        if (parType[nr]==parameterType.covInitTrait) covInitTraitVal[parPos[nr][0]][parPos[nr][1]] = covInitTraitVal[parPos[nr][1]][parPos[nr][0]] = value;
    }
    
    public double getParameter(int nr)
    {
        if (parType[nr]==parameterType.meanInitTrait) return meanInitTraitVal[parPos[nr][0]];
        if (parType[nr]==parameterType.err) return errVal[parPos[nr][0]];
        if (parType[nr]==parameterType.auto) return autoVal[parPos[nr][0]][parPos[nr][1]];
        if (parType[nr]==parameterType.covProc) return covProcVal[parPos[nr][0]][parPos[nr][1]];
        if (parType[nr]==parameterType.covInitTrait) return covInitTraitVal[parPos[nr][0]][parPos[nr][1]];
        return -999;
    }
    
    public void fixParameter(int[] nrs) {Arrays.sort(nrs); for (int i=nrs.length-1; i>=0; i--) fixParameter(nrs[i]);}
    public void fixParameter(int nr) {fixParameter(nr, getParameter(nr));}
    public static WienerProcessModel fixParameter(WienerProcessModel in, int nr, double value) {WienerProcessModel erg = new WienerProcessModel(in); erg.fixParameter(nr,value); return erg;}
    public void fixParameter(int nr, double value)
    {
        setParameter(nr, value);
        for (int i=0; i<meanInitTraitPar.length; i++) if (meanInitTraitPar[i]>nr) meanInitTraitPar[i]--;
        for (int i=0; i<errPar.length; i++) if (errPar[i]>nr) errPar[i]--;
        for (int i=0; i<autoPar.length; i++) for (int j=0; j<autoPar[i].length; j++) 
            if (autoPar[i][j]>nr) autoPar[i][j]--;
        for (int i=0; i<covProcPar.length; i++) for (int j=0; j<covProcPar[i].length; j++) 
            if (covProcPar[i][j]>nr) covProcPar[i][j]--;
        for (int i=0; i<covInitTraitPar.length; i++) for (int j=0; j<covInitTraitPar[i].length; j++) 
            if (covInitTraitPar[i][j]>nr) covInitTraitPar[i][j]--;

        if (parType[nr]==parameterType.meanInitTrait) meanInitTraitPar[parPos[nr][0]] = NOPARAMETER;
        if (parType[nr]==parameterType.err) errPar[parPos[nr][0]] = NOPARAMETER;
        if (parType[nr]==parameterType.auto) autoPar[parPos[nr][0]][parPos[nr][1]] = NOPARAMETER;
        if (parType[nr]==parameterType.covProc) covProcPar[parPos[nr][0]][parPos[nr][1]] = covProcPar[parPos[nr][1]][parPos[nr][0]] = NOPARAMETER;
        if (parType[nr]==parameterType.covInitTrait) covInitTraitPar[parPos[nr][0]][parPos[nr][1]] = covInitTraitPar[parPos[nr][1]][parPos[nr][0]] = NOPARAMETER;
        anzPar--;
        collectParameterTypesAndPos();
    }

    /**
     * UNFINISHED
     * 
     * @param anzPersons
     * @param values
     * @return
     */
    public double[][] createDataForward(int anzPersons, double[] values) {applyParameterValues(values); return createDataForward(anzPersons);}
    public double[][] createDataForward(int anzPersons)
    {
        return null;
    }
    
    
    public double[][] createData(int anzPersons, double[] values) {applyParameterValues(values); return createData(anzPersons);}
    public double[][] createData(int anzPersons)
    {
        if ((work5==null) || (work5.length!=anzVar) || (work5[0].length!=anzVar)) work5 = new double[anzVar][anzVar];
        if ((muWork5==null) || (muWork5.length!=anzVar)) muWork5 = new double[anzVar];

        this.anzPer = anzPersons;
   
        evaluateMuAndSigma();
        double[][] cholesky = Statik.choleskyDecompose(sigma);
        data = new double[anzPersons][anzVar];
        
        for (int i=0; i<anzPersons; i++)
        {
            for (int j=0; j<anzVar; j++) muWork5[j] = rand.nextGaussian();
            Statik.multiply(cholesky,muWork5,data[i]);
            for (int j=0; j<anzVar; j++) data[i][j] += mu[j];
            for (int j=0; j<anzOcc; j++) 
            {
                double d1 = data[i][2*j], d2 = data[i][2*j+1]; 
                data[i][2*j] = transInv[0][0]*d1 + transInv[0][1]*d2; data[i][2*j+1] = transInv[1][0]*d1 + transInv[1][1]*d2;
            }
        }
        computeMoments();
        return data;
    }
    
    public boolean covariancematricesPositiveDefinite(double[] values)
    {
        applyParameterValues(values);
        return (Statik.determinantOfPositiveDefiniteMatrix(covProcVal) != -1) && (Statik.determinantOfPositiveDefiniteMatrix(covInitTraitVal) != -1);
    }
    
    public double euclididanDistance(double[] values)
    {
        evaluateMuAndSigma(values);
        double erg = 0;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++) erg += (sigma[i][j] - dataCov[i][j])*(sigma[i][j] - dataCov[i][j]);
        for (int i=0; i<anzVar; i++) erg += (mu[i] - dataMean[i])*(mu[i] - dataMean[i]);
        return erg;
    }
        
    public double getMinusTwoLogLikelihood() {return getMinusTwoLogLikelihood(null, true);}
    public double getMinusTwoLogLikelihood(double[] value) {return getMinusTwoLogLikelihood(value, true);}
    public double getMinusTwoLogLikelihood(double[] value, boolean recomputeSigmaAndCorrectedMoments) 
    {
        if ((sigmaWork1==null) || (sigmaWork1.length!=anzVar) || (sigmaWork1[0].length!=anzVar)) sigmaWork1 = new double[anzVar][anzVar];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];

        if (value != null) applyParameterValues(value);
        if (recomputeSigmaAndCorrectedMoments) {evaluateMuAndSigma(value); computeCorrectedMoments();}
        if (Double.isNaN(ev1)) {ll = Double.NaN; return ll;} 
        
        double det = Statik.invert(sigma,sigInv, sigmaWork1);
        double signumTransDet = Math.signum(detTrans);
        if (Statik.determinantOfPositiveDefiniteMatrix(sigma) < 0) {ll = Double.NaN; return ll;} 
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(det); 
        ll -= anzPer*anzOcc*Math.log(detTrans*signumTransDet);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += corrMoments[i][j] * sigInv[i][j];
        
        return ll;
    }


    /**
     * Computes the minus two log likelihood and for each parameter its derivative and second derivative. Parameters are expected to be numbered
     * from 0 to anzPar-1. If values is not zero, these parameter values are applied; otherwise, the method assumes all values are correct.
     */
    public void computeLogLikelihoodDerivatives() {computeLogLikelihoodDerivatives(null,true);}
    public void computeLogLikelihoodDerivatives(double[] value) {computeLogLikelihoodDerivatives(value,true);}
    public void computeLogLikelihoodDerivatives(double[] value, boolean recomputeSigmaAndCorrectedMoments)
    {
        if ((sigmaWork1==null) || (sigmaWork1.length!=anzVar) || (sigmaWork1[0].length!=anzVar)) sigmaWork1 = new double[anzVar][anzVar];
        if ((sigmaWork2==null) || (sigmaWork2.length!=anzVar) || (sigmaWork2[0].length!=anzVar)) sigmaWork2 = new double[anzVar][anzVar];
        if ((sigmaWork3==null) || (sigmaWork3.length!=anzVar) || (sigmaWork3[0].length!=anzVar)) sigmaWork3 = new double[anzVar][anzVar];
        if ((worksd1==null) || (worksd1.length!=anzVar) || (worksd1[0].length!=anzVar)) worksd1 = new double[anzVar][anzVar];
        if ((worksd2==null) || (worksd2.length!=anzVar) || (worksd2[0].length!=anzVar)) worksd2 = new double[anzVar][anzVar];
        if ((worksdd==null) || (worksdd.length!=anzVar) || (worksdd[0].length!=anzVar)) worksdd = new double[anzVar][anzVar];
        if ((work1==null) || (work1.length!=2) || (work1[0].length!=2)) work1 = new double[2][2];
        if ((work2==null) || (work2.length!=2) || (work2[0].length!=2)) work2 = new double[2][2];
        if ((sigInv==null) || (sigInv.length!=anzVar) || (sigInv[0].length!=anzVar)) sigInv = new double[anzVar][anzVar];
        if ((llD==null) || (llD.length!=anzPar)) llD = new double[anzPar];
        if ((llDD==null) || (llDD.length!=anzPar) || (llDD[0].length!=anzPar)) llDD = new double[anzPar][anzPar];

        if (value != null) applyParameterValues(value);
        if (recomputeSigmaAndCorrectedMoments) {evaluateMuAndSigma(value); computeCorrectedMoments();}

        double det = Statik.invert(sigma,sigInv, sigmaWork1);
        double signumTransDet = Math.signum(detTrans);
        if ((Statik.determinantOfPositiveDefiniteMatrix(sigma) < 0) || (Double.isNaN(ev1))) {ll = Double.NaN; return;} 
        
        ll = anzPer*anzVar*LNTWOPI + anzPer*Math.log(det); 
        ll -= anzPer*anzOcc*Math.log(detTrans*signumTransDet);
        for (int i=0; i<anzVar; i++) 
            for (int j=0; j<anzVar; j++)
                ll += corrMoments[i][j] * sigInv[i][j];

        for (int d1=0; d1<anzPar; d1++)
        {
            llD[d1] = 0;
            if ((parType[d1]==parameterType.auto) || (parType[d1]==parameterType.covInitTrait) || 
                (parType[d1]==parameterType.covProc)  || (parType[d1]==parameterType.err))
            {
                computeSigmaDev(d1, sigmaWork1);
                Statik.multiply(sigInv, sigmaWork1, sigmaWork2);
                for (int i=0; i<anzVar; i++) llD[d1] += anzPer*sigmaWork2[i][i];
//                if (parType[d1]==parameterType.auto)
//                {
//                    int dnr = parPos[d1][0]*2+parPos[d1][1];
//                    Statik.multiply(transInv, transD[dnr], work1);
//                    for (int i=0; i<2; i++) llD[d1] -= anzPer*anzOcc*work1[i][i];
//                }
                Statik.multiply(sigmaWork2, sigInv, sigmaWork1);
                for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) llD[d1] -= sigmaWork1[i][j]*corrMoments[i][j];
            }
            if ((parType[d1]==parameterType.auto) || (parType[d1]==parameterType.meanInitTrait))
            {
                computeCorrectedMomentsDev(d1, sigmaWork1);
                for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) llD[d1] += sigInv[i][j]*sigmaWork1[i][j];
            }
        }
        for (int d1=0; d1<anzPar; d1++)
            for (int d2=0; d2<anzPar; d2++)
            {
                llDD[d1][d2] = 0;
                if ((parType[d1]==parameterType.auto) || (parType[d1]==parameterType.covInitTrait) || 
                        (parType[d1]==parameterType.covProc)  || (parType[d1]==parameterType.err))
                {
                    computeSigmaDev(d1, sigmaWork1);
                    Statik.multiply(sigInv, sigmaWork1, worksd1);
                }
                if ((parType[d2]==parameterType.auto) || (parType[d2]==parameterType.covInitTrait) || 
                        (parType[d2]==parameterType.covProc)  || (parType[d2]==parameterType.err))
                {
                    computeSigmaDev(d2, sigmaWork1);
                    Statik.multiply(sigInv, sigmaWork1, worksd2);
                }
                if (((parType[d2]==parameterType.auto) || (parType[d2]==parameterType.covInitTrait) || 
                        (parType[d2]==parameterType.covProc) || (parType[d2]==parameterType.err)) &&
                    ((parType[d1]==parameterType.auto) || (parType[d1]==parameterType.covInitTrait) || 
                                (parType[d1]==parameterType.covProc) || (parType[d1]==parameterType.err)))
                {
                    computeSigmaDevDev(d1,d2, sigmaWork1);
                    Statik.multiply(sigInv, sigmaWork1, worksdd);
                    Statik.multiply(worksd1, worksd2, sigmaWork1);
                    for (int i=0; i<anzVar; i++) llDD[d1][d2] += anzPer*(-sigmaWork1[i][i]+worksdd[i][i]);
//                    if ((parType[d1]==parameterType.auto) && (parType[d2]==parameterType.auto))
//                    {
//                        int dnr1 = parPos[d1][0]*2+parPos[d1][1], dnr2 = parPos[d2][0]*2+parPos[d2][1];
//                        Statik.multiply(transInv, transD[dnr1], work1);
//                        Statik.multiply(work1, transInv, work2);
//                        Statik.multiply(work2, transD[dnr2], work1);
//                        Statik.multiply(transInv, transDD[dnr1][dnr2], work2);
//                        for (int i=0; i<2; i++) llDD[d1][d2] += anzPer*anzOcc*(work1[i][i]-work2[i][i]);
//                    }
                    Statik.multiply(sigmaWork1,sigInv,sigmaWork2);
                    Statik.multiply(worksdd,sigInv,sigmaWork1);
                    for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) llDD[d1][d2] += (sigmaWork2[i][j]+sigmaWork2[j][i] - sigmaWork1[i][j]) * corrMoments[i][j];
                }
                if (((parType[d1]==parameterType.auto) || (parType[d1]==parameterType.covInitTrait) || 
                        (parType[d1]==parameterType.covProc)  || (parType[d1]==parameterType.err)) &&
                    ((parType[d2]==parameterType.auto) || (parType[d2]==parameterType.meanInitTrait)))
                {
                    Statik.multiply(worksd1, sigInv, sigmaWork1);
                    computeCorrectedMomentsDev(d2, sigmaWork2);
                    for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) llDD[d1][d2] -= sigmaWork1[i][j] * sigmaWork2[i][j];
                }
                if (((parType[d2]==parameterType.auto) || (parType[d2]==parameterType.covInitTrait) || 
                        (parType[d2]==parameterType.covProc)  || (parType[d2]==parameterType.err)) &&
                    ((parType[d1]==parameterType.auto) || (parType[d1]==parameterType.meanInitTrait)))
                {
                    Statik.multiply(worksd2, sigInv, sigmaWork1);
                    computeCorrectedMomentsDev(d1, sigmaWork2);
                    for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) llDD[d1][d2] -= sigmaWork1[i][j] * sigmaWork2[i][j];
                }
                if (((parType[d1]==parameterType.auto) || (parType[d1]==parameterType.meanInitTrait)) &&
                    ((parType[d2]==parameterType.auto) || (parType[d2]==parameterType.meanInitTrait)))
                {
                    computeCorrectedMomentsDevDev(d1,d2, sigmaWork1);
                    for (int i=0; i<anzVar; i++) for (int j=0; j<anzVar; j++) llDD[d1][d2] += sigInv[i][j] * sigmaWork1[i][j];
                }
            }
        
    }
    

    /**
     * Computes the optimal damping in the direction of move from pos. Result is returned in pos, move is the new movement 
     * 
     * @param pos   Initially position, return value
     * @param move  Initially direction, return value
     * @return      true if successfull, false if stuck or negative result
     */
    private boolean moveWithOptimalDampingOld(double[] pos, double[] move, double EPS)
    {
        if ((posWork==null) || (posWork.length!=pos.length)) posWork = new double[pos.length];
        for (int i=0; i<move.length; i++) posWork[i] = pos[i];
        
        double[] t, storePosPointer = pos;
        double start = getMinusTwoLogLikelihood(pos);
        double min = start; // Value at pos;
        double alt;      // Value at move;
        double pre;      // Value at last position of move.
        
//        System.out.println("POS  = "+Statik.matrixToString(pos)+"\t\t"+start);
//        System.out.println("MOVE = "+Statik.matrixToString(move));
        
        double derivative = Statik.multiply(llD, move);
        Statik.multiply((int)Math.signum(-derivative), move, move);
        Statik.add(pos,move,move);
        alt = getMinusTwoLogLikelihood(move);
        pre = min;

        int inRuns = 0;
        while ((!Double.isNaN(alt)) && (!Double.isInfinite(alt)) && (alt < pre))
        {
            pre = alt;
            for (int i=0; i<move.length; i++) move[i] = 2*move[i] - pos[i];
            alt = getMinusTwoLogLikelihood(move);
            inRuns++;
            if (inRuns == 30) System.out.println("Got stuck in interval search, min = "+min+", alternative = "+alt+", start = "+start);
            if (inRuns > 100) {System.out.println("Giving up."); return false;}
        }
        
        if ((pre != min) && (alt > min)) {for (int i=0; i<move.length; i++) move[i] = (move[i] + pos[i]) / 2.0; alt = pre;}
        pre = alt+EPS*EPS;
        
        inRuns = 0;
        while ((Double.isNaN(alt)) || (Double.isInfinite(alt)) || (Double.isNaN(pre)) || (Double.isInfinite(pre)) || (alt < pre) || (start < alt)) {
            pre = alt;
            if (pre < min) {min = pre; t = pos; pos = move; move = t;}
            for (int i=0; i<move.length; i++) move[i] = (move[i] + pos[i]) / 2.0;
            alt = getMinusTwoLogLikelihood(move);
            inRuns++;
            if (inRuns == 30) System.out.println("Got stuck in interval search, min = "+min+", alternative = "+alt+", start = "+start);
            if (inRuns > 100) {System.out.println("Giving up."); return false;}
        }
        for (int i=0; i<move.length; i++) move[i] = pos[i];             // Points have been manipulated, equating pos and move values

        if (storePosPointer != pos) {t = pos; pos = move; move = t;}    // rechanging pointers
        for (int i=0; i<move.length; i++) move[i] = pos[i] - posWork[i]; // To return movement
        if (min < 0) {System.out.println("Heading towards boundary minimum: "+min); return false;}
        
//        System.out.println("OPT  = "+Statik.matrixToString(pos)+"\t\t"+min);
//        System.out.println();
        return true;
    }
    
    /**
     * Computes the optimal damping in the direction of move from pos. Result is returned in pos, move is the new movement 
     * 
     * @param pos   Initially position, return value
     * @param move  Initially direction, return value
     * @return      true if successfull, false if stuck or negative result
     */
    private boolean moveWithOptimalDamping(double[] pos, double[] move, double EPS)
    {
        if ((p1w==null) || (p1w.length!=pos.length)) p1w = new double[pos.length];
        if ((p2w==null) || (p2w.length!=pos.length)) p2w = new double[pos.length];
        if ((cew==null) || (cew.length!=pos.length)) cew = new double[pos.length];
        if ((a1w==null) || (a1w.length!=pos.length)) a1w = new double[pos.length];
        if ((a2w==null) || (a2w.length!=pos.length)) a2w = new double[pos.length];
        double[] t; double td;
        double start = getMinusTwoLogLikelihood(pos);
        double p1v = start;

        int n = pos.length;
        for (int i=0; i<n; i++) p1w[i] = pos[i];
        
        double derivative = Statik.multiply(llD, move);
        Statik.multiply((int)Math.signum(-derivative), move, p2w);
        Statik.add(pos,p2w,p2w);
        double p2v = getMinusTwoLogLikelihood(p2w);
        
        while ((Double.isNaN(p2v)) || (Double.isInfinite(p2v))) {for (int i=0; i<n; i++) p2w[i] = (p1w[i]+p2w[i])/2.0; p2v = getMinusTwoLogLikelihood(p2w);}
        
        double cev = p2v+EPS*EPS, a1v, a2v, dist;
        
        // p1 will not be manipulated in this loop.
        int inRuns = 0;
        while ((p2v < p1v) && (p2v < cev))
        {
            for (int i=0; i<n; i++) cew[i] = p2w[i]; cev = p2v;
            for (int i=0; i<n; i++) p2w[i] = 2 * cew[i] - p1w[i];
            p2v = getMinusTwoLogLikelihood(p2w);
            while ((Double.isNaN(p2v)) || (Double.isInfinite(p2v))) {for (int i=0; i<n; i++) p2w[i] = (cew[i]+p2w[i])/2.0; p2v = getMinusTwoLogLikelihood(p2w);}

            if (inRuns == 30) System.out.println("I seem to approach a border minimum, best value = "+p2v+", previous was = "+cev+", start = "+start);
            if (inRuns > 100) {System.out.println("I reached a border minimum, I give up now."); return false;}
            inRuns++;
        }

        // at this point, it should be guaranteed that a minimum lies between p1w and p2w. 
        if (p2v < p1v) {t = p1w; p1w = p2w; p2w = t; td = p1v; p1v = p2v; p2v = td;}
        boolean goon = true; inRuns = 0;
        while (goon)
        {
            for (int i=0; i<n; i++) cew[i] = (p1w[i]+p2w[i])/2.0; cev = getMinusTwoLogLikelihood(cew);
            while (((cev>p1v) && (cev>p2v)) || (Double.isInfinite(cev)) || (Double.isNaN(cev)))
            {
                // This case means a maximum between p1v and p2v, or a illegal area, which is bad; 
                // taking the lower point is the best guess we can make. We will converge out of the prohibited area, but possible to a minimum free part.
                t = p2w; p2w = cew; cew = t; td = p2v; p2v = cev; cev = td;
                for (int i=0; i<n; i++) cew[i] = (p1w[i]+p2w[i])/2.0; cev = getMinusTwoLogLikelihood(cew);
            }
            if (cev>p1v) {t = p2w; p2w = cew; cew = t; td = p2v; p2v = cev; cev = td;}
            else if (cev>p2v) {t = p1w; p1w = cew; cew = t; td = p1v; p1v = cev; cev = td;}
            else {
                // This is the case that center is the smaller than both p1 and p2. Quarters need to be computed to make sure
                // that a minumum lies in the part.
                for (int i=0; i<n; i++) a1w[i] = (p1w[i]+cew[i])/2.0; a1v = getMinusTwoLogLikelihood(a1w); 
                for (int i=0; i<n; i++) a2w[i] = (p2w[i]+cew[i])/2.0; a2v = getMinusTwoLogLikelihood(a2w); 
                if (a1v < cev) {t = p2w; p2w = cew; cew = t; td = p2v; p2v = cev; cev = td;}
                else if (a2v < cev) {t = p1w; p1w = cew; cew = t; td = p1v; p1v = cev; cev = td;}
                else {
                    // This is the case that both quarters are higher than the center.
                    t = p2w; p2w = a2w; a2w = t; td = p2v; p2v = a2v; a2v = td;
                    t = p1w; p1w = a1w; a1w = t; td = p1v; p1v = a1v; a1v = td;
                }
            }
            if (p2v < p1v) {t = p1w; p1w = p2w; p2w = t; td = p1v; p1v = p2v; p2v = td;}
            dist = 0; for (int i=0; i<n; i++) dist += (p1w[i]-p2w[i])*(p1w[i]-p2w[i]);
            if (dist < EPS*EPS) goon = false;
            
            if (inRuns == 30) System.out.println("It takes me some time to converge, best value = "+p1v+", alternative = "+p2v+", start = "+start);
            if (inRuns > 100) {System.out.println("I give up inner iteration now."); return false;}
            inRuns++;
        }
        for (int i=0; i<n; i++) move[i] = p1w[i] - pos[i];
        for (int i=0; i<n; i++) pos[i] = p1w[i];

        if (p1v < 0) {System.out.println("Heading towards boundary minimum: "+p1v); return false;}
        return true;
    }    
    
    public double[] estimateML(double[] starting) {return estimateML(starting, 0.0001);}
    public double[] estimateML(double[] starting, double EPS)
    {
        final int MAXRUNS = 50; 

        double[] move = new double[anzPar];
        double[] pos = new double[anzPar];
        double[][] work1 = new double[anzPar][anzPar], work2 = new double[anzPar][anzPar];
        
        for (int i=0; i<anzPar; i++) pos[i] = starting[i];
        
        int runs = 0; double steplength = Double.POSITIVE_INFINITY, gain = Double.POSITIVE_INFINITY;
        computeLogLikelihoodDerivatives(pos);
        System.out.println("Step 0, pos = "+Statik.matrixToString(pos)+", -2ll = "+ll);
        double DEBUGstart = ll;
        while ((runs<=MAXRUNS) && (steplength > EPS) && (gain > EPS))
        {
            double lastLL = ll;
            Statik.invert(llDD, work1, work2);
            Statik.multiply(work1, llD, move);
            boolean success = moveWithOptimalDamping(pos, move, EPS);

            if (success)
            {
                computeLogLikelihoodDerivatives(pos);
                steplength = Statik.abs(move);
                gain = lastLL - ll;
                runs++;
                System.out.println("Step "+runs+", pos = "+Statik.matrixToString(pos)+", -2ll = "+ll);
            } else {
                for (int i=0; i<anzPar; i++) pos[i] = starting[i];
                computeLogLikelihoodDerivatives(pos);
                Statik.invert(llDD, work1, work2);
                Statik.multiply(work1, llD, move);
                double abs = Statik.abs(move);
                for (int i=0; i<anzPar; i++) pos[i] += starting[i] + rand.nextDouble() * abs / 10.0;
                if (errPar[0] != NOPARAMETER) pos[errPar[0]] += abs / 2.0;
                if (errPar[1] != NOPARAMETER) pos[errPar[1]] += abs / 2.0;
                System.out.println("Headed towards boundary minimum, I restarted with perturbed values and higher error.");
            }
        }

//        if (runs > MAXRUNS) System.out.println("Warning: More than 50 runs needed, final steplength = "+steplength);
//        System.out.println("Runs       = "+runs);
//        System.out.println("Steplength = "+steplength);
//        System.out.println("Last gain  = "+gain);
//        System.out.println("Total gain = "+(DEBUGstart - ll));
//        System.out.println("Final LL   = "+ll);
        
        if ((lastEstimate == null) || (lastEstimate.length != anzPar)) lastEstimate = new double[anzPar];
        for (int i=0; i<anzPar; i++) lastEstimate[i] = pos[i];
        return pos;
    }
    
    public void independentSigma() 
    {
        for (int i=0; i<sigma.length; i++)
            for (int j=0;j<sigma.length ;j++)
                sigma[i][j] = (i==j?this.dataCov[i][j]:0);
    }
    
    public int restrictedDF()
    {
        return anzVar*(anzVar+1)/2 - anzPar;
    }
    
    public double getSaturatedLL() 
    {
        double myll = ll;
        for (int i=0; i<anzVar; i++)
            for (int j=0; j<anzVar; j++)
                sigma[i][j] = dataCov[i][j];
        
        double sat = getMinusTwoLogLikelihood(null, false);
        ll = myll;
        return sat;
    }

    public double getRMSEA()
    {
        return Math.sqrt(Math.max((ll - restrictedDF()),0) / (restrictedDF()*(anzPer-1)));
    }
    
    public double getDeltaRMSEA(MultipleGroupFactorModel restrictedModel)
    {
        return Math.sqrt(((restrictedModel.ll - ll) - (restrictedModel.anzPar - anzPar))/((restrictedModel.anzPar - anzPar)*(anzPer-1)));
    }
    
    public double getCFI()
    {
        double myll = ll;
        independentSigma(); 
        this.computeLogLikelihoodDerivatives(null,false);
        double indepLL = ll;
        ll = myll;
        int restrictedDF = restrictedDF();
        int indepRestrictedDF = anzVar*(anzVar-1)/2;
        if (myll <= restrictedDF) return 1.0;
        return 1.0-((myll-restrictedDF) / Math.max(myll-restrictedDF,indepLL - indepRestrictedDF));
    }

    public double getCFI(MultipleGroupFactorModel restrictedModel)
    {
        if (ll <= restrictedDF()) return 1.0;
        return 1.0-((ll-restrictedDF()) / Math.max(ll-restrictedDF(),restrictedModel.ll - restrictedModel.restrictedDF()));
    }
    
    public double getDeltaCFI(MultipleGroupFactorModel restrictedModel)
    {
        return this.getCFI() - restrictedModel.getCFI();
    }
    
    public double getMcDonaldsCentralityIndex()
    {
        return Math.exp(-0.5*(ll-restrictedDF())/(anzPer-1));
    }
    
    public double[][] computeExpA()
    {
        if ((work1==null) || (work1.length!=2) || (work1[0].length!=2)) work1 = new double[2][2];
        double[][] erg = new double[2][2];
        
        computeTransformation();
        for (int i=0; i<2; i++) for (int j=0; j<2; j++) work1[i][j] = trans[i][j]*Math.exp((i==0?ev1:ev2));
        Statik.multiply(transInv, work1, erg);
        return erg;
    }
    
    public static void main(String args[])
    {
        WienerProcessModel model = new WienerProcessModel(new int[]{0,1,2,3}, new double[]{0,0,0,0},
                new int[][]{{4,5},{6,7}}, new double[][]{{-0.7,0.3},{0.1,-0.5}}, new int[][]{{8,9},{9,10}}, new double[][]{{1,0.1},{0.1,1}},
                new int[][]{{11,12,13,14},{12,15,16,17},{13,16,18,19},{14,17,19,20}}, new double[][]{{1,0.1,0.1,0.1},{0.1,1,0.1,0.1},{0.1,0.1,1,0.1},{0.1,0.1,0.1,1}},
                new int[]{21,22}, new double[]{0.1,0.1}, new double[]{0,2,3,4,8});
//        WienerProcessModel model = new WienerProcessModel(new int[]{0,1,2,3}, new double[]{0,0,0,0},
//                new int[][]{{4,5},{6,7}}, new double[][]{{-0.7,0.3},{0.1,-0.5}}, new int[][]{{8,9},{9,10}}, new double[][]{{1,0.1},{0.1,1}},
//                new int[][]{{11,12,13,14},{12,15,16,17},{13,16,18,19},{14,17,19,20}}, new double[][]{{1,0.1,0,0},{0.1,1,0,0},{0,0,0,0},{0,0,0,0}},
//                new int[]{21,22}, new double[]{0.1,0.1}, new double[]{0,2,3,4,5});
        
//      model.fixParameter(new int[]{0,1,2,3,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22});
        model.fixParameter(new int[]{13,14,16,17,18,19,20});
        
        System.out.println(Statik.matrixToString(model.computeExpA()));
        
        double[] a = new double[model.anzPar];
        for (int i=0; i<a.length; i++) a[i] = model.getParameter(i);
        model.applyParameterValues(a);
        model.computeTransformation();
        System.out.println(Statik.matrixToString(model.autoVal));
        double T = model.T, D = model.D, ev1 = model.ev1, ev2 = model.ev2; double[][] trans = Statik.copy(model.trans);
        System.out.println("T = "+T+", D = "+D+", ev1 = "+ev1+", ev2 = "+ev2+", ev1D = "+Statik.matrixToString(model.ev1D)+", ev2D = "+Statik.matrixToString(model.ev2D));
        System.out.println("Transformation Matrix = \r\n"+Statik.matrixToString(trans));
        System.out.println("Derivative wrt a00 of Transformation = \r\n"+Statik.matrixToString(model.transD[0]));
        System.out.println("Derivative wrt a01 of Transformation = \r\n"+Statik.matrixToString(model.transD[1]));
        System.out.println("Derivative wrt a10 of Transformation = \r\n"+Statik.matrixToString(model.transD[2]));
        System.out.println("Derivative wrt a11 of Transformation = \r\n"+Statik.matrixToString(model.transD[3]));
//        System.out.println("Derivative of D = "+Statik.matrixToString(model.DD));
        
        final double eps = 0.000001;
        
        double[] grad = Statik.copy(model.ev1D);
        double[][] hes = Statik.copy(model.evDD);
        double[] numD = new double[4];
        double[][] numDD = new double[4][4];
//        for (int i=0; i<4; i++) {
//            a[i]+= eps; model.applyParameterValues(a); model.computeTransformation(); a[i]-= eps;    
//            numD[i] = (model.ev1-ev1)/eps - grad[i];
//            for (int j=0; j<4; j++) numDD[i][j] = (model.ev1D[j]-grad[j])/eps - hes[i][j];  
//        }
//        System.out.println("Error 1st deriv. of ev1 = "+Statik.matrixToString(numD));
//        System.out.println("Error 2nd deriv. of ev1 = \r\n"+Statik.matrixToString(numDD));

        model.applyParameterValues(a); model.computeTransformation(); 
        grad = Statik.copy(model.ev2D);
        hes = Statik.copy(model.evDD);
//        for (int i=0; i<4; i++) {
//            a[i]+= eps; model.applyParameterValues(a); model.computeTransformation(); a[i]-= eps;    
//            numD[i] = (model.ev2-ev2)/eps - grad[i];
//            for (int j=0; j<4; j++) numDD[i][j] = (model.ev2D[j]-grad[j])/eps + hes[i][j];  
//        }
//        System.out.println("Error 1st deriv. of ev2 = "+Statik.matrixToString(numD));
//        System.out.println("Error 2nd deriv. of ev2 = \r\n"+Statik.matrixToString(numDD));
    
//        for (int p=0; p<2; p++) for (int q=0; q<2; q++)
//        {
//            model.applyParameterValues(a); model.computeTransformation();
//            double v = model.trans[p][q];
//            for (int i=0; i<4; i++) grad[i] = model.transD[i][p][q]; 
//            for (int i=0; i<4; i++) for (int j=0; j<4; j++) hes[i][j] = model.transDD[i][j][p][q]; 
//            for (int i=0; i<4; i++) {
//                a[i]+= eps; model.applyParameterValues(a); model.computeTransformation(); a[i]-= eps;    
//                numD[i] = (model.trans[p][q]-v)/eps - grad[i];
//                for (int j=0; j<4; j++) numDD[i][j] = (model.transD[j][p][q]-grad[j])/eps - hes[i][j];  
//            }
//            System.out.println("Error 1st deriv. of trans["+p+"]["+q+"] = "+Statik.matrixToString(numD));
//            System.out.println("Error 2nd deriv. of trans["+p+"]["+q+"] = \r\n"+Statik.matrixToString(numDD));
//        }

        
//        for (int t=0; t<2; t++) for (int p=0; p<2; p++) for (int q=0; q<4; q++)
//        {
//            model.applyParameterValues(a); model.computeTransformation(); model.computePM();
//            double v = model.M[t][p][q];
//            for (int i=0; i<4; i++) grad[i] = model.MD[t][i][p][q]; 
//            for (int i=0; i<4; i++) for (int j=0; j<4; j++) hes[i][j] = model.MDD[t][i][j][p][q]; 
//            for (int i=0; i<4; i++) {
//                a[i]+= eps; model.applyParameterValues(a); model.computeTransformation(); model.computePM(); a[i]-= eps;    
//                numD[i] = (model.M[t][p][q]-v)/eps - grad[i];
//                for (int j=0; j<4; j++) numDD[i][j] = (model.MD[t][j][p][q]-grad[j])/eps - hes[i][j];  
//            }
//            System.out.println("Error 1st deriv. of M["+p+"]["+q+"] at time "+t+" = "+Statik.matrixToString(numD));
//            System.out.println("Error 2nd deriv. of M["+p+"]["+q+"] at time "+t+"= \r\n"+Statik.matrixToString(numDD));
//        }
        
//        for (int t=0; t<2; t++) for (int p=0; p<2; p++) for (int q=0; q<2; q++)
//        {
//            model.applyParameterValues(a); model.computeTransformation(); model.computePM();
//            double v = model.P[t][p][q];
//            for (int i=0; i<4; i++) grad[i] = model.PD[t][i][p][q]; 
//            for (int i=0; i<4; i++) for (int j=0; j<4; j++) hes[i][j] = model.PDD[t][i][j][p][q]; 
//            for (int i=0; i<4; i++) {
//                a[i]+= eps; model.applyParameterValues(a); model.computeTransformation(); model.computePM(); a[i]-= eps;    
//                numD[i] = (model.P[t][p][q]-v)/eps - grad[i];
//                for (int j=0; j<4; j++) numDD[i][j] = (model.PD[t][j][p][q]-grad[j])/eps - hes[i][j];  
//            }
//            System.out.println("Error 1st deriv. of P["+p+"]["+q+"] at time "+t+" = "+Statik.matrixToString(numD));
//            System.out.println("Error 2nd deriv. of P["+p+"]["+q+"] at time "+t+"= \r\n"+Statik.matrixToString(numDD));
//        }

        int anzP = model.anzPar;
        grad = new double[anzP];
        hes = new double[anzP][anzP];
        numD = new double[anzP];
        numDD = new double[anzP][anzP];
        double[][] work = new double[model.anzVar][model.anzVar]; 
        model.evaluateMuAndSigma(a); 
//        for (int p=0; p<model.anzVar; p++) for (int q=0; q<model.anzVar; q++)
//        {
//            model.evaluateMuAndSigma(a); 
//            double v = model.sigma[p][q];
//            for (int i=0; i<model.anzPar; i++) {model.computeSigmaDev(i, work); grad[i] = work[p][q];} 
//            for (int i=0; i<anzP; i++) for (int j=0; j<anzP; j++) {model.computeSigmaDevDev(i, j, work); hes[i][j] = work[p][q];} 
//            for (int i=0; i<anzP; i++) {
//                a[i]+= eps; model.evaluateMuAndSigma(a); a[i]-= eps;    
//                numD[i] = (model.sigma[p][q]-v)/eps; 
//                for (int j=0; j<anzP; j++) {model.computeSigmaDev(j, work); numDD[i][j] = (work[p][q]-grad[j])/eps;}  
//            }
//            for (int i=0; i<anzP; i++) numD[i] = Statik.percentError(numD[i], grad[i]);
//            for (int i=0; i<anzP; i++) for (int j=0; j<anzP; j++) numDD[i][j] = Statik.percentError(numDD[i][j], hes[i][j]);
//            System.out.println("Error 1st deriv. of sigma["+p+"]["+q+"] = "+Statik.matrixToString(numD));
//            System.out.println("Error 2nd deriv. of sigma["+p+"]["+q+"] = \r\n"+Statik.matrixToString(numDD));
//        }

        model.evaluateMuAndSigma(a);
        model.createData(1000);
        System.out.println("Sigma = \r\n"+Statik.matrixToString(model.sigma));
        System.out.println("SigmaLat = \r\n"+Statik.matrixToString(model.sigmaLat));
        model.computeCorrectedMoments();
        System.out.println("Corr. Moments = \r\n"+Statik.matrixToString(model.corrMoments));
//        for (int p=0; p<model.anzVar; p++) for (int q=0; q<model.anzVar; q++)
//        {
//            model.evaluateMuAndSigma(a); 
//            model.computeCorrectedMoments();
//            double v = model.corrMoments[p][q];
//            for (int i=0; i<model.anzPar; i++) {model.computeCorrectedMomentsDev(i, work); grad[i] = work[p][q];} 
//            for (int i=0; i<anzP; i++) for (int j=0; j<anzP; j++) {model.computeCorrectedMomentsDevDev(i, j, work); hes[i][j] = work[p][q];} 
//            for (int i=0; i<anzP; i++) {
//                a[i]+= eps; model.evaluateMuAndSigma(a); model.computeCorrectedMoments(); a[i]-= eps;    
//                numD[i] = (model.corrMoments[p][q]-v)/eps; 
//                for (int j=0; j<anzP; j++) {model.computeCorrectedMomentsDev(j, work); numDD[i][j] = (work[p][q]-grad[j])/eps;}  
//            }
//            for (int i=0; i<anzP; i++) numD[i] = Statik.percentError(numD[i], grad[i]);
//            for (int i=0; i<anzP; i++) for (int j=0; j<anzP; j++) numDD[i][j] = Statik.percentError(numDD[i][j],hes[i][j]);
//            System.out.println("Error 1st deriv. of corrMoments["+p+"]["+q+"] = "+Statik.matrixToString(numD));
//            System.out.println("Error 2nd deriv. of corrMoments["+p+"]["+q+"] = \r\n"+Statik.matrixToString(numDD));
//        }

        model.computeLogLikelihoodDerivatives(a);
        double v = model.ll;
        grad = Statik.copy(model.llD);
        hes = Statik.copy(model.llDD);
        for (int i=0; i<anzP; i++) {
            a[i]+= eps; model.computeLogLikelihoodDerivatives(a); a[i]-= eps;    
            numD[i] = (model.ll-v)/eps;
            for (int j=0; j<anzP; j++) numDD[i][j] = (model.llD[j]-grad[j])/eps;  
        }
        for (int i=0; i<anzP; i++) numD[i] = Statik.percentError(numD[i], grad[i]);
        for (int i=0; i<anzP; i++) for (int j=0; j<anzP; j++) numDD[i][j] = Statik.percentError(numDD[i][j],hes[i][j]);
        System.out.println("Error 1st deriv. of -2ll = "+Statik.matrixToString(numD));
        System.out.println("Error 2nd deriv. of -2ll = \r\n"+Statik.matrixToString(numDD));
        
        Statik.writeMatrix(model.data, "ToManuel.txt", '\t');
        long startT = System.currentTimeMillis();
        int n = model.anzPar;
        int N = 500;
        double[] estsum = new double[n];
        double[] estssum = new double[n];
        int anzRep = 20;
        for (int j=0; j<anzRep; j++)
        {
            model.applyParameterValues(a);
            model.createData(N);
            double[] est = model.estimateML(a, 0.001);
//            System.out.println("Population Parameters = "+Statik.matrixToString(a));
//            System.out.println("Estimated Parameters  = "+Statik.matrixToString(est));
//            for (int i=0; i<est.length; i++) est[i] = Statik.percentError(est[i], a[i]);
//            System.out.println("Percentage Wrong      = "+Statik.matrixToString(est));
            for (int i=0; i<n; i++) {estsum[i] += est[i]; estssum[i] += est[i]*est[i];}
        }
        for (int i=0; i<n; i++) estsum[i] /= (double)anzRep;
        for (int i=0; i<n; i++) estssum[i] = Math.sqrt(estssum[i]/(double)anzRep - estsum[i]*estsum[i]);
        System.out.println("Population Parameters = "+Statik.matrixToString(a));
        System.out.println("Estimated Parameters  = "+Statik.matrixToString(estsum));
        for (int i=0; i<estsum.length; i++) estsum[i] = Statik.percentError(estsum[i], a[i]);
        System.out.println("Percentage Wrong      = "+Statik.matrixToString(estsum));
        System.out.println("Standard Deviation    = "+Statik.matrixToString(estssum));
        long finT = System.currentTimeMillis() - startT;
        System.out.println("Oveall time = "+finT+" ms.");
        
//        double[][] surface = new double[50][50];
//        for (int i=0; i<50; i++)
//            for (int j=0; j<50; j++)
//                surface[i][j] = model.getMinusTwoLogLikelihood(new double[]{-0.1+i*0.2/50.0,0+j*0.2/50.0});
//        Statik.writeMatrix(surface, "surface.txt", '\t');
    }
    
}
