/*
 * Created on 08.04.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package lgmsimulation;

import java.util.Random;

import java.io.*;

import lgmsimulation.Model.warningFlagTypes;

import silvers.Statik;

/**
 * @author timo
 */
public class SimpleLGM {
    
//    public static Random rand = Model.rand;
    public static Random rand = new Random(213523459);
    
    public final static int MISSING = -999;
    
    public final int DIGITS	= 3;
    public final double RESTRICTEDAREABORDER = 50000000.0;
    public final double EPS = 0.01;
	final double CHISQ1 = 3.841;		// 1 Freiheitsgrad
	final double CHISQ2 = 5.991;		// 2 Freiheitsgrade
	final double CHISQ5 = 11.070;		// 5 Freiheitsgrade
	final double CHISQ6 = 12.600;		// 6 Freiheitsgrade
	final double CHISQ7 = 14.067;		// 7 Freiheitsgrade
	final double CHISQ1OS = 2.706;		// 1 Freiheitsgrad, Signifikanzniveau 10 % (bzw. einseitig 5%)
	final double CHISQ2OSS = 5.140;		// Gleichanteilige Mischung von 1 and 2 Freiheitsgraden, Signifikanzniveau 5%
	final double CHISQ2OS = 4.605;		// 1 Freiheitsgrad, Signifikanzniveau 10 % (bzw. einseitig 5%)
	
	final double NORMVERT = 1.960;		// Gaussverteilung, Signifikanzniveau 2.5 % einseitig (bzw. zweiseitig 5%)
	final double NORMVERTOS	= 1.645; 	// Guassverteilung, Signifikanzniveau 5 % einseitig

    
    private int twollAdaptionSteps;
    private int twollInnerSteps;
    private double twollStartValue;
    public double twollValue;
    private double twollComplete;
    private double twollIndependent1;
    private double twollIndependent2;

    public double[][] createData (int anzPersons, double[][] covMatrix, double[] muVector, double[][] structureMatrix, double[] error)
    {
        int anzVar = structureMatrix.length;
        int anzFac = muVector.length;
        double[][] cholesky = Statik.choleskyDecompose(covMatrix);
        double[][] erg = new double[anzPersons][anzVar];
        double[][] structureChol = Statik.multiply(structureMatrix,cholesky);
        double[] structureMu   = Statik.multiply(structureMatrix,muVector);
/*        
        System.out.println("\r\ncovariance = \r\n"+Statik.matrixToString(covMatrix));
        System.out.println("\r\nCholesky = \r\n"+Statik.matrixToString(cholesky));
        System.out.println("\r\nCC^T = \r\n"+Statik.matrixToString(Statik.multiply(cholesky,Statik.transpose(cholesky))));
        System.out.println("\r\nStructure x Cholesky = \r\n"+Statik.matrixToString(structureChol));
 */       
        for (int i=0; i<anzPersons; i++)
        {
            double[] m = new double[anzFac];
            for (int j=0; j<anzFac; j++) m[j] = rand.nextGaussian();
            double[] sm = Statik.multiply(structureChol,m); sm = Statik.add(sm,structureMu);
            for (int j=0; j<anzVar; j++) erg[i][j] = sm[j] + rand.nextGaussian()*Math.sqrt(error[j]);
        }
        return erg;
    }
    
    /**
     * Computes the -2ll 
     * 
     * @param anzPer	Number of Persons
     * @param xsum		Sum of all datas per variable (sum_i data[i]);
     * @param xBiSum	Sum of all products of datas per variable (sum_i data[i][j]*data[i][k]
     * @param sigD		Covariance matrix
     * @param muD		Mean Vector
     * @return			-2ll value for this data set. 
     */
    public double twollEvaluate(LinearModel model, double[] pos)
    	{return twollEvaluate(model.anzPer, model.xsum, model.xBiSum, model.evaluateSigma(pos), model.evaluateMu(pos), false);}
    public double twollEvaluate(int anzPer, double[] xsum, double[][] xBiSum, double[][] sigD, double[] muD, boolean addPenalty) 
    	{return twollEvaluate(anzPer, xsum, xBiSum, sigD, muD, null, addPenalty);} 
    public double twollEvaluate(int anzPer, double[] xsum, double[][] xBiSum, double[][] sigD, double[] muD, double[][] parMatrix, boolean addPenalty)
    {
    	final int anzVar = xsum.length;
    	final double PENALTY = 2*RESTRICTEDAREABORDER;
    	
    	double[][] sigMInvD = Statik.invert(sigD);

    	double determinant = Statik.determinantOfPositiveDefiniteMatrix(sigD);
//    	System.out.println("Det Sigma = "+determinant);
    	double value;
    	boolean isPenalty = ((determinant <= 0.0) || (addPenalty));
//    	boolean isPenalty = ((determinant <= EPS) || (addPenalty));
    	if (parMatrix != null) isPenalty = isPenalty || (Statik.determinantOfPositiveDefiniteMatrix(parMatrix) > 0);
    	if (!isPenalty) value = Math.log(Math.abs(determinant))*anzPer;
    	else value = PENALTY;							    

    	value += anzPer*anzVar*1.8378770664093454835606594728112;			// log(2 Pi)

    	double sum = 0.0;
    	for (int j=0; j<anzVar; j++)
    		for (int k=0; k<anzVar; k++)
    			sum += (xBiSum[j][k] + anzPer * muD[j] * muD[k] - xsum[j] * muD[k] - xsum[k] * muD[j]) * sigMInvD[j][k];

    	value += sum; 
    				
    	return (isPenalty?Math.max(value,PENALTY):value);
    }

    // errorInfoAnz und errorInfoValue are additional information about error parameters, ordered as the error parameters. 
    // AdditionalErrorInfo carries triplets, with errPar, then anz information Units, then squared sum of these units.
    public double[] twollAproxLinearModel(LinearModel model, double[] initialIn) {return twollAproxLinearModel(model, initialIn, null);}
    public double[] twollAproxLinearModel(LinearModel model, double[] initialIn, double[][] additionalErrorInfo)
	{
	    final double VALUEBORDER = 1000000;
		final int MAXRUN = 50;
	
		final int anzPer = model.anzPer;
		final int anzFac = model.getAnzFac();
		final int anzVar = model.getAnzVar();
		final int anzPar = model.getAnzPar();
		final int anzMeanPar = model.getAnzMeanPar();
		final int anzVarPar = model.getAnzVarPar();
		final int anzErrPar = model.getAnzErrPar();
	
		double[] initial = initialIn;
		if (initial == null) initial = model.leastSquareAproxLinearModel();  
		double initialValue = -1.0, endValue = -1.0;
		
		// Evaluation of sigmaDev. SigmaDevDev und muDevDev sind berall null.
		// Die Ableitungen sind an allen Stellen nur noch Zahlen.
		double[][][] sigmaDev = model.evaluateSigmaDev();
		double[][] muDev = model.evaluateMuDev();
//		for(int i=0; i<anzPar; i++)
//		{
//		    System.out.println("SigmaDev parameter "+i+" = \r\n"+Statik.matrixToString(sigmaDev[i]));
//			System.out.println("MuDev parameter "+i+" = "+Statik.matrixToString(muDev[i]));
//		}
		
		double dist = 1.0;
		int runs = 0;
	
		double[] xd = new double[anzPar];
		for (int i=0; i<anzPar; i++) xd[i] = initial[i];
		
		double[][] sigD = model.evaluateSigma(xd);
		double[] muD = model.evaluateMu(xd);
//		boolean factorsPositiveDefinite = model.factorPositiveDefinite(xd);
		double value = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
        if (additionalErrorInfo != null) 
            for (int i=0; i<additionalErrorInfo.length; i++) {
                double x = xd[(int)additionalErrorInfo[i][0]]; 
                value += additionalErrorInfo[i][1]*Math.log(x) + additionalErrorInfo[i][2]/x; 
            }
		if (value > RESTRICTEDAREABORDER)
		{
//		    System.out.println("Least Squares is bad, I try to improve...");
			int tries = 0;
			while ((value > RESTRICTEDAREABORDER) && (tries < 10))
			{
			    model.raiseVarianceParameters(xd);
				sigD = model.evaluateSigma(xd);
				muD = model.evaluateMu(xd);
//				factorsPositiveDefinite = model.factorPositiveDefinite(xd);
				value = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
			    tries++;
			}
		}
	
		double[] zero = new double[anzPar];
		// for later use
		double[][] sigMoveD = new double[anzVar][anzVar];
		double[] muMoveD = new double[anzVar];
		double[][] sigNullParameter = Statik.multiply(-1,model.evaluateSigma(zero));
		double[] muNullParameter = Statik.multiply(-1,model.evaluateMu(zero));
		double[][] factorNullParameter = Statik.multiply(-1,model.evaluateFactorMatrix(zero));
		double[][] sigMInvD = new double[anzVar][anzVar];
		double[][] factorMatrix = new double[anzFac][anzFac];
		double[][] factorMatrixMove = new double[anzFac][anzFac];
		double[][] mat1 = new double[anzVar][anzVar];	// Arbeitsplatz fr Matrixinvertierung
		double[][] mat2 = new double[anzVar][anzVar];			// Zwischenspeicher
		double[][] mat3 = new double[anzPar][anzPar];			// Zwischenspeicher
		double[][][] sigMInvSigDevD = new double[anzPar-anzMeanPar][anzVar][anzVar];
		double[][][] sigMInvSigDevDSigMInv = new double[anzPar-anzMeanPar][anzVar][anzVar];
		double[] posD = new double[anzPar];
		double[][] jacobian = new double[anzPar][anzPar];
		double[][] jinv = new double[anzPar][anzPar]; 
		double[] move = new double[anzPar];
		int innersteps = 0;
		while ((runs < MAXRUN) && (dist > EPS))
		{
			Statik.invert(sigD, sigMInvD, mat1);
	
			// Vorbereiten von sigMInv * sigDev und sigMInv * sigDev * sigMInv fr alle Parameter ber anzMeanPar:
			for (int i=anzMeanPar; i<anzPar; i++)
			{
				Statik.multiply(sigMInvD, sigmaDev[i], sigMInvSigDevD[i-anzMeanPar]);
				Statik.multiply(sigMInvSigDevD[i-anzMeanPar], sigMInvD, sigMInvSigDevDSigMInv[i-anzMeanPar]);
			}
	
			// Aufbau des Ableitungs-Vektors; zunchst die Means:
			for (int i=0; i<anzMeanPar; i++)
			{
				posD[i] = 0.0;
				for (int j=0; j<anzVar; j++)
					for (int k=0; k<anzVar; k++) 
					    posD[i] -= 2.0* muDev[i][j]*sigMInvD[j][k]*(model.xsum[k]-anzPer*muD[k]);
			}
			// Aufbau des Ableitungs-Vektors, jetzt die Varianzen:
			for (int i=anzMeanPar; i<anzPar; i++)
			{
				double spur = 0.0;
				for (int j=0; j<anzVar; j++) spur += sigMInvSigDevD[i-anzMeanPar][j][j];
				posD[i] = (spur*(double)anzPer);
	
				double sum = 0.0;
				for (int j=0; j<anzVar; j++)
					for (int k=0; k<anzVar; k++)
						sum += (model.xBiSum[j][k] + anzPer * muD[j] * muD[k] - model.xsum[j] * muD[k] - model.xsum[k] * muD[j]) * sigMInvSigDevDSigMInv[i-anzMeanPar][j][k];
	
				posD[i] -= sum;
			}
				
			// Aufbau der Jacobi-Matrix, zunchst Mittelwert - Mittelwert
			for (int i=0; i<anzMeanPar; i++)
				for (int j=i; j<anzMeanPar; j++)
				{
					double sum = 0.0;
					for (int k=0; k<anzVar; k++)
						for (int l=0; l<anzVar; l++)
							sum += sigMInvD[k][l] * muDev[i][k] * muDev[j][l];
					jacobian[i][j] = jacobian[j][i] = 2*anzPer*sum;
					model.fisherInformationMatrix[i][j] = model.fisherInformationMatrix[j][i] = 2*anzPer*sum; 
				}
			// jetzt Mittelwert - Varianz
			for (int i=0; i<anzMeanPar; i++)
				for (int j=anzMeanPar; j<anzPar; j++)
				{
					double sum = 0.0;
					for (int k=0; k<anzVar; k++)
						for (int l=0; l<anzVar; l++)
							sum += sigMInvSigDevDSigMInv[j-anzMeanPar][k][l] * muDev[i][k] * (model.xsum[l] - anzPer*muD[l]);
					jacobian[i][j] = jacobian[j][i] = 2*sum;
					model.fisherInformationMatrix[i][j] = model.fisherInformationMatrix[j][i] = 0.0; 
				}
			// und jetzt Varianz - Varianz
			for (int i=anzMeanPar; i<anzPar; i++)
				for (int j=i; j<anzPar; j++)
				{
					Statik.multiply(sigMInvSigDevD[i-anzMeanPar],sigMInvSigDevD[j-anzMeanPar], mat1);
	
					double spur = 0.0;
					for (int k=0; k<anzVar; k++) spur += mat1[k][k];
					model.fisherInformationMatrix[i][j] = model.fisherInformationMatrix[j][i] = (double)anzPer * spur / 2.0; 
	
					Statik.multiply(mat1, sigMInvD, mat2);
	
					double sum = 0.0;
					for (int k=0; k<anzVar; k++)
						for (int l=0; l<anzVar; l++)
							sum += (model.xBiSum[k][l] + anzPer * muD[k] * muD[l] - model.xsum[k] * muD[l] - model.xsum[l] * muD[k]) * mat2[k][l];
	
					jacobian[i][j] = jacobian[j][i] = -(spur*(double)anzPer) + 2*sum;
				}

	        if (additionalErrorInfo != null) 
	            for (int i=0; i<additionalErrorInfo.length; i++) {
	                int pos = (int)additionalErrorInfo[i][0];
	                double x = xd[pos];
	                posD[pos] += (additionalErrorInfo[i][1]*x - additionalErrorInfo[i][2]) / (x*x);
	                jacobian[pos][pos] += 2* (additionalErrorInfo[i][2]-additionalErrorInfo[i][1]*x)/(x*x*x);
	                value += additionalErrorInfo[i][1]*Math.log(x) + additionalErrorInfo[i][2]/x; 
	            }

	        
	        Statik.invert(jacobian, jinv, mat3);
			for (int i=0; i<anzPar; i++)
			{
				move[i] = 0.0;
				for (int j=0; j<anzPar; j++) move[i] -= jinv[i][j] * posD[j];
			}
	
			// Evaluation of Sigma with move Parameter
			model.evaluateSigma(move, sigMoveD);
			model.evaluateMu(move, muMoveD);
			model.evaluateFactorMatrix(move, factorMatrix);
			sigMoveD = Statik.add(sigMoveD, sigNullParameter);
			muMoveD = Statik.add(muMoveD, muNullParameter);
			factorMatrixMove = Statik.add(factorMatrix, factorNullParameter);
	
//			System.out.println("\r\nJ^-1       = \r\n"+Statik.matrixToString(jinv));
//			System.out.println("\r\nSigma Move = \r\n"+Statik.matrixToString(sigMoveD));
//			System.out.println("\r\nMu Move    = \r\n"+Statik.matrixToString(muD));
	
			double diff = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
			if (runs==0) initialValue = diff;
//			System.out.print("Position "+runs+": ");
//			for (int i=0; i<xd.length; i++) System.out.print(xd[i]+",");
//			System.out.println(" Wert = "+diff);
	
			double lambda = twollInnerIteration(anzPer, model.xsum, model.xBiSum, sigD, muD, factorMatrix, sigMoveD, muMoveD, factorMatrixMove);
			innersteps += twollInnerSteps;
	
//			System.out.println(", Lambda = "+lambda);
			
//			System.out.println("Numerical move = "+Statik.matrixToString(Statik.multiply(-1,Statik.multiply(Statik.invert(numJacobian),numGradient))));
//			System.out.println("Proposed  move = "+Statik.matrixToString(move));
	
			for (int i=0; i<anzPar; i++) xd[i] += move[i] * lambda;
			for (int i=0; i<anzVar; i++)
			{
				muD[i] += lambda * muMoveD[i];
				for (int j=0; j<anzVar; j++)
					sigD[i][j] += lambda * sigMoveD[i][j];
			}

//			factorsPositiveDefinite = model.factorPositiveDefinite(xd);
			endValue = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
			diff = Math.abs(diff - endValue);
	
			dist = 0.0;
			for (int i=0; i<anzPar; i++) dist += move[i]*move[i];
			dist = Math.sqrt(dist) * Math.abs(lambda);
			dist = Math.max(Math.abs(diff),dist);				// Abbruchkriterium beide Schrittweiten klein.
			
			runs++;
		}
		
		// statische Variable
		twollAdaptionSteps = runs;
		twollInnerSteps = innersteps;
		twollStartValue = initialValue;
		twollValue = endValue;
		if (model.anzPer > 1)
		{
			double[][] matrix = Statik.copy(model.dataCov);
			double[] mean = Statik.copy(model.dataMean);
			twollComplete = twollEvaluate(anzPer, model.xsum, model.xBiSum, matrix, mean, false);
			for (int i=0; i<anzVar; i++)
				for (int j=0; j<anzVar; j++) if (i!=j) matrix[i][j] = 0.0;
			twollIndependent1 = twollEvaluate(anzPer, model.xsum, model.xBiSum, matrix, mean, false);
			double meanmean1 = 0.0, meanmean2 = 0.0;
			for (int i=0; i<anzVar/2; i++) { meanmean1 += mean[i]; meanmean2 += mean[i+anzVar/2];}
			for (int i=0; i<anzVar/2; i++) { mean[i] = 2*meanmean1/anzVar; mean[i+anzVar/2] = 2*meanmean2/anzVar;}
			twollIndependent2 = twollEvaluate(anzPer, model.xsum, model.xBiSum, matrix, mean, false);
		}
	
//		System.out.println("Value for initial value: "+initialValue);
//		System.out.println("Value for computed value: "+endValue);
//		System.out.println("Inner Steps = "+innersteps);
		
		if (dist > EPS) 
		{
			System.out.println("I gave up convergence after "+runs+" trials. Last distance was "+dist+" > "+EPS+".");
			return null;
		}
		
		return xd;
	}
    
    /**
     * Incomplete
     * @param model
     * @param initialIn
     * @return
     */
    public double[] twollAproxLinearModelWithAttrition(LinearModel model, double[] initialIn)
    {
        final double VALUEBORDER = 1000000;
        final int MAXRUN = 50;
    
        final int anzPer = model.anzPer;
        final int anzFac = model.getAnzFac();
        final int anzVar = model.getAnzVar();
        final int anzPar = model.getAnzPar();
        final int anzMeanPar = model.getAnzMeanPar();
        final int anzVarPar = model.getAnzVarPar();
        final int anzErrPar = model.getAnzErrPar();
    
        double[] initial = initialIn;
        if (initial == null) initial = model.leastSquareAproxLinearModel();  
        double initialValue = -1.0, endValue = -1.0;
        
        // Evaluation of sigmaDev. SigmaDevDev und muDevDev sind berall null.
        // Die Ableitungen sind an allen Stellen nur noch Zahlen.
        double[][][] sigmaDev = model.evaluateSigmaDev();
        double[][] muDev = model.evaluateMuDev();
//      for(int i=0; i<anzPar; i++)
//      {
//          System.out.println("SigmaDev parameter "+i+" = \r\n"+Statik.matrixToString(sigmaDev[i]));
//          System.out.println("MuDev parameter "+i+" = "+Statik.matrixToString(muDev[i]));
//      }
        
        double dist = 1.0;
        int runs = 0;
    
        double[] xd = new double[anzPar];
        for (int i=0; i<anzPar; i++) xd[i] = initial[i];
        
        double[][] sigD = model.evaluateSigma(xd);
        double[] muD = model.evaluateMu(xd);
//      boolean factorsPositiveDefinite = model.factorPositiveDefinite(xd);
        double value = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
        if (value > RESTRICTEDAREABORDER)
        {
//          System.out.println("Least Squares is bad, I try to improve...");
            int tries = 0;
            while ((value > RESTRICTEDAREABORDER) && (tries < 10))
            {
                model.raiseVarianceParameters(xd);
                sigD = model.evaluateSigma(xd);
                muD = model.evaluateMu(xd);
//              factorsPositiveDefinite = model.factorPositiveDefinite(xd);
                value = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
                tries++;
            }
        }
    
        double[] zero = new double[anzPar];
        // for later use
        double[][] sigMoveD = new double[anzVar][anzVar];
        double[] muMoveD = new double[anzVar];
        double[][] sigNullParameter = Statik.multiply(-1,model.evaluateSigma(zero));
        double[] muNullParameter = Statik.multiply(-1,model.evaluateMu(zero));
        double[][] factorNullParameter = Statik.multiply(-1,model.evaluateFactorMatrix(zero));
        double[][] sigMInvD = new double[anzVar][anzVar];
        double[][] factorMatrix = new double[anzFac][anzFac];
        double[][] factorMatrixMove = new double[anzFac][anzFac];
        double[][] mat1 = new double[anzVar][anzVar];   // Arbeitsplatz fr Matrixinvertierung
        double[][] mat2 = new double[anzVar][anzVar];           // Zwischenspeicher
        double[][] mat3 = new double[anzPar][anzPar];           // Zwischenspeicher
        double[][][] sigMInvSigDevD = new double[anzPar-anzMeanPar][anzVar][anzVar];
        double[][][] sigMInvSigDevDSigMInv = new double[anzPar-anzMeanPar][anzVar][anzVar];
        double[] posD = new double[anzPar];
        double[][] jacobian = new double[anzPar][anzPar];
        double[][] jinv = new double[anzPar][anzPar]; 
        double[] move = new double[anzPar];
        int innersteps = 0;
        while ((runs < MAXRUN) && (dist > EPS))
        {
            Statik.invert(sigD, sigMInvD, mat1);
    
            // Vorbereiten von sigMInv * sigDev und sigMInv * sigDev * sigMInv fr alle Parameter ber anzMeanPar:
            for (int i=anzMeanPar; i<anzPar; i++)
            {
                Statik.multiply(sigMInvD, sigmaDev[i], sigMInvSigDevD[i-anzMeanPar]);
                Statik.multiply(sigMInvSigDevD[i-anzMeanPar], sigMInvD, sigMInvSigDevDSigMInv[i-anzMeanPar]);
            }
    
            // Aufbau des Ableitungs-Vektors; zunchst die Means:
            for (int i=0; i<anzMeanPar; i++)
            {
                posD[i] = 0.0;
                for (int j=0; j<anzVar; j++)
                    for (int k=0; k<anzVar; k++) posD[i] -= 2.0* muDev[i][j]*sigMInvD[j][k]*(model.xsum[k]-anzPer*muD[k]);
            }
            // Aufbau des Ableitungs-Vektors, jetzt die Varianzen:
            for (int i=anzMeanPar; i<anzPar; i++)
            {
                double spur = 0.0;
                for (int j=0; j<anzVar; j++) spur += sigMInvSigDevD[i-anzMeanPar][j][j];
                posD[i] = (spur*(double)anzPer);
    
                double sum = 0.0;
                for (int j=0; j<anzVar; j++)
                    for (int k=0; k<anzVar; k++)
                        sum += (model.xBiSum[j][k] + anzPer * muD[j] * muD[k] - model.xsum[j] * muD[k] - model.xsum[k] * muD[j]) * sigMInvSigDevDSigMInv[i-anzMeanPar][j][k];
    
                posD[i] -= sum;
            }
                
            // Aufbau der Jacobi-Matrix, zunchst Mittelwert - Mittelwert
            for (int i=0; i<anzMeanPar; i++)
                for (int j=i; j<anzMeanPar; j++)
                {
                    double sum = 0.0;
                    for (int k=0; k<anzVar; k++)
                        for (int l=0; l<anzVar; l++)
                            sum += sigMInvD[k][l] * muDev[i][k] * muDev[j][l];
                    jacobian[i][j] = jacobian[j][i] = 2*anzPer*sum;
                    model.fisherInformationMatrix[i][j] = model.fisherInformationMatrix[j][i] = 2*anzPer*sum; 
                }
            // jetzt Mittelwert - Varianz
            for (int i=0; i<anzMeanPar; i++)
                for (int j=anzMeanPar; j<anzPar; j++)
                {
                    double sum = 0.0;
                    for (int k=0; k<anzVar; k++)
                        for (int l=0; l<anzVar; l++)
                            sum += sigMInvSigDevDSigMInv[j-anzMeanPar][k][l] * muDev[i][k] * (model.xsum[l] - anzPer*muD[l]);
                    jacobian[i][j] = jacobian[j][i] = 2*sum;
                    model.fisherInformationMatrix[i][j] = model.fisherInformationMatrix[j][i] = 0.0; 
                }
            // und jetzt Varianz - Varianz
            for (int i=anzMeanPar; i<anzPar; i++)
                for (int j=i; j<anzPar; j++)
                {
                    Statik.multiply(sigMInvSigDevD[i-anzMeanPar],sigMInvSigDevD[j-anzMeanPar], mat1);
    
                    double spur = 0.0;
                    for (int k=0; k<anzVar; k++) spur += mat1[k][k];
                    model.fisherInformationMatrix[i][j] = model.fisherInformationMatrix[j][i] = (double)anzPer * spur / 2.0; 
    
                    Statik.multiply(mat1, sigMInvD, mat2);
    
                    double sum = 0.0;
                    for (int k=0; k<anzVar; k++)
                        for (int l=0; l<anzVar; l++)
                            sum += (model.xBiSum[k][l] + anzPer * muD[k] * muD[l] - model.xsum[k] * muD[l] - model.xsum[l] * muD[k]) * mat2[k][l];
    
                    jacobian[i][j] = jacobian[j][i] = -(spur*(double)anzPer) + 2*sum;
                }

            Statik.invert(jacobian, jinv, mat3);
            for (int i=0; i<anzPar; i++)
            {
                move[i] = 0.0;
                for (int j=0; j<anzPar; j++) move[i] -= jinv[i][j] * posD[j];
            }
    
            // Evaluation of Sigma with move Parameter
            model.evaluateSigma(move, sigMoveD);
            model.evaluateMu(move, muMoveD);
            model.evaluateFactorMatrix(move, factorMatrix);
            sigMoveD = Statik.add(sigMoveD, sigNullParameter);
            muMoveD = Statik.add(muMoveD, muNullParameter);
            factorMatrixMove = Statik.add(factorMatrix, factorNullParameter);
    
//          System.out.println("\r\nJ^-1       = \r\n"+Statik.matrixToString(jinv));
//          System.out.println("\r\nSigma Move = \r\n"+Statik.matrixToString(sigMoveD));
//          System.out.println("\r\nMu Move    = \r\n"+Statik.matrixToString(muD));
    
            double diff = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
            if (runs==0) initialValue = diff;
//          System.out.print("Position "+runs+": ");
//          for (int i=0; i<xd.length; i++) System.out.print(xd[i]+",");
//          System.out.print(" Wert = "+diff);
    
            double lambda = twollInnerIteration(anzPer, model.xsum, model.xBiSum, sigD, muD, factorMatrix, sigMoveD, muMoveD, factorMatrixMove);
            innersteps += twollInnerSteps;
    
//          System.out.println(", Lambda = "+lambda);
            
//          System.out.println("Numerical move = "+Statik.matrixToString(Statik.multiply(-1,Statik.multiply(Statik.invert(numJacobian),numGradient))));
//          System.out.println("Proposed  move = "+Statik.matrixToString(move));
    
            for (int i=0; i<anzPar; i++) xd[i] += move[i] * lambda;
            for (int i=0; i<anzVar; i++)
            {
                muD[i] += lambda * muMoveD[i];
                for (int j=0; j<anzVar; j++)
                    sigD[i][j] += lambda * sigMoveD[i][j];
            }

//          factorsPositiveDefinite = model.factorPositiveDefinite(xd);
            endValue = twollEvaluate(anzPer, model.xsum, model.xBiSum, sigD, muD, false);
            diff = Math.abs(diff - endValue);
    
            dist = 0.0;
            for (int i=0; i<anzPar; i++) dist += move[i]*move[i];
            dist = Math.sqrt(dist) * Math.abs(lambda);
            dist = Math.max(Math.abs(diff),dist);               // Abbruchkriterium beide Schrittweiten klein.
            
            runs++;
        }
        
        // statische Variable
        twollAdaptionSteps = runs;
        twollInnerSteps = innersteps;
        twollStartValue = initialValue;
        twollValue = endValue;
        if (model.anzPer > 1)
        {
            double[][] matrix = Statik.copy(model.dataCov);
            double[] mean = Statik.copy(model.dataMean);
            twollComplete = twollEvaluate(anzPer, model.xsum, model.xBiSum, matrix, mean, false);
            for (int i=0; i<anzVar; i++)
                for (int j=0; j<anzVar; j++) if (i!=j) matrix[i][j] = 0.0;
            twollIndependent1 = twollEvaluate(anzPer, model.xsum, model.xBiSum, matrix, mean, false);
            double meanmean1 = 0.0, meanmean2 = 0.0;
            for (int i=0; i<anzVar/2; i++) { meanmean1 += mean[i]; meanmean2 += mean[i+anzVar/2];}
            for (int i=0; i<anzVar/2; i++) { mean[i] = 2*meanmean1/anzVar; mean[i+anzVar/2] = 2*meanmean2/anzVar;}
            twollIndependent2 = twollEvaluate(anzPer, model.xsum, model.xBiSum, matrix, mean, false);
        }
    
//      System.out.println("Value for initial value: "+initialValue);
//      System.out.println("Value for computed value: "+endValue);
//      System.out.println("Inner Steps = "+innersteps);
        
        if (dist > EPS) 
        {
            System.out.println("I gave up convergence after "+runs+" trials. Last distance was "+dist+" > "+EPS+".");
            return null;
        }
        
        return xd;
    }

    /**
	 * Schneidet die Suchebene entlang des Gradienten und findet per Intervallhalbierung die optimale Dmpfung des Newtonverfahrens, unter Bercksichtigung
	 * der Unterscheidung von Mini- und Maxima und der verbotenen Bereiche.
	 * 
	 * @param anzPer		Anzahl Personen
	 * @param xsum			Aufaddierte Daten
	 * @param xBiSum		Aufaddierte Produkte der Daten
	 * @param sigmaPar		Sigma an der momenatanen Position
	 * @param muPar			Mu an der momentanen Position
	 * @param sigmaGradient	Sigma-nderung entlang des Gradientens
	 * @param muGradient	Mu-nderung entlang des Gradientens
	 * @return				Optimale Dmpfung des Newtonverfahrens
	 * 
	 */
	public double twollInnerIteration(int anzPer, double[] xsum, double[][] xBiSum, double[][] sigmaPar, double[] muPar, 
	        double[][] facMatrix, double[][] sigmaGradient, double[] muGradient, double[][] facMatrixGradient)
	{
		double RESTRICTEDAREABORDER = 50000000.0;;

		double erg = twollInnerIterationZeroPossible(anzPer, xsum, xBiSum, sigmaPar, muPar, facMatrix, sigmaGradient, muGradient, facMatrixGradient);
		if (erg!=0) return erg;
		
//		System.out.println("Best idea was lambda = 0.0     ******************");
		erg = 1.0;
		double zeroValue = twollEvaluate(anzPer, xsum, xBiSum, sigmaPar, muPar, false);
		double value = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, erg, sigmaGradient), 
		        Statik.vectorLC(muPar, erg, muGradient), false);
		while (value > zeroValue)
		{
			erg /= 2;
			if (erg < EPS) return 0.0;
			value = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, erg, sigmaGradient), 
			        Statik.vectorLC(muPar, erg, muGradient), false);
		}
		return erg;	
	}

	private double twollInnerIterationZeroPossible(int anzPer, double[] xsum, double[][] xBiSum, double[][] sigmaPar, 
	        double[] muPar, double[][] facMatrix, double[][] sigmaGradient, double[] muGradient, double[][] facMatrixGradient)
	{
		int MAXSTEPS = 60;
//		double RESTRICTEDAREABORDER = 50000000.0;
		
		int stepcount = 3;
		double[] value = new double[3];
		double[] lambda = new double[3];

		value[0] = twollEvaluate(anzPer, xsum, xBiSum, sigmaPar, muPar, false);
		value[1] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, 1.0, sigmaGradient), 
		        Statik.vectorLC(muPar, 1.0, muGradient), false);
		value[2] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, 2.0, sigmaGradient), 
		        Statik.vectorLC(muPar, 2.0, muGradient), false);
		lambda[0] = 0.0;
		lambda[1] = 1.0;
		lambda[2] = 2.0;
		double bestguess = 0, bgval = value[0]; 
		if (value[1]<bgval) {bgval = value[1]; bestguess = lambda[1];}
		if (value[2]<bgval) {bgval = value[2]; bestguess = lambda[2];}
		
		// lambda_1 ist nicht legal
		if (value[1] > RESTRICTEDAREABORDER)
		{
		    double stepwidth = 1.0;
		    while ((value[0] >= RESTRICTEDAREABORDER) && ((value[2] >= RESTRICTEDAREABORDER)))
		    {
		        lambda[0] -= stepwidth; lambda[2] += stepwidth;
				value[0] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[0], sigmaGradient), 
				        Statik.vectorLC(muPar, lambda[0], muGradient), false);
				value[2] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[2], sigmaGradient), 
				        Statik.vectorLC(muPar, lambda[2], muGradient), false);
				stepwidth *= 1.2; stepcount += 2;
				if (stepcount > MAXSTEPS){
				    twollInnerSteps = MAXSTEPS;
				    return 0.0;
				}
		    }
		    if (value[0] < RESTRICTEDAREABORDER) {lambda[2] = lambda[0]+1; lambda[1] = lambda[0]; lambda[0] = lambda[0]-1;}
		    if (value[2] < RESTRICTEDAREABORDER) {lambda[0] = lambda[2]-1; lambda[1] = lambda[2]; lambda[2] = lambda[2]+1;}
			value[0] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[0], sigmaGradient), 
			        Statik.vectorLC(muPar, lambda[0], muGradient), false);
			value[1] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[1], sigmaGradient), 
			        Statik.vectorLC(muPar, lambda[1], muGradient), false);
			value[2] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[2], sigmaGradient), 
			        Statik.vectorLC(muPar, lambda[2], muGradient), false);
			if (value[0] < bgval) {bgval = value[0]; bestguess = lambda[0];}
			if (value[1] < bgval) {bgval = value[1]; bestguess = lambda[1];}
			if (value[2] < bgval) {bgval = value[2]; bestguess = lambda[2];}
			stepcount += 3;
		}
		
		// lambda_1 ist maximum
		while ((value[1] > value[0]) && (value[1] > value[2]))
		{
		    if (value[0] < value[2])
		    {
		        lambda[2] = lambda[1]; value[2] = value[1]; 
		        lambda[1] = (lambda[1]+lambda[0])/2.0; 
		    } else {
		        lambda[0] = lambda[1]; value[0] = value[1]; 
		        lambda[1] = (lambda[1]+lambda[2])/2.0; 
		    }
			value[1] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[1], sigmaGradient), 
			        Statik.vectorLC(muPar, lambda[1], muGradient), false);
			stepcount++;
			if (value[1] < bgval) {bgval = value[1]; bestguess = lambda[1];}
			if (stepcount > MAXSTEPS){
			    twollInnerSteps = MAXSTEPS;
			    return bestguess;
			}
		}
		
		// lambda_1 ist mittlerer Wert
		double stepwidth = Math.min(lambda[2]-lambda[1],lambda[1]-lambda[0]);
		int richtung = 0;
		if ((value[2] > value[1]) && (value[1] > value[0])) richtung = -1;
		if ((value[2] < value[1]) && (value[1] < value[0])) richtung = 1;
		while (richtung != 0)
		{
		    if (richtung == -1)
		    {
		        lambda[2] = lambda[1]; value[2] = value[1]; 
		        lambda[1] = lambda[0]; value[1] = value[0]; 
		        lambda[0] -= stepwidth; 
				value[0] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[0], sigmaGradient), 
				        Statik.vectorLC(muPar, lambda[0], muGradient), false);
				if (value[0] < bgval) {bgval = value[0]; bestguess = lambda[0];}
		    } else {
		        lambda[0] = lambda[1]; value[0] = value[1]; 
		        lambda[1] = lambda[2]; value[1] = value[2]; 
		        lambda[2] += stepwidth; 
				value[2] = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, lambda[2], sigmaGradient), 
				        Statik.vectorLC(muPar, lambda[2], muGradient), false);
				if (value[2] < bgval) {bgval = value[2]; bestguess = lambda[2];}
		    }
			stepcount++;
			if (stepcount > MAXSTEPS){
			    twollInnerSteps = MAXSTEPS;
			    return bestguess;
			}
			stepwidth *= 1.5;
			richtung = 0;
			if ((value[2] > value[1]) && (value[1] > value[0])) richtung = -1;
			if ((value[2] < value[1]) && (value[1] < value[0])) richtung = 1;
		}
		
		double nl, nv;
		// lambda_1 ist kleinster Wert
		while ( ((value[2]-value[1]>EPS) || (value[0]-value[1]>EPS)) && ((lambda[2]-lambda[1]>EPS) || (lambda[1]-lambda[0]>EPS)))
		{
		    if (value[0] < value[2])
		    {
		        nl = (lambda[1]+lambda[2])/2.0; 
		        nv = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, nl, sigmaGradient), 
		                Statik.vectorLC(muPar, nl, muGradient), false);
		        if (nv > value[1]) {lambda[2] = nl; value[2] = nv;} 
		        else 			   {lambda[0] = lambda[1]; value[0] = value[1]; lambda[1] = nl; value[1] = nv;}
		    } else {
		        nl = (lambda[1]+lambda[0])/2.0; 
		        nv = twollEvaluate(anzPer, xsum, xBiSum, Statik.matrixLC(sigmaPar, nl, sigmaGradient), 
		                Statik.vectorLC(muPar, nl, muGradient), false);
		        if (nv > value[1]) {lambda[0] = nl; value[0] = nv;} 
		        else 			   {lambda[2] = lambda[1]; value[2] = value[1]; lambda[1] = nl; value[1] = nv;}
		    }
	        if (nv < bgval) {bgval = nv; bestguess = nl;}
			stepcount++;
			if (stepcount > MAXSTEPS) return bestguess;
		}
		twollInnerSteps = stepcount;
		return bestguess;
	}
	
	// Beide Modelle werden mit den richtigen Parametern erwartet.
	public double sarrisSatoraPower(LinearModel nestedModel, LinearModel fullModel)
	{
	    int df = fullModel.anzPar - nestedModel.anzPar;
	    double[][] dataCorrelationMatrix = fullModel.evaluateSigma();
	    double[] initial = nestedModel.getNoMeanParameters();
	    twollAproxLinearModelTwoMatrixCompare(nestedModel, dataCorrelationMatrix, initial);
 		double noncentrality = fullModel.anzPer * twollValue;
		if (noncentrality<-0.01)
			System.out.println("Warning: Noncentrality is negative: "+noncentrality);
		if (noncentrality<0.0) noncentrality = 0.0;
// 		System.out.println("NCP = "+noncentrality);
		double power = Statik.chiSquareDensity(df, noncentrality, Statik.FIVEPERCENTTHRESHOLD[df-1]);
		return power;
	}
	
	
	// Ignoriert means
	public double[] twollAproxLinearModelTwoMatrixCompare(LinearModel model, double[][] dataMatrix, double[] initialIn) 
	{
	    final double VALUEBORDER = 1000000;
		final int MAXRUN = 50;
	
		final int anzPer = model.anzPer;
		final int anzFac = model.getAnzFac();
		final int anzVar = model.getAnzVar();
		final int anzPar = model.getAnzPar();
		final int anzMeanPar = model.getAnzMeanPar();
		final int anzVarPar = model.getAnzVarPar();
		final int anzErrPar = model.getAnzErrPar();
	
		double[] initial = initialIn;
		double initialValue = -1.0, endValue = -1.0;
		
		// Evaluation of sigmaDev. SigmaDevDev und muDevDev sind berall null.
		// Die Ableitungen sind an allen Stellen nur noch Zahlen.
		double[][][] sigmaDev = model.evaluateSigmaDev();
		double[][] muDev = model.evaluateMuDev();
//		for(int i=0; i<anzPar; i++)
//		{
//		    System.out.println("SigmaDev parameter "+i+" = \r\n"+Statik.matrixToString(sigmaDev[i]));
//			System.out.println("MuDev parameter "+i+" = "+Statik.matrixToString(muDev[i]));
//		}
		
		double dist = 1.0;
		int runs = 0;
	
		double[] xd = new double[anzVarPar + anzErrPar];
		for (int i=0; i<anzVarPar + anzErrPar; i++) xd[i] = initial[i];
		
		double[][] sigD = model.evaluateSigma(xd,true);
	
//		System.out.println("\r\nSigma = \r\n"+Statik.matrixToString(sigD));
//		System.out.println("\r\nMu    = \r\n"+Statik.matrixToString(muD));

		double[] zero = new double[anzVarPar + anzErrPar];
		// for later use
		double[][] sigMoveD = new double[anzVar][anzVar];
		double[][] sigNullParameter = Statik.multiply(-1,model.evaluateSigma(zero,true));
		double[][] sigMInvD = new double[anzVar][anzVar];
		double[][] mat1 = new double[anzVar][anzVar];	// Arbeitsplatz fr Matrixinvertierung
		double[][] mat2 = new double[anzVar][anzVar];			// Zwischenspeicher
		double[][] mat3 = new double[anzVarPar + anzErrPar][anzVarPar + anzErrPar];			// Zwischenspeicher
		double[][][] sigMInvSigDevD = new double[anzPar-anzMeanPar][anzVar][anzVar];
		double[][][] sigMInvSigDevDSigMInv = new double[anzPar-anzMeanPar][anzVar][anzVar];
		double[][][] dataMatrixSigMInvSigDevDSigMInv = new double[anzPar-anzMeanPar][anzVar][anzVar];
		double[] posD = new double[anzVarPar + anzErrPar];
		double[][] jacobian = new double[anzVarPar + anzErrPar][anzVarPar + anzErrPar];
		double[][] jinv = new double[anzVarPar + anzErrPar][anzVarPar + anzErrPar]; 
		double[] move = new double[anzVarPar + anzErrPar];
		int innersteps = 0;
		while ((runs < MAXRUN) && (dist > EPS))
		{
			Statik.invert(sigD, sigMInvD, mat1);
	
			// Vorbereiten von sigMInv * sigDev und sigMInv * sigDev * sigMInv fr alle Parameter ber anzMeanPar:
			for (int i=anzMeanPar; i<anzPar; i++)
			{
				Statik.multiply(sigMInvD, sigmaDev[i], sigMInvSigDevD[i-anzMeanPar]);
				Statik.multiply(sigMInvSigDevD[i-anzMeanPar], sigMInvD, sigMInvSigDevDSigMInv[i-anzMeanPar]);
				Statik.multiply(dataMatrix, sigMInvSigDevDSigMInv[i-anzMeanPar], dataMatrixSigMInvSigDevDSigMInv[i-anzMeanPar]);
			}
	
			// Aufbau des Ableitungs-Vektors, jetzt die Varianzen:
			for (int i=anzMeanPar; i<anzPar; i++)
			{
				double spur = 0.0;
				for (int j=0; j<anzVar; j++) spur += sigMInvSigDevD[i-anzMeanPar][j][j]-dataMatrixSigMInvSigDevDSigMInv[i-anzMeanPar][j][j];;
				posD[i-anzMeanPar] = spur;
			}
				
			// und jetzt Varianz - Varianz
			for (int i=anzMeanPar; i<anzPar; i++)
				for (int j=i; j<anzPar; j++)
				{
					Statik.multiply(sigMInvSigDevD[i-anzMeanPar],sigMInvSigDevD[j-anzMeanPar], mat1);
	
					double spur = 0.0;
					for (int k=0; k<anzVar; k++) spur -= mat1[k][k];
	
					Statik.multiply(dataMatrix, mat1, mat2);
					Statik.multiply(mat2, sigMInvD, mat1);
	
					for (int k=0; k<anzVar; k++) spur += 2*mat1[k][k];
					jacobian[i-anzMeanPar][j-anzMeanPar] = jacobian[j-anzMeanPar][i-anzMeanPar] = spur;
				}

			Statik.invert(jacobian, jinv, mat3);
			for (int i=0; i<anzVarPar+anzErrPar; i++)
			{
				move[i] = 0.0;
				for (int j=0; j<anzVarPar+anzErrPar; j++) move[i] -= jinv[i][j] * posD[j];
			}
	
			// Evaluation of Sigma with move Parameter
			model.evaluateSigma(move, sigMoveD, true);
			sigMoveD = Statik.add(sigMoveD, sigNullParameter);
	
			double diff = twollMatrixCompareEvaluate(dataMatrix, sigD);
			if (runs==0) initialValue = diff;
	
			double lambda = twollMatrixCompareInnerIteration(dataMatrix, sigD, sigMoveD);
			innersteps += twollInnerSteps;
	
			for (int i=0; i<anzVarPar+anzErrPar; i++) xd[i] += move[i] * lambda;
			for (int i=0; i<anzVar; i++)
			{
				for (int j=0; j<anzVar; j++)
					sigD[i][j] += lambda * sigMoveD[i][j];
			}
	
			endValue = twollMatrixCompareEvaluate(dataMatrix, sigD);
			diff = Math.abs(diff - endValue);
	
			dist = 0.0;
			for (int i=0; i<anzVarPar + anzErrPar; i++) dist += move[i]*move[i];
			dist = Math.sqrt(dist) * Math.abs(lambda);
			dist = Math.max(Math.abs(diff),dist);				// Abbruchkriterium beide Schrittweiten klein.
			
			runs++;
		}
		
		// statische Variable
		twollAdaptionSteps = runs;
		twollInnerSteps = innersteps;
		twollStartValue = initialValue;
		twollValue = endValue;
		
		if (dist > EPS) 
		{
			System.out.println("I gave up convergence after "+runs+" trials. Last distance was "+dist+" > "+EPS+".");
			return null;
		}
		
		return xd;
	}

	public static double twollMatrixCompareEvaluate(double[][] dataMatrix, double[][] sigD)
	{
		final int anzVar = dataMatrix.length;
		final double PENALTY = 100000000.0;

		double[][] sigMInvD = Statik.invert(sigD);

		double dSigma = Statik.determinantOfPositiveDefiniteMatrix(sigD);
		double dData = Statik.determinantOfPositiveDefiniteMatrix(dataMatrix);
		
		double value;
		if ((dSigma > 0.0) && (dData > 0.0)) value = Math.log(Math.abs(dSigma))-Math.log(Math.abs(dData));
		else value = PENALTY;							    

		// Berechnung von Spur (dataMatrix * sigMInvD)
		for (int i=0; i<anzVar; i++)
			for (int j=0; j<anzVar; j++) value += dataMatrix[i][j]*sigMInvD[j][i];
		value -= anzVar;
		
		return value;
	}

	public static double twollMatrixCompareInnerIteration(double[][] dataMatrix, double[][] sigmaPar, double[][] sigmaGradient)
	{
		double EPS = 0.01;
		double RESTRICTEDAREABORDER = 500000;

		double erg = twollMatrixCompareInnerIterationZeroPossible(dataMatrix, sigmaPar, sigmaGradient);
		if (erg!=0) return erg;
		
//		System.out.print(" *!!!* ");
		
		erg = 1.0;
		double zeroValue = twollMatrixCompareEvaluate(dataMatrix, sigmaPar);
		double value = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, erg, sigmaGradient));
		while (value > zeroValue)
		{
			erg /= 2;
			if (erg < EPS) return 0.0;
			value = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, erg, sigmaGradient));
		}
		return erg;	
	}
	/**
	 * Creation date: (29.03.2003 17:42:40)

	 	Versucht linear bzgl. des Gradienten das naheste Minimum zu par zu finden.
	 	berarbeitete Version. 
	 */
	private static double twollMatrixCompareInnerIterationZeroPossible(double[][] dataMatrix, double[][] sigmaPar, double[][] sigmaGradient)
	{
		double EPS = 0.01;
		int MAXSTEPS = 60;
		double RESTRICTEDAREABORDER = 500000;
		
		double[] values = new double[3];
		double[] lambdas = new double[3];

		values[0] = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, -1.0, sigmaGradient));
		values[1] = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, 0.0, sigmaGradient));
		values[2] = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, 1.0, sigmaGradient));
		lambdas[0] = -1.0;
		lambdas[1] = 0.0;
		lambdas[2] = 1.0;

		// herausholen aus dem restricted Bereich
		while (values[0]>=RESTRICTEDAREABORDER) {lambdas[0] /= 2; values[0] = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, lambdas[0], sigmaGradient));}
		while (values[2]>=RESTRICTEDAREABORDER) {lambdas[2] /= 2; values[2] = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, lambdas[2], sigmaGradient));}

		double bestguess = 0.0;	double bestguessV = values[1];
		if (values[0] < bestguessV) {bestguess = lambdas[0]; bestguessV = values[0];}
		if (values[2] < bestguessV) {bestguess = lambdas[2]; bestguessV = values[2];}

		int steps = 0;
		if ((values[0]<values[1]) || (values[2]<values[1]))
		{
			double stepwidth = 1.0;
			// Falls richtige Richtung nach kleineren Lambdas, werden die Lambdas hier vertauscht, so dass danach
			// lambda[2] in Schrittrichtung vor lambda[0] liegt.
			if (values[2]>values[1])
			{
				double t = lambdas[0]; lambdas[0] = lambdas[2]; lambdas[2] = t;
				t = values[0]; values[0] = values[2]; values[2] = t;
				stepwidth = -1.0;
			}
			
			// jetzt wird in Richtung von stepwidth gewandert, bis der mittlere Wert minimal ist.
			while (values[2] < values[1])
			{
				lambdas[0] = lambdas[1]; values[0] = values[1];
				lambdas[1] = lambdas[2]; values[1] = values[2];
				lambdas[2] = lambdas[1]+stepwidth; values[2] = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, lambdas[2], sigmaGradient));
				while (values[2]>=RESTRICTEDAREABORDER) 
				{
					stepwidth /= 2;
					lambdas[2] = lambdas[1] + stepwidth; 
					values[2] = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, lambdas[2], sigmaGradient));
				}
				if (values[2] < bestguessV) {bestguess = lambdas[2]; bestguessV = values[2];}

				if (steps > MAXSTEPS) {/*twollInnerSteps = steps; */return bestguess;}
				steps++;
			}
		}

		// schnell wieder zurcksortiere...
		if (lambdas[2]<lambdas[2])
		{
			double t = lambdas[0]; lambdas[0] = lambdas[2]; lambdas[2] = t;
			t = values[0]; values[0] = values[2]; values[2] = t;
		}
		
		while ( ((values[2]-values[1]>EPS) || (values[0]-values[1]>EPS)) && ((lambdas[2]-lambdas[1]>EPS) || (lambdas[1]-lambdas[0]>EPS)))
		{
			steps++;
			int groesserer = 0; if (values[2] > values[0]) groesserer = 2;
			double lneu = (lambdas[1]+lambdas[groesserer])/2;
			double vneu = twollMatrixCompareEvaluate(dataMatrix, Statik.matrixLC(sigmaPar, lneu, sigmaGradient));
			if (vneu < values[1]) 
			{
				if (groesserer == 0) {lambdas[2] = lambdas[1]; values[2] = values[1];
									 lambdas[1] = lneu; values[1] = vneu; }
				else 				{lambdas[0] = lambdas[1]; values[0] = values[1]; 
									 lambdas[1] = lneu; values[1] = vneu; }
			} else {
				lambdas[groesserer] = lneu; values[groesserer] = vneu; 
			}
		}
//		twollInnerSteps = steps;
		if ((lambdas[1]>62.0) && (lambdas[1]<64.0)) System.out.println("\r\nI'm going to return lambdas[1] (in end)= "+lambdas[1]);
		if (values[1]<bestguessV) {if ((lambdas[1]>62.0) && (lambdas[1]<64.0)) System.out.println("\r\nI'm going to return lambdas[1] (in end)= "+lambdas[1]); return lambdas[1];}
		else {if ((bestguess>62.0) && (bestguess<64.0)) System.out.println("\r\nI'm going to return bestguess (in end)= "+bestguess); return bestguess;}
	}
	
	public static double llValue2LGCMWithAttrition(double[][] dataComplete, double[] dataMiss1, double[][] cov, double[] err)
	{
        double[][] mom = new double[2][2], hessian = new double[2][2], hessInv = new double[2][2]; 
        int N1 = dataComplete.length, N2 = dataMiss1.length; 
        for (int i=0; i<2; i++) for (int j=0; j<2; j++) for (int k=0; k<N1; k++) mom[i][j] += dataComplete[k][i]*dataComplete[k][j];
        double datVar2 = 0; for (int k=0; k<N2; k++) datVar2 += dataMiss1[k]*dataMiss1[k];
        double s00 = (cov[0][0]+err[0]), s01 = (cov[0][0] + cov[1][0]), s11 = cov[0][0]+ 2*cov[0][1] + cov[1][1] + err[1]; // sNachS = 0,0,1, sNachC = 0,1,2
        double det = s00*s11-s01*s01, detdS = s00, detdC = 2*s00 - 2*s01;
	    
        double ll = N1*Math.log(det) + (s11*mom[0][0]-2*s01*mom[0][1]+s00*mom[1][1])/det + N2*Math.log(s11) + (datVar2)/s11;
        
        return ll;
	}
	/**
	 * optimizes variance and covariance of slope in a 2-occ-LGCM with missing data (quick implementation). cov has starting value for the 
	 * optimized value and will have the result afterwards.
	 * 
	 * @param dataComplete
	 * @param dataPureIntercept
	 * @param dataBoth
	 * @param cov
	 */
	public static boolean optimize2LGCMWithAttrition(double[][] dataComplete, double[] dataMiss1, double[][] cov, double[] err, double eps)
	{
	    try{
    	    final int MAXITER = 30;
    	    double[][] work = new double[2][2]; double[] move = new double[2];
    	    double[][] mom = new double[2][2], hessian = new double[2][2], hessInv = new double[2][2]; 
    	    int N1 = dataComplete.length, N2 = dataMiss1.length; 
    	    for (int i=0; i<2; i++) for (int j=0; j<2; j++) for (int k=0; k<N1; k++) mom[i][j] += dataComplete[k][i]*dataComplete[k][j];
    	    double datVar2 = 0; for (int k=0; k<N2; k++) datVar2 += dataMiss1[k]*dataMiss1[k];
    	    
    	    double[] gradient = new double[2]; double absMove = Double.MAX_VALUE;
    	    int iter = 0;
    	    while ((iter < MAXITER) && (absMove > eps))
    	    {
    	        double s00 = (cov[0][0]+err[0]), s01 = (cov[0][0] + cov[1][0]), s11 = cov[0][0]+ 2*cov[0][1] + cov[1][1] + err[1]; // sNachS = 0,0,1, sNachC = 0,1,2
    	        double det = s00*s11-s01*s01, detdS = s00, detdC = 2*s00 - 2*s01;
    	        
    	        double lok1 =   N1*detdS*det              - s01*s01*mom[0][0]        + 2*s01*s00*mom[0][1]                     - s00*s00*mom[1][1], 
    	               lok2 =   N1*detdC*det              - 2*s01*(s01-s11)*mom[0][0]- 2*(s01*s01+s00*s11-2*s01*s00)*mom[0][1] - 2*s00*(s00-s01)*mom[1][1],
                       lok1DS = N1*detdS*detdS, 
                       lok1DC = N1*detdS*detdC            - 2*s01*mom[0][0]          + 2*s00*mom[0][1],
    	               lok2DS = N1*detdC*detdS            + 2*s01*mom[0][0]          - 2*s00*mom[0][1],
    	               lok2DC = N1*detdC*detdC - 2*N1*det + 2*s11*mom[0][0]          - 4*s01*mom[0][1] + 2*s00*mom[1][1];
    	        // Ableitung von ll multiplizier det*det*s11*s11
    	        gradient[0] = lok1/(det*det) + (N2*s11 - datVar2)/(s11*s11); 
    	        gradient[1] = lok2/(det*det) + (2*N2*s11 - 2*datVar2)/(s11*s11);
    	        
    	        hessian[0][0] = (lok1DS*det-lok1*2*detdS)/(det*det*det) + (  N2*s11 - 2*(N2*s11 - datVar2))/(s11*s11*s11);
    	        hessian[0][1] = (lok1DC*det-lok1*2*detdC)/(det*det*det) + (2*N2*s11 - 4*(N2*s11 - datVar2))/(s11*s11*s11);
    	        hessian[1][0] = (lok2DS*det-lok2*2*detdS)/(det*det*det) + (2*N2*s11 - 2*(2*N2*s11 - 2*datVar2))/(s11*s11*s11);
    	        hessian[1][1] = (lok2DC*det-lok2*2*detdC)/(det*det*det) + (4*N2*s11 - 4*(2*N2*s11 - 2*datVar2))/(s11*s11*s11);
    	        
    	        /*
    //	        DEBUG
    	        //	        cov[1][1] += eps; 
    	        cov[0][1] += eps; cov[1][0] += eps;
    	        double[] gradient2 = new double[2]; double[][] hessian2 = new double[2][2];
    	        
                s00 = (cov[0][0]+err[0]); s01 = (cov[0][0] + cov[1][0]); s11 = cov[0][0]+ 2*cov[0][1] + cov[1][1] + err[1]; // sNachS = 0;0;1; sNachC = 0;1;2
                det = s00*s11-s01*s01; detdS = s00; detdC = 2*s00 - 2*s01;
                
                double ll2 = N1*Math.log(det) + (s11*mom[0][0]-2*s01*mom[0][1]+s00*mom[1][1])/det + N2*Math.log(s11) + (datVar2)/s11;
                
                       lok1 =   N1*detdS*det              - s01*s01*mom[0][0]        + 2*s01*s00*mom[0][1]                     - s00*s00*mom[1][1]; 
                       lok2 =   N1*detdC*det              - 2*s01*(s01-s11)*mom[0][0]- 2*(s01*s01+s00*s11-2*s01*s00)*mom[0][1] - 2*s00*(s00-s01)*mom[1][1];
                       lok1DS = N1*detdS*detdS;
                       lok1DC = N1*detdS*detdC            - 2*s01*mom[0][0]          + 2*s00*mom[0][1];
                       lok2DS = N1*detdC*detdS            + 2*s01*mom[0][0]          - 2*s00*mom[0][1];
                       lok2DC = N1*detdC*detdC - 2*N1*det + 2*s11*mom[0][0]          - 4*s01*mom[0][1] + 2*s00*mom[1][1];
                // Ableitung von ll multiplizier det*det*s11*s11
                gradient2[0] = lok1/(det*det) + (N2*s11 - datVar2)/(s11*s11); 
                gradient2[1] = lok2/(det*det) + (2*N2*s11 - 2*datVar2)/(s11*s11);
                
                hessian2[0][0] = (lok1DS*det-lok1*2*detdS)/(det*det*det) + (N2*s11 - 2*(N2*s11 - datVar2))/(s11*s11*s11);
                hessian2[0][1] = (lok1DC*det-lok1*2*detdC)/(det*det*det) + (2*N2*s11 - 4*(N2*s11 - datVar2))/(s11*s11*s11);
                hessian2[1][0] = (lok2DS*det-lok2*2*detdS)/(det*det*det) + (2*N2*s11 - 2*(2*N2*s11 - 2*datVar2))/(s11*s11*s11);
                hessian2[1][1] = (lok2DC*det-lok2*2*detdC)/(det*det*det) + (4*N2*s11 - 4*(2*N2*s11 - 2*datVar2))/(s11*s11*s11);
    
                ll2 = (ll2-ll) / eps;
                for (int i=0; i<2; i++) gradient2[i] = (gradient2[i] - gradient[i])/eps;
                for (int i=0; i<2; i++) for (int j=0; j<2; j++) hessian2[i][j] = (hessian2[i][j] - hessian[i][j])/eps;
                */
                Statik.invert(hessian, hessInv, work);
    	        Statik.multiply(hessInv, gradient, move);
    	        Statik.multiply((iter < 2?-0.6:(iter<4?-0.8:-1)),move, move);
    	        
    	        cov[1][1] += move[0]; cov[0][1] += move[1]; cov[1][0] += move[1];
    	        absMove = Statik.abs(move); iter++;
    	    }
    	    if (iter>=MAXITER) return false; else return true;
	    } catch (Exception e) {return false;}
	}
	
	public void manualLoop(int start, int end, int anzTrials, BufferedWriter psAll, BufferedWriter psPower, BufferedWriter psZeroVariance)
	{
	    
	    String erg = "";
	    
	    LinearModel[] fullModel = new LinearModel[6], 
	    			  covFixedModel = new LinearModel[6],
	    			  varFixedModel = new LinearModel[6];
        fullModel[0] = new LinearModel(
                new double[][]{  
                 {1,0.0},{1,0.05},{1,0.1},{1,0.15},{1,0.2},{1,0.25}
				,{1,0.3},{1,0.35},{1,0.4},{1,0.45},{1,0.5},{1,0.55}
				,{1,0.6},{1,0.65},{1,0.7},{1,0.75},{1,0.8},{1,0.85},{1,0.9},{1,0.95}},
                new double[][]{{100,0},{0,50}},
                new double[]{100,-20},
                new double[]{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10}
                );
        covFixedModel[0] = LinearModel.fixParameter(fullModel[0], 4);
        varFixedModel[0] = LinearModel.fixParameter(covFixedModel[0], 3);
        int anzVar = fullModel[0].anzVar;
        	
        int[][] datSelection = new int[][]{{0,2,4,6,8,10,12,14,16,18},{0,2,4,6,8,10},{0,2,4,6,8},{0,2,4,6},{0,2,4}};
        for (int i=1; i<6; i++) 
        {
            fullModel[i] = LinearModel.picDatapoints(fullModel[0],datSelection[i-1]);
            covFixedModel[i] = LinearModel.picDatapoints(covFixedModel[0],datSelection[i-1]);
            varFixedModel[i] = LinearModel.picDatapoints(varFixedModel[0],datSelection[i-1]);
        }
        
 //       int[]  bins = new int[200];

        int[] rejectCov = new int[6], rejectVar = new int[6], rejectVar1df = new int[6]; 
        int[] rejectVar3halfdf = new int[6], rejectVarOnesided = new int[6], rejectVar1dfOnesided = new int[6]; 
        int[] rejectCovWald = new int[6]; int[] rejectVarWald = new int[6];
        int[] rejectVarWaldOnesided = new int[6];
		int[] negativeVariance = new int[6];
        int[][] notRejectedBecauseOfNegativeVariance = new int[6][3]; 		// 3: 1 fr einseitigen Wald, 1 fr Varianz 2+1df, 2 fr Varianz 2+0df
		int haywood = 0;
        double[][] xsum = new double[datSelection.length+1][anzVar]; ;
        double[][][] xBiSum = new double[datSelection.length+1][anzVar][anzVar];
        double[] leastSquareEstimate = null, twollEstimate = null;
        double[] estimateMemory = new double[6];
        int runID = 0;
        long time;
        for (int cond = start; cond<=end; cond++)
        {
    		System.out.println("Starting condition "+cond);
    		time = System.currentTimeMillis();
    		int nr = cond;
    		
    		int covarsteiglevel = nr % 5; nr = nr/5;		// 3+10+40
    		int steigungsvarianz = nr % 2; nr = nr/2;
    		int fehler = nr % 4; nr = nr/4;
    		int sampelsize = nr % 4; nr = nr/4;					
    		
    		double svar = 50, cov = 0.0, err = 1;
    		if (steigungsvarianz==1) svar = 25;
    		if (covarsteiglevel==0) cov = -0.5 * Math.sqrt(100*svar);
    		if (covarsteiglevel==1) cov = -0.25 * Math.sqrt(100*svar);
    		if (covarsteiglevel==3) cov = 0.25 * Math.sqrt(100*svar);
    		if (covarsteiglevel==4) cov = 0.5 * Math.sqrt(100*svar);
    		if (fehler==1) err =  10;
    		if (fehler==2) err = 25;
    		if (fehler==3) err = 100;
    		for (int i=0; i<datSelection.length+1; i++)
    		{
    	        fullModel[i].setParameterValue(3, svar);
    		    fullModel[i].setParameterValue(4, cov);
    		    fullModel[i].setParameterValue(5, err);
    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, svar);
    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, 0);
    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
    		}
    		int anzPer = 100;
    		if (sampelsize==1) anzPer = 200;
    		if (sampelsize==2) anzPer = 500;
    		if (sampelsize==3) anzPer = 1000;
    		double[] twollVals = new double[3];
    		
    		double[] realValues = {100,-20,100,svar,cov,err};
    		String lsString, twllString;
    		/*
    		fullModel[0].anzPer = 1000;
    		fullModel[0].computeFisher(realValues);
    		double[][] finv = Statik.invert(fullModel[0].fisherInformationMatrix);
    		for (int i=0; i<finv.length; i++) 
    		    System.out.println(Math.sqrt(finv[i][i]));
    		    */
    		for (int i=0; i<6; i++) {rejectCov[i]=0; rejectVar[i]=0; rejectVar1df[i]=0; rejectVar3halfdf[i] = 0; rejectVarOnesided[i] = 0; 
    		rejectVar1dfOnesided[i]=0; rejectCovWald[i]=0; rejectVarWald[i]=0; rejectVarWaldOnesided[i]=0;
    		notRejectedBecauseOfNegativeVariance[i][0] = 0; notRejectedBecauseOfNegativeVariance[i][1] = 0; notRejectedBecauseOfNegativeVariance[i][2] = 0; negativeVariance[i] = 0;}
    		double[] fullDataEstimate = null;
    		double twollFullData;
    		for (int trial = 0; trial < anzTrials; trial++)
    		{
    		    if (trial % 100 == 0) System.out.println("Trial "+trial);
    		    erg = runID+"\t"+cond+"\t";
    		    fullModel[0].createData(anzPer);
    			// Berechnung des Daten-Summenvektors x_1 + x_2 + x_3 + ... + x_anzPer
    			for (int i=0; i<anzVar; i++) xsum[0][i] = 0.0;
    			for (int i=0; i<anzPer; i++)
    				for (int j=0; j<anzVar; j++) xsum[0][j] += fullModel[0].data[i][j];

    		    for (int datsel=0; datsel<6; datsel++)
    		    {
    		        if (datsel>0) fullModel[datsel].setData(Statik.submatrix(fullModel[0].data,null,datSelection[datsel-1]));

    		        /* DEBUG
    		        rand = new Random(DEBUGSEED);
    		        fullModel[datsel].createData(200);
    		        */ //DEBUG END
    		        boolean negativeVarianceFlag = false;
    		        for (int psel = 0; psel<3; psel++)
	    		    {
    		            lsString = ""; twllString = ""; String parVarString = "";
    		            if (psel==0)
    		            {
		    		        leastSquareEstimate = fullModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(fullModel[datsel], leastSquareEstimate);
		    		        for (int i=0; i<6; i++) estimateMemory[i] = twollEstimate[i];
		    		        negativeVarianceFlag = twollEstimate[3] < 0;
		    		        if (negativeVarianceFlag) negativeVariance[datsel]++;
		    		        for (int i=0; i<6; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t";
		    		        if (twollEstimate != null) 
		    		        {
		    		            double[][] inverseFisher = Statik.invert(fullModel[datsel].fisherInformationMatrix);
//		    		            System.out.println("datsel = "+datsel+", Fisher inverse = \r\n"+Statik.matrixToString(inverseFisher));
		    		            for (int i=0; i<6; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t";
		    		            for (int i=0; i<6; i++) parVarString += Statik.doubleNStellen(inverseFisher[i][i],DIGITS)+"\t";
//		    		            System.out.println("Estimate = "+twollEstimate[4]+", STDW = "+Math.sqrt(inverseFisher[4][4]));
//		    		            if (datsel==0) bins[Math.min(199,Math.max(0,(int)Math.round((twollEstimate[2]-100)*10)+100))]++;
		    		            rejectCovWald[datsel] += (Math.abs(twollEstimate[4]) / Math.sqrt(inverseFisher[4][4]) > NORMVERT? 1 : 0);
		    		            rejectVarWald[datsel] += (Math.abs(twollEstimate[3]) / Math.sqrt(inverseFisher[3][3]) > NORMVERT? 1 : 0);
		    		            rejectVarWaldOnesided[datsel] += (twollEstimate[3] / Math.sqrt(inverseFisher[3][3]) > NORMVERTOS? 1 : 0);
		    		            if ((negativeVarianceFlag) && (Math.abs(twollEstimate[3] / Math.sqrt(inverseFisher[3][3])) > NORMVERTOS))
		    		                    notRejectedBecauseOfNegativeVariance[datsel][0]++;
		    		        }
    		            }
    		            if (psel==1)
    		            {
    		                covFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = covFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(covFixedModel[datsel], leastSquareEstimate);
		    		        for (int i=0; i<4; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t"; 
		    		        lsString += "0.000\t"; lsString += Statik.doubleNStellen(leastSquareEstimate[4],DIGITS)+"\t";
		    		        if (twollEstimate != null) 
			    		    {
		    		            double[][] inverseFisher = Statik.invert(fullModel[datsel].fisherInformationMatrix);
		    		            for (int i=0; i<4; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t"; 
			    		        twllString += "0.000\t"; twllString += Statik.doubleNStellen(twollEstimate[4],DIGITS)+"\t";
		    		            for (int i=0; i<4; i++) parVarString += Statik.doubleNStellen(inverseFisher[i][i],DIGITS)+"\t"; 
			    		        parVarString += "0.000\t"; parVarString += Statik.doubleNStellen(inverseFisher[4][4],DIGITS)+"\t";
			    		    }
    		            }
    		            if (psel==2)
    		            {
    		                varFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = varFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(varFixedModel[datsel], leastSquareEstimate);
		    		        for (int i=0; i<3; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t"; 
		    		        lsString += "0.000\t0.000\t"; lsString += Statik.doubleNStellen(leastSquareEstimate[3],DIGITS)+"\t";
		    		        if (twollEstimate != null) 
			    		    {
		    		            double[][] inverseFisher = Statik.invert(fullModel[datsel].fisherInformationMatrix);
		    		            for (int i=0; i<3; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t"; 
			    		        twllString += "0.000\t0.000\t"; twllString += Statik.doubleNStellen(twollEstimate[3],DIGITS)+"\t";
		    		            for (int i=0; i<3; i++) parVarString += Statik.doubleNStellen(inverseFisher[i][i],DIGITS)+"\t"; 
			    		        parVarString += "0.000\t0.000\t"; parVarString += Statik.doubleNStellen(inverseFisher[3][3],DIGITS)+"\t";
			    		    }
    		            }
    		            for (int i=0; i<6; i++) erg += Statik.doubleNStellen(realValues[i],DIGITS)+"\t";
    		            erg += anzPer+"\t";
	    		        erg += (datsel+1)+"\t"+(psel+1)+"\t";
	    		        erg += lsString+parVarString;
						if (twollEstimate==null)
						{
						    for (int i=0; i<leastSquareEstimate.length+5; i++) erg += "-999\t";
						    haywood++;
						} else {
						    erg += twllString;
	//***						if (datsel==0) {fullDataEstimate = twollEstimate; twollFullData = -999.0;}
	//***						else {twollFullData = this.twollEvaluate(anzPer, xsum[datsel], xBiSum[datsel], fullModel[datsel].evaluateSigma(fullDataEstimate), fullModel[datsel].evaluateMu(fullDataEstimate));}
							erg += Statik.doubleNStellen(twollComplete,DIGITS) + "\t";
							erg += Statik.doubleNStellen(twollStartValue,DIGITS) + "\t";
		//***					erg += Statik.doubleNStellen(twollPopulation,DIGITS) + "\t";
							erg += Statik.doubleNStellen(twollValue,DIGITS) + "\t";
							erg += Statik.doubleNStellen(twollIndependent1,DIGITS) + "\t";
							erg += Statik.doubleNStellen(twollIndependent2,DIGITS) + "\t";
		//***					erg += Statik.doubleNStellen(SRMRVar,DIGITS) + "\t";
		//***					erg += Statik.doubleNStellen(SRMRmean,DIGITS) + "\t";
	//***						erg += Statik.doubleNStellen(twollFullData,DIGITS) + "\t";
							twollVals[psel] = twollValue;
						}
	    		    }
					if (twollVals[1] - twollVals[0] > CHISQ1) rejectCov[datsel]++;
					if (twollVals[2] - twollVals[0] > CHISQ2) rejectVar[datsel]++;
					if (twollVals[2] - twollVals[1] > CHISQ1) rejectVar1df[datsel]++;
					if ((twollVals[2] - twollVals[0] > CHISQ2OS) && (!negativeVarianceFlag)) rejectVarOnesided[datsel]++;
					if ((twollVals[2] - twollVals[0] > CHISQ2OSS) && (!negativeVarianceFlag)) rejectVar3halfdf[datsel]++;
					if ((twollVals[2] - twollVals[1] > CHISQ1OS) && (!negativeVarianceFlag)) rejectVar1dfOnesided[datsel]++;
					if ((twollVals[2] - twollVals[0] > CHISQ2OS) && (negativeVarianceFlag)) notRejectedBecauseOfNegativeVariance[datsel][2]++;
					if (negativeVarianceFlag)
					{
					    estimateMemory[3] = 0;
					    double val = twollEvaluate(fullModel[datsel],estimateMemory);
						if (twollVals[2] - val > CHISQ2OSS) rejectVar3halfdf[datsel]++;
						else if (twollVals[2] - twollVals[0] > CHISQ2OSS) notRejectedBecauseOfNegativeVariance[datsel][1]++;
					}
    		    	
    		    }
    		    try {
    		        psAll.write(erg+"\r\n"); psAll.flush();
    		    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
        		runID++;
    		}
		    String powerErg = "";
		    String varianceZeroCount = "";
		    for (int i=0; i<6; i++)
		    {
		        powerErg += 
		            (rejectCov[i] / (double)anzTrials)+"\t"+(rejectVar[i] / (double)anzTrials)+"\t"+(rejectVar1df[i] / (double)anzTrials)+"\t"+
		            (rejectVar3halfdf[i] / (double)anzTrials)+"\t"+(rejectVarOnesided[i] / (double)anzTrials)+"\t"+(rejectVar1dfOnesided[i] / (double)anzTrials)+"\t"+
		            (rejectCovWald[i] / (double)anzTrials)+"\t"+(rejectVarWald[i] / (double)anzTrials)+"\t"+
		            (rejectVarWaldOnesided[i] / (double)anzTrials)+"\t";
		        varianceZeroCount += (negativeVariance[i] / (double)anzTrials)+"\t"+(notRejectedBecauseOfNegativeVariance[i][0] / (double)anzTrials)+"\t"+
		        	(notRejectedBecauseOfNegativeVariance[i][1] / (double)anzTrials)+"\t"+(notRejectedBecauseOfNegativeVariance[i][2] / (double)anzTrials)+"\t";
		    }
		    try {
		        psPower.write(powerErg+"\r\n"); psPower.flush();
		        psZeroVariance.write(varianceZeroCount+"\r\n"); psZeroVariance.flush();
		    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}

		    System.out.println("Finished condition, time = "+(System.currentTimeMillis()-time));
    		System.gc();
        }

        System.out.println("I finished, found "+haywood+" cases without converged -2 log likelihood.");
 	}
	
	public void varianceTypeOneErrorTest(int anzTrials, BufferedWriter typeTwoError, double error, int anzPersons)
	{
	    String erg = "";
	    
	    LinearModel[] fullModel = new LinearModel[6], 
	    			  covFixedModel = new LinearModel[6],
	    			  varFixedModel = new LinearModel[6];
        fullModel[0] = new LinearModel(
                new double[][]{  
                 {1,0.0},{1,0.05},{1,0.1},{1,0.15},{1,0.2},{1,0.25}
				,{1,0.3},{1,0.35},{1,0.4},{1,0.45},{1,0.5},{1,0.55}
				,{1,0.6},{1,0.65},{1,0.7},{1,0.75},{1,0.8},{1,0.85},{1,0.9},{1,0.95}},
                new double[][]{{100,0},{0,0}},
                new double[]{100,-20},
                new double[]{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10}
                );
        covFixedModel[0] = LinearModel.fixParameter(fullModel[0], 4);
        varFixedModel[0] = LinearModel.fixParameter(covFixedModel[0], 3);
        int anzVar = fullModel[0].anzVar;
        	
        int[][] datSelection = new int[][]{{0,2,4,6,8,10,12,14,16,18},{0,2,4,6,8,10},{0,2,4,6,8},{0,2,4,6},{0,2,4}};
        for (int i=1; i<6; i++) 
        {
            fullModel[i] = LinearModel.picDatapoints(fullModel[0],datSelection[i-1]);
            covFixedModel[i] = LinearModel.picDatapoints(covFixedModel[0],datSelection[i-1]);
            varFixedModel[i] = LinearModel.picDatapoints(varFixedModel[0],datSelection[i-1]);
        }

        int[] reject = new int[6]; int[] rejectWald = new int[6];
		int haywood = 0;
        double[][] xsum = new double[datSelection.length+1][anzVar]; ;
        double[][][] xBiSum = new double[datSelection.length+1][anzVar][anzVar];
        double[] leastSquareEstimate = null, twollEstimate = null;
        int runID = 0;
        long time;
        
        int[] mlBin = new int[101];
        int[] waldBin = new int[161];

		time = System.currentTimeMillis();
		
		double svar = 0, cov = 0.0, err = error;
		for (int i=0; i<datSelection.length+1; i++)
		{
		    fullModel[i].setParameterValue(3, svar);
		    fullModel[i].setParameterValue(4, cov);
		    fullModel[i].setParameterValue(5, err);
		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, svar);
		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, 0);
		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
		}
		int anzPer = anzPersons;
		double[] twollVals = new double[3];
		
		double[] realValues = {100,-20,100,svar,cov,err};

		for (int i=0; i<6; i++) {reject[i]=0; rejectWald[i]=0;}
		double twollFullData;
		for (int trial = 0; trial < anzTrials; trial++)
		{
		    fullModel[0].createData(anzPer);
			// Berechnung des Daten-Summenvektors x_1 + x_2 + x_3 + ... + x_anzPer
			for (int i=0; i<anzVar; i++) xsum[0][i] = 0.0;
			for (int i=0; i<anzPer; i++)
				for (int j=0; j<anzVar; j++) xsum[0][j] += fullModel[0].data[i][j];

		    for (int datsel=0; datsel<6; datsel++)
		    {
		        if (datsel>0) fullModel[datsel].setData(Statik.submatrix(fullModel[0].data,null,datSelection[datsel-1]));
		        for (int psel = 0; psel<2; psel++)
    		    {
		            if (psel==0)
		            {
	    		        leastSquareEstimate = fullModel[datsel].leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(fullModel[datsel], leastSquareEstimate);
	    		        
	    		        if (twollEstimate != null) 
	    		        {
	    		            double[][] inverseFisher = Statik.invert(fullModel[datsel].fisherInformationMatrix);
	    		            double varTValue = twollEstimate[3] / Math.sqrt(inverseFisher[3][3]);
	    		            int intTVal = (int)Math.round(varTValue*10.0)+80;
	    		            rejectWald[datsel] += (Math.abs(twollEstimate[3]) / Math.sqrt(inverseFisher[3][3]) > 1.960? 1 : 0);
	    		            waldBin[(intTVal < 0?0: (intTVal > 160? 160: intTVal))]++;
//	    		            if (twollEstimate[3]<0.0) System.out.println("Somethings wrong: Not counted Haywood!");
	    		        }
		            }
		            if (psel==1)
		            {
		                varFixedModel[datsel].setData(fullModel[datsel].data);
	    		        leastSquareEstimate = varFixedModel[datsel].leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(varFixedModel[datsel], leastSquareEstimate);
		            }
					if (twollEstimate!=null)
						twollVals[psel] = twollValue;
    		    }
				if (twollVals[1] - twollVals[0] > CHISQ2) reject[datsel]++;
				int intTllVal = (int)Math.round((twollVals[1] - twollVals[0])*10.0);
				mlBin[(intTllVal>100?100:intTllVal)]++;
		    }
    		runID++;
		}
	    String powerErg = "";
	    for (int i=0; i<6; i++)
	        powerErg += (reject[i] / (double)anzTrials)+"\t"+(rejectWald[i] / (double)anzTrials)+"\t";
	    
	    powerErg +="\r\n\r\n";
	    for (int i=0; i<mlBin.length; i++) powerErg += mlBin[i]+"\r\n";
	    powerErg +="\r\n\r\n";
	    for (int i=0; i<waldBin.length; i++) powerErg += waldBin[i]+"\r\n";

	    try {
	        typeTwoError.write(powerErg+"\r\n"); typeTwoError.flush();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}

		System.out.println("I finished, found "+haywood+" cases without converged -2 log likelihood.");
 	}

	public void manualSSPower(BufferedWriter out)
	{
	    double[][] mcPower = Statik.loadMatrix("powerOut0to159.txt",'\t');
	    LinearModel[] fullModel = new LinearModel[6], 
	    			  covFixedModel = new LinearModel[6],
	    			  varFixedModel = new LinearModel[6];
        fullModel[0] = new LinearModel(
                new double[][]{  
                 {1,0.0},{1,0.05},{1,0.1},{1,0.15},{1,0.2},{1,0.25}
				,{1,0.3},{1,0.35},{1,0.4},{1,0.45},{1,0.5},{1,0.55}
				,{1,0.6},{1,0.65},{1,0.7},{1,0.75},{1,0.8},{1,0.85},{1,0.9},{1,0.95}},
                new double[][]{{100,0},{0,50}},
                new double[]{100,-20},
                new double[]{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10}
                );
        covFixedModel[0] = LinearModel.fixParameter(fullModel[0], 4);
        varFixedModel[0] = LinearModel.fixParameter(covFixedModel[0], 3);
        int anzVar = fullModel[0].anzVar;
        	
        int[][] datSelection = new int[][]{{0,2,4,6,8,10,12,14,16,18},{0,2,4,6,8,10},{0,2,4,6,8},{0,2,4,6},{0,2,4}};
        for (int i=1; i<6; i++) 
        {
            fullModel[i] = LinearModel.picDatapoints(fullModel[0],datSelection[i-1]);
            covFixedModel[i] = LinearModel.picDatapoints(covFixedModel[0],datSelection[i-1]);
            varFixedModel[i] = LinearModel.picDatapoints(varFixedModel[0],datSelection[i-1]);
        }
        
        double[][] erg = new double[54][50];
        double[][] mcErg = new double[54][4];
        long time;
        
        // Panels running over covariances, colums ordered as: first occ = 3,4,5,6,10,20, then samplesize = 100,200,500, then IS-Correlation = -0.5, 0.0, 0.5 
        for (int cond = 0; cond<=53; cond++)
        {
    		System.out.println("Starting condition "+cond);
    		time = System.currentTimeMillis();
    		int nr = cond;
    		
    		int occ = nr % 6; nr = nr/6;				// 3,4,5,6,10,20
    		int sampelsize = nr % 3; nr = nr/3;			// 100,200,500
    		int isCor = nr % 3; nr = nr/3;

    		double svar = 50;
    		int datsel = 5-occ;
    		int anzPer = 100;
    		if (sampelsize==1) anzPer = 200;
    		if (sampelsize==2) anzPer = 500;
    		double cor = -0.5;
    		if (isCor == 1) cor = 0.0;
    		if (isCor == 2) cor = 0.5;
        
	        for (int relNr=50; relNr < 100; relNr++)
	        {
	            double err = (100.0*100.0 / (double)relNr) - 100.0;
	    		time = System.currentTimeMillis();
	    		
	    		double cov = cor * Math.sqrt(100*svar);
	    		for (int i=0; i<datSelection.length+1; i++)
	    		{
	    		    fullModel[i].setParameterValue(3, svar);
	    		    fullModel[i].setParameterValue(4, cov);
	    		    fullModel[i].setParameterValue(5, err);
	    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, svar);
	    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
	    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
	    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, 0);
	    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
	    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
	    		}
	
	    		fullModel[datsel].anzPer = varFixedModel[datsel].anzPer = anzPer;
	    		erg[cond][relNr-50] = sarrisSatoraPower(varFixedModel[datsel], fullModel[datsel]);

                if (relNr==50) mcErg[cond][0] = mcPower[40*sampelsize+3*10+isCor*2][datsel*5+1];
                if (relNr==80) mcErg[cond][1] = mcPower[40*sampelsize+2*10+isCor*2][datsel*5+1];
                if (relNr==91) mcErg[cond][2] = mcPower[40*sampelsize+1*10+isCor*2][datsel*5+1];
                if (relNr==99) mcErg[cond][3] = mcPower[40*sampelsize+0*10+isCor*2][datsel*5+1];
	        }
    		System.out.println("Finished condition, took me "+(System.currentTimeMillis()-time)+" milliseconds.");
        }
	    try {
	        for (int i=0; i<erg[0].length; i++)
	        {
	            for (int j=0; j<erg.length; j++)
	            {
	                out.write(erg[j][i]+"\t");
	                if (i==0) out.write(""+mcErg[j][0]);
	                if (i==30) out.write(""+mcErg[j][1]);
	                if (i==41) out.write(""+mcErg[j][2]);
	                if (i==49) out.write(""+mcErg[j][3]);
	                out.write("\t");
	            }
	            out.write("\r\n");
	        }
	        out.write("\r\n\r\n\r\n");
	        out.flush();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
		System.gc();

        erg = new double[48][199];
        mcErg = new double[48][5];
        // Panels running over reliabilities, colums ordered as: first reliability = .99, .91, .8, .5, then samplesize = 100,200,500, then occ = 4,5,6,10  
        for (int cond = 0; cond<=47; cond++)
        {
    		System.out.println("Starting condition "+cond);
    		time = System.currentTimeMillis();
    		int nr = cond;
    		
    		int fehler = nr % 4; nr = nr/4;
    		int sampelsize = nr % 3; nr = nr/3;			// 100,200,500
    		int occ = nr % 4; nr = nr/4;				// 4,5,6,10

    		double svar = 50;
    		int datsel = 4-occ;
    		double err = 1;
    		if (fehler==1) err =  10;
    		if (fehler==2) err = 25;
    		if (fehler==3) err = 100;
    		int anzPer = 100;
    		if (sampelsize==1) anzPer = 200;
    		if (sampelsize==2) anzPer = 500;
        
	        for (int corNr=-99; corNr < 100; corNr++)
	        {
	            double cor = (double)(corNr) / 100.0;
	    		time = System.currentTimeMillis();
	    		
	    		double cov = cor * Math.sqrt(100*svar);
	    		for (int i=0; i<datSelection.length+1; i++)
	    		{
	    		    fullModel[i].setParameterValue(3, svar);
	    		    fullModel[i].setParameterValue(4, cov);
	    		    fullModel[i].setParameterValue(5, err);
	    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, svar);
	    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
	    		    covFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
	    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 3, 0);
	    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 4, 0);
	    		    varFixedModel[i].setParameterValueAccordingToOtherModel(fullModel[i], 5, err);
	    		}
	
	    		fullModel[datsel].anzPer = varFixedModel[datsel].anzPer = anzPer;
	    		erg[cond][corNr+99] = sarrisSatoraPower(varFixedModel[datsel], fullModel[datsel]);
                if (corNr==-50) mcErg[cond][0] = mcPower[40*sampelsize+fehler*10+0][datsel*5+1];
                if (corNr==-25) mcErg[cond][1] = mcPower[40*sampelsize+fehler*10+1][datsel*5+1];
                if (corNr==00) mcErg[cond][2] = mcPower[40*sampelsize+fehler*10+2][datsel*5+1];
                if (corNr==25) mcErg[cond][3] = mcPower[40*sampelsize+fehler*10+3][datsel*5+1];
                if (corNr==50) mcErg[cond][4] = mcPower[40*sampelsize+fehler*10+4][datsel*5+1];
	        }
    		System.out.println("Finished condition, took me "+(System.currentTimeMillis()-time)+" milliseconds.");
        }
	    try {
	        for (int i=0; i<erg[0].length; i++)
	        {
	            for (int j=0; j<erg.length; j++)
	            {
	                out.write(erg[j][i]+"\t");
	                if (i==49) out.write(""+mcErg[j][0]);
	                if (i==74) out.write(""+mcErg[j][1]);
	                if (i==99) out.write(""+mcErg[j][2]);
	                if (i==124) out.write(""+mcErg[j][3]);
	                if (i==149) out.write(""+mcErg[j][4]);
	                out.write("\t");
	            }
	            out.write("\r\n");
	        }
	        out.flush();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
		System.gc();
	}

	// start and end run from 0 to 47+54 = 102 (inclusive), 
	// the first  54 for occ = 3,4,5,6,10,20   X   N = 100, 200, 500   X   cor = -0.5, 0, 0.5, over reliabilities in steps of 1
	// the second 48 for err = 1,10,50,100    X   N = 100, 200, 500   X   occ = 4,5,6,10     , over correlations
	// the third   1 for err = 50             X   N = 200             X   occ = 5      X cor = 0, over effect.
	public void manualSSlikePower(BufferedWriter out, int start, int end, int anzTrials)
	{
	    LinearModel[] fullModel = new LinearModel[6], 
	    			  covFixedModel = new LinearModel[6],
	    			  varFixedModel = new LinearModel[6];
        fullModel[0] = new LinearModel(
                new double[][]{  
                 {1,0.0},{1,0.05},{1,0.1},{1,0.15},{1,0.2},{1,0.25}
				,{1,0.3},{1,0.35},{1,0.4},{1,0.45},{1,0.5},{1,0.55}
				,{1,0.6},{1,0.65},{1,0.7},{1,0.75},{1,0.8},{1,0.85},{1,0.9},{1,0.95}},
                new double[][]{{100,0},{0,50}},
                new double[]{100,-20},
                new double[]{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10}
                );
        covFixedModel[0] = LinearModel.fixParameter(fullModel[0], 4);
        varFixedModel[0] = LinearModel.fixParameter(covFixedModel[0], 3);
        int anzVar = fullModel[0].anzVar;
        	
        int[][] datSelection = new int[][]{{0,2,4,6,8,10,12,14,16,18},{0,2,4,6,8,10},{0,2,4,6,8},{0,2,4,6},{0,2,4}};
        for (int i=1; i<6; i++) 
        {
            fullModel[i] = LinearModel.picDatapoints(fullModel[0],datSelection[i-1]);
            covFixedModel[i] = LinearModel.picDatapoints(covFixedModel[0],datSelection[i-1]);
            varFixedModel[i] = LinearModel.picDatapoints(varFixedModel[0],datSelection[i-1]);
        }
        
        double[][] erg = new double[54][50];
        double[] xsum = new double[anzVar]; ;
        double[][] xBiSum = new double[anzVar][anzVar];
        double[] leastSquareEstimate = null, twollEstimate = null;
        double[] twollVals = new double[4];
        long time = 0, overallTime = System.currentTimeMillis();
        
        // Panels running over covariances, colums ordered as: first occ = 3,4,5,6,10,20, then samplesize = 100,200,500, then IS-Correlation = -0.5, 0.0, 0.5 
        for (int cond = start; (cond<=53) && (cond<=end); cond++)
        {
    		System.out.println("Starting condition "+cond);
    		time = System.currentTimeMillis();
    		int nr = cond;
    		
    		int occ = nr % 6; nr = nr/6;				// 3,4,5,6,10,20
    		int sampelsize = nr % 3; nr = nr/3;			// 100,200,500
    		int isCor = nr % 3; nr = nr/3;

    		double svar = 50;
    		int datsel = 5-occ;
    		int anzPer = 100;
    		if (sampelsize==1) anzPer = 200;
    		if (sampelsize==2) anzPer = 500;
    		double cor = -0.5;
    		if (isCor == 1) cor = 0.0;
    		if (isCor == 2) cor = 0.5;
        
    		double cov = cor * Math.sqrt(100*svar);

    		fullModel[datsel].setParameterValue(3, svar);
		    fullModel[datsel].setParameterValue(4, cov);
		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 3, svar);
		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 4, 0);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 3, 0);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 4, 0);
    		fullModel[datsel].anzPer = varFixedModel[datsel].anzPer = covFixedModel[datsel].anzPer = anzPer;

		    for (int relNr=50; relNr < 100; relNr++)
	        {
	            double err = (100.0*100.0 / (double)relNr) - 100.0;
	    		
    		    fullModel[datsel].setParameterValue(5, err);
    		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 5, err);
    		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 5, err);
	
    		    erg[cond][relNr-50] = 0;
        		for (int trial = 0; trial < anzTrials; trial++)
        		{
//        		    if (trial % 100 == 0) System.out.println("Reliability = "+relNr+", Trial "+trial);
        		    fullModel[datsel].createData(anzPer);
        		    xsum = fullModel[datsel].xsum; xBiSum = fullModel[datsel].xBiSum;

    		        boolean negativeVarianceFlag = false;
    		        for (int psel = 0; psel<3; psel++)
	    		    {
    		            if (psel==0)
    		            {
		    		        leastSquareEstimate = fullModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(fullModel[datsel], leastSquareEstimate);
		    		        negativeVarianceFlag = twollEstimate[3] < 0;
    		            }
    		            if (psel==1)
    		            {
    		                covFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = covFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(covFixedModel[datsel], leastSquareEstimate);
    		            }
    		            if (psel==2)
    		            {
    		                varFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = varFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(varFixedModel[datsel], leastSquareEstimate);
    		            }
						twollVals[psel] = twollValue;
	    		    }
//					if ((twollVals[2] - twollVals[0] > CHISQ2OS) && (!negativeVarianceFlag)) erg[cond][relNr-50]++;
					if (twollVals[2] - twollVals[0] > CHISQ2) erg[cond][relNr-50]++;
        		}
        		erg[cond][relNr-50] /= anzTrials;
	        }
    		System.out.println("Finished condition "+cond+", took me "+(System.currentTimeMillis()-time)+" milliseconds.");
        }
	    try {
	        for (int i=0; i<erg[0].length; i++)
	        {
	            for (int j=0; j<erg.length; j++)
	                out.write(erg[j][i]+"\t");
	            out.write("\r\n");
	        }
	        out.write("\r\n\r\n\r\n");
	        out.flush();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
		System.gc();

        erg = new double[48][199];

        System.out.println("Finished first figure, time = "+(System.currentTimeMillis()-overallTime));
        
        // Panels running over reliabilities, colums ordered as: first reliability = .99, .91, .8, .5, then samplesize = 100,200,500, then occ = 4,5,6,10
        int secondstart = (start>=54?start:54);
        for (int cond2 = secondstart; (cond2<=end) && (cond2<=47+54); cond2++)
        {
    		System.out.println("Starting condition "+cond2);
    		int cond = cond2 - 54;
    		int nr = cond;
    		
    		int fehler = nr % 4; nr = nr/4;
    		int sampelsize = nr % 3; nr = nr/3;			// 100,200,500
    		int occ = nr % 4; nr = nr/4;				// 4,5,6,10

    		double svar = 50;
    		int datsel = 4-occ;
    		double err = 1;
    		if (fehler==1) err =  10;
    		if (fehler==2) err = 25;
    		if (fehler==3) err = 100;
    		int anzPer = 100;
    		if (sampelsize==1) anzPer = 200;
    		if (sampelsize==2) anzPer = 500;
        
		    fullModel[datsel].setParameterValue(3, svar);
		    fullModel[datsel].setParameterValue(5, err);
		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 3, svar);
		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 4, 0);
		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 5, err);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 3, 0);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 4, 0);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 5, err);
    		fullModel[datsel].anzPer = varFixedModel[datsel].anzPer = covFixedModel[datsel].anzPer = anzPer;

		    for (int corNr=-99; corNr < 100; corNr++)
	        {
	            double cor = (double)(corNr) / 100.0;
	            time = System.currentTimeMillis();
	    		
	    		double cov = cor * Math.sqrt(100*svar);
    		    fullModel[datsel].setParameterValue(4, cov);
	
    		    erg[cond][corNr+99] = 0;
        		for (int trial = 0; trial < anzTrials; trial++)
        		{
//        		    if (trial % 100 == 0) System.out.println("Correlation = "+cor+", Trial "+trial);
        		    fullModel[datsel].createData(anzPer);
        		    xsum = fullModel[datsel].xsum; xBiSum = fullModel[datsel].xBiSum;

    		        boolean negativeVarianceFlag = false;
    		        for (int psel = 0; psel<3; psel++)
	    		    {
    		            if (psel==0)
    		            {
		    		        leastSquareEstimate = fullModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(fullModel[datsel], leastSquareEstimate);
		    		        negativeVarianceFlag = twollEstimate[3] < 0;
    		            }
    		            if (psel==1)
    		            {
    		                covFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = covFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(covFixedModel[datsel], leastSquareEstimate);
    		            }
    		            if (psel==2)
    		            {
    		                varFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = varFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(varFixedModel[datsel], leastSquareEstimate);
    		            }
						twollVals[psel] = twollValue;
	    		    }
//					if ((twollVals[2] - twollVals[0] > CHISQ2OS) && (!negativeVarianceFlag)) erg[cond][corNr+99]++;
					if (twollVals[2] - twollVals[0] > CHISQ2) erg[cond][corNr+99]++;
        		}
        		erg[cond][corNr+99] /= anzTrials;
	    		
	        }
    		System.out.println("Finished condition, took me "+(System.currentTimeMillis()-time)+" milliseconds.");
    		System.gc();
        }
        
	    try {
	        for (int i=0; i<erg[0].length; i++)
	        {
	            for (int j=0; j<erg.length; j++)
	                out.write(erg[j][i]+"\t");
	            out.write("\r\n");
	        }
	        out.write("\r\n\r\n\r\n");
	        out.flush();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
		System.gc();
		
		erg = new double[64][100];

		// Panels running over effect size, colums ordered as: first reliability = .5,0.81,.9,.99, then samplesize = 200,500, then occ = 4,5,6,10
        int thirdstart = (start>=102?start:102);
        for (int cond3 = secondstart; (cond3<=end) && (cond3<=47+54+32); cond3++)
        {
            time = System.currentTimeMillis();
    		System.out.println("Starting condition "+cond3);
    		int cond = cond3 - 102;
    		int nr = cond;
    		
    		int fehler = nr % 4; nr = nr/4;				// 0.5, 0.81, 0.9, 0.99
    		int sampelsize = nr % 2; nr = nr/2;			// 200,500
    		int occ = nr % 4; nr = nr/4;				// 4,5,6,10

    		int datsel = 4-occ;
    		double err = 1;
    		if (fehler==1) err =  10;
    		if (fehler==2) err = 25;
    		if (fehler==3) err = 100;
    		int anzPer = 200;
    		if (sampelsize==1) anzPer = 500;
        
		    fullModel[datsel].setParameterValue(5, err);
		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 4, 0);
		    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 5, err);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 3, 0);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 4, 0);
		    varFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 5, err);
    		fullModel[datsel].anzPer = varFixedModel[datsel].anzPer = covFixedModel[datsel].anzPer = anzPer;

		    for (int varNr=0; varNr < 100; varNr++)
	        {
	            double svar = (double)(varNr);
	    		
			    fullModel[datsel].setParameterValue(3, svar);
			    covFixedModel[datsel].setParameterValueAccordingToOtherModel(fullModel[datsel], 3, svar);

			    double cov = 0.0 * Math.sqrt(100*svar);
			    fullModel[datsel].setParameterValue(4, cov);
	
    		    erg[2*cond][varNr] = 0;
    		    erg[2*cond+1][varNr] = 0;
        		for (int trial = 0; trial < anzTrials; trial++)
        		{
//        		    if (trial % 100 == 0) System.out.println("Correlation = "+cor+", Trial "+trial);
        		    fullModel[datsel].createData(anzPer);
        		    xsum = fullModel[datsel].xsum; xBiSum = fullModel[datsel].xBiSum;

    		        boolean negativeVarianceFlag = false;
    		        for (int psel = 0; psel<3; psel++)
	    		    {
    		            if (psel==0)
    		            {
		    		        leastSquareEstimate = fullModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(fullModel[datsel], leastSquareEstimate);
		    		        negativeVarianceFlag = twollEstimate[3] < 0;
    		            }
    		            if (psel==1)
    		            {
    		                covFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = covFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(covFixedModel[datsel], leastSquareEstimate);
    		            }
    		            if (psel==2)
    		            {
    		                varFixedModel[datsel].setData(fullModel[datsel].data);
		    		        leastSquareEstimate = varFixedModel[datsel].leastSquareAproxLinearModel();
		    		        twollEstimate = twollAproxLinearModel(varFixedModel[datsel], leastSquareEstimate);
    		            }
						twollVals[psel] = twollValue;
	    		    }
					if ((twollVals[2] - twollVals[0] > CHISQ2OS) && (!negativeVarianceFlag)) erg[cond*2][varNr]++;
					if (twollVals[2] - twollVals[0] > CHISQ2) erg[cond*2+1][varNr]++;
        		}
        		erg[cond*2][varNr] /= anzTrials;
        		erg[cond*2+1][varNr] /= anzTrials;
	    		
	        }
    		System.out.println("Finished condition, took me "+(System.currentTimeMillis()-time)+" milliseconds.");
    		System.gc();
        }

	    try {
	        for (int i=0; i<erg[0].length; i++)
	        {
	            for (int j=0; j<erg.length; j++)
	                out.write(erg[j][i]+"\t");
	            out.write("\r\n");
	        }
	        out.flush();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
		System.gc();

		System.out.println("Finished overall, time = "+(System.currentTimeMillis()-overallTime));
        
	}

	
	public void manualLoopMultipleIndicator(int start, int end, int anzTrials, BufferedWriter psAll, BufferedWriter psPower)
	{
	    int anzInd = 3;
	    
	    String erg = "";
	    
	    LinearModel fullModel, covFixedModel, varFixedModel;
        fullModel = new LinearModel(
                new double[][]{{1,0.0},{1,0.1},{1,0.2},{1,0.3},{1,0.4},{1,0.5},{1,0.6},{1,0.7},{1,0.8},{1,0.9}},
                new int[][]{{0,2},{2,1}},
                new double[][]{{100,0.25 * Math.sqrt(100*50)},{0.25 * Math.sqrt(100*50),50}},
                new int[]{-1,-1},
                new double[]{100,-20},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{1,1,1,1,1,1,1,1,1,1}
                );
        int[] datSelection = new int[]{0,1,2,3,4};
        fullModel = LinearModel.picDatapoints(fullModel,datSelection);
	    fullModel.createData(200);
        // SS-Power
        System.out.println("Starting one-indicator SS Powers...");
        double[] varPower = new double[151], covPower = new double[151];
        covFixedModel = LinearModel.fixParameter(fullModel, 2+fullModel.anzMeanPar, 0.0);
        varFixedModel = LinearModel.fixParameter(covFixedModel, 1+fullModel.anzMeanPar, 0.0);
        for (int sserr=1; sserr<151; sserr++)
        {
            for (int i=0; i<5; i++) {fullModel.errVal[i]=covFixedModel.errVal[i]=varFixedModel.errVal[i] = sserr;}
            covPower[sserr] = sarrisSatoraPower(covFixedModel, fullModel);
            varPower[sserr] = sarrisSatoraPower(varFixedModel, fullModel);
        }
        System.out.println("Finished.");

        // Introducing multiple indicators
        if (anzInd > 1) 
        {
            double[] latRes = new double[anzInd]; for (int i=0; i<anzInd; i++) latRes[i] = 5.0;
            double[] lambda = new double[anzInd]; for (int i=0; i<anzInd; i++) lambda[i] = 1.0;
            fullModel.createMulitpleIndicators(3, latRes, lambda);
            fullModel.anzPer = 0;
        }
        covFixedModel = LinearModel.fixParameter(fullModel, 2+fullModel.anzMeanPar, 0.0);
        varFixedModel = LinearModel.fixParameter(covFixedModel, 1+fullModel.anzMeanPar, 0.0);

//        covFixedModel = LinearModel.picDatapoints(covFixedModel,datSelection);
//        varFixedModel = LinearModel.picDatapoints(varFixedModel,datSelection);
        
        int anzVar = fullModel.anzVar;
        
        	
        int rejectCov = 0, rejectVar = 0;
		int haywood = 0;
//        double[] xsum = new double[anzVar]; ;
//        double[][] xBiSum = new double[anzVar][anzVar];
        double[] leastSquareEstimate = null, twollEstimate = null;
        int runID = 0;
        long time;
        for (int cond = start; cond<=end; cond++)
        {
    		System.out.println("Starting condition "+cond);
    		time = System.currentTimeMillis();
    		int nr = cond;
    		
    		double lat = 1/3, err1 = 9, err2 = 15, err3 = 45, scov = 0.25 * Math.sqrt(100*50);
    		
    		int latent = nr % 2; nr = nr/2;
    		int fehler = nr;
    		
    		if (latent==0) lat = 1/3;
    		if (latent==1) lat = 16/3;
    		if (fehler==0) {err1 =   9; err2 = 15; err3 = 45;}	// = 5
    		if (fehler==1) {err1 =  16; err2 = 40; err3 = 80;}	// = 10
    		if (fehler==2) {err1 =  30; err2 = 45; err3 = 90;}	// = 15
    		if (fehler==3) {err1 =  45; err2 = 60; err3 = 90;}	// = 20
    		if (fehler==4) {err1 =  60; err2 = 75; err3 =100;}	// = 25
    		
    		fullModel.setParameterValue(2+fullModel.anzMeanPar,scov);
    		if (anzInd > 1)
    		{
	    		fullModel.setParameterValue(3+fullModel.anzMeanPar,lat);
//	    		fullModel.setParameterValue(4+fullModel.anzMeanPar,err);
	    		covFixedModel.setParameterValue(2+fullModel.anzMeanPar,lat);
//	    		covFixedModel.setParameterValue(3+fullModel.anzMeanPar,err);
	    		varFixedModel.setParameterValue(1+fullModel.anzMeanPar,lat);
//	    		varFixedModel.setParameterValue(2+fullModel.anzMeanPar,err);
    		} else {
//	    		fullModel.setParameterValue(3+fullModel.anzMeanPar,lat+err);
//	    		covFixedModel.setParameterValue(2+fullModel.anzMeanPar,lat+err);
//	    		varFixedModel.setParameterValue(1+fullModel.anzMeanPar,lat+err);
    		}
    		for (int i=0; i<5; i++) {fullModel.errVal[3*i+0] = err1; fullModel.errVal[3*i+1] = err2; fullModel.errVal[3*i+2] = err3;}
    		for (int i=0; i<5; i++) {covFixedModel.errVal[3*i+0] = err1; covFixedModel.errVal[3*i+1] = err2; covFixedModel.errVal[3*i+2] = err3;}
    		for (int i=0; i<5; i++) {varFixedModel.errVal[3*i+0] = err1; varFixedModel.errVal[3*i+1] = err2; varFixedModel.errVal[3*i+2] = err3;}
    		
    		int anzPer = 200;
    		double[] twollVals = new double[3];
    		
//    		double[] realValues = {100,50,scov,lat,err};
//    		if (fullModel.anzMeanPar>0) realValues = new double[]{100,-20,100,50,scov,lat,err};
    		double[] realValues = {100,50,scov,lat};
    		if (fullModel.anzMeanPar>0) realValues = new double[]{100,-20,100,50,scov,lat};
    		String lsString, twllString;

    		rejectCov = 0; rejectVar = 0;
    		for (int trial = 0; trial < anzTrials; trial++)
    		{
    		    erg = runID+"\t"+cond+"\t";
    		    fullModel.createData(anzPer);

    		    // Berechnung des Daten-Summenvektors x_1 + x_2 + x_3 + ... + x_anzPer
//    			for (int i=0; i<anzVar; i++) xsum[i] = 0.0;
//    			for (int i=0; i<anzPer; i++)
//    				for (int j=0; j<anzVar; j++) xsum[j] += fullModel.data[i][j];

		        for (int psel = 0; psel<3; psel++)
    		    {
		            lsString = ""; twllString = ""; String parVarString = "";
		            if (psel==0)
		            {
	    		        leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(fullModel, leastSquareEstimate);
	    		        for (int i=0; i<(anzInd==1?3:4)+fullModel.anzMeanPar; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t";
	    		        if (twollEstimate != null) 
	    		        {
	    		            for (int i=0; i<(anzInd==1?3:4)+fullModel.anzMeanPar; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t";
	    		        }
		            }
		            if (psel==1)
		            {
		                covFixedModel.setData(fullModel.data);
	    		        leastSquareEstimate = covFixedModel.leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(covFixedModel, leastSquareEstimate);
	    		        for (int i=0; i<2+fullModel.anzMeanPar; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t"; 
	    		        lsString += "0.000\t"; //lsString += Statik.doubleNStellen(leastSquareEstimate[2+fullModel.anzMeanPar],DIGITS)+"\t"; 
	    		        if (anzInd > 1) lsString += Statik.doubleNStellen(leastSquareEstimate[2+fullModel.anzMeanPar],DIGITS)+"\t"; 
	    		        if (twollEstimate != null) 
		    		    {
	    		            for (int i=0; i<1+fullModel.anzMeanPar; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t"; 
		    		        twllString += "0.000\t"; //twllString += Statik.doubleNStellen(twollEstimate[2+fullModel.anzMeanPar],DIGITS)+"\t"; 
		    		        if (anzInd > 1) twllString += Statik.doubleNStellen(twollEstimate[2+fullModel.anzMeanPar],DIGITS)+"\t";
		    		    }
		            }
		            if (psel==2)
		            {
		                varFixedModel.setData(fullModel.data);
	    		        leastSquareEstimate = varFixedModel.leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(varFixedModel, leastSquareEstimate);
	    		        for (int i=0; i<1+fullModel.anzMeanPar; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t"; 
	    		        lsString += "0.000\t0.000\t"; //lsString += Statik.doubleNStellen(leastSquareEstimate[1+fullModel.anzMeanPar],DIGITS)+"\t"; 
	    		        if (anzInd > 1) lsString += Statik.doubleNStellen(leastSquareEstimate[1+fullModel.anzMeanPar],DIGITS)+"\t";
	    		        if (twollEstimate != null) 
		    		    {
	    		            for (int i=0; i<1+fullModel.anzMeanPar; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t"; 
		    		        twllString += "0.000\t0.000\t"; //twllString += Statik.doubleNStellen(twollEstimate[1+fullModel.anzMeanPar],DIGITS)+"\t"; 
		    		        if (anzInd > 1) twllString += Statik.doubleNStellen(twollEstimate[1+fullModel.anzMeanPar],DIGITS)+"\t";
		    		    }
		            }
		            for (int i=0; i<(anzInd==1?3:4)+fullModel.anzMeanPar; i++) erg += Statik.doubleNStellen(realValues[i],DIGITS)+"\t";
		            erg += anzPer+"\t";
    		        erg += (psel+1)+"\t";
    		        erg += lsString+parVarString;
					if (twollEstimate==null)
					{
					    for (int i=0; i<(anzInd==1?3:4)+fullModel.anzMeanPar; i++) erg += "-999\t";
					    haywood++;
					} else {
					    erg += twllString;
						erg += Statik.doubleNStellen(twollComplete,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollStartValue,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollValue,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollIndependent1,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollIndependent2,DIGITS) + "\t";
						twollVals[psel] = twollValue;
					}
    		    }
				if (twollVals[1] - twollVals[0] > CHISQ1) rejectCov++;
				if (twollVals[2] - twollVals[0] > CHISQ2) rejectVar++;

				try {
			        psAll.write(erg+"\r\n"); psAll.flush();
			    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
	    		runID++;
		    }

    		String powerErg = "";
		    powerErg += (rejectCov / (double)anzTrials)+"\t"+(rejectVar / (double)anzTrials)+"\t";
		    try {
		        psPower.write(powerErg+"\r\n"); psPower.flush();
		    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}

		    System.out.println("Finished condition, time = "+(System.currentTimeMillis()-time));
    		System.gc();
        }
	    try {
	        psPower.write("\r\n");
	        for (int sserr=1; sserr<151; sserr++)
	        {
	            psPower.write(covPower[sserr]+"\t"+varPower[sserr]+"\r\n"); 
	            System.out.println(sserr+"\t"+covPower[sserr]+"\t"+varPower[sserr]);}
	        psPower.flush();
	        psPower.close();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}

        System.out.println("I finished, found "+haywood+" cases without converged -2 log likelihood.");
 	}
	
    public void manualLoopMultipleIndicatorJune2009()
    {
        int anzTrials = 10000;
        int anzTrialsSmooth = 2000;
        
        LinearModel fullModel, varFixedModel;
        fullModel = new LinearModel(
                new double[][]{{1,0.0},{1,0.1},{1,0.2},{1,0.3},{1,0.4}},
                new int[][]{{0,1},{1,2}},
                new double[][]{{100,0.5 * Math.sqrt(100*50)},{0.5 * Math.sqrt(100*50),50}},
                new int[]{-1,-1},
                new double[]{100,-20},
                new int[]{-1,-1,-1,-1,-1},
                new double[]{1,1,1,1,1}
                );

        int haywood = 0;
        double[] leastSquareEstimate = null, twollEstimate = null;
        varFixedModel = LinearModel.fixParameter(fullModel, 2, 0.0);
        varFixedModel.fixParameter(1, 0.0);
        // creating power for all errors
        /*
        for (int cond = 0; cond<2*2; cond++)
        {
            int nr = cond;
            
            int N = (nr%2==0?200:500); nr /= 2;
            double correlation = (nr%2==0?0.0:0.5); nr /= 2;
            fullModel.setParameterValue(1,correlation * Math.sqrt(100*50)); 
            varFixedModel.setParameterValue(1,correlation * Math.sqrt(100*50)); 

            System.out.print("\r\n"+N+"; "+correlation+"\t");
            for (int err=1; err < 150; err++)
            {
                for (int i=0; i<5; i++) fullModel.errVal[i] = varFixedModel.errVal[i] = err;

                int reject = 0, valid = 0;
                for (int trial = 0; trial < anzTrialsSmooth; trial++)
                {
                    fullModel.createData(N); varFixedModel.setData(fullModel.data);

                    leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
                    twollEstimate = twollAproxLinearModel(fullModel, leastSquareEstimate);
                    double fullTwoll = twollValue;
                    leastSquareEstimate = varFixedModel.leastSquareAproxLinearModel();
                    twollEstimate = twollAproxLinearModel(varFixedModel, leastSquareEstimate);
                    if (twollEstimate==null) haywood ++; 
                    else {if (twollValue - fullTwoll > CHISQ2) reject++; valid++;}
                }
                
                double power = (double)reject/(double)valid;
                System.out.print(power+"\t");
            }
        }
        System.out.println();
        
//        System.exit(0);
 * */
        fullModel.data = null;
        fullModel.createMulitpleIndicators(3, new double[]{1.0,1.0,1.0}, new double[]{1.0,1.0,1.0});
        fullModel.fixParameter(3, 100.0);
        varFixedModel = LinearModel.fixParameter(fullModel, 2, 0.0);
        varFixedModel.fixParameter(1, 0.0);
        
        int runID = 0;
        long time;
        System.out.println("RES\tERR\tpower00\tpower01\tpower10\tpower11");
        for (int cond = 0; cond<4*4*2*2; cond++)
        {
            int nr = cond;
            
            int N = (nr%2==0?200:500); nr /= 2;
            double correlation = (nr%2==0?0.0:0.5); nr /= 2;
            double latentResidual = (nr%4==0?0:(nr%4==1?5:(nr%4==2?10:20))); nr /= 4;
            double measurementError = (nr%4==0?1:(nr%4==1?16:(nr%4==2?31:61))); nr /= 4;
            
            fullModel.setParameterValue(1,correlation * Math.sqrt(100*50)); 
            varFixedModel.setParameterValue(1,correlation * Math.sqrt(100*50)); 
            for (int i=0; i<5; i++) varFixedModel.facCovVal[i+2][i+2] = fullModel.facCovVal[i+2][i+2] = latentResidual;
            for (int i=0; i<15; i++) varFixedModel.errVal[i] = fullModel.errVal[i] = measurementError;

            int reject = 0, valid = 0;
            for (int trial = 0; trial < anzTrials; trial++)
            {
                fullModel.createData(N); varFixedModel.setData(fullModel.data);

                leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
                twollEstimate = twollAproxLinearModel(fullModel, leastSquareEstimate);
                double fullTwoll = twollValue;
                leastSquareEstimate = varFixedModel.leastSquareAproxLinearModel();
                twollEstimate = twollAproxLinearModel(varFixedModel, leastSquareEstimate);
                if (twollEstimate==null) haywood ++; 
                else {if (twollValue - fullTwoll > CHISQ2) reject++; valid++;}

                runID++;
            }
            
            double power = (double)reject/(double)valid;
            if (cond%4 == 0) System.out.print("\r\n"+latentResidual+" & "+measurementError+" & "+
                    (100/(100+measurementError+latentResidual))+" & "+latentResidual+(measurementError/3.0));
            System.out.print(" & "+power);
        }
        System.out.println("\r\nI finished, found "+haywood+" cases without converged -2 log likelihood.");
    }

    public void manualTestOfDifferentIntercepts(int anzTrials, BufferedWriter psAll, BufferedWriter psPower)
	{
	    anzTrials = 1000;
	    LinearModel fullModel, covFixedModel, varFixedModel;
	    boolean yoked = true;
	    double svar = 25;
	    double cov = 0.25 * Math.sqrt(100*svar);
	    double err = 100;
        fullModel = new LinearModel(
                new double[][]{{1,0.0},{1,0.1},{1,0.2},{1,0.3},{1,0.4},{1,0.5},{1,0.6},{1,0.7},{1,0.8},{1,0.9}},
                new int[][]{{0,2},{2,1}},
                new double[][]{{100,cov},{cov,svar}},
                new int[]{-1,-1},
                new double[]{100,-20},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{err,err,err,err,err,err,err,err,err,err}
                );
	    fullModel.createData(100);
        covFixedModel = LinearModel.fixParameter(fullModel, 2+fullModel.anzMeanPar, 0.0);
        varFixedModel = LinearModel.fixParameter(covFixedModel, 1+fullModel.anzMeanPar, 0.0);

        int anzVar = fullModel.anzVar;
        	
        int[] rejectCov = new int[10], rejectVar1 = new int[10], rejectVar2 = new int[100];
		int haywood = 0;

		double[] leastSquareEstimate = null, twollEstimate = null;
        int runID = 0;
        long time = System.currentTimeMillis();
        String erg = "";
    		
		int anzPer = 200;
		double[] twollVals = new double[3];
		
		double[] realValues = {100,svar,cov,err};
		if (fullModel.anzMeanPar>0) realValues = new double[]{100,-20,100,svar,cov,err};
		String lsString, twllString;
		
		double[][] twllDiffSum = new double[10][2];

		for (int trial = 0; trial < anzTrials; trial++)
		{
		    System.out.println("Starting trial "+trial);
		    for (int i=0; i<10; i++)
		    {
		        fullModel.structure[i][1] = i*0.1;
		        varFixedModel.structure[i][1] = i*0.1;
		        covFixedModel.structure[i][1] = i*0.1;
		    }

		    fullModel.createData(anzPer);
			for (int intercept=0; intercept < 10; intercept+=1)
		    {
			    if (!yoked) fullModel.createData(anzPer);
    		    erg = runID+"\t"+intercept+"\t";
    		    for (int i=0; i<10; i++)
    		    {
    		        fullModel.structure[i][1] = i*0.1 - intercept*0.1;
    		        varFixedModel.structure[i][1] = i*0.1 - intercept*0.1;
    		        covFixedModel.structure[i][1] = i*0.1 - intercept*0.1;
    		    }

		        for (int psel = 0; psel<3; psel++)
    		    {
		            lsString = ""; twllString = ""; String parVarString = "";
		            if (psel==0)
		            {
	    		        leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(fullModel, leastSquareEstimate);
	    		        for (int i=0; i<3+fullModel.anzMeanPar; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t";
	    		        if (twollEstimate != null) 
	    		        {
	    		            for (int i=0; i<3+fullModel.anzMeanPar; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t";
	    		        }
		            }
		            if (psel==1)
		            {
		                covFixedModel.setData(fullModel.data);
	    		        leastSquareEstimate = covFixedModel.leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(covFixedModel, leastSquareEstimate);
	    		        for (int i=0; i<2+fullModel.anzMeanPar; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t"; 
	    		        lsString += "0.000\t"; //lsString += Statik.doubleNStellen(leastSquareEstimate[2+fullModel.anzMeanPar],DIGITS)+"\t"; 
	    		        if (twollEstimate != null) 
		    		    {
	    		            for (int i=0; i<1+fullModel.anzMeanPar; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t"; 
		    		        twllString += "0.000\t"; //twllString += Statik.doubleNStellen(twollEstimate[2+fullModel.anzMeanPar],DIGITS)+"\t"; 
		    		    }
		            }
		            if (psel==2)
		            {
		                varFixedModel.setData(fullModel.data);
	    		        leastSquareEstimate = varFixedModel.leastSquareAproxLinearModel();
	    		        twollEstimate = twollAproxLinearModel(varFixedModel, leastSquareEstimate);
	    		        for (int i=0; i<1+fullModel.anzMeanPar; i++) lsString += Statik.doubleNStellen(leastSquareEstimate[i],DIGITS)+"\t"; 
	    		        lsString += "0.000\t0.000\t"; 
	    		        if (twollEstimate != null) 
		    		    {
	    		            for (int i=0; i<1+fullModel.anzMeanPar; i++) twllString += Statik.doubleNStellen(twollEstimate[i],DIGITS)+"\t"; 
		    		        twllString += "0.000\t0.000\t"; 
		    		    }
		            }
		            for (int i=0; i<3+fullModel.anzMeanPar; i++) erg += Statik.doubleNStellen(realValues[i],DIGITS)+"\t";
		            erg += anzPer+"\t";
    		        erg += (psel+1)+"\t";
    		        erg += lsString+parVarString;
					if (twollEstimate==null)
					{
					    for (int i=0; i<3+fullModel.anzMeanPar; i++) erg += "-999\t";
					    haywood++;
					} else {
					    erg += twllString;
						erg += Statik.doubleNStellen(twollComplete,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollStartValue,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollValue,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollIndependent1,DIGITS) + "\t";
						erg += Statik.doubleNStellen(twollIndependent2,DIGITS) + "\t";
						twollVals[psel] = twollValue;
					}
    		    }
		        twllDiffSum[intercept][0] += twollVals[1] - twollVals[0];
		        twllDiffSum[intercept][1] += twollVals[2] - twollVals[0];
				if (twollVals[1] - twollVals[0] > CHISQ1) rejectCov[intercept]++;
				if (twollVals[2] - twollVals[1] > CHISQ1) rejectVar1[intercept]++;
				if (twollVals[2] - twollVals[0] > CHISQ2) rejectVar2[intercept]++;

				try {
			        psAll.write(erg+"\r\n"); psAll.flush();
			    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}
	    		runID++;
		    }

		    System.out.println("Finished condition, time = "+(System.currentTimeMillis()-time));
    		System.gc();
        }
	    try {
    		String powerErg = "";
    		for (int i=0; i<10; i++)
    		    powerErg += (rejectCov[i] / (double)anzTrials)+"\t"+(rejectVar1[i] / (double)anzTrials)+"\t"+(rejectVar2[i] / (double)anzTrials)+"\r\n";
		    psPower.write(powerErg+"\r\n");
		    psPower.write("\r\n");
		    for (int i=0; i<10; i++)
		    {
		        for (int j=0; j<2; j++)
		            psPower.write((twllDiffSum[i][j]/anzTrials)+"\t");
		    	psPower.write("\r\n");
		    }
		    psPower.flush();
	        psPower.close();
	    } catch (IOException e) {System.out.println("I encountered problems while trying to save data.");}

        System.out.println("I finished, encountered "+haywood+" cases without converged -2 log likelihood.");
	}

	public void annaModellSimple()
	{
	    double[][] coupleD = Statik.loadMatrix("timo.dat",'\t');
	    int[][] couple = new int[coupleD.length][2]; 
	    for (int i=0; i<coupleD.length; i++)
	        for (int j=0; j<2; j++) couple[i][j] = (int)Math.round(coupleD[i][j]);
        double[][] structure = new double[144][72];
        for (int i=0; i<structure.length; i++)
            for (int j=0; j<structure[0].length; j++) structure[i][j] = 0;
        for (int c=0; c<couple.length; c++)
        {
            structure[c][couple[c][0]] = 0.5;
            structure[c][couple[c][1]] = 0.5;
        }
        int[][] facCovPar = new int[72][72]; double[][] facCovVal = new double[72][72];
        for (int i=0; i<facCovPar.length; i++) 
            for (int j=0; j<facCovPar[i].length; j++) {facCovPar[i][j] = LinearModel.NOPARAMETER; facCovVal[i][j] = 0.0;}
        for (int i=0; i<4; i++)
	        for (int j=0; j<facCovPar.length/4; j++)
	            facCovPar[i*18+j][i*18+j] = i+4;
        double[] facMeanVal = new double[72]; for (int i=0; i<72; i++) facMeanVal[i] = 0.0;
        int[] facMeanPar = new int[72]; for (int i=0; i<72; i++) facMeanPar[i] = LinearModel.NOPARAMETER;
        for (int i=0; i<4; i++)
	        for (int j=0; j<facMeanPar.length/4; j++)
	            facMeanPar[i*18+j] = i;

        int[] errPar = new int[144]; for (int i=0; i<144; i++) errPar[i] = 8;
        double[] errVal = new double[144];

        LinearModel model = new LinearModel(structure, facCovPar, facCovVal, facMeanPar, facMeanVal, errPar, errVal);
        
        double[] trueVals = new double[]{0.01,0.01,0.01,0.01,0.01,0.01,0.01,0.01,0.01};
        model.setParameterValue(trueVals);
//        model.createData(1);
        double grandMean = 0.0; for (int i=0; i<144; i++) grandMean += coupleD[i][2];
        grandMean /= 144;
        System.out.println("Grand Mean = "+grandMean);
        double[][] data = new double[1][144];
        for (int i=0; i<144; i++) data[0][i] = coupleD[i][2] - grandMean;
        model.setData(data);
        
//        double[][] area = new double[8][8];
//        double[] xd = new double[]{0,0};
//        for (int vc = 0; vc<area.length; vc++)
//        {
//            System.out.println("vc = "+vc);
//            xd[0] = 0.05 + 0.05 * vc;
//            for (int ec = 0; ec < area[vc].length; ec++)
//	        {
//                xd[1] = 0.045 + 0.005 * ec;
//                area[vc][ec] = twollEvaluate(model, xd);	            
//	        }
//        }
//        Statik.writeMatrix(area, "area.txt",'\t');
        System.out.println("Starting estimation.");
        
        double[] twollEstimate = twollAproxLinearModel(model, new double[]{10,10,10,10,10,10,10,10,10});
        
        for (int i=0; i<trueVals.length; i++)
            System.out.println(i+"\t"+trueVals[i]+"\t"+twollEstimate[i]);
	}
	
	public void annaModell()
	{
	    int TPC = 16;			// Trials per couple
	    int[][] parOfCouples = new int[][]{{4,5,6,7},{5,8,9,10},{6,8,11,12},{7,9,11,13}}; 
	    double[][] coupleD = Statik.loadMatrix("probandenzuordnung.txt",'\t');
	    int[][] couple = new int[coupleD.length][coupleD[0].length]; 
	    for (int i=0; i<coupleD.length; i++)
	        for (int j=0; j<coupleD[i].length; j++) couple[i][j] = (int)Math.round(coupleD[i][j]);
        double[][] structure = new double[TPC * 144][72 + 144];
        for (int i=0; i<structure.length; i++)
            for (int j=0; j<structure[0].length; j++) structure[i][j] = 0;
        for (int c=0; c<couple.length; c++)
            for (int t=0; t<TPC; t++)
            {
                structure[c*TPC+t][couple[c][0]] = 1;
                structure[c*TPC+t][couple[c][1]] = 1;
                structure[c*TPC+t][72 + c]    = 1;
            }
        
        int[][] facCovPar = new int[72+144][72+144]; double[][] facCovVal = new double[72+144][72+144];
        for (int i=0; i<facCovPar.length; i++) 
            for (int j=0; j<facCovPar[i].length; j++) {facCovPar[i][j] = LinearModel.NOPARAMETER; facCovVal[i][j] = 0.0;}
        for (int g=0; g<4; g++) 
            for (int i=0; i<18; i++) facCovPar[i+18*g][i+18*g] = 0;
        for (int c=0; c<couple.length; c++)
            facCovPar[72 + c][72 + c] = parOfCouples[couple[c][0]/18][couple[c][1]/18];
        
        double[] facMeanVal = new double[144+72]; for (int i=0; i<144+72; i++) facMeanVal[i] = 0.0;
        int[] facMeanPar = new int[144+72]; for (int i=0; i<144+72; i++) facMeanPar[i] = LinearModel.NOPARAMETER; 
            
        int[] errPar = new int[144*TPC]; for (int i=0; i<144*TPC; i++) errPar[i] = 14;
        double[] errVal = new double[144*TPC];
        
        LinearModel model = new LinearModel(structure, facCovPar, facCovVal, facMeanPar, facMeanVal, errPar, errVal);
        
        double[] trueVals = new double[]{100,100,100,100,20,20,20,20,20,20,20,20,20,20,10};
        model.setParameterValue(trueVals);
        model.createData(1);

//        double[] leastSquareEstimate = model.leastSquareAproxLinearModel();
        double[] twollEstimate = twollAproxLinearModel(model, trueVals);
        
        for (int i=0; i<trueVals.length; i++)
            System.out.println(i+"\t"+trueVals[i]+"\t"+twollEstimate[i]);
	}

	public void juliusModel()
	{
	    double[][] dataOld = Statik.loadMatrix("juliusOldData.txt",'\t'); 
	    double[][] dataVeryOld = Statik.loadMatrix("juliusVeryOldData.txt",'\t'); 

        LinearModel linearModel = new LinearModel(
                new double[][]{{1,0},{1,1},{1,2},{1,3},{1,4}},
                new int[][]{{2,3},{3,4}},
                new double[][]{{0.5,0},{0,0.5}},
                new int[]{0,1},
                new double[]{0.5,0.0},
                new int[]{5,5,5,5,5},
                new double[]{0.5,0.5,0.5,0.5,0.5}
                );
        
        linearModel.picDatapoints(new int[]{1,2,3,4});
        dataOld = Statik.submatrix(dataOld, null, new int[]{1,2,3,4});
        dataVeryOld = Statik.submatrix(dataVeryOld, null, new int[]{1,2,3,4});
        
        LinearModel linearModelFixed = LinearModel.fixParameter(linearModel, 3);
        
        linearModel.setData(dataOld);
        double[] initial = new double[]{0.5,0.0,0.01,0.0,0.01,0.01};
        double[] twollEstimateOld = twollAproxLinearModel(linearModel, initial);
//        double mem = twollValue;
        linearModel.setData(dataVeryOld);
        initial = new double[]{0.5,0.0,0.01,0.0,0.01,0.01};
        double[] twollEstimateVeryOld = twollAproxLinearModel(linearModel, initial);
        double mem = twollValue;
        linearModelFixed.setData(dataVeryOld);
        linearModelFixed.setParameterValueAccordingToOtherModel(linearModel, 3, 0.00);
        initial = new double[]{0.5,0.0,0.01,0.0,0.01,0.01};
        double[] twollEstimateFixed = twollAproxLinearModel(linearModelFixed, initial);
        double diff = twollValue - mem;        

        System.out.println("Nr\tInitial\tOld\tVery Old\tfixed");
        for (int i=0; i<initial.length; i++)
            System.out.println(i+"\t"+initial[i]+"\t"+twollEstimateOld[i]+"\t"+twollEstimateVeryOld[i]+"\t"+twollEstimateFixed[(i>0?i-1:i)]);
        System.out.println("TWOLL Difference = "+diff);
        System.out.println("Significant to niveau: "+Statik.chiSquareDensity(1, 0, diff));

	
        LinearModel quadraticModel = new LinearModel(
                new double[][]{{1,0,0},{1,1,1},{1,2,4},{1,3,9},{1,4,16}},
                new int[][]{{3,4,5},{4,6,7},{5,7,8}},
                new double[][]{{0.5,0,0},{0,0.5,0},{0,0,0.5}},
                new int[]{0,1,2},
                new double[]{0.5,0.0,0.0},
                new int[]{9,9,9,9,9},
                new double[]{0.5,0.5,0.5,0.5,0.5}
                );
        quadraticModel.picDatapoints(new int[]{1,2,3,4});
        LinearModel quadraticModelFixed = LinearModel.fixParameter(quadraticModel, 1);
//        quadraticModelFixed.fixParameter(1);
        
        quadraticModel.setData(dataOld);
        initial = new double[]{0.5,0.0,0.0,0.01,0.0,0.0,0.01,0.0,0.01,0.01};
        double[] twollEstimateOldQ = twollAproxLinearModel(quadraticModel, initial);
        quadraticModel.setData(dataVeryOld);
        double[] twollEstimateVeryOldQ = twollAproxLinearModel(quadraticModel, initial);
        mem = twollValue;
        quadraticModelFixed.setData(dataVeryOld);
        quadraticModelFixed.setParameterValueAccordingToOtherModel(quadraticModel, 1, twollEstimateOldQ[1]);
//        quadraticModelFixed.setParameterValueAccordingToOtherModel(quadraticModel, 2, twollEstimateOldQ[2]);
        initial = new double[]{0.5,0.0,0.01,0.0,0.0,0.01,0.0,0.01,0.01};
        double[] twollEstimateVeryOldFixedQ = twollAproxLinearModel(quadraticModelFixed, initial);
        diff = twollValue - mem;        

        initial = new double[]{0.5,0.0,0.0,0.01,0.0,0.0,0.01,0.0,0.01,0.01};
        System.out.println("Nr\tInitial\tOld\tVery Old\tVery Old fixed");
        for (int i=0; i<initial.length; i++)
        {
            if (i<1) System.out.println(i+"\t"+initial[i]+"\t"+twollEstimateOldQ[i]+"\t"+twollEstimateVeryOldQ[i]+"\t"+twollEstimateVeryOldFixedQ[i]);
            if ((i==1)) System.out.println(i+"\t"+initial[i]+"\t"+twollEstimateOldQ[i]+"\t"+twollEstimateVeryOldQ[i]);
            if (i>1) System.out.println(i+"\t"+initial[i]+"\t"+twollEstimateOldQ[i]+"\t"+twollEstimateVeryOldQ[i]+"\t"+twollEstimateVeryOldFixedQ[i-1]);
        }
        System.out.println("TWOLL Difference = "+diff);
        System.out.println("Significant to niveau: "+Statik.chiSquareDensity(1, 0, diff));
        
	}
	
	
	public void stoelEtAl()
	{
	    int anzTrials = 1000;
	    LinearModel fullModel, varFixedModel;
	    double svar = 25;
	    double cov = 0.25 * Math.sqrt(100*svar);
	    double err = 10;
        fullModel = new LinearModel(
                new double[][]{{1,0.0},{1,0.2},{1,0.4},{1,0.8}},
                new int[][]{{-1,1},{1,0}},
                new double[][]{{100,cov},{cov,svar}},
                new int[]{-1,-1},
                new double[]{100,-20},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{err,err,err,err,err,err,err,err,err,err}
                );
        varFixedModel = LinearModel.fixParameter(LinearModel.fixParameter(fullModel, 1, 0.0), 0, 0.0);
	    double[][] restrictedCorrelationMatrix = varFixedModel.evaluateSigma();
	    double baseline = SimpleLGM.twollMatrixCompareEvaluate(restrictedCorrelationMatrix, restrictedCorrelationMatrix);

        double[][] fitVal = new double[100][100];
        for (int ccount = 0; ccount < 100; ccount++)
            for (int varcount = 0; varcount < 100; varcount++)
            {
                svar = -100 + 2*varcount;
                cov  = -50 + ccount;
    		    fullModel.setParameterValue(0, svar);
    		    fullModel.setParameterValue(1, cov);

    		    double[][] dataCorrelationMatrix = fullModel.evaluateSigma();
    	 		fitVal[ccount][varcount] = SimpleLGM.twollMatrixCompareEvaluate(dataCorrelationMatrix, restrictedCorrelationMatrix)-baseline;
    	 		if (fitVal[ccount][varcount]>3) fitVal[ccount][varcount] = 0;
            }
        Statik.writeMatrix(fitVal, "Fitvalues.txt", '\t');

        fullModel.anzPer = 1000;
	    fullModel.setParameterValue(0, 0.0);
	    fullModel.setParameterValue(1, 0.0);
        fullModel.computeFisher();
        double[][] invFisher = Statik.invert(fullModel.fisherInformationMatrix);
        double[] pos = new double[2];
        for (int ccount = 0; ccount < 100; ccount++)
            for (int varcount = 0; varcount < 100; varcount++)
            {
                pos[0] = -100 + 2*varcount;
                pos[1]  = -50 + ccount;
                double v = Statik.multiply(pos, invFisher, pos);
                fitVal[ccount][varcount] = 1000000*Math.exp(-v/2.0);
            }
        Statik.writeMatrix(fitVal, "FitHitProb.txt", '\t');
        
        svar = -10;
        cov = 20;
        varFixedModel.setParameterValueAccordingToOtherModel(fullModel, 0,svar);
        varFixedModel.setParameterValueAccordingToOtherModel(fullModel, 1,cov);
	    restrictedCorrelationMatrix = varFixedModel.evaluateSigma();
	    baseline = SimpleLGM.twollMatrixCompareEvaluate(restrictedCorrelationMatrix, restrictedCorrelationMatrix);
        for (int ccount = 0; ccount < 100; ccount++)
            for (int varcount = 0; varcount < 100; varcount++)
            {
                svar = -100 + 2*varcount;
                cov  = -50 + ccount;
    		    fullModel.setParameterValue(0, svar);
    		    fullModel.setParameterValue(1, cov);

    		    double[][] dataCorrelationMatrix = fullModel.evaluateSigma();
    	 		fitVal[ccount][varcount] = SimpleLGM.twollMatrixCompareEvaluate(dataCorrelationMatrix, restrictedCorrelationMatrix)-baseline;
    	 		if (fitVal[ccount][varcount]>3) fitVal[ccount][varcount] = 0;
            }
        Statik.writeMatrix(fitVal, "FitvaluesNonzero.txt", '\t');
        
        fullModel.anzPer = 1000;
	    fullModel.setParameterValue(0, -10.0);
	    fullModel.setParameterValue(1, 20.0);
        fullModel.computeFisher();
        invFisher = Statik.invert(fullModel.fisherInformationMatrix);
        pos = new double[2];
        for (int ccount = 0; ccount < 100; ccount++)
            for (int varcount = 0; varcount < 100; varcount++)
            {
                pos[0] = (-100 + 2*varcount + 10.0);
                pos[1] = (-50  + ccount     - 20.0);
                double v = Statik.multiply(pos, invFisher, pos);
                fitVal[ccount][varcount] = 1000000*Math.exp(-v/2.0);
            }
        Statik.writeMatrix(fitVal, "FitHitProbNonZero.txt", '\t');
        
	}
	
	public void pengshengNi()
	{
	    int anzTrials = 10000;
	    double t = 1.0;
	    double scale = 4;
	    int N = 186;
        LinearModel fullModel = new LinearModel(
                new double[][]{{1,0,0,0},{1,t/2,0,0},{1,t,0,0},{0,0,1,0},{0,0,1,t/2},{0,0,1,t}},
                new int[][]{{-1,-1,-1,-1},{-1,-1,-1,0},{-1,-1,-1,-1},{-1,0,-1,-1}},
                new double[][]{{100,0,0,0},{0,50*scale,0,0.25*50*scale},{0,0,100,0},{0,0.25*50*scale,0,50*scale}},
                new int[]{-1,-1,-1,-1},
                new double[]{0,0,0,0},
                new int[]{-1,-1,-1,-1,-1,-1},
                new double[]{25,25,25,25,25,25}
                );
        LinearModel covFixedModel = LinearModel.fixParameter(fullModel, 0, 0.0);

        double[] leastSquareEstimate;
        int reject = 0;
		for (int trial = 0; trial < anzTrials; trial++)
		{
		    fullModel.createData(N);

	        leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
	        twollAproxLinearModel(fullModel, leastSquareEstimate);
	        double val = twollValue;
	        
	        covFixedModel.setData(fullModel.data);
	        leastSquareEstimate = covFixedModel.leastSquareAproxLinearModel();
	        twollAproxLinearModel(covFixedModel, leastSquareEstimate);

	        if (twollValue - val > CHISQ1) reject++;
	    }
		System.out.println("Power = "+((double)reject / (double)anzTrials));
		
	}
	
	public void methEvalPresentation()
	{
	    int anzTrials = 1000;
	    double[] erg = new double[200];
        int N = 100;
        double t = 10;
        int occ = 11;
	    double lev = 100.0;
	    double eff = 0.07;
	    double rel = 0.9;
	    double[][] structure = new double[occ][2];
	    double[] err = new double[occ]; int[] errFac = new int[occ];
	    for (int i=0; i<occ; i++)
	    {
	        structure[i] = new double[]{1,i*t/(double)(occ-1)};
            errFac[i] = -1; 
	        err[i] = lev*(1-rel)/rel; 
	    }
        LinearModel fullModel = new LinearModel(
                structure,
                new int[][]{{-1,-1},{-1,0}},
                new double[][]{{lev,0},{0,eff}},
                new int[]{-1,-1},
                new double[]{0,0},
                errFac,
                err
                );
        LinearModel covFixedModel = LinearModel.fixParameter(fullModel, 0, 0.0);
        fullModel.anzPer = 100;
        long startTime = System.currentTimeMillis();
        double ssVal = 0;
        for (int i=0; i<10000; i++)
            ssVal = sarrisSatoraPower(covFixedModel, fullModel);
        System.out.println("Saris Satorra Power = "+ssVal+", Time = "+(System.currentTimeMillis() - startTime));

        double[] leastSquareEstimate;
        startTime = System.currentTimeMillis();
        for (int rep = 0; rep < erg.length; rep++)
        {
            System.out.print("Starting repetition "+rep+" of "+erg.length+", so far "+(System.currentTimeMillis() - startTime)+" ms used");
            int reject = 0;
    		for (int trial = 0; trial < anzTrials; trial++)
    		{
    		    fullModel.createData(N);
    
    	        leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
    	        twollAproxLinearModel(fullModel, leastSquareEstimate);
    	        double val = twollValue;
    	        
    	        covFixedModel.setData(fullModel.data);
    	        leastSquareEstimate = covFixedModel.leastSquareAproxLinearModel();
    	        twollAproxLinearModel(covFixedModel, leastSquareEstimate);
    
    	        if (twollValue - val > CHISQ1) reject++;
    	    }
    		erg[rep] = ((double)reject / (double)anzTrials);
            Statik.writeMatrix(erg, "power11Occasions.txt");
    		System.out.println(", Power = "+((double)reject / (double)anzTrials));
        }
        System.out.println("Finished, took me "+(System.currentTimeMillis() - startTime)+" ms.");
	}

    public double bjmspRevision(int N, int anzTrials, double t, int occ)
    {
        double erg = -1.0;
        double lev = 100.0;
        double eff = 0.07;
        double rel = 0.9;
        double[][] structure = new double[occ][2];
        double[] err = new double[occ]; int[] errFac = new int[occ];
        for (int i=0; i<occ; i++)
        {
            structure[i] = new double[]{1,i*t/(double)(occ-1)};
            errFac[i] = 1; 
            err[i] = lev*(1-rel)/rel; 
        }
        LinearModel fullModel = new LinearModel(
                structure,
                new int[][]{{-1,-1},{-1,0}},
                new double[][]{{lev,0},{0,eff}},
                new int[]{-1,-1},
                new double[]{0,0},
                errFac,
                err
                );
        LinearModel covFixedModel = LinearModel.fixParameter(fullModel, 1, 999.9);
        covFixedModel = LinearModel.fixParameter(covFixedModel,0, 0.0);
        fullModel.anzPer = N;
        long startTime = System.currentTimeMillis();

        double[] leastSquareEstimate, twollEstimate;
        startTime = System.currentTimeMillis();
        int reject = 0;
        for (int trial = 0; trial < anzTrials; trial++)
        {
            fullModel.createData(N);

            leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
            twollEstimate = twollAproxLinearModel(fullModel, leastSquareEstimate);
            double val = twollValue;
            
            covFixedModel.setData(fullModel.data);
            for (int i=0; i<occ; i++) covFixedModel.errVal[i] = twollEstimate[1];
            leastSquareEstimate = covFixedModel.leastSquareAproxLinearModel();
            twollEstimate = twollAproxLinearModel(covFixedModel, leastSquareEstimate);

            if (twollValue - val > CHISQ1) reject++;
        }
        erg = ((double)reject / (double)anzTrials);
//        System.out.println("N = "+N+", t = "+t+", occ = "+occ+", Power = "+((double)reject / (double)anzTrials));
//        System.out.println("Finished, took me "+(System.currentTimeMillis() - startTime)+" ms.");
        return erg;
    }

    public void miOneVariableSimulation()
	{
	    int anzTrials = 10000;
	    int N = 200;
	    double lvar = 100;
	    double svar = 50;
	    double cov = 0.25*Math.sqrt(100*50);
        LinearModel fullModel, varFixedModel;
        fullModel = new LinearModel(
                new double[][]{{1,0},{1,.1},{1,.2},{1,.3},{1,0.4}},
                new int[][]{{-1,1},{1,0}},
                new double[][]{{lvar,cov},{cov,svar}},
                new int[]{-1,-1},
                new double[]{100,-20},
                new int[]{-1,-1,-1,-1,-1},
                new double[]{20,20,20,20,20}
                );
        varFixedModel = LinearModel.fixParameter(LinearModel.fixParameter(fullModel, 1, 0.0), 0, 0.0);
	    
        double[] erg = new double[100]; erg[0] = 1.0;
        double[] leastSquareEstimate;
        for (int errC = 1; errC < erg.length; errC++)
        {
            System.out.println("Starting with "+errC);
            int reject = 0;
            double err = 150+(double)errC*150.0/(double)erg.length;
            for (int i=0; i<fullModel.errVal.length; i++) fullModel.errVal[i] = err;
            for (int i=0; i<varFixedModel.errVal.length; i++) varFixedModel.errVal[i] = err;
            for (int trial = 0; trial < anzTrials; trial++)
            {
                fullModel.createData(N);
    
                leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
                twollAproxLinearModel(fullModel, leastSquareEstimate);
                double val = twollValue;
                
                varFixedModel.setData(fullModel.data);
                leastSquareEstimate = varFixedModel.leastSquareAproxLinearModel();
                twollAproxLinearModel(varFixedModel, leastSquareEstimate);
    
                if (twollValue - val > CHISQ2) reject++;
            }
            erg[errC] = ((double)reject/(double)anzTrials);
            Statik.writeMatrix(erg, "MIPower");
        } 
	}
	
	public void anonymusPaper()
	{
	    int anzTrials = 10000;
	    int N = 336;
	    int T = 6;
	    double varL = 0.5;
	    double eff = 0.2;
	    int K = 3;
	    double err = (0.5/0.6 - 0.5)/K + 0.5;
	    
	    double sThetaS = 12*err / (T*T*T - T);
	    double x = (T-1)/2;
	    double sThetaT = err/T;
	    
	    double effErrEQ7 = sThetaS;
	    double effErrEQ9 = sThetaS - (sThetaS*x - 0)*(sThetaS*x - 0) / (sThetaT + varL + sThetaS*x*x);
	    double effErrEQ10 = 1 / ( (1/sThetaS) + (x*x/(sThetaT + varL)));
	    
	    double effErr = effErrEQ10;
	    System.out.println(effErrEQ7 + " : "+effErrEQ9 + " : "+effErrEQ10);
	
	    /*
	    // Oder of L1, S1, L2, S2					T = 4
        LinearModel orgModel = new LinearModel(
                new double[][]{{1,0,0,0},{1,1,0,0},{1,2,0,0},{1,3,0,0},{0,0,1,0},{0,0,1,1},{0,0,1,2},{0,0,1,3}},
                new int[][]{{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1}},
                new double[][]{{varL,0,0,0},{0,0.1,0,0},{0,0,varL,0},{0,0,0,0.1}},
//                new int[]{0,2,1,3},
                new int[]{0,1,0,2},
                new double[]{0,0.5*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1),0,(0.5+eff)*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1)},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{err,err,err,err,err,err,err,err}
                );
        LinearModel sameSlopeMeanModel = new LinearModel(
                new double[][]{{1,0,0,0},{1,1,0,0},{1,2,0,0},{1,3,0,0},{0,0,1,0},{0,0,1,1},{0,0,1,2},{0,0,1,3}},
                new int[][]{{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1}},
                new double[][]{{varL,0,0,0},{0,0.1,0,0},{0,0,varL,0},{0,0,0,0.1}},
//                new int[]{0,2,1,2},
                new int[]{0,1,0,1},
                new double[]{0,0.5*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1),0,(0.5+eff)*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1)},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{err,err,err,err,err,err,err,err}
                );
        */
        // Oder of L1, S1, L2, S2					T = 6
        LinearModel orgModel = new LinearModel(
                new double[][]{{1,0,0,0},{1,1,0,0},{1,2,0,0},{1,3,0,0},{1,4,0,0},{1,5,0,0},{0,0,1,0},{0,0,1,1},{0,0,1,2},{0,0,1,3},{0,0,1,4},{0,0,1,5}},
                new int[][]{{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1}},
                new double[][]{{varL,0,0,0},{0,0.1,0,0},{0,0,varL,0},{0,0,0,0.1}},
//                new int[]{0,2,1,3},
                new int[]{0,1,0,2},
                new double[]{0,0.5*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1),0,(0.5+eff)*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1)},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{err,err,err,err,err,err,err,err,err,err,err,err}
                );
        LinearModel sameSlopeMeanModel = new LinearModel(
                new double[][]{{1,0,0,0},{1,1,0,0},{1,2,0,0},{1,3,0,0},{1,4,0,0},{1,5,0,0},{0,0,1,0},{0,0,1,1},{0,0,1,2},{0,0,1,3},{0,0,1,4},{0,0,1,5}},
                new int[][]{{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1},{-1,-1,-1,-1}},
                new double[][]{{varL,0,0,0},{0,0.1,0,0},{0,0,varL,0},{0,0,0,0.1}},
//                new int[]{0,2,1,2},
                new int[]{0,1,0,1},
                new double[]{0,0.5*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1),0,(0.5+eff)*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1)},
                new int[]{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
                new double[]{err,err,err,err,err,err,err,err,err,err,err,err}
                );

        
        LinearModel PEorgModel = new LinearModel(
                new double[][]{{1,0},{0,1}},
                new int[][]{{-1,-1},{-1,-1}},
                new double[][]{{0.1,0},{0,0.1}},
                new int[]{0,1},
                new double[]{0.5*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1),(0.5+eff)*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1)},
                new int[]{-1,-1},
                new double[]{effErr,effErr}
                );
        LinearModel PESameSlopeMeanModel = new LinearModel(
                new double[][]{{1,0},{0,1}},
                new int[][]{{-1,-1},{-1,-1}},
                new double[][]{{0.1,0},{0,0.1}},
                new int[]{0,0},
                new double[]{0.5*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1),(0.5+eff)*Math.sqrt(1.0+(T-1)*(T-1)*0.1)/(T-1)},
                new int[]{-1,-1},
                new double[]{effErr,effErr}
                );

        
        
        double[] leastSquareEstimate;
        int rejectFull = 0, rejectPE = 0;
		for (int trial = 0; trial < anzTrials; trial++)
		{
		    orgModel .createData(N);

	        leastSquareEstimate = orgModel .leastSquareAproxLinearModel();
	        twollAproxLinearModel(orgModel , leastSquareEstimate);
	        double val = twollValue;
	        
	        sameSlopeMeanModel .setData(orgModel.data);
	        leastSquareEstimate = sameSlopeMeanModel .leastSquareAproxLinearModel();
	        twollAproxLinearModel(sameSlopeMeanModel , leastSquareEstimate);

	        if (twollValue - val > CHISQ1) rejectFull++;
		
		    PEorgModel .createData(N);

	        leastSquareEstimate = PEorgModel.leastSquareAproxLinearModel();
	        twollAproxLinearModel(PEorgModel , leastSquareEstimate);
	        val = twollValue;
	        
	        PESameSlopeMeanModel .setData(PEorgModel.data);
	        leastSquareEstimate = PESameSlopeMeanModel .leastSquareAproxLinearModel();
	        twollAproxLinearModel(PESameSlopeMeanModel , leastSquareEstimate);

	        if (twollValue - val > CHISQ1) rejectPE++;
		}
		System.out.println("Power = "+((double)rejectFull / (double)anzTrials));
		System.out.println("Power (paper) = "+((double)rejectPE / (double)anzTrials));
	}
	
    public double salthouse(double varS, double reliability, double T)
    {
        int anzTrials = 1000;
        int N = 1000;
        double varL = 1;
        double covS = 0.6 * Math.sqrt(varS*varS);
        double err = varL/reliability - varL;
        
        // Oder of L1, S1, L2, S2                   T = 6
        LinearModel orgModel = new LinearModel(
                new double[][]{{1,0,0,0},{1,T,0,0},{0,0,1,0},{0,0,1,T}},
                new int[][]{{-1,-1,-1,-1},{-1,-1,-1,0},{-1,-1,-1,-1},{-1,0,-1,-1}},
                new double[][]{{varL,0,0.9*varL,0},{0,varS,0,covS},{0.9*varL,0,varL,0},{0,covS,0,varS}},
                new int[]{-1,-1,-1,-1},
                new double[]{0,0,0,0},
                new int[]{-1,-1,-1,-1},
                new double[]{err,err,err,err}
                );
        LinearModel fixedModel = LinearModel.fixParameter(orgModel, 0, 0.0);

        double[] leastSquareEstimate;
        int reject = 0;
        for (int trial = 0; trial < anzTrials; trial++)
        {
            orgModel.createData(N);

            leastSquareEstimate = orgModel.leastSquareAproxLinearModel();
            twollAproxLinearModel(orgModel, leastSquareEstimate);
            double val = twollValue;
            
            fixedModel.setData(orgModel.data);
            leastSquareEstimate = fixedModel.leastSquareAproxLinearModel();
            twollAproxLinearModel(fixedModel, leastSquareEstimate);

            if (twollValue - val > CHISQ1) reject++;
        }
        return (double)reject/(double)anzTrials;
    }

    // Just one variance source with one error source.
    public static void simplestSimulation()
    {
        SimpleLGM work = new SimpleLGM();
        int anzTrials = 100000;
        int N = 20;
        double var = 0.44;
        double err = 0.201;
        LinearModel fullModel, varFixedModel;
        fullModel = new LinearModel(
                new double[][]{{1}},
                new int[][]{{0}},
                new double[][]{{var}},
                new int[]{-1},
                new double[]{0},
                new int[]{-1},
                new double[]{err}
                );
        varFixedModel = LinearModel.fixParameter(fullModel, 0, 0.0);
        fullModel.anzPer = N;
        long startTime = System.currentTimeMillis();
        double ssVal = 0;
        for (int i=0; i<100000; i++)
            ssVal = work.sarrisSatoraPower(varFixedModel, fullModel);
        System.out.println("Saris Satorra Power = "+ssVal+", Time = "+(System.currentTimeMillis() - startTime));
        
        double[] erg = new double[1];
        double[] leastSquareEstimate;
        for (int rep = 0; rep < erg.length; rep++)
        {
            System.out.println("Starting repetition "+rep);
            int reject = 0;
            for (int trial = 0; trial < anzTrials; trial++)
            {
                fullModel.createData(N);
    
                leastSquareEstimate = fullModel.leastSquareAproxLinearModel();
                work.twollAproxLinearModel(fullModel, leastSquareEstimate);
                double val = work.twollValue;
                
                varFixedModel.setData(fullModel.data);
                leastSquareEstimate = varFixedModel.leastSquareAproxLinearModel();
                work.twollAproxLinearModel(varFixedModel, leastSquareEstimate);
    
                if (work.twollValue - val > work.CHISQ1) reject++;
            }
            erg[rep] = (double)reject/(double)anzTrials;
            Statik.writeMatrix(erg, "power1occasion.txt");
        } 
    }
    
    public double powerByBootstrap(LinearModel model, int anzRep, int bootN, int targetParameterNr, double nullValue, double[] startingValues)
    {
        double[] popEstimates = twollAproxLinearModel(model, (startingValues==null?model.leastSquareAproxLinearModel():startingValues));
        return powerByBootstrapWithPopulationEstimates(model,anzRep,bootN,targetParameterNr,nullValue,popEstimates);
    }
    public double powerByBootstrapWithPopulationEstimates(LinearModel model, int anzRep, int bootN, int targetParameterNr, double nullValue, double[] popEstimates)
    {
        double[][] popData = model.data;
        int N = popData.length;
        int K = popData[0].length;
        double[][] bootData = new double[bootN][K];
        double[][] participation = new double[N][2];
        for (int i=0; i<N; i++) {participation[i][0] = i; participation[i][1] = 0;}
        
        LinearModel free = new LinearModel(model);
        int anzPar = free.anzPar;
        for (int i=0; i<targetParameterNr; i++) free.fixParameter(0, popEstimates[i]); 
        for (int i=targetParameterNr+1; i<anzPar; i++) free.fixParameter(1, popEstimates[i]);
        free.setParameterValue(0, popEstimates[targetParameterNr]);
//        free.setParameterValue(0, nullValue);
        LinearModel fixed = new LinearModel(free);
        fixed.fixParameter(0, nullValue);
        free.data = fixed.data = bootData;      // error-prone, but should work here.
        free.anzPer = fixed.anzPer = bootN;
        
        double[] starting = {popEstimates[targetParameterNr]};
        double[] startingFixed = new double[0];
        
        int reject = 0;
        for (int rep=0; rep < anzRep; rep++)
        {
            for (int i=0; i<N; i++) participation[i][1] = Math.floor(participation[i][1]) + rand.nextDouble();
            java.util.Arrays.sort(participation, new java.util.Comparator<double[]>(){
                public int compare(double[] a, double[] b) {return (a[1]>b[1]?1:(a[1]<b[1]?-1:0));}
            });

            for (int i=0; i<bootN; i++)
            {
                participation[i][1] += 1;
                for (int j=0; j<K; j++) bootData[i][j] = popData[(int)Math.round(participation[i][0])][j];
            }
            free.createData(bootN); fixed.setData(free.data);
            free.computeMoments(); fixed.computeMoments();

            twollAproxLinearModel(free, starting);
            double val = twollValue;
            twollAproxLinearModel(fixed, startingFixed);

            if (twollValue - val > CHISQ1) reject++;
        
        }
        
        
        return ((double)reject)/((double)anzRep);
    }
    
    public static LinearModel createExponentialFloModel(int occ, double T)
    {
        final double EXPFACTOR = 0.22;
        double step = T / (double)(occ-1);
        
        double[][] structure = new double[occ][3];
        for (int i=0; i<occ; i++) {structure[i][0] = 1; structure[i][1] = Math.round(i*step)-100.0; structure[i][2] = -Math.exp(-EXPFACTOR*Math.round(i*step));}
        int[] errFac = new int[occ];
        double[] errVal = new double[occ];
        for (int i=0; i<occ; i++) {errFac[i] = 9; errVal[i] = 1.0;}

        LinearModel model = new LinearModel(
                structure,
                new int[][]{{3,4,5},{4,6,7},{5,7,8}},
                new double[][]{{1.0,0.0,0.0},{0.0,1.0,0.0},{0.0,0.0,1.0}},
                new int[]{0,1,2},
                new double[]{0,0,0},
                errFac,
                errVal
                );

        return model;
    }
    
    public static void manualFloDataTest(double[][] orgData, int occ, double T)
    {
        SimpleLGM lgm = new SimpleLGM();
        
//        int occ = 11;
//        double T = 31.67;
        double step = T / (double)(occ-1);
        int N = 40;     // bootstrap - N
        int targetParameter = 1;
        double targetNullValue = 0.0;
        int anzRep = 1000;
        
        double[][] structure = new double[occ][2];
        for (int i=0; i<occ; i++) {structure[i][0] = 1; structure[i][1] = Math.round(i*step);}
        int[] errFac = new int[occ];
        double[] errVal = new double[occ];
        for (int i=0; i<occ; i++) {errFac[i] = 5; errVal[i] = 1.0;}

        LinearModel model = new LinearModel(
                structure,
                new int[][]{{2,3},{3,4}},
                new double[][]{{1.0,0.0},{0.0,1.0}},
                new int[]{0,1},
                new double[]{0,0},
                errFac,
                errVal
                );

        double[][] modelData = new double[orgData.length][occ];
        for (int i=0; i<orgData.length; i++) 
            for (int j=0; j<occ; j++)
            {
                modelData[i][j] = orgData[i][(int)Math.round(j*step)];
//                if (modelData[i][j] < 0) System.out.println("Warning: Missing at person "+i+", row "+(j*step)+", I try next 5 entries.");
                int k=0; while ((k<5) && (modelData[i][j] < 0))
                {
                    modelData[i][j] = orgData[i][(int)Math.round(j*step)+1+k]; k++;
                }
                if (modelData[i][j] < 0) {System.out.println("Error: Too many subsequent missings at person "+i+"."); System.exit(1);}
            }
        model.setData(modelData);
        
        double power = lgm.powerByBootstrap(model, anzRep, N, targetParameter, targetNullValue, null);
        System.out.println("Power (occ = "+occ+") = "+power);
    }

    public static void manualFloDataTestExponential(double[][] orgData, int occ, double T, double[] startingValues)
    {
        SimpleLGM lgm = new SimpleLGM();
        if (startingValues == null) startingValues = estimateFullFloModel(orgData);
        
        double step = T / (double)(occ-1);
        int N = 40;     // N of the bootstrap
        int targetParameter = 1;
        double targetNullValue = 0.0;
        int anzRep = 10000;
        
        LinearModel model = createExponentialFloModel(occ, T);

        double[][] modelData = new double[orgData.length][occ];
        for (int i=0; i<orgData.length; i++) 
            for (int j=0; j<occ; j++)
            {
                modelData[i][j] = orgData[i][(int)Math.round(j*step)];
                if (modelData[i][j] < 0) System.out.println("Warning: Missing at person "+i+", row "+(j*step)+", I try next 5 entries.");
                int k=0; while ((k<5) && (modelData[i][j] < 0))
                {
                    modelData[i][j] = orgData[i][(int)Math.round(j*step)+1+k]; k++;
                }
                if (modelData[i][j] < 0) {System.out.println("Error: Too many subsequent missings at person "+i+"."); System.exit(1);}
            }
        model.setData(modelData);
        model.setParameterValue(startingValues);
        
//        double[] popEstimates = lgm.twollAproxLinearModel(model, startingValues);
        double power = lgm.powerByBootstrapWithPopulationEstimates(model, anzRep, N, targetParameter, targetNullValue, startingValues);
//        System.out.println("Power (occ = "+occ+", T = "+T+") = "+power);
        System.out.print(power+"\t");
    }

    public static double[] estimateFullFloModel(double[][] inData)
    {
        SimpleLGM lgm = new SimpleLGM();

        LinearModel model = createExponentialFloModel(inData[0].length, inData[0].length);
        model.setData(inData);
//        model.fixParameter(8, 0.0001);
//        model.fixParameter(7, 0.00);
//        model.fixParameter(5, 0.00);
//        model.fixParameter(2, 0.00);

        double[] popLsEstimates = model.leastSquareAproxLinearModel();
        double[] popEstimates = lgm.twollAproxLinearModel(model, popLsEstimates);

        return popEstimates;
    }
    
    public static double[][] createFloDataTestExponential(int occ, double T, int N, double[] parameters)
    {
        SimpleLGM lgm = new SimpleLGM();

        final double EXPFACTOR = 0.22;
        double step = T / (double)(occ-1);
        
        LinearModel model = createExponentialFloModel(occ, T);
                
        model.setParameterValue(parameters);
        double[][] dataOut = model.createData(N);
//      for (int i=0; i<dataOut.length; i++)
//      for (int j=0; j<dataOut[0].length; j++)
//      {
//          if (dataOut[i][j] < 0.0) dataOut[i][j] = 0.0;
//          if (dataOut[i][j] > 1.0) dataOut[i][j] = 1.0;
//      }
        model.setData(dataOut);

        double[] popLsEstimates = model.leastSquareAproxLinearModel();
        double[] popEstimates = lgm.twollAproxLinearModel(model, popLsEstimates);
        System.out.print("Simulat data set estimate is ");
        for (int i=0; i<10; i++)
          System.out.print(popEstimates[i]+", ");
        System.out.println();
        System.out.println("MSE = "+Statik.abs(Statik.add(popEstimates, Statik.multiply(-1,parameters))));
        
        return dataOut;
    }

    public static double[][] read100DayData(String filename, int offset)
    {
        final int MAXSES = 120;
        double[][] raw = Statik.loadMatrix(filename, '\t');
        java.util.Vector<double[]> data = new java.util.Vector<double[]>();
        int vpid = -1, sid = -1;
        double[] datline = new double[MAXSES-offset+1];
        for (int i=0; i<raw.length; i++)
        {
            if ((int)Math.round(raw[i][0])!=vpid) 
            {
                if (vpid != -1) for (int j=sid; j<MAXSES+1; j++) datline[j-offset] = -999; 
                sid = 1; 
                if (vpid != -1) {data.add(datline); datline = new double[MAXSES-offset+1];} 
                vpid = (int)Math.round(raw[i][0]); 
            }
            if (sid >= offset) for (int j=sid; j<(int)Math.round(raw[i][1]); j++) datline[j-offset] = -999;
            sid = (int)Math.round(raw[i][1]);
            if (sid >= offset) {datline[sid-offset] = raw[i][2]; sid++;}
        }
        if (sid >= offset) for (int j=sid; j<MAXSES+1; j++) datline[j-offset] = -999; 
        data.add(datline);  
        double[][] erg = new double[data.size()][MAXSES-offset+1];
        for (int i=0; i<erg.length; i++) 
        {
            datline = (double[])data.elementAt(i);
            for (int j=0; j<MAXSES-offset+1; j++) erg[i][j] = datline[j];
        }
        return erg;
        
    }
    
    public static void reviewBJMSP373_050309()
    {
        int districts = 10;
        int schools = 3;
        int students = 20;
        double studentVar = .712;
        double schoolVar = .044;
        double popRo = 0.1;
        double districtVar = popRo*(studentVar+schoolVar)/(1-popRo);
        System.out.println("District Variance = "+districtVar);
        int highRep = 100;
        int anzRep = 50;
        
        double[][] structure = new double[schools*students][1+schools];
        for (int i=0; i<schools; i++)
            for (int j=0; j<students; j++)
            {
                structure[i*students+j][0] = 1;
                structure[i*students+j][i+1] = 1;
            }
        int[] errPar = new int[schools*students]; double[] errVal = new double[schools*students];
        for (int i=0; i<errPar.length; i++) {errPar[i] = 0; errVal[i] = studentVar;}
        int[][] cov = new int[1+schools][1+schools];
        for (int i=0; i<cov.length;i++) for (int j=0; j<cov.length;j++) cov[i][j] = -1;
        for (int i=0; i<cov.length; i++) cov[i][i] = 1;
        cov[0][0] = 2;
        double[][] covV = new double[1+schools][1+schools]; for (int i=0; i<cov.length; i++) covV[i][i] = schoolVar;
        covV[0][0] = districtVar;
        int[] mPar = new int[1+schools]; double[] mV = new double[1+schools];
        for (int i=0; i<schools+1; i++) {mPar[i] = -1; mV[i] = 0.0;}

        SimpleLGM tester = new SimpleLGM();
        LinearModel model = new LinearModel(
                structure,
                cov,
                covV,
                mPar,
                mV,
                errPar,
                errVal
                );
        double[] grad = new double[3];
        double[][] invFisher = new double[3][3];
        double[][] workMatrix = new double[3][3];
        double[] work = new double[3];
        int hSignificantlyBelow = 0, hSignificantlyAbove = 0;
        int hb2 = 0, ha2 = 0;
        
        double[] populationParameter = new double[]{studentVar,schoolVar,districtVar};
        for (int hrep = 0; hrep<highRep; hrep++)
        {
            int significantlyBelow = 0, significantlyAbove = 0;
            for (int rep=0; rep<anzRep; rep++)
            {
                model.createData(districts);
                double[] estimate = tester.twollAproxLinearModel(model, populationParameter);
                model.computeFisher(estimate);
                Statik.invert(model.fisherInformationMatrix, invFisher, workMatrix);
                double sum = (estimate[0] + estimate[1] + estimate[2]);
                double ro = estimate[2]/sum;
                grad[0] = grad[1] = -estimate[2] / (sum*sum); grad[2] = (estimate[0]+estimate[1])/(sum*sum);
                Statik.multiply(invFisher, grad, work);
                double se = Math.sqrt(Statik.multiply(grad, work)); 
                double seTrans = se / (ro*(1-ro));
                double roTrans= Math.log(ro / (1-ro));
                double lower = roTrans - 1.96*seTrans, upper = roTrans + 1.96*seTrans;
                lower = 1 / (1+Math.exp(-lower)); upper = 1 / (1+Math.exp(-upper));
                if (upper < popRo) significantlyBelow++;
                if (lower > popRo) significantlyAbove++;
            }
            hSignificantlyBelow += significantlyBelow; hSignificantlyAbove += significantlyAbove; 
            hb2 += significantlyBelow*significantlyBelow; ha2 += significantlyAbove*significantlyAbove; 
            System.out.print("Ratio below = \t"+(significantlyBelow / (double)anzRep));
            System.out.println("\t\tRatio above = \t"+(significantlyAbove / (double)anzRep));
        }
        System.out.print("Total Ratio below = "+(hSignificantlyBelow / (double)(anzRep*highRep)));
        System.out.println("\t\tTotal Ratio above = "+(hSignificantlyAbove / (double)(anzRep*highRep)));

        model.computeFisher(populationParameter);
        Statik.invert(model.fisherInformationMatrix, invFisher, workMatrix);
        double sum = (populationParameter[0] + populationParameter[1] + populationParameter[2]);
        grad[0] = grad[1] = -populationParameter[2] / (sum*sum); grad[2] = (populationParameter[0]+populationParameter[1])/(sum*sum);
        Statik.multiply(invFisher, grad, work);
        double sePop = Math.sqrt(Statik.multiply(grad, work));
        populationParameter[2] = 0.214;
        System.out.println("SE_pop(ro) = "+sePop);
        model.computeFisher(populationParameter);
        Statik.invert(model.fisherInformationMatrix, invFisher, workMatrix);
        sum = (populationParameter[0] + populationParameter[1] + populationParameter[2]);
        grad[0] = grad[1] = -populationParameter[2] / (sum*sum); grad[2] = (populationParameter[0]+populationParameter[1])/(sum*sum);
        Statik.multiply(invFisher, grad, work);
        sePop = Math.sqrt(Statik.multiply(grad, work));
        System.out.println("SE_.214(ro) = "+sePop);
        populationParameter[2] = 0.05;
        model.computeFisher(populationParameter);
        Statik.invert(model.fisherInformationMatrix, invFisher, workMatrix);
        sum = (populationParameter[0] + populationParameter[1] + populationParameter[2]);
        grad[0] = grad[1] = -populationParameter[2] / (sum*sum); grad[2] = (populationParameter[0]+populationParameter[1])/(sum*sum);
        Statik.multiply(invFisher, grad, work);
        sePop = Math.sqrt(Statik.multiply(grad, work));
        System.out.println("SE_.05(ro) = "+sePop);
     }
    
    public static void wetteManuel()
    {
        LinearModel model = new LinearModel(
                new double[][]{{1,0},{1,1}},
                new int[][]{{-1,-1},{-1,-1}},
                new double[][]{{1.0,0.5},{0.5,1.0}},
                new int[]{-1,0},
                new double[]{0,0},
                new int[]{-1,-1},
                new double[]{0.1,0.1}
                );
        SimpleLGM work = new SimpleLGM();
        
        int anzrep = 1000; double sumsum = 0; double sqsum = 0; int anzsup = 200;
        for (int sup = 0; sup<anzsup; sup++)
        {
            double sum = 0; 
            for (int rep=0; rep<anzrep; rep++)
            {
                model.createData(100);
                int anz = 0;for (int i=0; i<model.data.length; i++) if (model.data[i][0] > 0) anz++;
                double[][] ndata = new double[anz][2]; int j=0; for (int i=0; i<model.data.length; i++) if (model.data[i][0] > 0) ndata[j++] = model.data[i];
                model.setData(ndata);
                
                double[] est = work.twollAproxLinearModel(model, new double[]{0});
                sum += est[0]; 
            }
            double v = sum / (double)anzrep;
            sumsum += v;
            sqsum += v*v;
            System.out.println("Average estimated mean slope = \t"+(sum/(double)anzrep));
        }
        System.out.println("Total Average = "+(sumsum/(double)anzsup));
        System.out.println("Total STDV    = "+Math.sqrt((sqsum-sumsum*sumsum/(double)anzsup)/(double)anzsup));
    }
    
    /** 
     * computes the effective error to find a mean effect in slope (and a good approximation of the variance) with known variance of level and error variance
     * in a LGCM over time span T and K observations in addition to the baseline, with a survival rate of r per time unit.
     */ 
    public static double lgcmSpecialWithAttrition(double T, double K, double r, double lv, double err)
    {
        double inv = 0;
        // i is number of measurements in addition to baseline
        for (int i=1; i<=K; i++)
        {
            double Ti = (double)(T*i)/(double)K;
            double ni = Math.pow(r,Ti); if (i<K) ni -= Math.pow(r, Ti + (double)T/(double)(K));
            double linv = Ti*Ti * (i+1)*(lv*(i+1)*(i+2)+2*err*(2*i+1))/(12*err*i*(lv*(i+1)+err));
            inv += ni * linv;
        }
        return 1.0/inv;    
    }
    
    public static double[][] createExponentialData(double meanAsy, double varAsy, double meanRate, double varRate, double meanShift, double varShift, double startAge, double varError, int N, int time) 
    { double[][] erg = new double[N][time]; return createExponentialData(meanAsy, varAsy, meanRate, varRate, meanShift, varShift, startAge, varError, N, time, erg); }
    public static double[][] createExponentialData(double meanAsy, double varAsy, double meanRate, double varRate, double meanShift, double varShift, double startAge, double varError, int N, int time, double[][] erg)
    {
        double stdvAsy = Math.sqrt(varAsy), stdvRate = Math.sqrt(varRate), stdvShift = Math.sqrt(varShift), stdvErr = Math.sqrt(varError); 
        for (int i=0; i<N; i++)
        {
            double asy = rand.nextGaussian()*stdvAsy+meanAsy;
            double rate = rand.nextGaussian()*stdvRate+meanRate;
            double shift = rand.nextGaussian()*stdvShift+meanShift;
            
            for (int j=0; j<time; j++)
            {
                double err = rand.nextGaussian()*stdvErr;
                double score = asy - Math.exp(rate*(j+startAge-shift));
                erg[i][j] = score + err;
            }
        }
        return erg;
    }

    private static void setBreakpointInSplines(SingletonModel model, double sppt)
    {
        for (int i=0; i<model.anzVar; i++) {model.structureVal[i][1] = (i<sppt?(i-sppt)/(double)50:0) ; 
                                            model.structureVal[i][2] = (i>sppt?(i-sppt)/(double)50:0);} 
    }
    
    
    public static void developmentalSimulation(String[] args) {
        developmentalSimulation(Integer.parseInt(args[0]),Integer.parseInt(args[1]),Integer.parseInt(args[2]), 
                                Integer.parseInt(args[3]),Integer.parseInt(args[4]),args[5]);}
    public static void developmentalSimulation(int startCond, int endCond, int repetitions, int maxOccasionsSplines, int maxOccasionsFreebasis, String fileNameAddon)
    {
        try {
            final double EPS = 0.001;
            BufferedWriter ergWriter = new BufferedWriter(new FileWriter("DevSim"+startCond+"To"+endCond+"_"+fileNameAddon+".txt"));
            
            // Contains from the input: meanAsy, varAsy, meanRate, varRate, meanShift, varShift, varError, startAge, occ, N         10 
            // From the output,       : General: ll Saturated, ll Independent,                                                      2
            //                          No Growth Model (mean I, var I, error, ll)                                                  4
            //                          Linear Model, var S = 0 (mean (I,S), var I, error, ll)                                      5
            //                          Linear Model (mean (I,S), var (I,S), cov IS, error, ll)                                     7
            //                          Quadratic Model, var Q = 0 (mean (I,S,Q), var (I,S), cov (IS), error, ll)                   8
            //                          Quadratic Model (mean (I,S,Q), var (I,S,Q), cov (IS, IQ, SQ), error, ll)                    11
            //                          Spline Model (spline point, mean (I,S1,S2), var (I,S1,S2), cov(IS1, IS2, S1S2), error, ll)  12
            //                          Free Basis Model (startKind, mean (I), var (I,C), cov IC, error, 
            //                                            ll simple, ll LS, ll linear ML, ll mean basis, basis (50 values))         60
            double[] erg = new double[119];
    
            double[][] spaghetti = new double[30][51];
            double[][][][] rawData = new double[5][5][][]; // fr 5 #occ und 5 #N
            // 5 different # of occasions, each with following models:
            // Pure Intercept Model
            // Linear Model, no var S
            // Linear Model
            // Quadratic Model, no var Q
            // Quadratic Model
            // Free Basis Model
            // Linear Spline Model, breakpoint gets specified in the process.
            SingletonModel[][] model = new SingletonModel[5][7];
            for (int occNr = 0; occNr < 5; occNr++)
            {
                int occ=(occNr==0?6:(occNr==1?11:(occNr==2?16:(occNr==3?21:51))));
                double[][] structVal = new double[occ][1]; int[][] structPar = new int[occ][1]; 
                for (int i=0; i<occ; i++) {structVal[i][0] = 1; structPar[i][0] = -1;}
                model[occNr][0] = new SingletonModel(new int[]{0}, new double[]{0}, structPar, structVal, new int[][]{{1}}, new double[][]{{0}}, 2, 1);
    
                structVal = new double[occ][2]; structPar = new int[occ][2]; 
                for (int i=0; i<occ; i++) {structVal[i][0] = 1; structVal[i][1] = i/(double)50; structPar[i][0] = -1; structPar[i][1] = -1;}
                model[occNr][1] = new SingletonModel(new int[]{0,1}, new double[]{0,0}, structPar, structVal, 
                        new int[][]{{2,-1},{-1,-1}}, new double[][]{{1,0},{0,0}}, 3, 1);
                model[occNr][2] = new SingletonModel(new int[]{0,1}, new double[]{0,0}, structPar, structVal, 
                        new int[][]{{2,4},{4,3}}, new double[][]{{1,0},{0,1}}, 5, 1);
                
                structVal = new double[occ][3]; structPar = new int[occ][3]; 
                for (int i=0; i<occ; i++) {structVal[i][0] = 1; structVal[i][1] = i/(double)50; structVal[i][2] = i*i/(double)2500; structPar[i][0] = -1; structPar[i][1] = -1; structPar[i][2] = -1;}
                model[occNr][3] = new SingletonModel(new int[]{0,1,2}, new double[]{0,0,0}, structPar, structVal, 
                        new int[][]{{3,5,-1},{5,4,-1},{-1,-1,-1}}, new double[][]{{1,0,0},{0,1,0},{0,0,0}}, 6, 1);
                model[occNr][4] = new SingletonModel(new int[]{0,1,2}, new double[]{0,0,0}, structPar, structVal, 
                        new int[][]{{3,6,7},{6,4,8},{7,8,5}}, new double[][]{{1,0,0},{0,1,0},{0,0,1}}, 9, 1);
                
                structVal = new double[occ][3]; structPar = new int[occ][3]; 
                for (int i=0; i<occ; i++) {structVal[i][0] = 1; structPar[i][0] = structPar[i][1] = structPar[i][2] = -1;}
                model[occNr][5] = new SingletonModel(new int[]{0,1,2}, new double[]{0,0,0}, structPar, structVal, 
                        new int[][]{{3,6,7},{6,4,8},{7,8,5}}, new double[][]{{1,0,0},{0,1,0},{0,0,1}}, 9, 1);
                
                structVal = new double[occ][2]; structPar = new int[occ][2]; 
                for (int i=0; i<occ; i++) {structVal[i][0] = 1; structVal[i][1] = i/(double)50; structPar[i][0] = -1; structPar[i][1] = 4+i;}
                structPar[0][1] = -1; 
                model[occNr][6] = new SingletonModel(new int[]{0,-1}, new double[]{0,1}, structPar, structVal, 
                        new int[][]{{1,3},{3,2}}, new double[][]{{1,0},{0,1}}, 4, 1);
                
                for (int j=0; j<5; j++) 
                    rawData[occNr][j] = new double[(j==0?60:(j==1?200:(j==2?500:(j==3?1000:5000))))][occ];
            }
            
            double[] starting, erg1, erg2, erg3;
            double erg1v = MISSING, erg2v = MISSING, erg3v = MISSING, erg4v = MISSING, startingKind = MISSING;
            double[] splinePoint = new double[5];
            
            long time = System.currentTimeMillis(); int e2;
            for (int cond = startCond; cond < endCond+1; cond++)
            {
                System.out.print("Starting condition "+cond+", "+(System.currentTimeMillis()-time)+" ms since startup.");
                int nr = cond;
                
                int reliabilityNr = nr % 3; nr = nr/3;
                int samplesizeNr = nr % 5; nr = nr/5;                 
                
                double meanAsy = 30, varAsy = 20, meanRate = 0.05, varRate = 0, meanShift = 20, varShift = 20, startAge = 30;
                double rel = 0.8;
                if (reliabilityNr == 1) rel = 0.91; if (reliabilityNr == 2) rel = 0.99; 
                double varError = varAsy * (1.0-rel) / rel;
                int N = 60;
                if (samplesizeNr == 1) N = 200; if (samplesizeNr == 2) N = 500; if (samplesizeNr == 3) N = 1000; if (samplesizeNr == 4) N = 5000;
    
                for (int rep = 0; rep < repetitions; rep++)
                {
                    System.out.print(".");
                    createExponentialData(meanAsy, varAsy, meanRate, varRate, meanShift, varShift, startAge, varError, N, 51, rawData[4][samplesizeNr]);

                    if ((rep==0) && (samplesizeNr == 4))
                    {
                        for (int i=0; i<30; i++)
                            for (int j=0; j<51; j++)
                                spaghetti[i][j] = rawData[4][samplesizeNr][i][j];
                        Statik.writeMatrix(spaghetti, "Spaghetti"+reliabilityNr+".txt",'\t');
                    }                        
                    
                    for (int occNr = 0; occNr < 5; occNr++)
                    {
                        int occ = (occNr==0?6:(occNr==1?11:(occNr==2?16:(occNr==3?21:51))));
                        if (occ!=51) for (int j=0; j<occ; j++) for (int i=0; i<N; i++) rawData[occNr][samplesizeNr][i][j] = rawData[4][samplesizeNr][i][j];
                        for (int i=0; i<model[occNr].length; i++) model[occNr][i].setData(rawData[occNr][samplesizeNr]); 
                        e2 = 0;
                        erg[e2++] = meanAsy; erg[e2++] = varAsy; erg[e2++] = meanRate; erg[e2++] = varRate; 
                        erg[e2++] = meanShift; erg[e2++] = varShift; erg[e2++] = varError; erg[e2++] = 40; 
                        erg[e2++] = occ;
                        erg[e2++] = N;
                        erg[e2++] = model[occNr][0].getSaturatedLL();
                        erg[e2++] = model[occNr][0].getIndependentLL();
                        for (int modelNr = 0; modelNr < model[occNr].length; modelNr++)
                        {
                            if (modelNr < 5) model[occNr][modelNr].estimateML(model[occNr][modelNr].estimateLS(EPS),EPS);
                            if ((modelNr == 5) && (occNr < maxOccasionsSplines)) {
                                double l = 0.5, r = occ-1.5, c = 0.5*r;
                                setBreakpointInSplines(model[occNr][modelNr],l); model[occNr][modelNr].estimateML(EPS); double lv = model[occNr][modelNr].ll; 
                                setBreakpointInSplines(model[occNr][modelNr],r); model[occNr][modelNr].estimateML(EPS); double rv = model[occNr][modelNr].ll; 
                                setBreakpointInSplines(model[occNr][modelNr],c); model[occNr][modelNr].estimateML(EPS); double cv = model[occNr][modelNr].ll;
                                while (r-l > 0.5)
                                {
                                    double a1 = (l+c)/2.0, a2 = (c+r)/2.0;
                                    setBreakpointInSplines(model[occNr][modelNr],a1); model[occNr][modelNr].estimateML(EPS); double a1v = model[occNr][modelNr].ll;
                                    setBreakpointInSplines(model[occNr][modelNr],a2); model[occNr][modelNr].estimateML(EPS); double a2v = model[occNr][modelNr].ll;
                                    double min = lv; if (rv<min) min = rv; if (cv<min) min = cv; if (a1v<min) min = a1v; if (a2v<min) min = a2v;
                                    if ((min==lv) || (min==a1v)) {rv = cv; r = c; cv = a1v; c = a1;}
                                    else if ((min==rv) || (min==a2v)) {lv = cv; l = c; cv = a2v; c = a2;}
                                    else {l = a1; lv = a1v; r = a2; rv = a2v;}
                                }
                                splinePoint[occNr] = c; 
                                setBreakpointInSplines(model[occNr][modelNr],c); model[occNr][modelNr].estimateML(EPS); 
                            }
                            if ((modelNr == 6) && (occNr < maxOccasionsFreebasis)) {
                                starting = model[occNr][modelNr].getArbitraryStartingValues();
                                erg1 = model[occNr][modelNr].estimateML(starting,EPS); 
                                erg1v = (model[occNr][modelNr].warningFlag==warningFlagTypes.FAILED?Double.MAX_VALUE:model[occNr][modelNr].ll);
                                starting = model[occNr][modelNr].estimateLS();
                                if (model[occNr][modelNr].warningFlag!=warningFlagTypes.FAILED) { 
                                    erg2 = model[occNr][modelNr].estimateML(starting,EPS); 
                                    erg2v = (model[occNr][modelNr].warningFlag==warningFlagTypes.FAILED?Double.MAX_VALUE:model[occNr][modelNr].ll); 
                                } else {erg2 = null; erg2v = Double.MAX_VALUE;}
                                starting = model[occNr][modelNr].estimateMLOfLinearModel();
                                erg3 = model[occNr][modelNr].estimateML(starting,EPS);
                                erg3v = (model[occNr][modelNr].warningFlag==warningFlagTypes.FAILED?Double.MAX_VALUE:model[occNr][modelNr].ll);
                                starting = model[occNr][modelNr].getFreeBasisStartingValues();
                                model[occNr][modelNr].estimateML(starting,EPS);
                                erg4v = (model[occNr][modelNr].warningFlag==warningFlagTypes.FAILED?Double.MAX_VALUE:model[occNr][modelNr].ll);
//                                starting = model[occNr][modelNr].getArbitraryStartingValues();
//                                model[occNr][modelNr].estimateMLByPathtracking(starting,EPS);
//                                erg4v = (model[occNr][modelNr].warningFlag==SingletonModel.warningFlagTypes.FAILED?Double.MAX_VALUE:model[occNr][modelNr].ll);
//                                erg4v = Double.MAX_VALUE;
                                startingKind = 4;
                                if ((erg1v < erg2v) && (erg1v < erg3v) && (erg1v < erg4v)) {model[occNr][modelNr].setParameter(erg1); startingKind = 1;} 
                                if ((erg2v < erg1v) && (erg2v < erg3v) && (erg2v < erg4v)) {model[occNr][modelNr].setParameter(erg2); startingKind = 2;} 
                                if ((erg3v < erg1v) && (erg3v < erg2v) && (erg3v < erg4v)) {model[occNr][modelNr].setParameter(erg3); startingKind = 3;} 
                                if ((erg1v < Double.MAX_VALUE) || (erg2v < Double.MAX_VALUE) || (erg3v < Double.MAX_VALUE) || (erg4v < Double.MAX_VALUE))
                                    model[occNr][modelNr].warningFlag = warningFlagTypes.OK;
                                if (erg1v == Double.MAX_VALUE) erg1v = MISSING;
                                if (erg2v == Double.MAX_VALUE) erg2v = MISSING;
                                if (erg3v == Double.MAX_VALUE) erg3v = MISSING;
                                if (erg4v == Double.MAX_VALUE) erg4v = MISSING;
//                                System.out.println("Comparison free Basis = ("+erg1v+", "+erg2v+", "+erg3v+", "+erg4v+")");
                            }
                        }
                        for (int modelNr = 0; modelNr < 5; modelNr++) 
                        {
                            if (model[occNr][modelNr].warningFlag != Model.warningFlagTypes.FAILED)
                            {
                                for (int i=0; i<model[occNr][modelNr].anzPar; i++) erg[e2++] = model[occNr][modelNr].getParameter(i);
                                erg[e2++] = model[occNr][modelNr].ll;
                            } else for (int i=0; i<model[occNr][modelNr].anzPar+1; i++) erg[e2++] = MISSING;
                        }
                        if ((occNr < maxOccasionsSplines) && (model[occNr][5].warningFlag != Model.warningFlagTypes.FAILED))
                        {
                            erg[e2++] = splinePoint[occNr];
                            for (int i=0; i<model[occNr][5].anzPar; i++) erg[e2++] = model[occNr][5].getParameter(i);
                            erg[e2++] = model[occNr][5].ll;
                        } else for (int i=0; i<12; i++) erg[e2++] = MISSING;
                        if ((model[occNr][6].warningFlag != Model.warningFlagTypes.FAILED) && (occNr <maxOccasionsFreebasis))
                        {
                            erg[e2++] = startingKind;
                            for (int i=0; i<model[occNr][6].anzPar; i++) 
                                if (model[occNr][6].parType[i] != SingletonModel.parameterType.structure) erg[e2++] = model[occNr][6].getParameter(i);
                            erg[e2++] = erg1v; erg[e2++] = erg2v; erg[e2++] = erg3v; erg[e2++] = erg4v;
                            for (int i=0; i<model[occNr][6].anzPar; i++) 
                                if (model[occNr][6].parType[i] == SingletonModel.parameterType.structure) erg[e2++] = model[occNr][6].getParameter(i);
                        } else for (int i=0; i<model[occNr][5].anzPar+2; i++) erg[e2++] = MISSING;
                        for (int i=occ; i<49; i++) erg[e2++] = -999;
                        
                        ergWriter.write(Statik.matrixToString(erg)+"\r\n");
                        ergWriter.flush();
                    }
                }
                System.out.println();
            }
            System.out.println("I finished, "+(System.currentTimeMillis()-time)+" ms since startup.");
        } catch (IOException e)
        {
            System.out.println("Sorry, something bad went wrong with the hard disc access.");
        }
    }
    
    public static void leadFollowerRegression()
    {
        double[][] inData = Statik.loadMatrix("analysis_abcd.txt", '\t');
        double[] dyadeMean = new double[144];
        double[] dyadeVar = new double[144];
        int[][] dyadeAG = new int[144][2];
        
        int dyadeNr = -1; int lastID1 = -1; int lastID2 = -1;
        double locMean = 0, locSqr = 0; int locAnz = 0;
        int ag1 = 0, ag2 = 0;
        // reading in all lines from input file
        for (int i=1; i<inData.length; i++)
        {
            int id1 = (int)Math.round(inData[i][1]); ag1 = (id1/100)-1;
            int id2 = (int)Math.round(inData[i][2]); ag2 = (id2/100)-1;
            if ((id1!=lastID1) || (id2 != lastID2)) 
            {
                if (dyadeNr >= 0)
                {
                    dyadeMean[dyadeNr] = locMean/locAnz; dyadeVar[dyadeNr] = locSqr/locAnz - dyadeMean[dyadeNr]*dyadeMean[dyadeNr];
                    locAnz = 0; locMean = 0.0; locSqr = 0.0;
                }
                lastID1 = id1; lastID2 = id2; 
                dyadeNr++;
            }
            dyadeAG[dyadeNr][0] = ag1+1; dyadeAG[dyadeNr][1] = ag2+1; 
            locMean += inData[i][13];
            locSqr  += inData[i][13]*inData[i][13];
            locAnz++;
        }
        dyadeMean[dyadeNr] = locMean/locAnz; dyadeVar[dyadeNr] = locSqr/locAnz - dyadeMean[dyadeNr]*dyadeMean[dyadeNr];

        double[][] erg = new double[144][4];
        for (int i=0; i<erg.length; i++) erg[i] = new double[]{dyadeAG[i][0],dyadeAG[i][1],dyadeMean[i],dyadeVar[i]};
        Statik.writeMatrix(erg, "analysisAbcdGrouplevel.txt", '\t');
    }

        
    public static void leadFollowerFit()
    {
        int[][] lookup = new int[][]{{0,1,2,3},{1,4,5,6},{2,5,7,8},{3,6,8,9}};
       double[][] inData = Statik.loadMatrix("analysis_abcd.txt", '\t');
        int trialsPerDyade = 16;
        int anzAgeGroups = 4;
        int anzPer = 72;
        int anzDyades = anzPer*2;
        int anzTotalObs = inData.length-1;
        int anzAgeCombs = 10;
        
        // initializing
        double[][] struct = new double[trialsPerDyade*anzDyades][anzPer+anzDyades];
        for (int i=0; i<struct.length;i++) for (int j=0; j<struct[i].length; j++) struct[i][j] = 0;
        int[][] structPar = new int[trialsPerDyade*anzDyades][anzPer+anzDyades];
        for (int i=0; i<struct.length;i++) for (int j=0; j<struct[i].length; j++) structPar[i][j] = -1;
        int[] idList = new int[500]; for (int i=0; i<500; i++) idList[i] = -1;
        int c =0; for (int i=1; i<inData.length; i++) {if (idList[(int)Math.round(inData[i][1])] == -1) idList[(int)Math.round(inData[i][1])] = c++;} 
        for (int i=1; i<inData.length; i++) {if (idList[(int)Math.round(inData[i][2])] == -1) idList[(int)Math.round(inData[i][2])] = c++;}
        int dyadeNr = -1; int lastID1 = -1; int lastID2 = -1;
        int[] facMean = new int[anzPer+anzDyades];
        for (int i=0; i<anzPer; i++) facMean[i] = -1;
        double[] facMeanVal = new double[anzPer+anzDyades];
        for (int i=0; i<anzPer; i++) facMeanVal[i] = 0;
        int[][] facCov = new int[anzPer+anzDyades][anzPer+anzDyades];
        for (int i=0; i<facCov.length; i++) for (int j=0; j<facCov[i].length; j++) facCov[i][j] = -1;
        double[][] facCovVal = new double[anzPer+anzDyades][anzPer+anzDyades];
        for (int i=0; i<facCov.length; i++) for (int j=0; j<facCov[i].length; j++) facCovVal[i][j] = (i==j?1:0);
        double[][] data = new double[1][anzTotalObs];
        int[] errPar = new int[anzTotalObs];
        double[] errVal = new double[anzTotalObs];
        for (int i=0; i<anzTotalObs; i++) {errPar[i] = anzAgeCombs+anzAgeGroups+anzAgeCombs; errVal[i] = 1;}
        
        // reading in all lines from input file, creating struct, facMean, facCov, and data.
        for (int i=1; i<inData.length; i++)
        {
            int id1 = (int)Math.round(inData[i][1]); int ag1 = (id1/100)-1;
            int id2 = (int)Math.round(inData[i][2]); int ag2 = (id2/100)-1;
            if ((id1!=lastID1) || (id2 != lastID2)) {lastID1 = id1; lastID2 = id2; dyadeNr++;}
            struct[i-1][idList[id1]] = 1;
            struct[i-1][idList[id2]] = 1;
            struct[i-1][anzPer + dyadeNr] = 1;
            facMean[anzPer+dyadeNr] = lookup[ag1][ag2];
            facCov[idList[id1]][idList[id1]] = anzAgeCombs+ag1; facCov[idList[id2]][idList[id2]] = anzAgeCombs+ag2;
            facCov[anzPer+dyadeNr][anzPer+dyadeNr] = anzAgeCombs+anzAgeGroups+lookup[ag1][ag2];           
            
            data[0][i-1] = (ag2<ag1?-inData[i][13]:inData[i][13]);
        }
        
        Statik.writeMatrix(struct, "structureMatrix.txt", '\t');
        
        GeneralModel model = new GeneralModel(structPar, struct, facCov, facCovVal, facMean, facMeanVal, errPar, errVal);

    }
    
    public static void main(String[] args) 
    {

        System.exit(0);
        
        
//        if (args.length==0) developmentalSimulation(0,14,2,5,3,"test");
//        developmentalSimulation(args);
//        System.exit(0);
        
//        double[][] data = createExponentialData(30, 10, 0.05, 0.005*0.005, 22, 25, 30, 0.1, 200, 60);
//        Statik.writeMatrix(data, "toPaolo.txt", '\t');
//        System.exit(0);
        
//        double Ti = 13, err = 24, lv = 80;
//        for (int i=1; i<=5; i++)
//            System.out.println(1.0 / (Ti * (i+1)*(lv*(i+1)*(i+2)+2*err*(2*i+1))/(12*err*i*(lv*(i+1)+err))));
//
//        System.exit(0);
        
        for (int th = 2; th <= 40; th++)
        {
            for (int n=1; n <= 8; n++)
                System.out.print(lgcmSpecialWithAttrition(th/2.0, n, 0.8279, 80, 24)+"\t");
            System.out.println();
        }
        
        
//        SimpleLGM work = new SimpleLGM();
//        work.manualLoopMultipleIndicatorJune2009();
        System.exit(0);
        
//        reviewBJMSP373_050309();
//        
//        System.exit(0);
        
//        double[][] data = Statik.loadMatrix("100TageMatrixJungMissingCorrected.txt", '\t');
//        double[] popEstimates = estimateFullFloModel(data);
////        for (int T = 20; T<100; T += 10)
//        int T = 30;
//        for (int occ = 3; occ<10; occ += 1)
//            manualFloDataTestExponential(data,occ,T, popEstimates);
//        data = Statik.submatrix(data, 0, data.length, 40, data[0].length);
        
//        double[] popEstimates = estimateFullFloModel(data);
//        System.out.println("popestimates = "+Statik.matrixToString(popEstimates));
//        for (int i=0; i<10; i++)
//            System.out.print(popEstimates[i]+", ");
//        data = createFloDataTestExponential(100, 99, 100, popEstimates);
//        double[] Ts = new double[]{45.55,43.06,40.79,38.78,37,35.44,34.04,32.80,31.67,30.65,29.72,28.87,28.09,27.36,26.69,26.07,25.49,24.49};
//        for (int occ=3; occ<=10; occ++)
//        {
//            for (int T = 20; T < 21; T += 5)
//                manualFloDataTestExponential(data,occ,T, popEstimates);
//            System.out.println();
//        }
//        double[][] floDataMatrix = read100DayData("100TageAlt.txt");
//        Statik.writeMatrix(floDataMatrix, "100TageMatrixAlt.txt", '\t');
       
        System.exit(0);
        SimpleLGM lgm = new SimpleLGM();
//        long time = System.currentTimeMillis();
//        try {lgm.manualSSlikePower(new BufferedWriter(new FileWriter("nix.txt")),16,16,100);} catch (Exception e) {}
//        System.out.println("time = "+(System.currentTimeMillis()-time));
//        System.exit(0);
        
//        System.out.println(lgm.salthouse(0.2, 0.85, 0.1));
        
//        lgm.methEvalPresentation();
//        lgm.simplestSimulation();
//        for (int vs = 1; vs < 10; vs++)
//            for (int rel = 0; rel < 3; rel++)
//                for (int t=1; t<4; t++)
//                {
//                    double varS = (double)vs/(double)200;
//                    double reld = .8 + rel * 0.05;
//                    System.out.println(("Variance = "+varS+", reliability = "+reld+", T = "+t+", power = "+lgm.salthouse(varS, reld, t)));
//                }
//        lgm.miOneVariableSimulation();
     
//        for (int i=8; i<15; i++)
//        {
//            double v1 = lgm.bjmspRevision(i*10,100000,14.63,3);
//            double v2 = lgm.bjmspRevision(i*10,100000,10.00,11);
//            System.out.println("N = "+(i*10)+"\t"+(v2-v1));
//        }
        System.exit(0);
        
        int start = 102, end = 133, trials =10000;
        if (args.length==3) 
        {
            start = Integer.parseInt(args[0]);
            end = Integer.parseInt(args[1]);
            trials = Integer.parseInt(args[2]);
        }
//        SimpleLGM lgm = new SimpleLGM();
        
		try {
//		    for (int i=0; i<1; i++) lgm.annaModellSimple();
//		    lgm.stoelEtAl();
			BufferedWriter outTypeOneTest = new BufferedWriter(new FileWriter("typeOneTestOut.txt"));
//			BufferedWriter outAllIC = new BufferedWriter(new FileWriter("interceptTestOut.txt"));
//			BufferedWriter outPowerIC = new BufferedWriter(new FileWriter("intercept_powerOut.txt"));
//			BufferedWriter outAllMI = new BufferedWriter(new FileWriter("MI2_out"+start+"to"+end+".txt"));
//			BufferedWriter outPowerMI = new BufferedWriter(new FileWriter("MI2_powerOut"+start+"to"+end+".txt"));
//			BufferedWriter outAll = new BufferedWriter(new FileWriter("out"+start+"to"+end+".txt"));
//			BufferedWriter outPower = new BufferedWriter(new FileWriter("powerOut"+start+"to"+end+".txt"));
//			BufferedWriter outZeroVarCount = new BufferedWriter(new FileWriter("zeroVarCountOut"+start+"to"+end+".txt"));
//	        lgm.manualLoop(start,end,trials, outAll, outPower, outZeroVarCount);
//	        lgm.manualSSlikePower(new BufferedWriter(new FileWriter("DensePlotOut.txt")), start, end, trials);
//	        for (int i=0; i<4; i++)
//	            for (int j=0; j<4; j++)
//	            {
//	                double error = 1; if (i==1) error = 10; if (i==2) error = 25; if (i==3) error = 100;
//	                int persons = 100; if (j==1) persons = 200; if (j==2) persons = 500; if (j==3) persons = 1000;
//	    			lgm.varianceTypeTwoErrorTest(trials,new BufferedWriter(new FileWriter("typeTwoErrorN"+persons+"err"+error+".txt")),error,persons);
//	            }
			
			lgm.varianceTypeOneErrorTest(trials, outTypeOneTest, 10, 100);
//	        lgm.manualTestOfDifferentIntercepts(trials,outAllIC, outPowerIC);
//			outAllIC.close(); 
//			outPowerIC.close();
		} catch (Exception e) {
		    System.out.println("Some error:"+e);
		}
    }
}
